# MICROSOFT SOFTWARE LICENSE TERMS

## MICROSOFT OFFICE JAVASCRIPT (OFFICE.JS) API LIBRARY

These license terms are an agreement between Microsoft Corporation (or based on where you live, one of its affiliates) and you. Please read them. They apply to your use of the software named above, which includes the media on which you received it, if any, and supersede any other agreement referenced in the software that may apply to your use of the software. The terms also apply to any Microsoft

- updates,
- supplements,
- Internet-based services, and
- support services

for this software, unless other terms accompany those items. If so, those terms apply.

**By using the software, you accept these terms. If you do not accept them, do not use the software.**

**YOU MAY USE THE SOFTWARE SOLELY IN APPS DEVELOPED BY YOU THAT INTEROPERATE WITH MICROSOFT 365 PRODUCTS, APPS, AND SERVICES (REFERRED TO AS "AUTHORIZED APPS").**

**IF YOU RECEIVE THE SOFTWARE AS PART OF OR IN CONNECTION WITH AN APPLICATION DEVELOPED BY A THIRD PARTY, THESE LICENSE TERMS DO NOT APPLY TO YOU. THE LICENSE TERMS APPLICABLE TO THE THIRD PARTY APPLICATION APPLY TO YOUR USE OF THE SOFTWARE.**

**If you comply with these license terms, you have the rights below.**

1. **INSTALLATION AND USE RIGHTS.** You may install and use any number of copies of the software on your devices to design, develop and test Authorized Apps. You may also use any number of copies of the software as part of the Authorized Apps you develop for your internal business purposes.
1. **ADDITIONAL LICENSING REQUIREMENTS AND/OR USE RIGHTS.**
    1. **Distributable Code.** The software contains code that you are permitted to distribute (a) as part of the Authorized Apps you develop; or (b) in a stand-alone manner, but for the sole purpose of enabling the use of or updating the Authorized Apps you develop, if you comply with the terms below.
        1. **Right to Use and Distribute. "Distributable Code" is code from the Office.JS API Library.**
            - You may copy and distribute all the code provided in the source code form in the software in its original form.
            - Third Party Distribution. You may permit the distributor of the Authorized Apps to copy and distribute the Distributable Code as part of the Authorized Apps, or in a stand-alone manner solely for the purpose of enabling the use of or updating the Authorized Apps.
        1. **Distribution Requirements. For any Distributable Code you distribute, you must**
            - add significant primary functionality to it in Authorized Apps;
            - distribute the Distributable Code only for use with the Authorized Apps;
            - require distributors and external end users to agree to terms that protect it at least as much as this agreement; include in these terms, user interface or documentation, a notice that Microsoft is not responsible for maintaining, updating or supporting the Authorized Apps
            - display your valid copyright notice on Authorized Apps; and
            - indemnify, defend, and hold harmless Microsoft from any claims, including attorneys’ fees, related to the distribution or use of Authorized Apps.
        1. **Distribution Restrictions. You may not**
            - alter any copyright, trademark or patent notice in the Distributable Code;
            - use Microsoft’s trademarks in the names of Authorized Apps in a way that suggests Authorized Apps come from or are endorsed by Microsoft;
            - include Distributable Code in malicious, deceptive or unlawful programs;
            - modify the Distributable Code; or
            - modify or distribute the source code of any Distributable Code so that any part of it becomes subject to an Excluded License. An Excluded License is one that requires, as a condition of use, modification or distribution, that
                - the code be disclosed or distributed in source code form; or
                - others have the right to modify it.
1. **PRE-RELEASE SOFTWARE.** If you are using a pre-release or beta version of the software, the terms of this section also apply to the pre-release or beta software:
    1. The software is a pre-release version and is provided "AS-IS," "WITH ALL FAULTS," AND "AS AVAILABLE." It may not operate correctly, and it may be different from the commercially released version.
    1. **Confidential Information.** The software, including its user interface, features and documentation, is confidential and proprietary to Microsoft and its suppliers.
        1. **Use.** For five years after installation of the software or its commercial release, whichever is first, you may not disclose confidential information to third parties. You may disclose confidential information only to your employees and consultants who need to know the information. You must have written agreements with them that protect the confidential information at least as much as this agreement.
        1. **Survival.** Your duty to protect confidential information survives this agreement.
        1. **Exclusions.** You may disclose confidential information in response to a judicial or governmental order. You must first give written notice to Microsoft to allow it to seek a protective order or otherwise protect the information. Confidential information does not include information that:
            1. becomes publicly known through no wrongful act;
            1. you received from a third party who did not breach confidentiality obligations to Microsoft or its suppliers; or
            1. you developed independently.
1. **FEEDBACK.** If you give feedback about the software to Microsoft, you give to Microsoft, without charge, the right to use, share and commercialize your feedback in any way and for any purpose. You also give to third parties, without charge, any patent rights needed for their products, technologies and services to use or interface with any specific parts of a Microsoft software or service that includes the feedback. You will not give feedback that is subject to a license that requires Microsoft to license its software or documentation to third parties because we include your feedback in them. These rights survive this agreement.
1. **SCOPE OF LICENSE.** You may only use the software in Authorized Apps. The software is licensed, not sold. This agreement only gives you some rights to use the software. Microsoft reserves all other rights. Unless applicable law gives you more rights despite this limitation, you may use the software only as expressly permitted in this agreement. In doing so, you must comply with any technical limitations in the software that only allow you to use it in certain ways. You may not
    - work around any technical limitations in the software;
    - use the software in any way that intentionally harms services provided by Microsoft or impairs anyone else’s use of such services; 
    - use the software to try to gain unauthorized access to any service, data, account or network by any means; 
    - make more copies of the software than specified in this agreement or allowed by applicable law, despite this limitation;
    - publish the software for others to copy; or
    - rent, lease or lend the software.
1. **BACKUP COPY.** You may make one backup copy of the software. You may use it only to reinstall the software.
1. **DOCUMENTATION.** Any person that has valid access to your computer or internal network may copy and use the documentation for your internal, reference purposes.
1. **TRANSFER TO A THIRD PARTY.** The first user of the software may transfer it and this agreement directly to a third party. Before the transfer, that party must agree that this agreement applies to the transfer and use of the software. The first user must uninstall the software before transferring it separately from the device. The first user may not retain any copies.
1. **EXPORT RESTRICTIONS.** The software is subject to United States export laws and regulations. You must comply with all domestic and international export laws and regulations that apply to the software. These laws include restrictions on destinations, end users and end use. For additional information, see www.microsoft.com/exporting.
1. **SUPPORT SERVICES.** Because this software is "as is," we will not provide support services for it.
1. **ENTIRE AGREEMENT.** This agreement, and the terms for supplements, updates, Internet-based services and support services that you use, are the entire agreement for the software and support services.
1. **APPLICABLE LAW.**
    1. **United States.** If you acquired the software in the United States, Washington state law governs the interpretation of this agreement and applies to claims for breach of it, regardless of conflict of laws principles. The laws of the state where you live govern all other claims, including claims under state consumer protection laws, unfair competition laws, and in tort.
    1. **Outside the United States.** If you acquired the software in any other country, the laws of that country apply.
1. **LEGAL EFFECT.** This agreement describes certain legal rights. You may have other rights under the laws of your country. You may also have rights with respect to the party from whom you acquired the software. This agreement does not change your rights under the laws of your country if the laws of your country do not permit it to do so.
1. **DISCLAIMER OF WARRANTY. The software is licensed "as-is." You bear the risk of using it. Microsoft gives no express warranties, guarantees or conditions. You may have additional consumer rights under your local laws which this agreement cannot change. To the extent permitted under your local laws, Microsoft excludes the implied warranties of merchantability, fitness for a particular purpose and non-infringement.**
1. **LIMITATION ON AND EXCLUSION OF REMEDIES AND DAMAGES. You can recover from Microsoft and its suppliers only direct damages up to U.S. $5.00. You cannot recover any other damages, including consequential, lost profits, special, indirect or incidental damages.**
    This limitation applies to

    - anything related to the software, services, content (including code) on third party Internet sites, or third party programs; and
    - claims for breach of contract, breach of warranty, guarantee or condition, strict liability, negligence, or other tort to the extent permitted by applicable law.

    It also applies even if Microsoft knew or should have known about the possibility of the damages. The above limitation or exclusion may not apply to you because your country may not allow the exclusion or limitation of incidental, consequential or other damages.
