/*
	Copyright (c) Microsoft Corporation.  All rights reserved.
*/

/*
	Your use of this file is governed by the Microsoft Services Agreement http://go.microsoft.com/fwlink/?LinkId=266419.
*/

/*
* @overview es6-promise - a tiny implementation of Promises/A+.
* @copyright Copyright (c) 2014 Yehuda Katz, Tom Dale, Stefan Penner and contributors (Conversion to ES6 API by Jake Archibald)
* @license   Licensed under MIT license
*            See https://raw.githubusercontent.com/jakearchibald/es6-promise/master/LICENSE
* @version   2.3.0
*/


// Sources:
// osfweb: 16.0\16.0.15407.10000
// runtime: 16.0\16.0.15407.10000
// core: 16.0\16.0.15407.10000
// host: 16.0\16.0.15407.10000



var OfficeExt,__extends=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();!function(e){var t=function(){function e(){}return e.prototype.isMsAjaxLoaded=function(){return!!("undefined"!==typeof Sys&&"undefined"!==typeof Type&&Sys.StringBuilder&&"function"===typeof Sys.StringBuilder&&Type.registerNamespace&&"function"===typeof Type.registerNamespace&&Type.registerClass&&"function"===typeof Type.registerClass&&"function"===typeof Function._validateParams&&Sys.Serialization&&Sys.Serialization.JavaScriptSerializer&&"function"===typeof Sys.Serialization.JavaScriptSerializer.serialize)},e.prototype.loadMsAjaxFull=function(e){var t=("https:"===window.location.protocol.toLowerCase()?"https:":"http:")+"//ajax.aspnetcdn.com/ajax/3.5/MicrosoftAjax.js";OSF.OUtil.loadScript(t,e)},Object.defineProperty(e.prototype,"msAjaxError",{get:function(){return null==this._msAjaxError&&this.isMsAjaxLoaded()&&(this._msAjaxError=Error),this._msAjaxError},set:function(e){this._msAjaxError=e},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"msAjaxString",{get:function(){return null==this._msAjaxString&&this.isMsAjaxLoaded()&&(this._msAjaxString=String),this._msAjaxString},set:function(e){this._msAjaxString=e},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"msAjaxDebug",{get:function(){return null==this._msAjaxDebug&&this.isMsAjaxLoaded()&&(this._msAjaxDebug=Sys.Debug),this._msAjaxDebug},set:function(e){this._msAjaxDebug=e},enumerable:!0,configurable:!0}),e}();e.MicrosoftAjaxFactory=t}(OfficeExt||(OfficeExt={}));var OsfMsAjaxFactory=new OfficeExt.MicrosoftAjaxFactory,OSF=OSF||{};!function(e){var t=function(){function e(e){this._internalStorage=e}return e.prototype.getItem=function(e){try{return this._internalStorage&&this._internalStorage.getItem(e)}catch(e){return null}},e.prototype.setItem=function(e,t){try{this._internalStorage&&this._internalStorage.setItem(e,t)}catch(e){}},e.prototype.clear=function(){try{this._internalStorage&&this._internalStorage.clear()}catch(e){}},e.prototype.removeItem=function(e){try{this._internalStorage&&this._internalStorage.removeItem(e)}catch(e){}},e.prototype.getKeysWithPrefix=function(e){var t=[];try{for(var n=this._internalStorage&&this._internalStorage.length||0,r=0;r<n;r++){var o=this._internalStorage.key(r);0===o.indexOf(e)&&t.push(o)}}catch(e){}return t},e.prototype.isLocalStorageAvailable=function(){return null!=this._internalStorage},e}();e.SafeStorage=t}(OfficeExt||(OfficeExt={})),OSF.XdmFieldName={ConversationUrl:"ConversationUrl",AppId:"AppId"},OSF.TestFlightStart=1e3,OSF.TestFlightEnd=1009,OSF.FlightNames={UseOriginNotUrl:0,AddinEnforceHttps:2,FirstPartyAnonymousProxyReadyCheckTimeout:6,AddinRibbonIdAllowUnknown:9,ManifestParserDevConsoleLog:15,AddinActionDefinitionHybridMode:18,UseActionIdForUILessCommand:20,RequirementSetRibbonApiOnePointTwo:21,SetFocusToTaskpaneIsEnabled:22,ShortcutInfoArrayInUserPreferenceData:23,OSFTestFlight1000:OSF.TestFlightStart,OSFTestFlight1001:OSF.TestFlightStart+1,OSFTestFlight1002:OSF.TestFlightStart+2,OSFTestFlight1003:OSF.TestFlightStart+3,OSFTestFlight1004:OSF.TestFlightStart+4,OSFTestFlight1005:OSF.TestFlightStart+5,OSFTestFlight1006:OSF.TestFlightStart+6,OSFTestFlight1007:OSF.TestFlightStart+7,OSFTestFlight1008:OSF.TestFlightStart+8,OSFTestFlight1009:OSF.TestFlightEnd},OSF.TrustUXFlightValues={TrustUXControlA:0,TrustUXExperimentB:1,TrustUXExperimentC:2},OSF.FlightTreatmentNames={AddinDialogIFrameContentWindowKillSwitch:"Microsoft.Office.SharedOnline.AddinDialogIFrameContentWindowKillSwitch",AddinTrustUXImprovement:"Microsoft.Office.SharedOnline.AddinTrustUXImprovement",AllowStorageAccessByUserActivationOnIFrameCheck:"Microsoft.Office.SharedOnline.AllowStorageAccessByUserActivationOnIFrameCheck",BlockAutoOpenAddInIfStoreDisabled:"Microsoft.Office.SharedOnline.BlockAutoOpenAddInIfStoreDisabled",CheckProxyIsReadyRetry:"Microsoft.Office.SharedOnline.OEP.CheckProxyIsReadyRetry",InsertionDialogFixesEnabled:"Microsoft.Office.SharedOnline.InsertionDialogFixesEnabled",TeachingUIForPrivateCatelogEnabled:"Microsoft.Office.SharedOnline.TeachingUIForPrivateCatelogEnabled",WopiPreinstalledAddInsEnabled:"Microsoft.Office.SharedOnline.WopiPreinstalledAddInsEnabled",WopiUseNewActivate:"Microsoft.Office.SharedOnline.WopiUseNewActivate",MosManifestEnabled:"Microsoft.Office.SharedOnline.OEP.MosManifest"},OSF.Flights=[],OSF.IntFlights={},OSF.Settings={},OSF.WindowNameItemKeys={BaseFrameName:"baseFrameName",HostInfo:"hostInfo",XdmInfo:"xdmInfo",SerializerVersion:"serializerVersion",AppContext:"appContext",Flights:"flights"},OSF.OUtil=function(){var e=-1,t="#",n={},r=null,o=null,i=(new Date).getTime();function a(){var e=2147483647*Math.random();return(e^=i^(new Date).getMilliseconds()<<Math.floor(21*Math.random())).toString(16)}function s(){if(!r){try{var e=window.sessionStorage}catch(t){e=null}r=new OfficeExt.SafeStorage(e)}return r}function c(e){var t,n,r=[],o=[],i=e.length;for(t=0;t<i;t++)(n=e[t]).tabIndex?n.tabIndex>0?o.push(n):0===n.tabIndex&&r.push(n):r.push(n);return o=o.sort((function(e,t){var n=e.tabIndex-t.tabIndex;return 0===n&&(n=o.indexOf(e)-o.indexOf(t)),n})),[].concat(o,r)}return{set_entropy:function(e){if("string"==typeof e)for(var t=0;t<e.length;t+=4){for(var n=0,r=0;r<4&&t+r<e.length;r++)n=(n<<8)+e.charCodeAt(t+r);i^=n}else i^="number"==typeof e?e:2147483647*Math.random();i&=2147483647},extend:function(e,t){var n=function(){};n.prototype=t.prototype,e.prototype=new n,e.prototype.constructor=e,e.uber=t.prototype,t.prototype.constructor===Object.prototype.constructor&&(t.prototype.constructor=t)},setNamespace:function(e,t){t&&e&&!t[e]&&(t[e]={})},unsetNamespace:function(e,t){t&&e&&t[e]&&delete t[e]},serializeSettings:function(e){var t={};for(var n in e){var r=e[n];try{r=JSON?JSON.stringify(r,(function(e,t){return OSF.OUtil.isDate(this[e])?OSF.DDA.SettingsManager.DateJSONPrefix+this[e].getTime()+OSF.DDA.SettingsManager.DataJSONSuffix:t})):Sys.Serialization.JavaScriptSerializer.serialize(r),t[n]=r}catch(e){}}return t},deserializeSettings:function(e){var t={};for(var n in e=e||{}){var r=e[n];try{r=JSON?JSON.parse(r,(function(e,t){var n;return"string"===typeof t&&t&&t.length>6&&t.slice(0,5)===OSF.DDA.SettingsManager.DateJSONPrefix&&t.slice(-1)===OSF.DDA.SettingsManager.DataJSONSuffix&&(n=new Date(parseInt(t.slice(5,-1))))?n:t})):Sys.Serialization.JavaScriptSerializer.deserialize(r,!0),t[n]=r}catch(e){}}return t},loadScript:function(e,t,r){if(e&&t){var o=window.document,i=n[e];if(i)i.loaded?t():i.pendingCallbacks.push(t);else{var a=o.createElement("script");a.type="text/javascript",i={loaded:!1,pendingCallbacks:[t],timer:null},n[e]=i;var s=function(){null!=i.timer&&(clearTimeout(i.timer),delete i.timer),i.loaded=!0;for(var e=i.pendingCallbacks.length,t=0;t<e;t++){i.pendingCallbacks.shift()()}},c=function(t){delete n[e],null!=i.timer&&(clearTimeout(i.timer),delete i.timer);for(var r=i.pendingCallbacks.length,o=0;o<r;o++){i.pendingCallbacks.shift()(t)}};a.readyState?a.onreadystatechange=function(){"loaded"!=a.readyState&&"complete"!=a.readyState||(a.onreadystatechange=null,s())}:a.onload=s,a.onerror=c,r=r||3e4,i.timer=setTimeout((function(){window.navigator.userAgent.indexOf("Trident")>0?c(null):c(new Event("Script load timed out"))}),r),a.setAttribute("crossOrigin","anonymous"),a.src=e,o.getElementsByTagName("head")[0].appendChild(a)}}},loadCSS:function(e){if(e){var t=window.document,n=t.createElement("link");n.type="text/css",n.rel="stylesheet",n.href=e,t.getElementsByTagName("head")[0].appendChild(n)}},parseEnum:function(e,t){var n=t[e.trim()];if("undefined"==typeof n)throw OsfMsAjaxFactory.msAjaxDebug.trace("invalid enumeration string:"+e),OsfMsAjaxFactory.msAjaxError.argument("str");return n},delayExecutionAndCache:function(){var e={calc:arguments[0]};return function(){return e.calc&&(e.val=e.calc.apply(this,arguments),delete e.calc),e.val}},getUniqueId:function(){return(e+=1).toString()},formatString:function(){var e=arguments,t=e[0];return t.replace(/{(\d+)}/gm,(function(t,n){var r=parseInt(n,10)+1;return void 0===e[r]?"{"+n+"}":e[r]}))},generateConversationId:function(){return[a(),a(),(new Date).getTime().toString()].join("_")},getFrameName:function(e){return"_xdm_"+e+this.generateConversationId()},addXdmInfoAsHash:function(e,t){return OSF.OUtil.addInfoAsHash(e,"&_xdm_Info=",t,!1)},addSerializerVersionAsHash:function(e,t){return OSF.OUtil.addInfoAsHash(e,"&_serializer_version=",t,!0)},addFlightsAsHash:function(e,t){return OSF.OUtil.addInfoAsHash(e,"&_flights=",t,!0)},addInfoAsHash:function(e,n,r,o){var i,a=(e=e.trim()||"").split(t),s=a.shift(),c=a.join(t);return i=o?[n,encodeURIComponent(r),c].join(""):[c,n,r].join(""),[s,t,i].join("")},parseHostInfoFromWindowName:function(e,t){return OSF.OUtil.parseInfoFromWindowName(e,t,OSF.WindowNameItemKeys.HostInfo)},parseXdmInfo:function(e){var t=OSF.OUtil.parseXdmInfoWithGivenFragment(e,window.location.hash);return t||(t=OSF.OUtil.parseXdmInfoFromWindowName(e,window.name)),t},parseXdmInfoFromWindowName:function(e,t){return OSF.OUtil.parseInfoFromWindowName(e,t,OSF.WindowNameItemKeys.XdmInfo)},parseXdmInfoWithGivenFragment:function(e,t){return OSF.OUtil.parseInfoWithGivenFragment("&_xdm_Info=","_xdm_",!1,e,t)},parseSerializerVersion:function(e){var t=OSF.OUtil.parseSerializerVersionWithGivenFragment(e,window.location.hash);return isNaN(t)&&(t=OSF.OUtil.parseSerializerVersionFromWindowName(e,window.name)),t},parseSerializerVersionFromWindowName:function(e,t){return parseInt(OSF.OUtil.parseInfoFromWindowName(e,t,OSF.WindowNameItemKeys.SerializerVersion))},parseSerializerVersionWithGivenFragment:function(e,t){return parseInt(OSF.OUtil.parseInfoWithGivenFragment("&_serializer_version=","_serializer_version=",!0,e,t))},parseFlights:function(e){var t=OSF.OUtil.parseFlightsWithGivenFragment(e,window.location.hash);return 0==t.length&&(t=OSF.OUtil.parseFlightsFromWindowName(e,window.name)),t},checkFlight:function(e){return OSF.Flights&&OSF.Flights.indexOf(e)>=0},pushFlight:function(e){return OSF.Flights.indexOf(e)<0&&(OSF.Flights.push(e),!0)},getBooleanSetting:function(e){return OSF.OUtil.getBooleanFromDictionary(OSF.Settings,e)},getBooleanFromDictionary:function(e,t){var n=e&&t&&void 0!==e[t]&&e[t]&&("string"===typeof e[t]&&"TRUE"===e[t].toUpperCase()||"boolean"===typeof e[t]&&e[t]);return void 0!==n&&n},getIntFromDictionary:function(e,t){return e&&t&&void 0!==e[t]&&"string"===typeof e[t]?parseInt(e[t]):NaN},pushIntFlight:function(e,t){return!(e in OSF.IntFlights)&&(OSF.IntFlights[e]=t,!0)},getIntFlight:function(e){return OSF.IntFlights&&e in OSF.IntFlights?OSF.IntFlights[e]:NaN},parseFlightsFromWindowName:function(e,t){return OSF.OUtil.parseArrayWithDefault(OSF.OUtil.parseInfoFromWindowName(e,t,OSF.WindowNameItemKeys.Flights))},parseFlightsWithGivenFragment:function(e,t){return OSF.OUtil.parseArrayWithDefault(OSF.OUtil.parseInfoWithGivenFragment("&_flights=","_flights=",!0,e,t))},parseArrayWithDefault:function(e){var t=[];try{t=JSON.parse(e)}catch(e){}return Array.isArray(t)||(t=[]),t},parseInfoFromWindowName:function(e,t,n){try{var r=JSON.parse(t),o=null!=r?r[n]:null,i=s();if(!e&&i&&null!=r){var a=r[OSF.WindowNameItemKeys.BaseFrameName]+n;o?i.setItem(a,o):o=i.getItem(a)}return o}catch(e){return null}},parseInfoWithGivenFragment:function(e,t,n,r,o){var i=o.split(e),a=i.length>1?i[i.length-1]:null;n&&null!=a&&(a.indexOf("&")>=0&&(a=a.split("&")[0]),a=decodeURIComponent(a));var c=s();if(!r&&c){var l=window.name.indexOf(t);if(l>-1){var u=window.name.indexOf(";",l);-1==u&&(u=window.name.length);var p=window.name.substring(l,u);a?c.setItem(p,a):a=c.getItem(p)}}return a},getConversationId:function(){var e=window.location.search,t=null;if(e){var n=e.indexOf("&");(t=n>0?e.substring(1,n):e.substr(1))&&"="===t.charAt(t.length-1)&&(t=t.substring(0,t.length-1))&&(t=decodeURIComponent(t))}return t},getInfoItems:function(e){var t=e.split("$");return"undefined"==typeof t[1]&&(t=e.split("|")),"undefined"==typeof t[1]&&(t=e.split("%7C")),t},getXdmFieldValue:function(e,t){var n="",r=OSF.OUtil.parseXdmInfo(t);if(r){var o=OSF.OUtil.getInfoItems(r);if(void 0!=o&&o.length>=3)switch(e){case OSF.XdmFieldName.ConversationUrl:n=o[2];break;case OSF.XdmFieldName.AppId:n=o[1]}}return n},validateParamObject:function(e,t,n){var r=Function._validateParams(arguments,[{name:"params",type:Object,mayBeNull:!1},{name:"expectedProperties",type:Object,mayBeNull:!1},{name:"callback",type:Function,mayBeNull:!0}]);if(r)throw r;for(var o in t)if(r=Function._validateParameter(e[o],t[o],o))throw r},writeProfilerMark:function(e){window.msWriteProfilerMark&&(window.msWriteProfilerMark(e),OsfMsAjaxFactory.msAjaxDebug.trace(e))},outputDebug:function(e){"undefined"!==typeof OsfMsAjaxFactory&&OsfMsAjaxFactory.msAjaxDebug&&OsfMsAjaxFactory.msAjaxDebug.trace&&OsfMsAjaxFactory.msAjaxDebug.trace(e)},defineNondefaultProperty:function(e,t,n,r){for(var o in n=n||{},r){var i=r[o];void 0==n[i]&&(n[i]=!0)}return Object.defineProperty(e,t,n),e},defineNondefaultProperties:function(e,t,n){for(var r in t=t||{})OSF.OUtil.defineNondefaultProperty(e,r,t[r],n);return e},defineEnumerableProperty:function(e,t,n){return OSF.OUtil.defineNondefaultProperty(e,t,n,["enumerable"])},defineEnumerableProperties:function(e,t){return OSF.OUtil.defineNondefaultProperties(e,t,["enumerable"])},defineMutableProperty:function(e,t,n){return OSF.OUtil.defineNondefaultProperty(e,t,n,["writable","enumerable","configurable"])},defineMutableProperties:function(e,t){return OSF.OUtil.defineNondefaultProperties(e,t,["writable","enumerable","configurable"])},finalizeProperties:function(e,t){t=t||{};for(var n=Object.getOwnPropertyNames(e),r=n.length,o=0;o<r;o++){var i=n[o],a=Object.getOwnPropertyDescriptor(e,i);a.get||a.set||(a.writable=t.writable||!1),a.configurable=t.configurable||!1,a.enumerable=t.enumerable||!0,Object.defineProperty(e,i,a)}return e},mapList:function(e,t){var n=[];if(e)for(var r in e)n.push(t(e[r]));return n},listContainsKey:function(e,t){for(var n in e)if(t==n)return!0;return!1},listContainsValue:function(e,t){for(var n in e)if(t==e[n])return!0;return!1},augmentList:function(e,t){var n=e.push?function(t,n){e.push(n)}:function(t,n){e[t]=n};for(var r in t)n(r,t[r])},redefineList:function(e,t){for(var n in e)delete e[n];for(var r in t)e[r]=t[r]},isArray:function(e){return"[object Array]"===Object.prototype.toString.apply(e)},isFunction:function(e){return"[object Function]"===Object.prototype.toString.apply(e)},isDate:function(e){return"[object Date]"===Object.prototype.toString.apply(e)},addEventListener:function(e,t,n){e.addEventListener?e.addEventListener(t,n,!1):Sys.Browser.agent===Sys.Browser.InternetExplorer&&e.attachEvent?e.attachEvent("on"+t,n):e["on"+t]=n},removeEventListener:function(e,t,n){e.removeEventListener?e.removeEventListener(t,n,!1):Sys.Browser.agent===Sys.Browser.InternetExplorer&&e.detachEvent?e.detachEvent("on"+t,n):e["on"+t]=null},xhrGet:function(e,t,n){var r;try{(r=new XMLHttpRequest).onreadystatechange=function(){4==r.readyState&&(200==r.status?t(r.responseText):n(r.status))},r.open("GET",e,!0),r.send()}catch(e){n(e)}},encodeBase64:function(e){if(!e)return e;var t,n,r,o,i,a,s,c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",l=[],u=[],p=0,f=e.length;do{t=e.charCodeAt(p++),n=e.charCodeAt(p++),r=e.charCodeAt(p++),s=0,o=255&t,i=t>>8,a=255&n,u[s++]=o>>2,u[s++]=(3&o)<<4|i>>4,u[s++]=(15&i)<<2|a>>6,u[s++]=63&a,isNaN(n)||(o=n>>8,i=255&r,a=r>>8,u[s++]=o>>2,u[s++]=(3&o)<<4|i>>4,u[s++]=(15&i)<<2|a>>6,u[s++]=63&a),isNaN(n)?u[s-1]=64:isNaN(r)&&(u[s-2]=64,u[s-1]=64);for(var d=0;d<s;d++)l.push(c.charAt(u[d]))}while(p<f);return l.join("")},getSessionStorage:function(){return s()},getLocalStorage:function(){if(!o){try{var e=window.localStorage}catch(t){e=null}o=new OfficeExt.SafeStorage(e)}return o},convertIntToCssHexColor:function(e){return"#"+(Number(e)+16777216).toString(16).slice(-6)},attachClickHandler:function(e,t){e.onclick=function(e){t()},e.ontouchend=function(e){t(),e.preventDefault()}},getQueryStringParamValue:function(e,t){var n=Function._validateParams(arguments,[{name:"queryString",type:String,mayBeNull:!1},{name:"paramName",type:String,mayBeNull:!1}]);if(n)return OsfMsAjaxFactory.msAjaxDebug.trace("OSF_Outil_getQueryStringParamValue: Parameters cannot be null."),"";var r=new RegExp("[\\?&]"+t+"=([^&#]*)","i");return r.test(e)?r.exec(e)[1]:(OsfMsAjaxFactory.msAjaxDebug.trace("OSF_Outil_getQueryStringParamValue: The parameter is not found."),"")},getHostnamePortionForLogging:function(e){var t=Function._validateParams(arguments,[{name:"hostname",type:String,mayBeNull:!1}]);if(t)return"";var n=e.split("."),r=n.length;return r>=2?n[r-2]+"."+n[r-1]:1==r?n[0]:void 0},isiOS:function(){return!!window.navigator.userAgent.match(/(iPad|iPhone|iPod)/g)},isChrome:function(){return window.navigator.userAgent.indexOf("Chrome")>0&&!OSF.OUtil.isEdge()},isEdge:function(){return window.navigator.userAgent.indexOf("Edge")>0},isIE:function(){return window.navigator.userAgent.indexOf("Trident")>0},isFirefox:function(){return window.navigator.userAgent.indexOf("Firefox")>0},startsWith:function(e,t,n){return n?e.substr(0,t.length)===t:e.startsWith(t)},containsPort:function(e,t,n,r){return this.startsWith(e,t+"//"+n+":"+r,!0)||this.startsWith(e,n+":"+r,!0)},getRedundandPortString:function(e,t){return e&&t?"https:"==t.protocol&&this.containsPort(e,"https:",t.hostname,"443")?":443":"http:"==t.protocol&&this.containsPort(e,"http:",t.hostname,"80")?":80":"":""},removeChar:function(e,t){return t<e.length-1?e.substring(0,t)+e.substring(t+1):t==e.length-1?e.substring(0,e.length-1):e},cleanUrlOfChar:function(e,t){var n;for(n=0;n<e.length;n++)if(e.charAt(n)===t){if(n+1>=e.length)return this.removeChar(e,n);if("/"===t){if("?"===e.charAt(n+1)||"#"===e.charAt(n+1))return this.removeChar(e,n)}else if("?"===t&&"#"===e.charAt(n+1))return this.removeChar(e,n)}return e},cleanUrl:function(e){if(e=this.cleanUrlOfChar(e,"/"),e=this.cleanUrlOfChar(e,"?"),"https://"==(e=this.cleanUrlOfChar(e,"#")).substr(0,8))-1!=(t=e.indexOf(":443"))&&(t!=e.length-4&&"/"!=e.charAt(t+4)&&"?"!=e.charAt(t+4)&&"#"!=e.charAt(t+4)||(e=e.substring(0,t)+e.substring(t+4)));else if("http://"==e.substr(0,7)){var t;-1!=(t=e.indexOf(":80"))&&(t!=e.length-3&&"/"!=e.charAt(t+3)&&"?"!=e.charAt(t+3)&&"#"!=e.charAt(t+3)||(e=e.substring(0,t)+e.substring(t+3)))}return e},parseUrl:function(e,t){if(void 0===t&&(t=!1),"undefined"!==typeof e&&e){var n=this.isIE(),r={protocol:void 0,hostname:void 0,host:void 0,port:void 0,pathname:void 0,search:void 0,hash:void 0,isPortPartOfUrl:void 0};try{if(n){var o=document.createElement("a");if(o.href=e,!o||!o.protocol||!o.host||!o.hostname||!o.href||this.cleanUrl(o.href).toLowerCase()!==this.cleanUrl(e).toLowerCase())throw"InvalidUrl";if(OSF.OUtil.checkFlight(OSF.FlightNames.AddinEnforceHttps)&&t&&"https:"!=o.protocol)throw new Error("NotHttps");var i=this.getRedundandPortString(e,o);r.protocol=o.protocol,r.hostname=o.hostname,r.port=""==i?o.port:"",r.host=""!=i?o.hostname:o.host,r.pathname=(n?"/":"")+o.pathname,r.search=o.search,r.hash=o.hash,r.isPortPartOfUrl=this.containsPort(e,o.protocol,o.hostname,o.port)}else{var a=new URL(e);if(a&&a.protocol&&a.host&&a.hostname){if(OSF.OUtil.checkFlight(OSF.FlightNames.AddinEnforceHttps)&&t&&"https:"!=a.protocol)throw new Error("NotHttps");r.protocol=a.protocol,r.hostname=a.hostname,r.port=a.port,r.host=a.host,r.pathname=a.pathname,r.search=a.search,r.hash=a.hash,r.isPortPartOfUrl=a.host.lastIndexOf(":"+a.port)==a.host.length-a.port.length-1}}}catch(e){if("NotHttps"===e.message)throw e}return r}},shallowCopy:function(e){if(null==e)return null;if(e instanceof Object){if(Array.isArray(e)){for(var t=[],n=0;n<e.length;n++)t.push(e[n]);return t}var r=e.constructor();for(var o in e)e.hasOwnProperty(o)&&(r[o]=e[o]);return r}return e},createObject:function(e){var t=null;if(e){t={};for(var n=e.length,r=0;r<n;r++)t[e[r].name]=e[r].value}return t},addClass:function(e,t){if(!OSF.OUtil.hasClass(e,t)){var n=e.getAttribute("class");n?e.setAttribute("class",n+" "+t):e.setAttribute("class",t)}},removeClass:function(e,t){if(OSF.OUtil.hasClass(e,t)){var n=e.getAttribute("class"),r=new RegExp("(\\s|^)"+t+"(\\s|$)");n=n.replace(r,""),e.setAttribute("class",n)}},hasClass:function(e,t){var n=e.getAttribute("class");return n&&n.match(new RegExp("(\\s|^)"+t+"(\\s|$)"))},focusToFirstTabbable:function(e,t){var n,r,o=!1,i=function(e){o=!0},a=function(e,t,n){return t<0||t>e||0===t&&n?-1:t!==e-1||n?n?t-1:t+1:-1};if(e=c(e),n=t?e.length-1:0,0===e.length)return null;for(;!o&&n>=0&&n<e.length;)r=e[n],window.focus(),r.addEventListener("focus",i),r.focus(),r.removeEventListener("focus",i),n=a(e.length,n,t),o||r!==document.activeElement||(o=!0);return o?r:null},focusToNextTabbable:function(e,t,n){var r,o,i,a=!1,s=function(e){a=!0},l=function(e,t,n){return t<0||t>e||0===t&&n?-1:t!==e-1||n?n?t-1:t+1:-1};if(r=function(e,t){for(var n=0;n<e.length;n++)if(e[n]===t)return n;return-1}(e=c(e),t),(o=l(e.length,r,n))<0)return null;for(;!a&&o>=0&&o<e.length;)(i=e[o]).addEventListener("focus",s),i.focus(),i.removeEventListener("focus",s),o=l(e.length,o,n),a||i!==document.activeElement||(a=!0);return a?i:null},isNullOrUndefined:function(e){return"undefined"===typeof e||null===e},stringEndsWith:function(e,t){if(!OSF.OUtil.isNullOrUndefined(e)&&!OSF.OUtil.isNullOrUndefined(t)){if(t.length>e.length)return!1;if(e.substr(e.length-t.length)===t)return!0}return!1},hashCode:function(e){var t=0;if(!OSF.OUtil.isNullOrUndefined(e))for(var n=0,r=e.length;n<r;)t=(t<<5)-t+e.charCodeAt(n++)|0;return t},getValue:function(e,t){return OSF.OUtil.isNullOrUndefined(e)?t:e},externalNativeFunctionExists:function(e){return"unknown"===e||"undefined"!==e}}}(),OSF.OUtil.Guid=function(){var e=["0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"];return{generateNewGuid:function(){for(var t="",n=(new Date).getTime(),r=0;r<32&&n>0;r++)8!=r&&12!=r&&16!=r&&20!=r||(t+="-"),t+=e[n%16],n=Math.floor(n/16);for(;r<32;r++)8!=r&&12!=r&&16!=r&&20!=r||(t+="-"),t+=e[Math.floor(16*Math.random())];return t}}}();try{!function(){OSF.Flights=OSF.OUtil.parseFlights(!0)}()}catch(e){}window.OSF=OSF,OSF.OUtil.setNamespace("OSF",window),OSF.MessageIDs={FetchBundleUrl:0,LoadReactBundle:1,LoadBundleSuccess:2,LoadBundleError:3},OSF.AppName={Unsupported:0,Excel:1,Word:2,PowerPoint:4,Outlook:8,ExcelWebApp:16,WordWebApp:32,OutlookWebApp:64,Project:128,AccessWebApp:256,PowerpointWebApp:512,ExcelIOS:1024,Sway:2048,WordIOS:4096,PowerPointIOS:8192,Access:16384,Lync:32768,OutlookIOS:65536,OneNoteWebApp:131072,OneNote:262144,ExcelWinRT:524288,WordWinRT:1048576,PowerpointWinRT:2097152,OutlookAndroid:4194304,OneNoteWinRT:8388608,ExcelAndroid:8388609,VisioWebApp:8388610,OneNoteIOS:8388611,WordAndroid:8388613,PowerpointAndroid:8388614,Visio:8388615,OneNoteAndroid:4194305},OSF.InternalPerfMarker={DataCoercionBegin:"Agave.HostCall.CoerceDataStart",DataCoercionEnd:"Agave.HostCall.CoerceDataEnd"},OSF.HostCallPerfMarker={IssueCall:"Agave.HostCall.IssueCall",ReceiveResponse:"Agave.HostCall.ReceiveResponse",RuntimeExceptionRaised:"Agave.HostCall.RuntimeExecptionRaised"},OSF.AgaveHostAction={Select:0,UnSelect:1,CancelDialog:2,InsertAgave:3,CtrlF6In:4,CtrlF6Exit:5,CtrlF6ExitShift:6,SelectWithError:7,NotifyHostError:8,RefreshAddinCommands:9,PageIsReady:10,TabIn:11,TabInShift:12,TabExit:13,TabExitShift:14,EscExit:15,F2Exit:16,ExitNoFocusable:17,ExitNoFocusableShift:18,MouseEnter:19,MouseLeave:20,UpdateTargetUrl:21,InstallCustomFunctions:22,SendTelemetryEvent:23,UninstallCustomFunctions:24,SendMessage:25,LaunchExtensionComponent:26,StopExtensionComponent:27,RestartExtensionComponent:28,EnableTaskPaneHeaderButton:29,DisableTaskPaneHeaderButton:30,TaskPaneHeaderButtonClicked:31,RemoveAppCommandsAddin:32,RefreshRibbonGallery:33,GetOriginalControlId:34,OfficeJsReady:35,InsertDevManifest:36,InsertDevManifestError:37,SendCustomerContent:38,KeyboardShortcuts:39},OSF.SharedConstants={NotificationConversationIdSuffix:"_ntf"},OSF.DialogMessageType={DialogMessageReceived:0,DialogParentMessageReceived:1,DialogClosed:12006},OSF.OfficeAppContext=function(e,t,n,r,o,i,a,s,c,l,u,p,f,d,h,m,g,y,O,_,b,v,S,A,D,P,I){this._id=e,this._appName=t,this._appVersion=n,this._appUILocale=r,this._dataLocale=o,this._docUrl=i,this._clientMode=a,this._settings=s,this._reason=c,this._osfControlType=l,this._eToken=u,this._correlationId=p,this._appInstanceId=f,this._touchEnabled=d,this._commerceAllowed=h,this._appMinorVersion=m,this._requirementMatrix=g,this._hostCustomMessage=y,this._hostFullVersion=O,this._isDialog=!1,this._clientWindowHeight=_,this._clientWindowWidth=b,this._addinName=v,this._appDomains=S,this._dialogRequirementMatrix=A,this._featureGates=D,this._officeTheme=P,this._initialDisplayMode=I,this.get_id=function(){return this._id},this.get_appName=function(){return this._appName},this.get_appVersion=function(){return this._appVersion},this.get_appUILocale=function(){return this._appUILocale},this.get_dataLocale=function(){return this._dataLocale},this.get_docUrl=function(){return this._docUrl},this.get_clientMode=function(){return this._clientMode},this.get_bindings=function(){return this._bindings},this.get_settings=function(){return this._settings},this.get_reason=function(){return this._reason},this.get_osfControlType=function(){return this._osfControlType},this.get_eToken=function(){return this._eToken},this.get_correlationId=function(){return this._correlationId},this.get_appInstanceId=function(){return this._appInstanceId},this.get_touchEnabled=function(){return this._touchEnabled},this.get_commerceAllowed=function(){return this._commerceAllowed},this.get_appMinorVersion=function(){return this._appMinorVersion},this.get_requirementMatrix=function(){return this._requirementMatrix},this.get_dialogRequirementMatrix=function(){return this._dialogRequirementMatrix},this.get_hostCustomMessage=function(){return this._hostCustomMessage},this.get_hostFullVersion=function(){return this._hostFullVersion},this.get_isDialog=function(){return this._isDialog},this.get_clientWindowHeight=function(){return this._clientWindowHeight},this.get_clientWindowWidth=function(){return this._clientWindowWidth},this.get_addinName=function(){return this._addinName},this.get_appDomains=function(){return this._appDomains},this.get_featureGates=function(){return this._featureGates},this.get_officeTheme=function(){return this._officeTheme},this.get_initialDisplayMode=function(){return this._initialDisplayMode?this._initialDisplayMode:0}},OSF.OsfControlType={DocumentLevel:0,ContainerLevel:1},OSF.ClientMode={ReadOnly:0,ReadWrite:1},OSF.OUtil.setNamespace("Microsoft",window),OSF.OUtil.setNamespace("Office",Microsoft),OSF.OUtil.setNamespace("Client",Microsoft.Office),OSF.OUtil.setNamespace("WebExtension",Microsoft.Office),Microsoft.Office.WebExtension.InitializationReason={Inserted:"inserted",DocumentOpened:"documentOpened",ControlActivation:"controlActivation"},Microsoft.Office.WebExtension.ValueFormat={Unformatted:"unformatted",Formatted:"formatted"},Microsoft.Office.WebExtension.FilterType={All:"all"},Microsoft.Office.WebExtension.Parameters={BindingType:"bindingType",CoercionType:"coercionType",ValueFormat:"valueFormat",FilterType:"filterType",Columns:"columns",SampleData:"sampleData",GoToType:"goToType",SelectionMode:"selectionMode",Id:"id",PromptText:"promptText",ItemName:"itemName",FailOnCollision:"failOnCollision",StartRow:"startRow",StartColumn:"startColumn",RowCount:"rowCount",ColumnCount:"columnCount",Callback:"callback",AsyncContext:"asyncContext",Data:"data",Rows:"rows",OverwriteIfStale:"overwriteIfStale",FileType:"fileType",EventType:"eventType",Handler:"handler",SliceSize:"sliceSize",SliceIndex:"sliceIndex",ActiveView:"activeView",Status:"status",PlatformType:"platformType",HostType:"hostType",ForceConsent:"forceConsent",ForceAddAccount:"forceAddAccount",AuthChallenge:"authChallenge",AllowConsentPrompt:"allowConsentPrompt",ForMSGraphAccess:"forMSGraphAccess",AllowSignInPrompt:"allowSignInPrompt",JsonPayload:"jsonPayload",EnableNewHosts:"enableNewHosts",AccountTypeFilter:"accountTypeFilter",AddinTrustId:"addinTrustId",Reserved:"reserved",Tcid:"tcid",Xml:"xml",Namespace:"namespace",Prefix:"prefix",XPath:"xPath",Text:"text",ImageLeft:"imageLeft",ImageTop:"imageTop",ImageWidth:"imageWidth",ImageHeight:"imageHeight",TaskId:"taskId",FieldId:"fieldId",FieldValue:"fieldValue",ServerUrl:"serverUrl",ListName:"listName",ResourceId:"resourceId",ViewType:"viewType",ViewName:"viewName",GetRawValue:"getRawValue",CellFormat:"cellFormat",TableOptions:"tableOptions",TaskIndex:"taskIndex",ResourceIndex:"resourceIndex",CustomFieldId:"customFieldId",Url:"url",MessageHandler:"messageHandler",Width:"width",Height:"height",RequireHTTPs:"requireHTTPS",MessageToParent:"messageToParent",DisplayInIframe:"displayInIframe",MessageContent:"messageContent",HideTitle:"hideTitle",UseDeviceIndependentPixels:"useDeviceIndependentPixels",PromptBeforeOpen:"promptBeforeOpen",EnforceAppDomain:"enforceAppDomain",UrlNoHostInfo:"urlNoHostInfo",TargetOrigin:"targetOrigin",AppCommandInvocationCompletedData:"appCommandInvocationCompletedData",Base64:"base64",FormId:"formId"},OSF.OUtil.setNamespace("DDA",OSF),OSF.DDA.DocumentMode={ReadOnly:1,ReadWrite:0},OSF.DDA.PropertyDescriptors={AsyncResultStatus:"AsyncResultStatus"},OSF.DDA.EventDescriptors={},OSF.DDA.ListDescriptors={},OSF.DDA.UI={},OSF.DDA.getXdmEventName=function(e,t){return t==Microsoft.Office.WebExtension.EventType.BindingSelectionChanged||t==Microsoft.Office.WebExtension.EventType.BindingDataChanged||t==Microsoft.Office.WebExtension.EventType.DataNodeDeleted||t==Microsoft.Office.WebExtension.EventType.DataNodeInserted||t==Microsoft.Office.WebExtension.EventType.DataNodeReplaced?e+"_"+t:t},OSF.DDA.MethodDispId={dispidMethodMin:64,dispidGetSelectedDataMethod:64,dispidSetSelectedDataMethod:65,dispidAddBindingFromSelectionMethod:66,dispidAddBindingFromPromptMethod:67,dispidGetBindingMethod:68,dispidReleaseBindingMethod:69,dispidGetBindingDataMethod:70,dispidSetBindingDataMethod:71,dispidAddRowsMethod:72,dispidClearAllRowsMethod:73,dispidGetAllBindingsMethod:74,dispidLoadSettingsMethod:75,dispidSaveSettingsMethod:76,dispidGetDocumentCopyMethod:77,dispidAddBindingFromNamedItemMethod:78,dispidAddColumnsMethod:79,dispidGetDocumentCopyChunkMethod:80,dispidReleaseDocumentCopyMethod:81,dispidNavigateToMethod:82,dispidGetActiveViewMethod:83,dispidGetDocumentThemeMethod:84,dispidGetOfficeThemeMethod:85,dispidGetFilePropertiesMethod:86,dispidClearFormatsMethod:87,dispidSetTableOptionsMethod:88,dispidSetFormatsMethod:89,dispidExecuteRichApiRequestMethod:93,dispidAppCommandInvocationCompletedMethod:94,dispidCloseContainerMethod:97,dispidGetAccessTokenMethod:98,dispidGetAuthContextMethod:99,dispidOpenBrowserWindow:102,dispidCreateDocumentMethod:105,dispidInsertFormMethod:106,dispidDisplayRibbonCalloutAsyncMethod:109,dispidGetSelectedTaskMethod:110,dispidGetSelectedResourceMethod:111,dispidGetTaskMethod:112,dispidGetResourceFieldMethod:113,dispidGetWSSUrlMethod:114,dispidGetTaskFieldMethod:115,dispidGetProjectFieldMethod:116,dispidGetSelectedViewMethod:117,dispidGetTaskByIndexMethod:118,dispidGetResourceByIndexMethod:119,dispidSetTaskFieldMethod:120,dispidSetResourceFieldMethod:121,dispidGetMaxTaskIndexMethod:122,dispidGetMaxResourceIndexMethod:123,dispidCreateTaskMethod:124,dispidAddDataPartMethod:128,dispidGetDataPartByIdMethod:129,dispidGetDataPartsByNamespaceMethod:130,dispidGetDataPartXmlMethod:131,dispidGetDataPartNodesMethod:132,dispidDeleteDataPartMethod:133,dispidGetDataNodeValueMethod:134,dispidGetDataNodeXmlMethod:135,dispidGetDataNodesMethod:136,dispidSetDataNodeValueMethod:137,dispidSetDataNodeXmlMethod:138,dispidAddDataNamespaceMethod:139,dispidGetDataUriByPrefixMethod:140,dispidGetDataPrefixByUriMethod:141,dispidGetDataNodeTextMethod:142,dispidSetDataNodeTextMethod:143,dispidMessageParentMethod:144,dispidSendMessageMethod:145,dispidExecuteFeature:146,dispidQueryFeature:147,dispidMethodMax:147},OSF.DDA.EventDispId={dispidEventMin:0,dispidInitializeEvent:0,dispidSettingsChangedEvent:1,dispidDocumentSelectionChangedEvent:2,dispidBindingSelectionChangedEvent:3,dispidBindingDataChangedEvent:4,dispidDocumentOpenEvent:5,dispidDocumentCloseEvent:6,dispidActiveViewChangedEvent:7,dispidDocumentThemeChangedEvent:8,dispidOfficeThemeChangedEvent:9,dispidDialogMessageReceivedEvent:10,dispidDialogNotificationShownInAddinEvent:11,dispidDialogParentMessageReceivedEvent:12,dispidObjectDeletedEvent:13,dispidObjectSelectionChangedEvent:14,dispidObjectDataChangedEvent:15,dispidContentControlAddedEvent:16,dispidActivationStatusChangedEvent:32,dispidRichApiMessageEvent:33,dispidAppCommandInvokedEvent:39,dispidOlkItemSelectedChangedEvent:46,dispidOlkRecipientsChangedEvent:47,dispidOlkAppointmentTimeChangedEvent:48,dispidOlkRecurrenceChangedEvent:49,dispidOlkAttachmentsChangedEvent:50,dispidOlkEnhancedLocationsChangedEvent:51,dispidOlkInfobarClickedEvent:52,dispidTaskSelectionChangedEvent:56,dispidResourceSelectionChangedEvent:57,dispidViewSelectionChangedEvent:58,dispidDataNodeAddedEvent:60,dispidDataNodeReplacedEvent:61,dispidDataNodeDeletedEvent:62,dispidEventMax:63},OSF.DDA.ErrorCodeManager=function(){var e={};return{getErrorArgs:function(t){var n=e[t];return n?(n.name||(n.name=e[this.errorCodes.ooeInternalError].name),n.message||(n.message=e[this.errorCodes.ooeInternalError].message)):n=e[this.errorCodes.ooeInternalError],n},addErrorMessage:function(t,n){e[t]=n},errorCodes:{ooeSuccess:0,ooeChunkResult:1,ooeCoercionTypeNotSupported:1e3,ooeGetSelectionNotMatchDataType:1001,ooeCoercionTypeNotMatchBinding:1002,ooeInvalidGetRowColumnCounts:1003,ooeSelectionNotSupportCoercionType:1004,ooeInvalidGetStartRowColumn:1005,ooeNonUniformPartialGetNotSupported:1006,ooeGetDataIsTooLarge:1008,ooeFileTypeNotSupported:1009,ooeGetDataParametersConflict:1010,ooeInvalidGetColumns:1011,ooeInvalidGetRows:1012,ooeInvalidReadForBlankRow:1013,ooeUnsupportedDataObject:2e3,ooeCannotWriteToSelection:2001,ooeDataNotMatchSelection:2002,ooeOverwriteWorksheetData:2003,ooeDataNotMatchBindingSize:2004,ooeInvalidSetStartRowColumn:2005,ooeInvalidDataFormat:2006,ooeDataNotMatchCoercionType:2007,ooeDataNotMatchBindingType:2008,ooeSetDataIsTooLarge:2009,ooeNonUniformPartialSetNotSupported:2010,ooeInvalidSetColumns:2011,ooeInvalidSetRows:2012,ooeSetDataParametersConflict:2013,ooeCellDataAmountBeyondLimits:2014,ooeSelectionCannotBound:3e3,ooeBindingNotExist:3002,ooeBindingToMultipleSelection:3003,ooeInvalidSelectionForBindingType:3004,ooeOperationNotSupportedOnThisBindingType:3005,ooeNamedItemNotFound:3006,ooeMultipleNamedItemFound:3007,ooeInvalidNamedItemForBindingType:3008,ooeUnknownBindingType:3009,ooeOperationNotSupportedOnMatrixData:3010,ooeInvalidColumnsForBinding:3011,ooeSettingNameNotExist:4e3,ooeSettingsCannotSave:4001,ooeSettingsAreStale:4002,ooeOperationNotSupported:5e3,ooeInternalError:5001,ooeDocumentReadOnly:5002,ooeEventHandlerNotExist:5003,ooeInvalidApiCallInContext:5004,ooeShuttingDown:5005,ooeUnsupportedEnumeration:5007,ooeIndexOutOfRange:5008,ooeBrowserAPINotSupported:5009,ooeInvalidParam:5010,ooeRequestTimeout:5011,ooeInvalidOrTimedOutSession:5012,ooeInvalidApiArguments:5013,ooeOperationCancelled:5014,ooeWorkbookHidden:5015,ooeWriteNotSupportedWhenModalDialogOpen:5016,ooeTooManyIncompleteRequests:5100,ooeRequestTokenUnavailable:5101,ooeActivityLimitReached:5102,ooeRequestPayloadSizeLimitExceeded:5103,ooeResponsePayloadSizeLimitExceeded:5104,ooeCustomXmlNodeNotFound:6e3,ooeCustomXmlError:6100,ooeCustomXmlExceedQuota:6101,ooeCustomXmlOutOfDate:6102,ooeNoCapability:7e3,ooeCannotNavTo:7001,ooeSpecifiedIdNotExist:7002,ooeNavOutOfBound:7004,ooeElementMissing:8e3,ooeProtectedError:8001,ooeInvalidCellsValue:8010,ooeInvalidTableOptionValue:8011,ooeInvalidFormatValue:8012,ooeRowIndexOutOfRange:8020,ooeColIndexOutOfRange:8021,ooeFormatValueOutOfRange:8022,ooeCellFormatAmountBeyondLimits:8023,ooeMemoryFileLimit:11e3,ooeNetworkProblemRetrieveFile:11001,ooeInvalidSliceSize:11002,ooeInvalidCallback:11101,ooeInvalidWidth:12e3,ooeInvalidHeight:12001,ooeNavigationError:12002,ooeInvalidScheme:12003,ooeAppDomains:12004,ooeRequireHTTPS:12005,ooeWebDialogClosed:12006,ooeDialogAlreadyOpened:12007,ooeEndUserAllow:12008,ooeEndUserIgnore:12009,ooeNotUILessDialog:12010,ooeCrossZone:12011,ooeModalDialogOpen:12012,ooeDocumentIsInactive:12013,ooeDialogParentIsMinimized:12014,ooeNotSSOAgave:13e3,ooeSSOUserNotSignedIn:13001,ooeSSOUserAborted:13002,ooeSSOUnsupportedUserIdentity:13003,ooeSSOInvalidResourceUrl:13004,ooeSSOInvalidGrant:13005,ooeSSOClientError:13006,ooeSSOServerError:13007,ooeAddinIsAlreadyRequestingToken:13008,ooeSSOUserConsentNotSupportedByCurrentAddinCategory:13009,ooeSSOConnectionLost:13010,ooeResourceNotAllowed:13011,ooeSSOUnsupportedPlatform:13012,ooeSSOCallThrottled:13013,ooeAccessDenied:13990,ooeGeneralException:13991},initializeErrorMessages:function(t){e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCoercionTypeNotSupported]={name:t.L_InvalidCoercion,message:t.L_CoercionTypeNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeGetSelectionNotMatchDataType]={name:t.L_DataReadError,message:t.L_GetSelectionNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCoercionTypeNotMatchBinding]={name:t.L_InvalidCoercion,message:t.L_CoercionTypeNotMatchBinding},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidGetRowColumnCounts]={name:t.L_DataReadError,message:t.L_InvalidGetRowColumnCounts},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSelectionNotSupportCoercionType]={name:t.L_DataReadError,message:t.L_SelectionNotSupportCoercionType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidGetStartRowColumn]={name:t.L_DataReadError,message:t.L_InvalidGetStartRowColumn},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNonUniformPartialGetNotSupported]={name:t.L_DataReadError,message:t.L_NonUniformPartialGetNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeGetDataIsTooLarge]={name:t.L_DataReadError,message:t.L_GetDataIsTooLarge},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeFileTypeNotSupported]={name:t.L_DataReadError,message:t.L_FileTypeNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeGetDataParametersConflict]={name:t.L_DataReadError,message:t.L_GetDataParametersConflict},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidGetColumns]={name:t.L_DataReadError,message:t.L_InvalidGetColumns},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidGetRows]={name:t.L_DataReadError,message:t.L_InvalidGetRows},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidReadForBlankRow]={name:t.L_DataReadError,message:t.L_InvalidReadForBlankRow},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeUnsupportedDataObject]={name:t.L_DataWriteError,message:t.L_UnsupportedDataObject},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCannotWriteToSelection]={name:t.L_DataWriteError,message:t.L_CannotWriteToSelection},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDataNotMatchSelection]={name:t.L_DataWriteError,message:t.L_DataNotMatchSelection},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeOverwriteWorksheetData]={name:t.L_DataWriteError,message:t.L_OverwriteWorksheetData},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDataNotMatchBindingSize]={name:t.L_DataWriteError,message:t.L_DataNotMatchBindingSize},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSetStartRowColumn]={name:t.L_DataWriteError,message:t.L_InvalidSetStartRowColumn},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidDataFormat]={name:t.L_InvalidFormat,message:t.L_InvalidDataFormat},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDataNotMatchCoercionType]={name:t.L_InvalidDataObject,message:t.L_DataNotMatchCoercionType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDataNotMatchBindingType]={name:t.L_InvalidDataObject,message:t.L_DataNotMatchBindingType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSetDataIsTooLarge]={name:t.L_DataWriteError,message:t.L_SetDataIsTooLarge},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNonUniformPartialSetNotSupported]={name:t.L_DataWriteError,message:t.L_NonUniformPartialSetNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSetColumns]={name:t.L_DataWriteError,message:t.L_InvalidSetColumns},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSetRows]={name:t.L_DataWriteError,message:t.L_InvalidSetRows},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSetDataParametersConflict]={name:t.L_DataWriteError,message:t.L_SetDataParametersConflict},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSelectionCannotBound]={name:t.L_BindingCreationError,message:t.L_SelectionCannotBound},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeBindingNotExist]={name:t.L_InvalidBindingError,message:t.L_BindingNotExist},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeBindingToMultipleSelection]={name:t.L_BindingCreationError,message:t.L_BindingToMultipleSelection},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSelectionForBindingType]={name:t.L_BindingCreationError,message:t.L_InvalidSelectionForBindingType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeOperationNotSupportedOnThisBindingType]={name:t.L_InvalidBindingOperation,message:t.L_OperationNotSupportedOnThisBindingType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNamedItemNotFound]={name:t.L_BindingCreationError,message:t.L_NamedItemNotFound},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeMultipleNamedItemFound]={name:t.L_BindingCreationError,message:t.L_MultipleNamedItemFound},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidNamedItemForBindingType]={name:t.L_BindingCreationError,message:t.L_InvalidNamedItemForBindingType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeUnknownBindingType]={name:t.L_InvalidBinding,message:t.L_UnknownBindingType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeOperationNotSupportedOnMatrixData]={name:t.L_InvalidBindingOperation,message:t.L_OperationNotSupportedOnMatrixData},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidColumnsForBinding]={name:t.L_InvalidBinding,message:t.L_InvalidColumnsForBinding},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSettingNameNotExist]={name:t.L_ReadSettingsError,message:t.L_SettingNameNotExist},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSettingsCannotSave]={name:t.L_SaveSettingsError,message:t.L_SettingsCannotSave},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSettingsAreStale]={name:t.L_SettingsStaleError,message:t.L_SettingsAreStale},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeOperationNotSupported]={name:t.L_HostError,message:t.L_OperationNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError]={name:t.L_InternalError,message:t.L_InternalErrorDescription},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDocumentReadOnly]={name:t.L_PermissionDenied,message:t.L_DocumentReadOnly},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeEventHandlerNotExist]={name:t.L_EventRegistrationError,message:t.L_EventHandlerNotExist},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidApiCallInContext]={name:t.L_InvalidAPICall,message:t.L_InvalidApiCallInContext},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeShuttingDown]={name:t.L_ShuttingDown,message:t.L_ShuttingDown},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeUnsupportedEnumeration]={name:t.L_UnsupportedEnumeration,message:t.L_UnsupportedEnumerationMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeIndexOutOfRange]={name:t.L_IndexOutOfRange,message:t.L_IndexOutOfRange},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeBrowserAPINotSupported]={name:t.L_APINotSupported,message:t.L_BrowserAPINotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeRequestTimeout]={name:t.L_APICallFailed,message:t.L_RequestTimeout},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidOrTimedOutSession]={name:t.L_InvalidOrTimedOutSession,message:t.L_InvalidOrTimedOutSessionMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidApiArguments]={name:t.L_APICallFailed,message:t.L_InvalidApiArgumentsMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeWorkbookHidden]={name:t.L_APICallFailed,message:t.L_WorkbookHiddenMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeWriteNotSupportedWhenModalDialogOpen]={name:t.L_APICallFailed,message:t.L_WriteNotSupportedWhenModalDialogOpen},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeTooManyIncompleteRequests]={name:t.L_APICallFailed,message:t.L_TooManyIncompleteRequests},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeRequestTokenUnavailable]={name:t.L_APICallFailed,message:t.L_RequestTokenUnavailable},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeActivityLimitReached]={name:t.L_APICallFailed,message:t.L_ActivityLimitReached},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeRequestPayloadSizeLimitExceeded]={name:t.L_APICallFailed,message:t.L_RequestPayloadSizeLimitExceededMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeResponsePayloadSizeLimitExceeded]={name:t.L_APICallFailed,message:t.L_ResponsePayloadSizeLimitExceededMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCustomXmlNodeNotFound]={name:t.L_InvalidNode,message:t.L_CustomXmlNodeNotFound},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCustomXmlError]={name:t.L_CustomXmlError,message:t.L_CustomXmlError},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCustomXmlExceedQuota]={name:t.L_CustomXmlExceedQuotaName,message:t.L_CustomXmlExceedQuotaMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCustomXmlOutOfDate]={name:t.L_CustomXmlOutOfDateName,message:t.L_CustomXmlOutOfDateMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNoCapability]={name:t.L_PermissionDenied,message:t.L_NoCapability},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCannotNavTo]={name:t.L_CannotNavigateTo,message:t.L_CannotNavigateTo},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSpecifiedIdNotExist]={name:t.L_SpecifiedIdNotExist,message:t.L_SpecifiedIdNotExist},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNavOutOfBound]={name:t.L_NavOutOfBound,message:t.L_NavOutOfBound},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCellDataAmountBeyondLimits]={name:t.L_DataWriteReminder,message:t.L_CellDataAmountBeyondLimits},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeElementMissing]={name:t.L_MissingParameter,message:t.L_ElementMissing},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeProtectedError]={name:t.L_PermissionDenied,message:t.L_NoCapability},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidCellsValue]={name:t.L_InvalidValue,message:t.L_InvalidCellsValue},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidTableOptionValue]={name:t.L_InvalidValue,message:t.L_InvalidTableOptionValue},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidFormatValue]={name:t.L_InvalidValue,message:t.L_InvalidFormatValue},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeRowIndexOutOfRange]={name:t.L_OutOfRange,message:t.L_RowIndexOutOfRange},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeColIndexOutOfRange]={name:t.L_OutOfRange,message:t.L_ColIndexOutOfRange},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeFormatValueOutOfRange]={name:t.L_OutOfRange,message:t.L_FormatValueOutOfRange},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCellFormatAmountBeyondLimits]={name:t.L_FormattingReminder,message:t.L_CellFormatAmountBeyondLimits},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeMemoryFileLimit]={name:t.L_MemoryLimit,message:t.L_CloseFileBeforeRetrieve},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNetworkProblemRetrieveFile]={name:t.L_NetworkProblem,message:t.L_NetworkProblemRetrieveFile},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSliceSize]={name:t.L_InvalidValue,message:t.L_SliceSizeNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDialogAlreadyOpened]={name:t.L_DisplayDialogError,message:t.L_DialogAlreadyOpened},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidWidth]={name:t.L_IndexOutOfRange,message:t.L_IndexOutOfRange},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidHeight]={name:t.L_IndexOutOfRange,message:t.L_IndexOutOfRange},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNavigationError]={name:t.L_DisplayDialogError,message:t.L_NetworkProblem},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidScheme]={name:t.L_DialogNavigateError,message:t.L_DialogInvalidScheme},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeAppDomains]={name:t.L_DisplayDialogError,message:t.L_DialogAddressNotTrusted},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeRequireHTTPS]={name:t.L_DisplayDialogError,message:t.L_DialogRequireHTTPS},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeEndUserIgnore]={name:t.L_DisplayDialogError,message:t.L_UserClickIgnore},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCrossZone]={name:t.L_DisplayDialogError,message:t.L_NewWindowCrossZoneErrorString},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeModalDialogOpen]={name:t.L_DisplayDialogError,message:t.L_ModalDialogOpen},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDocumentIsInactive]={name:t.L_DisplayDialogError,message:t.L_DocumentIsInactive},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDialogParentIsMinimized]={name:t.L_DisplayDialogError,message:t.L_DialogParentIsMinimized},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNotSSOAgave]={name:t.L_APINotSupported,message:t.L_InvalidSSOAddinMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUserNotSignedIn]={name:t.L_UserNotSignedIn,message:t.L_UserNotSignedIn},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUserAborted]={name:t.L_UserAborted,message:t.L_UserAbortedMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUnsupportedUserIdentity]={name:t.L_UnsupportedUserIdentity,message:t.L_UnsupportedUserIdentityMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOInvalidResourceUrl]={name:t.L_InvalidResourceUrl,message:t.L_InvalidResourceUrlMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOInvalidGrant]={name:t.L_InvalidGrant,message:t.L_InvalidGrantMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOClientError]={name:t.L_SSOClientError,message:t.L_SSOClientErrorMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOServerError]={name:t.L_SSOServerError,message:t.L_SSOServerErrorMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeAddinIsAlreadyRequestingToken]={name:t.L_AddinIsAlreadyRequestingToken,message:t.L_AddinIsAlreadyRequestingTokenMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUserConsentNotSupportedByCurrentAddinCategory]={name:t.L_SSOUserConsentNotSupportedByCurrentAddinCategory,message:t.L_SSOUserConsentNotSupportedByCurrentAddinCategoryMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOConnectionLost]={name:t.L_SSOConnectionLostError,message:t.L_SSOConnectionLostErrorMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUnsupportedPlatform]={name:t.L_APINotSupported,message:t.L_SSOUnsupportedPlatform},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOCallThrottled]={name:t.L_APICallFailed,message:t.L_RequestTokenUnavailable},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeOperationCancelled]={name:t.L_OperationCancelledError,message:t.L_OperationCancelledErrorMessage}}}}(),function(e){!function(e){var t=function(){return function(){}}();e.RequirementVersion=t;var n=function(){return function(e){this.isSetSupported=function(e,t){if(void 0==e)return!1;void 0==t&&(t=0);var n=this._setMap._sets;if(n.hasOwnProperty(e.toLowerCase())){var r=n[e.toLowerCase()];try{var o=this._getVersion(r);t+="";var i=this._getVersion(t);if(o.major>0&&o.major>i.major)return!0;if(o.major>0&&o.minor>=0&&o.major==i.major&&o.minor>=i.minor)return!0}catch(e){return!1}}return!1},this._getVersion=function(e){var t=(e+="").split("."),n=0,r=0;if(t.length<2&&isNaN(Number(e)))throw"version format incorrect";if(n=Number(t[0]),t.length>=2&&(r=Number(t[1])),isNaN(n)||isNaN(r))throw"version format incorrect";return{minor:r,major:n}},this._setMap=e,this.isSetSupported=this.isSetSupported.bind(this)}}();e.RequirementMatrix=n;var r=function(){return function(e){this._addSetMap=function(e){for(var t in e)this._sets[t]=e[t]},this._sets=e}}();e.DefaultSetRequirement=r;var o=function(e){function t(){return e.call(this,{dialogapi:1.1})||this}return __extends(t,e),t}(r);e.DefaultRequiredDialogSetRequirement=o;var i=function(e){function t(){return e.call(this,{dialogorigin:1.1})||this}return __extends(t,e),t}(r);e.DefaultOptionalDialogSetRequirement=i;var a=function(e){function t(){return e.call(this,{bindingevents:1.1,documentevents:1.1,excelapi:1.1,matrixbindings:1.1,matrixcoercion:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1})||this}return __extends(t,e),t}(r);e.ExcelClientDefaultSetRequirement=a;var s=function(e){function t(){var t=e.call(this)||this;return t._addSetMap({imagecoercion:1.1}),t}return __extends(t,e),t}(a);e.ExcelClientV1DefaultSetRequirement=s;var c=function(e){function t(){return e.call(this,{mailbox:1.3})||this}return __extends(t,e),t}(r);e.OutlookClientDefaultSetRequirement=c;var l=function(e){function t(){return e.call(this,{bindingevents:1.1,compressedfile:1.1,customxmlparts:1.1,documentevents:1.1,file:1.1,htmlcoercion:1.1,matrixbindings:1.1,matrixcoercion:1.1,ooxmlcoercion:1.1,pdffile:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1,textfile:1.1,wordapi:1.1})||this}return __extends(t,e),t}(r);e.WordClientDefaultSetRequirement=l;var u=function(e){function t(){var t=e.call(this)||this;return t._addSetMap({customxmlparts:1.2,wordapi:1.2,imagecoercion:1.1}),t}return __extends(t,e),t}(l);e.WordClientV1DefaultSetRequirement=u;var p=function(e){function t(){return e.call(this,{activeview:1.1,compressedfile:1.1,documentevents:1.1,file:1.1,pdffile:1.1,selection:1.1,settings:1.1,textcoercion:1.1})||this}return __extends(t,e),t}(r);e.PowerpointClientDefaultSetRequirement=p;var f=function(e){function t(){var t=e.call(this)||this;return t._addSetMap({imagecoercion:1.1}),t}return __extends(t,e),t}(p);e.PowerpointClientV1DefaultSetRequirement=f;var d=function(e){function t(){return e.call(this,{selection:1.1,textcoercion:1.1})||this}return __extends(t,e),t}(r);e.ProjectClientDefaultSetRequirement=d;var h=function(e){function t(){return e.call(this,{bindingevents:1.1,documentevents:1.1,matrixbindings:1.1,matrixcoercion:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1,file:1.1})||this}return __extends(t,e),t}(r);e.ExcelWebDefaultSetRequirement=h;var m=function(e){function t(){return e.call(this,{compressedfile:1.1,documentevents:1.1,file:1.1,imagecoercion:1.1,matrixcoercion:1.1,ooxmlcoercion:1.1,pdffile:1.1,selection:1.1,settings:1.1,tablecoercion:1.1,textcoercion:1.1,textfile:1.1})||this}return __extends(t,e),t}(r);e.WordWebDefaultSetRequirement=m;var g=function(e){function t(){return e.call(this,{activeview:1.1,settings:1.1})||this}return __extends(t,e),t}(r);e.PowerpointWebDefaultSetRequirement=g;var y=function(e){function t(){return e.call(this,{mailbox:1.3})||this}return __extends(t,e),t}(r);e.OutlookWebDefaultSetRequirement=y;var O=function(e){function t(){return e.call(this,{activeview:1.1,documentevents:1.1,selection:1.1,settings:1.1,textcoercion:1.1})||this}return __extends(t,e),t}(r);e.SwayWebDefaultSetRequirement=O;var _=function(e){function t(){return e.call(this,{bindingevents:1.1,partialtablebindings:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1})||this}return __extends(t,e),t}(r);e.AccessWebDefaultSetRequirement=_;var b=function(e){function t(){return e.call(this,{bindingevents:1.1,documentevents:1.1,matrixbindings:1.1,matrixcoercion:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1})||this}return __extends(t,e),t}(r);e.ExcelIOSDefaultSetRequirement=b;var v=function(e){function t(){return e.call(this,{bindingevents:1.1,compressedfile:1.1,customxmlparts:1.1,documentevents:1.1,file:1.1,htmlcoercion:1.1,matrixbindings:1.1,matrixcoercion:1.1,ooxmlcoercion:1.1,pdffile:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1,textfile:1.1})||this}return __extends(t,e),t}(r);e.WordIOSDefaultSetRequirement=v;var S=function(e){function t(){var t=e.call(this)||this;return t._addSetMap({customxmlparts:1.2,wordapi:1.2}),t}return __extends(t,e),t}(v);e.WordIOSV1DefaultSetRequirement=S;var A=function(e){function t(){return e.call(this,{activeview:1.1,compressedfile:1.1,documentevents:1.1,file:1.1,pdffile:1.1,selection:1.1,settings:1.1,textcoercion:1.1})||this}return __extends(t,e),t}(r);e.PowerpointIOSDefaultSetRequirement=A;var D=function(e){function t(){return e.call(this,{mailbox:1.1})||this}return __extends(t,e),t}(r);e.OutlookIOSDefaultSetRequirement=D;var P=function(){function e(){}return e.initializeOsfDda=function(){OSF.OUtil.setNamespace("Requirement",OSF.DDA)},e.getDefaultRequirementMatrix=function(t){this.initializeDefaultSetMatrix();var o=void 0,i=t.get_requirementMatrix();if(void 0!=i&&i.length>0&&"undefined"!==typeof JSON){var a=JSON.parse(t.get_requirementMatrix().toLowerCase());o=new n(new r(a))}else{var s=e.getClientFullVersionString(t);o=void 0!=e.DefaultSetArrayMatrix&&void 0!=e.DefaultSetArrayMatrix[s]?new n(e.DefaultSetArrayMatrix[s]):new n(new r({}))}return o},e.getDefaultDialogRequirementMatrix=function(e){var t=void 0,a=e.get_dialogRequirementMatrix();if(void 0!=a&&a.length>0&&"undefined"!==typeof JSON){var s=JSON.parse(e.get_requirementMatrix().toLowerCase());t=new r(s)}else{t=new o;var c=e.get_requirementMatrix();if(void 0!=c&&c.length>0&&"undefined"!==typeof JSON){s=JSON.parse(c.toLowerCase());for(var l in t._sets)s.hasOwnProperty(l)&&(t._sets[l]=s[l]);var u=new i;for(var l in u._sets)s.hasOwnProperty(l)&&(t._sets[l]=s[l])}}return new n(t)},e.getClientFullVersionString=function(e){var t=e.get_appMinorVersion(),n="",r="",o=e.get_appName();return(1024==o||4096==o||8192==o||65536==o)&&1==e.get_appVersion()?r=4096==o&&t>=15?"16.00.01":"16.00":64==e.get_appName()?r=e.get_appVersion():(n=t<10?"0"+t:""+t,r=e.get_appVersion()+"."+n),e.get_appName()+"-"+r},e.initializeDefaultSetMatrix=function(){e.DefaultSetArrayMatrix[e.Excel_RCLIENT_1600]=new a,e.DefaultSetArrayMatrix[e.Word_RCLIENT_1600]=new l,e.DefaultSetArrayMatrix[e.PowerPoint_RCLIENT_1600]=new p,e.DefaultSetArrayMatrix[e.Excel_RCLIENT_1601]=new s,e.DefaultSetArrayMatrix[e.Word_RCLIENT_1601]=new u,e.DefaultSetArrayMatrix[e.PowerPoint_RCLIENT_1601]=new f,e.DefaultSetArrayMatrix[e.Outlook_RCLIENT_1600]=new c,e.DefaultSetArrayMatrix[e.Excel_WAC_1600]=new h,e.DefaultSetArrayMatrix[e.Word_WAC_1600]=new m,e.DefaultSetArrayMatrix[e.Outlook_WAC_1600]=new y,e.DefaultSetArrayMatrix[e.Outlook_WAC_1601]=new y,e.DefaultSetArrayMatrix[e.Project_RCLIENT_1600]=new d,e.DefaultSetArrayMatrix[e.Access_WAC_1600]=new _,e.DefaultSetArrayMatrix[e.PowerPoint_WAC_1600]=new g,e.DefaultSetArrayMatrix[e.Excel_IOS_1600]=new b,e.DefaultSetArrayMatrix[e.SWAY_WAC_1600]=new O,e.DefaultSetArrayMatrix[e.Word_IOS_1600]=new v,e.DefaultSetArrayMatrix[e.Word_IOS_16001]=new S,e.DefaultSetArrayMatrix[e.PowerPoint_IOS_1600]=new A,e.DefaultSetArrayMatrix[e.Outlook_IOS_1600]=new D},e.Excel_RCLIENT_1600="1-16.00",e.Excel_RCLIENT_1601="1-16.01",e.Word_RCLIENT_1600="2-16.00",e.Word_RCLIENT_1601="2-16.01",e.PowerPoint_RCLIENT_1600="4-16.00",e.PowerPoint_RCLIENT_1601="4-16.01",e.Outlook_RCLIENT_1600="8-16.00",e.Excel_WAC_1600="16-16.00",e.Word_WAC_1600="32-16.00",e.Outlook_WAC_1600="64-16.00",e.Outlook_WAC_1601="64-16.01",e.Project_RCLIENT_1600="128-16.00",e.Access_WAC_1600="256-16.00",e.PowerPoint_WAC_1600="512-16.00",e.Excel_IOS_1600="1024-16.00",e.SWAY_WAC_1600="2048-16.00",e.Word_IOS_1600="4096-16.00",e.Word_IOS_16001="4096-16.00.01",e.PowerPoint_IOS_1600="8192-16.00",e.Outlook_IOS_1600="65536-16.00",e.DefaultSetArrayMatrix={},e}();e.RequirementsMatrixFactory=P}(e.Requirement||(e.Requirement={}))}(OfficeExt||(OfficeExt={})),OfficeExt.Requirement.RequirementsMatrixFactory.initializeOsfDda(),Microsoft.Office.WebExtension.ApplicationMode={WebEditor:"webEditor",WebViewer:"webViewer",Client:"client"},Microsoft.Office.WebExtension.DocumentMode={ReadOnly:"readOnly",ReadWrite:"readWrite"},OSF.NamespaceManager=function(){var e,t=!1;return{enableShortcut:function(){t||(window.Office?e=window.Office:OSF.OUtil.setNamespace("Office",window),window.Office=Microsoft.Office.WebExtension,t=!0)},disableShortcut:function(){t&&(e?window.Office=e:OSF.OUtil.unsetNamespace("Office",window),t=!1)}}}(),OSF.NamespaceManager.enableShortcut(),Microsoft.Office.WebExtension.useShortNamespace=function(e){e?OSF.NamespaceManager.enableShortcut():OSF.NamespaceManager.disableShortcut()},Microsoft.Office.WebExtension.select=function(e,t){var n;if(e&&"string"==typeof e){var r=e.indexOf("#");if(-1!=r){var o=e.substring(0,r),i=e.substring(r+1);switch(o){case"binding":case"bindings":i&&(n=new OSF.DDA.BindingPromise(i))}}}if(n)return n.onFail=t,n;if(t){var a=typeof t;if("function"!=a)throw OSF.OUtil.formatString(Strings.OfficeOM.L_CallbackNotAFunction,a);var s={};s[Microsoft.Office.WebExtension.Parameters.Callback]=t,OSF.DDA.issueAsyncResult(s,OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidApiCallInContext,OSF.DDA.ErrorCodeManager.getErrorArgs(OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidApiCallInContext))}},OSF.DDA.Context=function(e,t,n,r,o){if(OSF.OUtil.defineEnumerableProperties(this,{contentLanguage:{value:e.get_dataLocale()},displayLanguage:{value:e.get_appUILocale()},touchEnabled:{value:e.get_touchEnabled()},commerceAllowed:{value:e.get_commerceAllowed()},host:{value:OfficeExt.HostName.Host.getInstance().getHost()},platform:{value:OfficeExt.HostName.Host.getInstance().getPlatform()},isDialog:{value:OSF._OfficeAppFactory.getHostInfo().isDialog},diagnostics:{value:OfficeExt.HostName.Host.getInstance().getDiagnostics(e.get_hostFullVersion())}}),n&&OSF.OUtil.defineEnumerableProperty(this,"license",{value:n}),e.ui&&OSF.OUtil.defineEnumerableProperty(this,"ui",{value:e.ui}),e.auth&&OSF.OUtil.defineEnumerableProperty(this,"auth",{value:e.auth}),e.webAuth&&OSF.OUtil.defineEnumerableProperty(this,"webAuth",{value:e.webAuth}),e.application&&OSF.OUtil.defineEnumerableProperty(this,"application",{value:e.application}),e.extensionLifeCycle&&OSF.OUtil.defineEnumerableProperty(this,"extensionLifeCycle",{value:e.extensionLifeCycle}),e.messaging&&OSF.OUtil.defineEnumerableProperty(this,"messaging",{value:e.messaging}),e.ui&&e.ui.taskPaneAction&&OSF.OUtil.defineEnumerableProperty(this,"taskPaneAction",{value:e.ui.taskPaneAction}),e.ui&&e.ui.ribbonGallery&&OSF.OUtil.defineEnumerableProperty(this,"ribbonGallery",{value:e.ui.ribbonGallery}),e.get_isDialog()){var i=OfficeExt.Requirement.RequirementsMatrixFactory.getDefaultDialogRequirementMatrix(e);OSF.OUtil.defineEnumerableProperty(this,"requirements",{value:i})}else{if(t&&OSF.OUtil.defineEnumerableProperty(this,"document",{value:t}),r){var a=r.displayName||"appOM";delete r.displayName,OSF.OUtil.defineEnumerableProperty(this,a,{value:r})}e.get_officeTheme()?OSF.OUtil.defineEnumerableProperty(this,"officeTheme",{get:function(){return e.get_officeTheme()}}):o&&OSF.OUtil.defineEnumerableProperty(this,"officeTheme",{get:function(){return o()}});i=OfficeExt.Requirement.RequirementsMatrixFactory.getDefaultRequirementMatrix(e);OSF.OUtil.defineEnumerableProperty(this,"requirements",{value:i})}},OSF.DDA.OutlookContext=function(e,t,n,r,o){OSF.DDA.OutlookContext.uber.constructor.call(this,e,null,n,r,o),t&&OSF.OUtil.defineEnumerableProperty(this,"roamingSettings",{value:t})},OSF.OUtil.extend(OSF.DDA.OutlookContext,OSF.DDA.Context),OSF.DDA.OutlookAppOm=function(e,t,n){},OSF.DDA.Application=function(e){},OSF.DDA.Document=function(e,t){var n;switch(e.get_clientMode()){case OSF.ClientMode.ReadOnly:n=Microsoft.Office.WebExtension.DocumentMode.ReadOnly;break;case OSF.ClientMode.ReadWrite:n=Microsoft.Office.WebExtension.DocumentMode.ReadWrite}t&&OSF.OUtil.defineEnumerableProperty(this,"settings",{value:t}),OSF.OUtil.defineMutableProperties(this,{mode:{value:n},url:{value:e.get_docUrl()}})},OSF.DDA.JsomDocument=function(e,t,n){OSF.DDA.JsomDocument.uber.constructor.call(this,e,n),t&&OSF.OUtil.defineEnumerableProperty(this,"bindings",{get:function(){return t}});var r=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[r.GetSelectedDataAsync,r.SetSelectedDataAsync]),OSF.DDA.DispIdHost.addEventSupport(this,new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.DocumentSelectionChanged]))},OSF.OUtil.extend(OSF.DDA.JsomDocument,OSF.DDA.Document),OSF.OUtil.defineEnumerableProperty(Microsoft.Office.WebExtension,"context",{get:function(){var e;return OSF&&OSF._OfficeAppFactory&&(e=OSF._OfficeAppFactory.getContext()),e}}),OSF.DDA.License=function(e){OSF.OUtil.defineEnumerableProperty(this,"value",{value:e})},OSF.DDA.ApiMethodCall=function(e,t,n,r,o){var i=e.length,a=OSF.OUtil.delayExecutionAndCache((function(){return OSF.OUtil.formatString(Strings.OfficeOM.L_InvalidParameters,o)}));this.verifyArguments=function(e,t){for(var n in e){var r=e[n],o=t[n];if(r.enum)switch(typeof o){case"string":if(OSF.OUtil.listContainsValue(r.enum,o))break;case"undefined":throw OSF.DDA.ErrorCodeManager.errorCodes.ooeUnsupportedEnumeration;default:throw a()}if(r.types&&!OSF.OUtil.listContainsValue(r.types,typeof o))throw a()}},this.extractRequiredArguments=function(t,n,r){if(t.length<i)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_MissingRequiredArguments);var o,s=[];for(o=0;o<i;o++)s.push(t[o]);this.verifyArguments(e,s);var c={};for(o=0;o<i;o++){var l=e[o],u=s[o];if(l.verify)if(!l.verify(u,n,r))throw a();c[l.name]=u}return c},this.fillOptions=function(e,n,r,o){for(var i in e=e||{},t)if(!OSF.OUtil.listContainsKey(e,i)){var a=void 0,s=t[i];s.calculate&&n&&(a=s.calculate(n,r,o)),a||void 0===s.defaultValue||(a=s.defaultValue),e[i]=a}return e},this.constructCallArgs=function(e,t,o,i){var a={};for(var s in e)a[s]=e[s];for(var c in t)a[c]=t[c];for(var l in n)a[l]=n[l](o,i);return r&&(a=r(a,o,i)),a}},OSF.OUtil.setNamespace("AsyncResultEnum",OSF.DDA),OSF.DDA.AsyncResultEnum.Properties={Context:"Context",Value:"Value",Status:"Status",Error:"Error"},Microsoft.Office.WebExtension.AsyncResultStatus={Succeeded:"succeeded",Failed:"failed"},OSF.DDA.AsyncResultEnum.ErrorCode={Success:0,Failed:1},OSF.DDA.AsyncResultEnum.ErrorProperties={Name:"Name",Message:"Message",Code:"Code"},OSF.DDA.AsyncMethodNames={},OSF.DDA.AsyncMethodNames.addNames=function(e){for(var t in e){var n={};OSF.OUtil.defineEnumerableProperties(n,{id:{value:t},displayName:{value:e[t]}}),OSF.DDA.AsyncMethodNames[t]=n}},OSF.DDA.AsyncMethodCall=function(e,t,n,r,o,i,a){var s=e.length,c=new OSF.DDA.ApiMethodCall(e,t,n,i,a);this.verifyAndExtractCall=function(e,n,r){var o=c.extractRequiredArguments(e,n,r),i=function(e,n,r,o){if(e.length>s+2)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyArguments);for(var i,a,l=e.length-1;l>=s;l--){var u=e[l];switch(typeof u){case"object":if(i)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyOptionalObjects);i=u;break;case"function":if(a)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyOptionalFunction);a=u;break;default:throw OsfMsAjaxFactory.msAjaxError.argument(Strings.OfficeOM.L_InValidOptionalArgument)}}if(i=c.fillOptions(i,n,r,o),a){if(i[Microsoft.Office.WebExtension.Parameters.Callback])throw Strings.OfficeOM.L_RedundantCallbackSpecification;i[Microsoft.Office.WebExtension.Parameters.Callback]=a}return c.verifyArguments(t,i),i}(e,o,n,r);return c.constructCallArgs(o,i,n,r)},this.processResponse=function(e,t,n,i){return e==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess?r?r(t,n,i):t:o?o(e,t):OSF.DDA.ErrorCodeManager.getErrorArgs(e)},this.getCallArgs=function(e){for(var t,n,r=e.length-1;r>=s;r--){var o=e[r];switch(typeof o){case"object":t=o;break;case"function":n=o}}return t=t||{},n&&(t[Microsoft.Office.WebExtension.Parameters.Callback]=n),t}},OSF.DDA.AsyncMethodCallFactory=function(){return{manufacture:function(e){var t=e.supportedOptions?OSF.OUtil.createObject(e.supportedOptions):[],n=e.privateStateCallbacks?OSF.OUtil.createObject(e.privateStateCallbacks):[];return new OSF.DDA.AsyncMethodCall(e.requiredArguments||[],t,n,e.onSucceeded,e.onFailed,e.checkCallArgs,e.method.displayName)}}}(),OSF.DDA.AsyncMethodCalls={},OSF.DDA.AsyncMethodCalls.define=function(e){OSF.DDA.AsyncMethodCalls[e.method.id]=OSF.DDA.AsyncMethodCallFactory.manufacture(e)},OSF.DDA.Error=function(e,t,n){OSF.OUtil.defineEnumerableProperties(this,{name:{value:e},message:{value:t},code:{value:n}})},OSF.DDA.AsyncResult=function(e,t){OSF.OUtil.defineEnumerableProperties(this,{value:{value:e[OSF.DDA.AsyncResultEnum.Properties.Value]},status:{value:t?Microsoft.Office.WebExtension.AsyncResultStatus.Failed:Microsoft.Office.WebExtension.AsyncResultStatus.Succeeded}}),e[OSF.DDA.AsyncResultEnum.Properties.Context]&&OSF.OUtil.defineEnumerableProperty(this,"asyncContext",{value:e[OSF.DDA.AsyncResultEnum.Properties.Context]}),t&&OSF.OUtil.defineEnumerableProperty(this,"error",{value:new OSF.DDA.Error(t[OSF.DDA.AsyncResultEnum.ErrorProperties.Name],t[OSF.DDA.AsyncResultEnum.ErrorProperties.Message],t[OSF.DDA.AsyncResultEnum.ErrorProperties.Code])})},OSF.DDA.issueAsyncResult=function(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.Callback];if(r){var o,i={};i[OSF.DDA.AsyncResultEnum.Properties.Context]=e[Microsoft.Office.WebExtension.Parameters.AsyncContext],t==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess?i[OSF.DDA.AsyncResultEnum.Properties.Value]=n:(o={},n=n||OSF.DDA.ErrorCodeManager.getErrorArgs(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError),o[OSF.DDA.AsyncResultEnum.ErrorProperties.Code]=t||OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError,o[OSF.DDA.AsyncResultEnum.ErrorProperties.Name]=n.name||n,o[OSF.DDA.AsyncResultEnum.ErrorProperties.Message]=n.message||n),r(new OSF.DDA.AsyncResult(i,o))}},OSF.DDA.SyncMethodNames={},OSF.DDA.SyncMethodNames.addNames=function(e){for(var t in e){var n={};OSF.OUtil.defineEnumerableProperties(n,{id:{value:t},displayName:{value:e[t]}}),OSF.DDA.SyncMethodNames[t]=n}},OSF.DDA.SyncMethodCall=function(e,t,n,r,o){var i=e.length,a=new OSF.DDA.ApiMethodCall(e,t,n,r,o);this.verifyAndExtractCall=function(e,n,r){var o=a.extractRequiredArguments(e,n,r),s=function(e,n,r,o){if(e.length>i+1)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyArguments);for(var s,c=e.length-1;c>=i;c--){var l=e[c];switch(typeof l){case"object":if(s)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyOptionalObjects);s=l;break;default:throw OsfMsAjaxFactory.msAjaxError.argument(Strings.OfficeOM.L_InValidOptionalArgument)}}return s=a.fillOptions(s,n,r,o),a.verifyArguments(t,s),s}(e,o,n,r);return a.constructCallArgs(o,s,n,r)}},OSF.DDA.SyncMethodCallFactory=function(){return{manufacture:function(e){var t=e.supportedOptions?OSF.OUtil.createObject(e.supportedOptions):[];return new OSF.DDA.SyncMethodCall(e.requiredArguments||[],t,e.privateStateCallbacks,e.checkCallArgs,e.method.displayName)}}}(),OSF.DDA.SyncMethodCalls={},OSF.DDA.SyncMethodCalls.define=function(e){OSF.DDA.SyncMethodCalls[e.method.id]=OSF.DDA.SyncMethodCallFactory.manufacture(e)},OSF.DDA.ListType=function(){var e={};return{setListType:function(t,n){e[t]=n},isListType:function(t){return OSF.OUtil.listContainsKey(e,t)},getDescriptor:function(t){return e[t]}}}(),OSF.DDA.HostParameterMap=function(e,t){var n={};function r(o,i){var a=o?{}:void 0;for(var s in o){var c,l=o[s];if(OSF.DDA.ListType.isListType(s))for(var u in c=[],l)c.push(r(l[u],i));else if(OSF.OUtil.listContainsKey(n,s))c=n[s][i](l);else if("fromHost"==i&&e.preserveNesting(s))c=r(l,i);else{var p=t[s];if(p){var f=p[i];f&&void 0===(c=f[l])&&(c=l)}else c=l}a[s]=c}return a}function o(n,o,i){var a,s=t[n][i];if("toHost"==i)a=function n(r,o){var i;for(var a in o){var s;if(void 0!=(s=e.isComplexType(a)?n(r,t[a].toHost):r[a])){i||(i={});var c=o[a];"self"==c&&(c=a),i[c]=e.pack(a,s)}}return i}(r(o,i),s);else if("fromHost"==i){a=r(function n(r,o,i){for(var a in i||(i={}),o){var s,c,l=o[a];if("self"==l)s=r;else{if("sourceData"==l){i[a]=r.toArray();continue}s=r[l]}if(null===s||void 0===s)i[a]=void 0;else if(s=e.unpack(a,s),e.isComplexType(a))c=t[a].fromHost,e.preserveNesting(a)?i[a]=n(s,c):n(s,c,i);else if(OSF.DDA.ListType.isListType(a)){(c={})[OSF.DDA.ListType.getDescriptor(a)]="self";var u=new Array(s.length);for(var p in s)u[p]=n(s[p],c);i[a]=u}else i[a]=s}return i}(o,s),i)}return a}n[Microsoft.Office.WebExtension.Parameters.Data]={toHost:function(e){if(null!=e&&void 0!==e.rows){var t={};t[OSF.DDA.TableDataProperties.TableRows]=e.rows,t[OSF.DDA.TableDataProperties.TableHeaders]=e.headers,e=t}return e},fromHost:function(e){return e}},n[Microsoft.Office.WebExtension.Parameters.SampleData]=n[Microsoft.Office.WebExtension.Parameters.Data],t||(t={}),this.addMapping=function(e,n){var r,o;if(n.map)for(var i in o={},r=n.map){var a=r[i];"self"==a&&(a=i),o[a]=i}else r=n.toHost,o=n.fromHost;var s=t[e];if(s){var c=s.toHost;for(var l in c)r[l]=c[l];for(var u in c=s.fromHost)o[u]=c[u]}else s=t[e]={};s.toHost=r,s.fromHost=o},this.toHost=function(e,t){return o(e,t,"toHost")},this.fromHost=function(e,t){return o(e,t,"fromHost")},this.self="self",this.sourceData="sourceData",this.addComplexType=function(t){e.addComplexType(t)},this.getDynamicType=function(t){return e.getDynamicType(t)},this.setDynamicType=function(t,n){e.setDynamicType(t,n)},this.dynamicTypes=n,this.doMapValues=function(e,t){return r(e,t)}},OSF.DDA.SpecialProcessor=function(e,t){this.addComplexType=function(t){e.push(t)},this.getDynamicType=function(e){return t[e]},this.setDynamicType=function(e,n){t[e]=n},this.isComplexType=function(t){return OSF.OUtil.listContainsValue(e,t)},this.isDynamicType=function(e){return OSF.OUtil.listContainsKey(t,e)},this.preserveNesting=function(e){var t=[];return OSF.DDA.PropertyDescriptors&&t.push(OSF.DDA.PropertyDescriptors.Subset),OSF.DDA.DataNodeEventProperties&&(t=t.concat([OSF.DDA.DataNodeEventProperties.OldNode,OSF.DDA.DataNodeEventProperties.NewNode,OSF.DDA.DataNodeEventProperties.NextSiblingNode])),OSF.OUtil.listContainsValue(t,e)},this.pack=function(e,n){return this.isDynamicType(e)?t[e].toHost(n):n},this.unpack=function(e,n){return this.isDynamicType(e)?t[e].fromHost(n):n}},OSF.DDA.getDecoratedParameterMap=function(e,t){var n=new OSF.DDA.HostParameterMap(e);n.self;function r(e){var t=null;if(e){t={};for(var n=e.length,r=0;r<n;r++)t[e[r].name]=e[r].value}return t}for(var o in n.define=function(e){var t={},o=r(e.toHost);e.invertible?t.map=o:e.canonical?t.toHost=t.fromHost=o:(t.toHost=o,t.fromHost=r(e.fromHost)),n.addMapping(e.type,t),e.isComplexType&&n.addComplexType(e.type)},t)n.define(t[o]);return n},OSF.OUtil.setNamespace("DispIdHost",OSF.DDA),OSF.DDA.DispIdHost.Methods={InvokeMethod:"invokeMethod",AddEventHandler:"addEventHandler",RemoveEventHandler:"removeEventHandler",OpenDialog:"openDialog",CloseDialog:"closeDialog",MessageParent:"messageParent",SendMessage:"sendMessage"},OSF.DDA.DispIdHost.Delegates={ExecuteAsync:"executeAsync",RegisterEventAsync:"registerEventAsync",UnregisterEventAsync:"unregisterEventAsync",ParameterMap:"parameterMap",OpenDialog:"openDialog",CloseDialog:"closeDialog",MessageParent:"messageParent",SendMessage:"sendMessage"},OSF.DDA.DispIdHost.Facade=function(e,t){var n={},r=OSF.DDA.AsyncMethodNames,o=OSF.DDA.MethodDispId,i={GoToByIdAsync:o.dispidNavigateToMethod,GetSelectedDataAsync:o.dispidGetSelectedDataMethod,SetSelectedDataAsync:o.dispidSetSelectedDataMethod,GetDocumentCopyChunkAsync:o.dispidGetDocumentCopyChunkMethod,ReleaseDocumentCopyAsync:o.dispidReleaseDocumentCopyMethod,GetDocumentCopyAsync:o.dispidGetDocumentCopyMethod,AddFromSelectionAsync:o.dispidAddBindingFromSelectionMethod,AddFromPromptAsync:o.dispidAddBindingFromPromptMethod,AddFromNamedItemAsync:o.dispidAddBindingFromNamedItemMethod,GetAllAsync:o.dispidGetAllBindingsMethod,GetByIdAsync:o.dispidGetBindingMethod,ReleaseByIdAsync:o.dispidReleaseBindingMethod,GetDataAsync:o.dispidGetBindingDataMethod,SetDataAsync:o.dispidSetBindingDataMethod,AddRowsAsync:o.dispidAddRowsMethod,AddColumnsAsync:o.dispidAddColumnsMethod,DeleteAllDataValuesAsync:o.dispidClearAllRowsMethod,RefreshAsync:o.dispidLoadSettingsMethod,SaveAsync:o.dispidSaveSettingsMethod,GetActiveViewAsync:o.dispidGetActiveViewMethod,GetFilePropertiesAsync:o.dispidGetFilePropertiesMethod,GetOfficeThemeAsync:o.dispidGetOfficeThemeMethod,GetDocumentThemeAsync:o.dispidGetDocumentThemeMethod,ClearFormatsAsync:o.dispidClearFormatsMethod,SetTableOptionsAsync:o.dispidSetTableOptionsMethod,SetFormatsAsync:o.dispidSetFormatsMethod,GetAccessTokenAsync:o.dispidGetAccessTokenMethod,GetAuthContextAsync:o.dispidGetAuthContextMethod,ExecuteRichApiRequestAsync:o.dispidExecuteRichApiRequestMethod,AppCommandInvocationCompletedAsync:o.dispidAppCommandInvocationCompletedMethod,CloseContainerAsync:o.dispidCloseContainerMethod,OpenBrowserWindow:o.dispidOpenBrowserWindow,CreateDocumentAsync:o.dispidCreateDocumentMethod,InsertFormAsync:o.dispidInsertFormMethod,ExecuteFeature:o.dispidExecuteFeature,QueryFeature:o.dispidQueryFeature,AddDataPartAsync:o.dispidAddDataPartMethod,GetDataPartByIdAsync:o.dispidGetDataPartByIdMethod,GetDataPartsByNameSpaceAsync:o.dispidGetDataPartsByNamespaceMethod,GetPartXmlAsync:o.dispidGetDataPartXmlMethod,GetPartNodesAsync:o.dispidGetDataPartNodesMethod,DeleteDataPartAsync:o.dispidDeleteDataPartMethod,GetNodeValueAsync:o.dispidGetDataNodeValueMethod,GetNodeXmlAsync:o.dispidGetDataNodeXmlMethod,GetRelativeNodesAsync:o.dispidGetDataNodesMethod,SetNodeValueAsync:o.dispidSetDataNodeValueMethod,SetNodeXmlAsync:o.dispidSetDataNodeXmlMethod,AddDataPartNamespaceAsync:o.dispidAddDataNamespaceMethod,GetDataPartNamespaceAsync:o.dispidGetDataUriByPrefixMethod,GetDataPartPrefixAsync:o.dispidGetDataPrefixByUriMethod,GetNodeTextAsync:o.dispidGetDataNodeTextMethod,SetNodeTextAsync:o.dispidSetDataNodeTextMethod,GetSelectedTask:o.dispidGetSelectedTaskMethod,GetTask:o.dispidGetTaskMethod,GetWSSUrl:o.dispidGetWSSUrlMethod,GetTaskField:o.dispidGetTaskFieldMethod,GetSelectedResource:o.dispidGetSelectedResourceMethod,GetResourceField:o.dispidGetResourceFieldMethod,GetProjectField:o.dispidGetProjectFieldMethod,GetSelectedView:o.dispidGetSelectedViewMethod,GetTaskByIndex:o.dispidGetTaskByIndexMethod,GetResourceByIndex:o.dispidGetResourceByIndexMethod,SetTaskField:o.dispidSetTaskFieldMethod,SetResourceField:o.dispidSetResourceFieldMethod,GetMaxTaskIndex:o.dispidGetMaxTaskIndexMethod,GetMaxResourceIndex:o.dispidGetMaxResourceIndexMethod,CreateTask:o.dispidCreateTaskMethod};for(var a in i)r[a]&&(n[r[a].id]=i[a]);r=OSF.DDA.SyncMethodNames;var s={MessageParent:(o=OSF.DDA.MethodDispId).dispidMessageParentMethod,SendMessage:o.dispidSendMessageMethod};for(var a in s)r[a]&&(n[r[a].id]=s[a]);r=Microsoft.Office.WebExtension.EventType;var c={SettingsChanged:(o=OSF.DDA.EventDispId).dispidSettingsChangedEvent,DocumentSelectionChanged:o.dispidDocumentSelectionChangedEvent,BindingSelectionChanged:o.dispidBindingSelectionChangedEvent,BindingDataChanged:o.dispidBindingDataChangedEvent,ActiveViewChanged:o.dispidActiveViewChangedEvent,OfficeThemeChanged:o.dispidOfficeThemeChangedEvent,DocumentThemeChanged:o.dispidDocumentThemeChangedEvent,AppCommandInvoked:o.dispidAppCommandInvokedEvent,DialogMessageReceived:o.dispidDialogMessageReceivedEvent,DialogParentMessageReceived:o.dispidDialogParentMessageReceivedEvent,ObjectDeleted:o.dispidObjectDeletedEvent,ObjectSelectionChanged:o.dispidObjectSelectionChangedEvent,ObjectDataChanged:o.dispidObjectDataChangedEvent,ContentControlAdded:o.dispidContentControlAddedEvent,RichApiMessage:o.dispidRichApiMessageEvent,ItemChanged:o.dispidOlkItemSelectedChangedEvent,RecipientsChanged:o.dispidOlkRecipientsChangedEvent,AppointmentTimeChanged:o.dispidOlkAppointmentTimeChangedEvent,RecurrenceChanged:o.dispidOlkRecurrenceChangedEvent,AttachmentsChanged:o.dispidOlkAttachmentsChangedEvent,EnhancedLocationsChanged:o.dispidOlkEnhancedLocationsChangedEvent,InfobarClicked:o.dispidOlkInfobarClickedEvent,TaskSelectionChanged:o.dispidTaskSelectionChangedEvent,ResourceSelectionChanged:o.dispidResourceSelectionChangedEvent,ViewSelectionChanged:o.dispidViewSelectionChangedEvent,DataNodeInserted:o.dispidDataNodeAddedEvent,DataNodeReplaced:o.dispidDataNodeReplacedEvent,DataNodeDeleted:o.dispidDataNodeDeletedEvent};for(var l in c)r[l]&&(n[r[l]]=c[l]);function u(e){return e==OSF.DDA.EventDispId.dispidObjectDeletedEvent||e==OSF.DDA.EventDispId.dispidObjectSelectionChangedEvent||e==OSF.DDA.EventDispId.dispidObjectDataChangedEvent||e==OSF.DDA.EventDispId.dispidContentControlAddedEvent}function p(e,t,n,r){if("number"!=typeof e)throw e;r||(r=t.getCallArgs(n)),OSF.DDA.issueAsyncResult(r,e,OSF.DDA.ErrorCodeManager.getErrorArgs(e))}this[OSF.DDA.DispIdHost.Methods.InvokeMethod]=function(r,o,i,a){var s;try{var c=r.id,l=OSF.DDA.AsyncMethodCalls[c];s=l.verifyAndExtractCall(o,i,a);var u=n[c],f=e(c),d=null;if(window.Excel&&window.Office.context.requirements.isSetSupported("RedirectV1Api")&&(window.Excel._RedirectV1APIs=!0),window.Excel&&window.Excel._RedirectV1APIs&&(d=window.Excel._V1APIMap[c])){var h=OSF.OUtil.shallowCopy(s);delete h[Microsoft.Office.WebExtension.Parameters.AsyncContext],d.preprocess&&(h=d.preprocess(h));var m=new window.Excel.RequestContext,g=d.call(m,h);m.sync().then((function(){var e=g.value,t=e.status;delete e.status,delete e["@odata.type"],d.postprocess&&(e=d.postprocess(e,h)),0!=t&&(e=OSF.DDA.ErrorCodeManager.getErrorArgs(t)),OSF.DDA.issueAsyncResult(s,t,e)})).catch((function(e){OSF.DDA.issueAsyncResult(s,OSF.DDA.ErrorCodeManager.errorCodes.ooeFailure,null)}))}else{var y;y=t.toHost?t.toHost(u,s):s;var O=(new Date).getTime();f[OSF.DDA.DispIdHost.Delegates.ExecuteAsync]({dispId:u,hostCallArgs:y,onCalling:function(){},onReceiving:function(){},onComplete:function(e,n){var r;r=e==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess&&t.fromHost?t.fromHost(u,n):n;var o=l.processResponse(e,r,i,s);OSF.DDA.issueAsyncResult(s,e,o),!OSF.AppTelemetry||OSF.ConstantNames&&OSF.ConstantNames.IsCustomFunctionsRuntime||OSF.AppTelemetry.onMethodDone(u,y,Math.abs((new Date).getTime()-O),e)}})}}catch(e){p(e,l,o,s)}},this[OSF.DDA.DispIdHost.Methods.AddEventHandler]=function(r,o,i,a){var s,c,l,f=!1;function d(e){var t;e==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess&&((f?o.addObjectEventHandler(c,s[Microsoft.Office.WebExtension.Parameters.Id],l):o.addEventHandler(c,l))||(e=OSF.DDA.ErrorCodeManager.errorCodes.ooeEventHandlerAdditionFailed));e!=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess&&(t=OSF.DDA.ErrorCodeManager.getErrorArgs(e)),OSF.DDA.issueAsyncResult(s,e,t)}try{var h=OSF.DDA.AsyncMethodCalls[OSF.DDA.AsyncMethodNames.AddHandlerAsync.id];if(s=h.verifyAndExtractCall(r,i,o),c=s[Microsoft.Office.WebExtension.Parameters.EventType],l=s[Microsoft.Office.WebExtension.Parameters.Handler],a)return void d(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess);var m=n[c],g=(f=u(m))?s[Microsoft.Office.WebExtension.Parameters.Id]:i.id||"";if(0==(f?o.getObjectEventHandlerCount(c,g):o.getEventHandlerCount(c)))(0,e(c)[OSF.DDA.DispIdHost.Delegates.RegisterEventAsync])({eventType:c,dispId:m,targetId:g,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)},onComplete:d,onEvent:function(e){var n=t.fromHost(m,e);f?o.fireObjectEvent(g,OSF.DDA.OMFactory.manufactureEventArgs(c,g,n)):o.fireEvent(OSF.DDA.OMFactory.manufactureEventArgs(c,i,n))}});else d(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)}catch(e){p(e,h,r,s)}},this[OSF.DDA.DispIdHost.Methods.RemoveEventHandler]=function(t,r,o){var i,a,s,c=!1;function l(e){var t;e!=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess&&(t=OSF.DDA.ErrorCodeManager.getErrorArgs(e)),OSF.DDA.issueAsyncResult(i,e,t)}try{var f=OSF.DDA.AsyncMethodCalls[OSF.DDA.AsyncMethodNames.RemoveHandlerAsync.id];a=(i=f.verifyAndExtractCall(t,o,r))[Microsoft.Office.WebExtension.Parameters.EventType],s=i[Microsoft.Office.WebExtension.Parameters.Handler];var d,h,m=n[a],g=(c=u(m))?i[Microsoft.Office.WebExtension.Parameters.Id]:o.id||"";null===s?(h=c?r.clearObjectEventHandlers(a,g):r.clearEventHandlers(a),d=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess):d=(h=c?r.removeObjectEventHandler(a,g,s):r.removeEventHandler(a,s))?OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess:OSF.DDA.ErrorCodeManager.errorCodes.ooeEventHandlerNotExist;var y=c?r.getObjectEventHandlerCount(a,g):r.getEventHandlerCount(a);if(h&&0==y)(0,e(a)[OSF.DDA.DispIdHost.Delegates.UnregisterEventAsync])({eventType:a,dispId:m,targetId:g,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)},onComplete:l});else l(d)}catch(e){p(e,f,t,i)}},this[OSF.DDA.DispIdHost.Methods.OpenDialog]=function(r,o,i,a){var s,c,l=null,u=Microsoft.Office.WebExtension.EventType.DialogMessageReceived,f=Microsoft.Office.WebExtension.EventType.DialogEventReceived;function d(e){if(e!=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)n=OSF.DDA.ErrorCodeManager.getErrorArgs(e);else{var t={};t[Microsoft.Office.WebExtension.Parameters.Id]=c,t[Microsoft.Office.WebExtension.Parameters.Data]=o;var n=l.processResponse(e,t,i,s);OSF.DialogShownStatus.hasDialogShown=!0,o.clearEventHandlers(u),o.clearEventHandlers(f)}OSF.DDA.issueAsyncResult(s,e,n)}try{if(void 0!=u&&void 0!=f||d(OSF.DDA.ErrorCodeManager.ooeOperationNotSupported),a){if(null==OSF.DDA.AsyncMethodNames.DisplayModalDialogAsync)return void d(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError);l=OSF.DDA.AsyncMethodCalls[OSF.DDA.AsyncMethodNames.DisplayModalDialogAsync.id]}else{if(null==OSF.DDA.AsyncMethodNames.DisplayDialogAsync)return void d(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError);l=OSF.DDA.AsyncMethodCalls[OSF.DDA.AsyncMethodNames.DisplayDialogAsync.id]}s=l.verifyAndExtractCall(r,i,o);var h=n[u],m=e(u),g=void 0!=m[OSF.DDA.DispIdHost.Delegates.OpenDialog]?m[OSF.DDA.DispIdHost.Delegates.OpenDialog]:m[OSF.DDA.DispIdHost.Delegates.RegisterEventAsync];s.isModal=a,c=JSON.stringify(s),OSF.DialogShownStatus.hasDialogShown||(o.clearQueuedEvent(u),o.clearQueuedEvent(f),o.clearQueuedEvent(Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived)),g({eventType:u,dispId:h,targetId:c,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)},onComplete:d,onEvent:function(e){var n=t.fromHost(h,e),r=OSF.DDA.OMFactory.manufactureEventArgs(u,i,n);if(r.type==f){var a=OSF.DDA.ErrorCodeManager.getErrorArgs(r.error),s={};s[OSF.DDA.AsyncResultEnum.ErrorProperties.Code]=status||OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError,s[OSF.DDA.AsyncResultEnum.ErrorProperties.Name]=a.name||a,s[OSF.DDA.AsyncResultEnum.ErrorProperties.Message]=a.message||a,r.error=new OSF.DDA.Error(s[OSF.DDA.AsyncResultEnum.ErrorProperties.Name],s[OSF.DDA.AsyncResultEnum.ErrorProperties.Message],s[OSF.DDA.AsyncResultEnum.ErrorProperties.Code])}o.fireOrQueueEvent(r),n[OSF.DDA.PropertyDescriptors.MessageType]==OSF.DialogMessageType.DialogClosed&&(o.clearEventHandlers(u),o.clearEventHandlers(f),o.clearEventHandlers(Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived),OSF.DialogShownStatus.hasDialogShown=!1)}})}catch(e){p(e,l,r,s)}},this[OSF.DDA.DispIdHost.Methods.CloseDialog]=function(t,r,o,i){var a,s,c,l=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess;try{var u=OSF.DDA.AsyncMethodCalls[OSF.DDA.AsyncMethodNames.CloseAsync.id];a=u.verifyAndExtractCall(t,i,o),s=Microsoft.Office.WebExtension.EventType.DialogMessageReceived,c=Microsoft.Office.WebExtension.EventType.DialogEventReceived,o.clearEventHandlers(s),o.clearEventHandlers(c);var f=n[s],d=e(s);(void 0!=d[OSF.DDA.DispIdHost.Delegates.CloseDialog]?d[OSF.DDA.DispIdHost.Delegates.CloseDialog]:d[OSF.DDA.DispIdHost.Delegates.UnregisterEventAsync])({eventType:s,dispId:f,targetId:r,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)},onComplete:function(e){l=e,OSF.DialogShownStatus.hasDialogShown=!1}})}catch(e){p(e,u,t,a)}if(l!=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)throw OSF.OUtil.formatString(Strings.OfficeOM.L_FunctionCallFailed,OSF.DDA.AsyncMethodNames.CloseAsync.displayName,l)},this[OSF.DDA.DispIdHost.Methods.MessageParent]=function(t,r){var o=OSF.DDA.SyncMethodCalls[OSF.DDA.SyncMethodNames.MessageParent.id].verifyAndExtractCall(t,r,{});return(0,e(OSF.DDA.SyncMethodNames.MessageParent.id)[OSF.DDA.DispIdHost.Delegates.MessageParent])({dispId:n[OSF.DDA.SyncMethodNames.MessageParent.id],hostCallArgs:o,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)}})},this[OSF.DDA.DispIdHost.Methods.SendMessage]=function(t,r,o){var i=OSF.DDA.SyncMethodCalls[OSF.DDA.SyncMethodNames.SendMessage.id].verifyAndExtractCall(t,o,{});return(0,e(OSF.DDA.SyncMethodNames.SendMessage.id)[OSF.DDA.DispIdHost.Delegates.SendMessage])({dispId:n[OSF.DDA.SyncMethodNames.SendMessage.id],hostCallArgs:i,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)}})}},OSF.DDA.DispIdHost.addAsyncMethods=function(e,t,n){for(var r in t){var o=t[r],i=o.displayName;e[i]||OSF.OUtil.defineEnumerableProperty(e,i,{value:function(t){return function(){var r=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.InvokeMethod];r(t,arguments,e,n)}}(o)})}},OSF.DDA.DispIdHost.addEventSupport=function(e,t,n){var r=OSF.DDA.AsyncMethodNames.AddHandlerAsync.displayName,o=OSF.DDA.AsyncMethodNames.RemoveHandlerAsync.displayName;e[r]||OSF.OUtil.defineEnumerableProperty(e,r,{value:function(){var r=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.AddEventHandler];r(arguments,t,e,n)}}),e[o]||OSF.OUtil.defineEnumerableProperty(e,o,{value:function(){var n=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.RemoveEventHandler];n(arguments,t,e)}})},function(e){var t=function(){function e(){}return e.isInstanceOfType=function(e,t){if("undefined"===typeof t||null===t)return!1;if(t instanceof e)return!0;var n=t.constructor;return n&&"function"===typeof n&&n.__typeName&&"Object"!==n.__typeName||(n=Object),!(n!==e)||n.__typeName&&e.__typeName&&n.__typeName===e.__typeName},e}();e.MsAjaxTypeHelper=t;var n=function(){function e(){}return e.create=function(e,t){var n=new Error(e);if(n.message=e,t)for(var r in t)n[r]=t[r];return n.popStackFrame(),n},e.parameterCount=function(t){var n="Sys.ParameterCountException: "+(t||"Parameter count mismatch."),r=e.create(n,{name:"Sys.ParameterCountException"});return r.popStackFrame(),r},e.argument=function(t,n){var o="Sys.ArgumentException: "+(n||"Value does not fall within the expected range.");t&&(o+="\n"+r.format("Parameter name: {0}",t));var i=e.create(o,{name:"Sys.ArgumentException",paramName:t});return i.popStackFrame(),i},e.argumentNull=function(t,n){var o="Sys.ArgumentNullException: "+(n||"Value cannot be null.");t&&(o+="\n"+r.format("Parameter name: {0}",t));var i=e.create(o,{name:"Sys.ArgumentNullException",paramName:t});return i.popStackFrame(),i},e.argumentOutOfRange=function(t,n,o){var i="Sys.ArgumentOutOfRangeException: "+(o||"Specified argument was out of the range of valid values.");t&&(i+="\n"+r.format("Parameter name: {0}",t)),"undefined"!==typeof n&&null!==n&&(i+="\n"+r.format("Actual value was {0}.",n));var a=e.create(i,{name:"Sys.ArgumentOutOfRangeException",paramName:t,actualValue:n});return a.popStackFrame(),a},e.argumentType=function(t,n,o,i){var a="Sys.ArgumentTypeException: ";a+=i||(n&&o?r.format("Object of type '{0}' cannot be converted to type '{1}'.",n.getName?n.getName():n,o.getName?o.getName():o):"Object cannot be converted to the required type."),t&&(a+="\n"+r.format("Parameter name: {0}",t));var s=e.create(a,{name:"Sys.ArgumentTypeException",paramName:t,actualType:n,expectedType:o});return s.popStackFrame(),s},e.argumentUndefined=function(t,n){var o="Sys.ArgumentUndefinedException: "+(n||"Value cannot be undefined.");t&&(o+="\n"+r.format("Parameter name: {0}",t));var i=e.create(o,{name:"Sys.ArgumentUndefinedException",paramName:t});return i.popStackFrame(),i},e.invalidOperation=function(t){var n="Sys.InvalidOperationException: "+(t||"Operation is not valid due to the current state of the object."),r=e.create(n,{name:"Sys.InvalidOperationException"});return r.popStackFrame(),r},e}();e.MsAjaxError=n;var r=function(){function e(){}return e.format=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];var r=e;return r.replace(/{(\d+)}/gm,(function(e,n){var r=parseInt(n,10);return void 0===t[r]?"{"+n+"}":t[r]}))},e.startsWith=function(e,t){return e.substr(0,t.length)===t},e}();e.MsAjaxString=r;var o=function(){function e(){}return e.trace=function(e){"undefined"!==typeof Debug&&Debug.writeln&&Debug.writeln(e),window.console&&window.console.log&&window.console.log(e),window.opera&&window.opera.postError&&window.opera.postError(e),window.debugService&&window.debugService.trace&&window.debugService.trace(e);var t=document.getElementById("TraceConsole");t&&"TEXTAREA"===t.tagName.toUpperCase()&&(t.innerHTML+=e+"\n")},e}();if(e.MsAjaxDebug=o,!OsfMsAjaxFactory.isMsAjaxLoaded()){var i=function(e,t,n){void 0!==e.__typeName&&null!==e.__typeName||(e.__typeName=t),void 0!==e.__class&&null!==e.__class||(e.__class=n)};i(Function,"Function",!0),i(Error,"Error",!0),i(Object,"Object",!0),i(String,"String",!0),i(Boolean,"Boolean",!0),i(Date,"Date",!0),i(Number,"Number",!0),i(RegExp,"RegExp",!0),i(Array,"Array",!0),Function.createCallback||(Function.createCallback=function(e,t){var n=Function._validateParams(arguments,[{name:"method",type:Function},{name:"context",mayBeNull:!0}]);if(n)throw n;return function(){var n=arguments.length;if(n>0){for(var r=[],o=0;o<n;o++)r[o]=arguments[o];return r[n]=t,e.apply(this,r)}return e.call(this,t)}}),Function.createDelegate||(Function.createDelegate=function(e,t){var n=Function._validateParams(arguments,[{name:"instance",mayBeNull:!0},{name:"method",type:Function}]);if(n)throw n;return function(){return t.apply(e,arguments)}}),Function._validateParams||(Function._validateParams=function(e,t,n){var r,o=t.length;if(n=n||"undefined"===typeof n,r=Function._validateParameterCount(e,t,n))return r.popStackFrame(),r;for(var i=0,a=e.length;i<a;i++){var s=t[Math.min(i,o-1)],c=s.name;if(s.parameterArray)c+="["+(i-o+1)+"]";else if(!n&&i>=o)break;if(r=Function._validateParameter(e[i],s,c))return r.popStackFrame(),r}return null}),Function._validateParameterCount||(Function._validateParameterCount=function(e,t,r){var o,i,a=t.length,s=e.length;if(s<a){var c=a;for(o=0;o<a;o++){var l=t[o];(l.optional||l.parameterArray)&&c--}s<c&&(i=!0)}else if(r&&s>a)for(i=!0,o=0;o<a;o++)if(t[o].parameterArray){i=!1;break}if(i){var u=n.parameterCount();return u.popStackFrame(),u}return null}),Function._validateParameter||(Function._validateParameter=function(e,t,n){var r,o=t.type,i=!!t.integer,a=!!t.domElement,s=!!t.mayBeNull;if(r=Function._validateParameterType(e,o,i,a,s,n))return r.popStackFrame(),r;var c=t.elementType,l=!!t.elementMayBeNull;if(o===Array&&"undefined"!==typeof e&&null!==e&&(c||!l))for(var u=!!t.elementInteger,p=!!t.elementDomElement,f=0;f<e.length;f++){var d=e[f];if(r=Function._validateParameterType(d,c,u,p,l,n+"["+f+"]"))return r.popStackFrame(),r}return null}),Function._validateParameterType||(Function._validateParameterType=function(t,n,r,o,i,a){var s;return"undefined"===typeof t?i?null:((s=e.MsAjaxError.argumentUndefined(a)).popStackFrame(),s):null===t?i?null:((s=e.MsAjaxError.argumentNull(a)).popStackFrame(),s):n&&!e.MsAjaxTypeHelper.isInstanceOfType(n,t)?((s=e.MsAjaxError.argumentType(a,typeof t,n)).popStackFrame(),s):null}),window.Type||(window.Type=Function),Type.registerNamespace||(Type.registerNamespace=function(e){for(var t=e.split("."),n=window,r=0;r<t.length;r++)n[t[r]]=n[t[r]]||{},n=n[t[r]]}),Type.prototype.registerClass||(Type.prototype.registerClass=function(e){({})}),"undefined"===typeof Sys&&Type.registerNamespace("Sys"),Error.prototype.popStackFrame||(Error.prototype.popStackFrame=function(){if(0!==arguments.length)throw n.parameterCount();if("undefined"!==typeof this.stack&&null!==this.stack&&"undefined"!==typeof this.fileName&&null!==this.fileName&&"undefined"!==typeof this.lineNumber&&null!==this.lineNumber){for(var e=this.stack.split("\n"),t=e[0],r=this.fileName+":"+this.lineNumber;"undefined"!==typeof t&&null!==t&&-1===t.indexOf(r);)e.shift(),t=e[0];var o=e[1];if("undefined"!==typeof o&&null!==o){var i=o.match(/@(.*):(\d+)$/);"undefined"!==typeof i&&null!==i&&(this.fileName=i[1],this.lineNumber=parseInt(i[2]),e.shift(),this.stack=e.join("\n"))}}}),OsfMsAjaxFactory.msAjaxError=n,OsfMsAjaxFactory.msAjaxString=r,OsfMsAjaxFactory.msAjaxDebug=o}}(OfficeExt||(OfficeExt={})),OSF.OUtil.setNamespace("SafeArray",OSF.DDA),OSF.DDA.SafeArray.Response={Status:0,Payload:1},OSF.DDA.SafeArray.UniqueArguments={Offset:"offset",Run:"run",BindingSpecificData:"bindingSpecificData",MergedCellGuid:"{66e7831f-81b2-42e2-823c-89e872d541b3}"},OSF.OUtil.setNamespace("Delegate",OSF.DDA.SafeArray),OSF.DDA.SafeArray.Delegate._onException=function(e,t){var n,r=e.number;if(r)switch(r){case-2146828218:n=OSF.DDA.ErrorCodeManager.errorCodes.ooeNoCapability;break;case-2147467259:n=t.dispId==OSF.DDA.EventDispId.dispidDialogMessageReceivedEvent?OSF.DDA.ErrorCodeManager.errorCodes.ooeDialogAlreadyOpened:OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError;break;case-2146828283:case-2147209089:n=OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidParam;break;case-2147208704:n=OSF.DDA.ErrorCodeManager.errorCodes.ooeTooManyIncompleteRequests;break;case-2146827850:default:n=OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError}t.onComplete&&t.onComplete(n||OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError)},OSF.DDA.SafeArray.Delegate._onExceptionSyncMethod=function(e,t){var n,r=e.number;if(r)switch(r){case-2146828218:n=OSF.DDA.ErrorCodeManager.errorCodes.ooeNoCapability;break;case-2146827850:default:n=OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError}return n||OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError},OSF.DDA.SafeArray.Delegate.SpecialProcessor=function(){function e(e){var t;try{var n=e.ubound(1),r=e.ubound(2);if(e=e.toArray(),1==n&&1==r)t=[e];else{t=[];for(var o=0;o<n;o++){for(var i=[],a=0;a<r;a++){var s=e[o*r+a];s!=OSF.DDA.SafeArray.UniqueArguments.MergedCellGuid&&i.push(s)}i.length>0&&t.push(i)}}}catch(e){}return t}var t={};t[Microsoft.Office.WebExtension.Parameters.Data]=function(){return{toHost:function(e){if(OSF.DDA.TableDataProperties&&"string"!=typeof e&&void 0!==e[OSF.DDA.TableDataProperties.TableRows]){var t=[];t[0]=e[OSF.DDA.TableDataProperties.TableRows],t[1]=e[OSF.DDA.TableDataProperties.TableHeaders],e=t}return e},fromHost:function(t){var n;if(t.toArray)if(2===t.dimensions())n=e(t);else{var r=t.toArray();2===r.length&&(null!=r[0]&&r[0].toArray||null!=r[1]&&r[1].toArray)?((n={})[OSF.DDA.TableDataProperties.TableRows]=e(r[0]),n[OSF.DDA.TableDataProperties.TableHeaders]=e(r[1])):n=r}else n=t;return n}}}(),OSF.DDA.SafeArray.Delegate.SpecialProcessor.uber.constructor.call(this,[],t),this.unpack=function(e,n){var r;this.isComplexType(e)||OSF.DDA.ListType.isListType(e)?r=void 0!==n&&void 0!==n.toArray?n.toArray():n||{}:r=this.isDynamicType(e)?t[e].fromHost(n):n;return r}},OSF.OUtil.extend(OSF.DDA.SafeArray.Delegate.SpecialProcessor,OSF.DDA.SpecialProcessor),OSF.DDA.SafeArray.Delegate.ParameterMap=OSF.DDA.getDecoratedParameterMap(new OSF.DDA.SafeArray.Delegate.SpecialProcessor,[{type:Microsoft.Office.WebExtension.Parameters.ValueFormat,toHost:[{name:Microsoft.Office.WebExtension.ValueFormat.Unformatted,value:0},{name:Microsoft.Office.WebExtension.ValueFormat.Formatted,value:1}]},{type:Microsoft.Office.WebExtension.Parameters.FilterType,toHost:[{name:Microsoft.Office.WebExtension.FilterType.All,value:0}]}]),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.AsyncResultStatus,fromHost:[{name:Microsoft.Office.WebExtension.AsyncResultStatus.Succeeded,value:0},{name:Microsoft.Office.WebExtension.AsyncResultStatus.Failed,value:1}]}),OSF.DDA.SafeArray.Delegate.executeAsync=function(e){function t(e){var n=e;if(null!=e&&e.toArray){var r=e.toArray();n=new Array(r.length);for(var o=0;o<r.length;o++)n[o]=t(r[o])}return n}try{e.onCalling&&e.onCalling(),OSF.ClientHostController.execute(e.dispId,function e(t){var n=t;if(OSF.OUtil.isArray(t))for(var r=n.length,o=0;o<r;o++)n[o]=e(n[o]);else if(OSF.OUtil.isDate(t))n=t.getVarDate();else if("object"===typeof t&&!OSF.OUtil.isArray(t))for(var i in n=[],t)OSF.OUtil.isFunction(t[i])||(n[i]=e(t[i]));return n}(e.hostCallArgs),(function(n,r){var o,i;if("number"===typeof n?(o=[],i=n):i=(o=n.toArray())[OSF.DDA.SafeArray.Response.Status],i==OSF.DDA.ErrorCodeManager.errorCodes.ooeChunkResult)return null!=(a=t(a=o[OSF.DDA.SafeArray.Response.Payload]))&&(e._chunkResultData||(e._chunkResultData=new Array),e._chunkResultData[a[0]]=a[1]),!1;if(e.onReceiving&&e.onReceiving(),e.onComplete){var a;if(i==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess){if(o.length>2){a=[];for(var s=1;s<o.length;s++)a[s-1]=o[s]}else a=o[OSF.DDA.SafeArray.Response.Payload];if(e._chunkResultData&&null!=(a=t(a))){var c=a[a.length-1];e._chunkResultData.length==c?a[a.length-1]=e._chunkResultData:i=OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError}}else a=o[OSF.DDA.SafeArray.Response.Payload];e.onComplete(i,a)}return!0}))}catch(t){OSF.DDA.SafeArray.Delegate._onException(t,e)}},OSF.DDA.SafeArray.Delegate._getOnAfterRegisterEvent=function(e,t){var n=(new Date).getTime();return function(r){t.onReceiving&&t.onReceiving();var o=r.toArray?r.toArray()[OSF.DDA.SafeArray.Response.Status]:r;t.onComplete&&t.onComplete(o),OSF.AppTelemetry&&OSF.AppTelemetry.onRegisterDone(e,t.dispId,Math.abs((new Date).getTime()-n),o)}},OSF.DDA.SafeArray.Delegate.registerEventAsync=function(e){e.onCalling&&e.onCalling();var t=OSF.DDA.SafeArray.Delegate._getOnAfterRegisterEvent(!0,e);try{OSF.ClientHostController.registerEvent(e.dispId,e.targetId,(function(t,n){e.onEvent&&e.onEvent(n),OSF.AppTelemetry&&OSF.AppTelemetry.onEventDone(e.dispId)}),t)}catch(t){OSF.DDA.SafeArray.Delegate._onException(t,e)}},OSF.DDA.SafeArray.Delegate.unregisterEventAsync=function(e){e.onCalling&&e.onCalling();var t=OSF.DDA.SafeArray.Delegate._getOnAfterRegisterEvent(!1,e);try{OSF.ClientHostController.unregisterEvent(e.dispId,e.targetId,t)}catch(t){OSF.DDA.SafeArray.Delegate._onException(t,e)}},OSF.ClientMode={ReadWrite:0,ReadOnly:1},OSF.DDA.RichInitializationReason={1:Microsoft.Office.WebExtension.InitializationReason.Inserted,2:Microsoft.Office.WebExtension.InitializationReason.DocumentOpened},OSF.InitializationHelper=function(e,t,n,r,o){this._hostInfo=e,this._webAppState=t,this._context=n,this._settings=r,this._hostFacade=o,this._initializeSettings=this.initializeSettings},OSF.InitializationHelper.prototype.deserializeSettings=function(e,t){var n=OSF.OUtil.getSessionStorage();if(n){var r=n.getItem(OSF._OfficeAppFactory.getCachedSessionSettingsKey());r?e=JSON.parse(r):(r=JSON.stringify(e),n.setItem(OSF._OfficeAppFactory.getCachedSessionSettingsKey(),r))}var o=OSF.DDA.SettingsManager.deserializeSettings(e);return t?new OSF.DDA.RefreshableSettings(o):new OSF.DDA.Settings(o)},OSF.InitializationHelper.prototype.saveAndSetDialogInfo=function(e){},OSF.InitializationHelper.prototype.setAgaveHostCommunication=function(){},OSF.InitializationHelper.prototype.prepareRightBeforeWebExtensionInitialize=function(e){this.prepareApiSurface(e),Microsoft.Office.WebExtension.initialize(this.getInitializationReason(e))},OSF.InitializationHelper.prototype.prepareApiSurface=function(e){var t,n,r=new OSF.DDA.License(e.get_eToken()),o=OSF.DDA.OfficeTheme&&OSF.DDA.OfficeTheme.getOfficeTheme?OSF.DDA.OfficeTheme.getOfficeTheme:null;e.get_isDialog()?OSF.DDA.UI.ChildUI&&(e.ui=new OSF.DDA.UI.ChildUI):OSF.DDA.UI.ParentUI&&(e.ui=new OSF.DDA.UI.ParentUI,OfficeExt.Container&&OSF.DDA.DispIdHost.addAsyncMethods(e.ui,[OSF.DDA.AsyncMethodNames.CloseContainerAsync])),OSF.DDA.OpenBrowser&&OSF.DDA.DispIdHost.addAsyncMethods(e.ui,[OSF.DDA.AsyncMethodNames.OpenBrowserWindow]),OSF.DDA.ExecuteFeature&&OSF.DDA.DispIdHost.addAsyncMethods(e.ui,[OSF.DDA.AsyncMethodNames.ExecuteFeature]),OSF.DDA.QueryFeature&&OSF.DDA.DispIdHost.addAsyncMethods(e.ui,[OSF.DDA.AsyncMethodNames.QueryFeature]),OSF.DDA.Auth&&(e.auth=new OSF.DDA.Auth,OSF.DDA.DispIdHost.addAsyncMethods(e.auth,[OSF.DDA.AsyncMethodNames.GetAccessTokenAsync])),OSF._OfficeAppFactory.setContext(new OSF.DDA.Context(e,e.doc,r,null,o)),t=OSF.DDA.DispIdHost.getClientDelegateMethods,n=OSF.DDA.SafeArray.Delegate.ParameterMap,OSF._OfficeAppFactory.setHostFacade(new OSF.DDA.DispIdHost.Facade(t,n))},OSF.InitializationHelper.prototype.getInitializationReason=function(e){return OSF.DDA.RichInitializationReason[e.get_reason()]},OSF.DDA.DispIdHost.getClientDelegateMethods=function(e){var t={};if(t[OSF.DDA.DispIdHost.Delegates.ExecuteAsync]=OSF.DDA.SafeArray.Delegate.executeAsync,t[OSF.DDA.DispIdHost.Delegates.RegisterEventAsync]=OSF.DDA.SafeArray.Delegate.registerEventAsync,t[OSF.DDA.DispIdHost.Delegates.UnregisterEventAsync]=OSF.DDA.SafeArray.Delegate.unregisterEventAsync,t[OSF.DDA.DispIdHost.Delegates.OpenDialog]=OSF.DDA.SafeArray.Delegate.openDialog,t[OSF.DDA.DispIdHost.Delegates.CloseDialog]=OSF.DDA.SafeArray.Delegate.closeDialog,t[OSF.DDA.DispIdHost.Delegates.MessageParent]=OSF.DDA.SafeArray.Delegate.messageParent,t[OSF.DDA.DispIdHost.Delegates.SendMessage]=OSF.DDA.SafeArray.Delegate.sendMessage,OSF.DDA.AsyncMethodNames.RefreshAsync&&e==OSF.DDA.AsyncMethodNames.RefreshAsync.id){t[OSF.DDA.DispIdHost.Delegates.ExecuteAsync]=OSF.DDA.ClientSettingsManager.getSettingsExecuteMethod((function(e,t,n){return"function"===typeof OSF.DDA.ClientSettingsManager.refresh?OSF.DDA.ClientSettingsManager.refresh(t,n):OSF.DDA.ClientSettingsManager.read(t,n)}))}if(OSF.DDA.AsyncMethodNames.SaveAsync&&e==OSF.DDA.AsyncMethodNames.SaveAsync.id){t[OSF.DDA.DispIdHost.Delegates.ExecuteAsync]=OSF.DDA.ClientSettingsManager.getSettingsExecuteMethod((function(e,t,n){return OSF.DDA.ClientSettingsManager.write(e[OSF.DDA.SettingsManager.SerializedSettings],e[Microsoft.Office.WebExtension.Parameters.OverwriteIfStale],t,n)}))}return t},function(e){var t=function(){function e(){}return e.prototype.execute=function(e,t,n){setTimeout((function(){window.external.Execute(e,t,n)}),0)},e.prototype.registerEvent=function(e,t,n,r){setTimeout((function(){window.external.RegisterEvent(e,t,n,r)}),0)},e.prototype.unregisterEvent=function(e,t,n){setTimeout((function(){window.external.UnregisterEvent(e,t,n)}),0)},e.prototype.openDialog=function(t,n,r,o){if(!e.popup||e.popup.closed){window.dialogAPIErrorCode=void 0;var i=JSON.parse(n),a=i.url;if(a){var s=a.split("#"),c="?";s[0].indexOf("?")>-1&&(c="&");var l="width="+screen.width*i.width/100+", height="+screen.height*i.height/100;s[0]=s[0].concat(c).concat("action=displayDialog");var u=s.join("#");if(e.popup=window.open(u,"",l),e.DialogEventListener=function(n){if(n.source==e.popup)try{var o=JSON.parse(n.data);o.dialogMessage&&r(t,[OSF.DialogMessageType.DialogMessageReceived,o.dialogMessage.messageContent])}catch(e){OsfMsAjaxFactory.msAjaxDebug.trace("messages received cannot be handlered. Message:"+n.data)}},void 0!=e.popup&&void 0==window.dialogAPIErrorCode)window.addEventListener("message",e.DialogEventListener),e.interval=window.setInterval((function(){try{(null==e.popup||e.popup.closed)&&(window.clearInterval(e.interval),window.removeEventListener("message",e.DialogEventListener),e.NotifyError=null,r(t,[OSF.DialogMessageType.DialogClosed]))}catch(e){OsfMsAjaxFactory.msAjaxDebug.trace("Error happened when popup window closed.")}}),500),e.NotifyError=function(e){r(t,[e])},o(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess);else{var p=OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError;window.dialogAPIErrorCode&&(p=window.dialogAPIErrorCode),o(p)}}else o(OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidScheme)}else o(OSF.DDA.ErrorCodeManager.errorCodes.ooeDialogAlreadyOpened)},e.prototype.messageParent=function(e){var t=e[Microsoft.Office.WebExtension.Parameters.MessageToParent],n={dialogMessage:{messageType:OSF.DialogMessageType.DialogMessageReceived,messageContent:t}};window.opener.postMessage(JSON.stringify(n),window.location.origin)},e.prototype.closeDialog=function(t,n,r){e.popup?(e.interval&&window.clearInterval(e.interval),e.popup.close(),e.popup=null,window.removeEventListener("message",e.DialogEventListener),e.NotifyError=null,r(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)):r(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError)},e.prototype.sendMessage=function(e){},e}();e.MacRichClientHostController=t}(OfficeExt||(OfficeExt={}));var OSFWebkit,OSFLog,Logger,OSFAriaLogger,OSFAppTelemetry,OSFPerfUtil;OSF=OSF||{};!function(e){var t=function(){function e(e){this.data=e,this.safeArrayFlag=this.isSafeArray(e)}return e.prototype.dimensions=function(){var e=0;return this.safeArrayFlag?e=this.data[0][0]:this.isArray()&&(e=2),e},e.prototype.getItem=function(){var e=null;e=this.safeArrayFlag?this.toArray():this.data;for(var t=0;t<arguments.length;t++)e=e[arguments[t]];return e},e.prototype.lbound=function(e){return 0},e.prototype.ubound=function(e){var t=0;if(this.safeArrayFlag)t=this.data[0][e];else if(this.isArray()){if(1==e)return this.data.length;if(2==e){if(OSF.OUtil.isArray(this.data[0]))return this.data[0].length;if(null!=this.data[0])return 1}}return t},e.prototype.toArray=function(){if(0==this.isArray())return this.data;for(var t=[],n=this.safeArrayFlag?1:0;n<this.data.length;n++){var r=this.data[n];this.isSafeArray(r)?t.push(new e(r)):t.push(r)}return t},e.prototype.isArray=function(){return OSF.OUtil.isArray(this.data)},e.prototype.isSafeArray=function(e){var t=!1;if(OSF.OUtil.isArray(e)&&OSF.OUtil.isArray(e[0])){var n=e[0],r=n[0];if(n.length!=r+1)return!1;for(var o=1,i=1;i<n.length;i++){var a=n[i];if(0==isFinite(a))return!1;o*=a}t=++o==e.length}return t},e}();e.WebkitSafeArray=t}(OSFWebkit||(OSFWebkit={})),function(e){!function(e){var t=null;e.agaveHostCallback=function(e,n){t.agaveHostCallback(e,n)},e.agaveHostEventCallback=function(e,n){t.agaveHostEventCallback(e,n)},e.GetScriptMessenger=function(){return null==t&&(t=r.IsSupportedByHost()?new r:new o("OSF.ScriptMessaging.agaveHostCallback","OSF.ScriptMessaging.agaveHostEventCallback")),t};var n=function(){return function(e,t,n){this.id=e,this.targetId=t,this.handler=n}}(),r=function(){function e(){this.eventHandlers=[]}return e.IsSupportedByHost=function(){return!!window._osfHostAPI},e.prototype.invokeMethod=function(e,t,n,r){window._osfHostAPI(e,this.constructMessagingArgs(t,n),(function(e){var t=r(e);return void 0===t||!0===t}))},e.prototype.registerEvent=function(e,t,n,r,o,i){var a={id:n,targetId:r},s=window._osfHostRegisterEvent(e,this.constructMessagingArgs(t,a),(function(e){return o(e),!1}),(function(e){return i(e),!0}));this.eventHandlers.push({targetId:r,dispId:n,callbackId:s.eventCallbackId})},e.prototype.unregisterEvent=function(e,t,n,r,o){var i={id:n,targetId:r};window._osfHostAPI(e,this.constructMessagingArgs(t,i),(function(e){return o(e),!0}));for(var a=this.eventHandlers.length-1;a>=0;a--){var s=this.eventHandlers[a];s.dispId===n&&s.targetId===r&&(this.eventHandlers.splice(a,1),window._osfHostUnregisterCallback(s.callbackId))}},e.prototype.agaveHostCallback=function(e,t){},e.prototype.agaveHostEventCallback=function(e,t){},e.prototype.constructMessagingArgs=function(e,t){return{params:t,methodId:e}},e}(),o=function(){function e(t,n){this.callingIndex=0,this.callbackList={},this.eventHandlerList={},this.asyncMethodCallbackFunctionName=t,this.eventCallbackFunctionName=n,this.conversationId=e.getCurrentTimeMS().toString()}return e.prototype.invokeMethod=function(e,t,n,r){this.postWebkitMessage({},e,t,n,r)},e.prototype.registerEvent=function(e,t,r,o,i,a){var s={eventCallbackFunction:this.eventCallbackFunctionName},c={id:r,targetId:o},l=this.postWebkitMessage(s,e,t,c,a);this.eventHandlerList[l]=new n(r,o,i)},e.prototype.unregisterEvent=function(e,t,n,r,o){var i={id:n,targetId:r};for(var a in this.eventHandlerList)if(this.eventHandlerList.hasOwnProperty(a)){var s=this.eventHandlerList[a];s.id==n&&s.targetId==r&&delete this.eventHandlerList[a]}this.invokeMethod(e,t,i,o)},e.prototype.agaveHostCallback=function(e,t){var n=this.callbackList[e];if(n){var r=n(t);void 0!==r&&!0!==r||delete this.callbackList[e]}},e.prototype.agaveHostEventCallback=function(e,t){var n=this.eventHandlerList[e];n&&n.handler(t)},e.prototype.postWebkitMessage=function(t,n,r,o,i){t.methodId=r,t.params=o;var a="";i&&(a=this.generateCorrelationId(),this.callbackList[a]=i,t.callbackId=a,t.callbackFunction=this.asyncMethodCallbackFunctionName);var s=function(){window.webkit.messageHandlers[n].postMessage(JSON.stringify(t))},c=e.getCurrentTimeMS();return null==this.lastMessageTimestamp||c-this.lastMessageTimestamp>=e.MESSAGE_TIME_DELTA?(s(),this.lastMessageTimestamp=c):(this.lastMessageTimestamp+=e.MESSAGE_TIME_DELTA,setTimeout((function(){s()}),this.lastMessageTimestamp-c)),a},e.prototype.generateCorrelationId=function(){return++this.callingIndex,this.conversationId+this.callingIndex},e.getCurrentTimeMS=function(){return(new Date).getTime()},e.MESSAGE_TIME_DELTA=10,e}()}(e.ScriptMessaging||(e.ScriptMessaging={}))}(OSFWebkit||(OSFWebkit={})),OSF.ScriptMessaging=OSFWebkit.ScriptMessaging,function(e){e.MessageHandlerName="Agave",e.PopupMessageHandlerName="WefPopupHandler",function(e){e[e.Settings=0]="Settings",e[e.SolutionReferenceId=1]="SolutionReferenceId",e[e.AppType=2]="AppType",e[e.MajorVersion=3]="MajorVersion",e[e.MinorVersion=4]="MinorVersion",e[e.RevisionVersion=5]="RevisionVersion",e[e.APIVersionSequence=6]="APIVersionSequence",e[e.AppCapabilities=7]="AppCapabilities",e[e.APPUILocale=8]="APPUILocale",e[e.AppDataLocale=9]="AppDataLocale",e[e.BindingCount=10]="BindingCount",e[e.DocumentUrl=11]="DocumentUrl",e[e.ActivationMode=12]="ActivationMode",e[e.ControlIntegrationLevel=13]="ControlIntegrationLevel",e[e.SolutionToken=14]="SolutionToken",e[e.APISetVersion=15]="APISetVersion",e[e.CorrelationId=16]="CorrelationId",e[e.InstanceId=17]="InstanceId",e[e.TouchEnabled=18]="TouchEnabled",e[e.CommerceAllowed=19]="CommerceAllowed",e[e.RequirementMatrix=20]="RequirementMatrix",e[e.HostCustomMessage=21]="HostCustomMessage",e[e.HostFullVersion=22]="HostFullVersion",e[e.InitialDisplayMode=23]="InitialDisplayMode"}(e.AppContextProperties||(e.AppContextProperties={})),function(e){e[e.Execute=1]="Execute",e[e.RegisterEvent=2]="RegisterEvent",e[e.UnregisterEvent=3]="UnregisterEvent",e[e.WriteSettings=4]="WriteSettings",e[e.GetContext=5]="GetContext",e[e.SendMessage=6]="SendMessage",e[e.MessageParent=7]="MessageParent",e[e.SendMessage2=8]="SendMessage2",e[e.MessageParent2=9]="MessageParent2"}(e.MethodId||(e.MethodId={}));var t=function(){function t(e){this.hostScriptProxy=e,this.useFullDialogAPI=!!window._enableFullDialogAPI,this.osfSupportsDialogOrigin=!!window._osfEnableDialogOrigin}return t.prototype.execute=function(t,n,r){var o={id:t,apiArgs:n};this.hostScriptProxy.invokeMethod(OSF.Webkit.MessageHandlerName,OSF.Webkit.MethodId.Execute,o,(function(t){if(r){var n=[];if(OSF.OUtil.isArray(t))for(var o=0;o<t.length;o++){var i=t[o];OSF.OUtil.isArray(i)&&(i=new e.WebkitSafeArray(i)),n.unshift(i)}return r.apply(null,n)}}))},t.prototype.registerEvent=function(t,n,r,o){this.hostScriptProxy.registerEvent(OSF.Webkit.MessageHandlerName,OSF.Webkit.MethodId.RegisterEvent,t,n,(function(t){var n=t,o=0;OSF.OUtil.isArray(t)&&t.length>=2&&(n=t[0],o=t[1]),r&&r(o,new e.WebkitSafeArray(n))}),(function(t){if(o)return o(new e.WebkitSafeArray(t))}))},t.prototype.unregisterEvent=function(t,n,r){this.hostScriptProxy.unregisterEvent(OSF.Webkit.MessageHandlerName,OSF.Webkit.MethodId.UnregisterEvent,t,n,(function(t){return r(new e.WebkitSafeArray(t))}))},t.prototype.messageParent=function(e){if(this.useFullDialogAPI&&e){var t=e[Microsoft.Office.WebExtension.Parameters.MessageToParent];"boolean"===typeof t&&(!0===t?e[Microsoft.Office.WebExtension.Parameters.MessageToParent]="true":!1===t&&(e[Microsoft.Office.WebExtension.Parameters.MessageToParent]=""))}var n,r;if(this.osfSupportsDialogOrigin&&e[Microsoft.Office.WebExtension.Parameters.TargetOrigin]?(n=this.useFullDialogAPI?JSON.stringify(e):e[Microsoft.Office.WebExtension.Parameters.MessageToParent],r=OSF.Webkit.MethodId.MessageParent2):(n=e[Microsoft.Office.WebExtension.Parameters.MessageToParent],r=OSF.Webkit.MethodId.MessageParent),this.useFullDialogAPI)this.hostScriptProxy.invokeMethod(OSF.Webkit.MessageHandlerName,r,n,null);else{var o={dialogMessage:{messageType:OSF.DialogMessageType.DialogMessageReceived,messageContent:n}},i=r==OSF.Webkit.MethodId.MessageParent2?e[Microsoft.Office.WebExtension.Parameters.TargetOrigin]:window.location.origin;window.opener.postMessage(JSON.stringify(o),i)}},t.prototype.openDialog=function(e,n,r,o){if(this.useFullDialogAPI)this.registerEvent(e,n,r,o);else if(!t.popup||t.popup.closed){t.OpenDialogCallback=void 0;var i=JSON.parse(n),a=i.url;if(a){var s=a.split("#"),c="?";s[0].indexOf("?")>-1&&(c="&");var l="width="+screen.width*i.width/100+", height="+screen.height*i.height/100;s[0]=s[0].concat(c).concat("action=displayDialog");var u=s.join("#");t.popup=window.open(u,"",l),t.DialogEventListener=function(t){if(t.origin==window.location.origin)try{var n=JSON.parse(t.data);n.dialogMessage&&r(e,[OSF.DialogMessageType.DialogMessageReceived,n.dialogMessage.messageContent,t.origin])}catch(e){OsfMsAjaxFactory.msAjaxDebug.trace("messages received cannot be handlered. Message:"+t.data)}},t.OpenDialogCallback=function(e){e==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess&&(window.addEventListener("message",t.DialogEventListener),t.interval=window.setInterval(p,1e3),t.NotifyError=f),o(e)}}else o(OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidScheme)}else o(OSF.DDA.ErrorCodeManager.errorCodes.ooeDialogAlreadyOpened);function p(){try{(null==t.popup||t.popup.closed)&&(window.clearInterval(t.interval),window.removeEventListener("message",t.DialogEventListener),t.NotifyError=null,t.popup=null,r(e,[OSF.DialogMessageType.DialogClosed]))}catch(e){OsfMsAjaxFactory.msAjaxDebug.trace("Error happened when popup window closed.")}}function f(t){r(e,[t])}},t.prototype.closeDialog=function(e,n,r){this.useFullDialogAPI?this.unregisterEvent(e,n,r):t.popup?(t.interval&&window.clearInterval(t.interval),t.popup.close(),t.popup=null,window.removeEventListener("message",t.DialogEventListener),t.NotifyError=null,r(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)):r(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError)},t.prototype.sendMessage=function(e){var t,n;this.osfSupportsDialogOrigin&&e[Microsoft.Office.WebExtension.Parameters.TargetOrigin]?(t=JSON.stringify(e),n=OSF.Webkit.MethodId.SendMessage2):(t=e[Microsoft.Office.WebExtension.Parameters.MessageContent],n=OSF.Webkit.MethodId.SendMessage,!isNaN(parseFloat(t))&&isFinite(t)&&(t=t.toString())),this.hostScriptProxy.invokeMethod(OSF.Webkit.MessageHandlerName,n,t,null)},t}();e.WebkitHostController=t}(OSFWebkit||(OSFWebkit={})),OSF.Webkit=OSFWebkit,OSF.initializeWebkitCommon=function(){OSF.DDA.ClientSettingsManager={getSettingsExecuteMethod:function(e){return function(t){var n=function(e,n){t.onReceiving&&t.onReceiving(),t.onComplete&&t.onComplete(e,n)};try{e(t.hostCallArgs,t.onCalling,n)}catch(e){n(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError,{name:Strings.OfficeOM.L_InternalError,message:e})}}},read:function(e,t){e&&e();OSF._OfficeAppFactory.getInitializationHelper().getAppContext(null,(function(e){t&&t(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess,e.get_settings())}))},write:function(e,t,n,r){var o={},i=[],a=[];for(var s in e)i.push(s),a.push(e[s]);o.keys=i,o.values=a,n&&n();OSF.ScriptMessaging.GetScriptMessenger().invokeMethod(OSF.Webkit.MessageHandlerName,OSF.Webkit.MethodId.WriteSettings,o,(function(e){r&&r(e[0],null)}))}},OSF.InitializationHelper.prototype.initializeSettings=function(e,t){var n=e.get_settings();return this.deserializeSettings(n,t)},OSF.InitializationHelper.prototype.getAppContext=function(e,t){var n;n=this._hostInfo.isDialog&&window.webkit.messageHandlers[OSF.Webkit.PopupMessageHandlerName]?OSF.Webkit.PopupMessageHandlerName:OSF.Webkit.MessageHandlerName,OSF.ScriptMessaging.GetScriptMessenger().invokeMethod(n,OSF.Webkit.MethodId.GetContext,[],(function(e){for(var n,r=OSF.Webkit.AppContextProperties,o=e[r.AppType],i=e[r.Settings],a={},s=i[0],c=i[1],l=0;l<s.length;l++)a[s[l]]=c[l];var u=e[r.SolutionReferenceId],p=e[r.MajorVersion],f=e[r.MinorVersion],d=e[r.AppCapabilities],h=e[r.APPUILocale],m=e[r.AppDataLocale],g=e[r.DocumentUrl],y=e[r.ActivationMode],O=e[r.ControlIntegrationLevel],_=e[r.SolutionToken];_=_?_.toString():"";var b=e[r.CorrelationId],v=e[r.InstanceId],S=e[r.TouchEnabled],A=e[r.CommerceAllowed],D=e[r.RequirementMatrix],P=e[r.HostCustomMessage],I=e[r.HostFullVersion],C=e[r.InitialDisplayMode];n=new OSF.OfficeAppContext(u,o,p,h,m,g,d,a,y,O,_,b,v,S,A,f,D,P,I,void 0,void 0,void 0,void 0,void 0,void 0,void 0,C),OSF.AppTelemetry&&OSF.AppTelemetry.initialize(n),t(n)}))}},function(e){!function(t){var n=function(){function e(){this._osfOfficeTheme=null,this._osfOfficeThemeTimeStamp=null}return e.prototype.getOfficeTheme=function(){if(OSF.DDA._OsfControlContext){if(this._osfOfficeTheme&&this._osfOfficeThemeTimeStamp&&(new Date).getTime()-this._osfOfficeThemeTimeStamp<e._osfOfficeThemeCacheValidPeriod)OSF.AppTelemetry&&OSF.AppTelemetry.onPropertyDone("GetOfficeThemeInfo",0);else{var t=(new Date).getTime(),n=OSF.DDA._OsfControlContext.GetOfficeThemeInfo(),r=(new Date).getTime();for(var o in OSF.AppTelemetry&&OSF.AppTelemetry.onPropertyDone("GetOfficeThemeInfo",Math.abs(r-t)),this._osfOfficeTheme=JSON.parse(n),this._osfOfficeTheme)this._osfOfficeTheme[o]=OSF.OUtil.convertIntToCssHexColor(this._osfOfficeTheme[o]);this._osfOfficeThemeTimeStamp=r}return this._osfOfficeTheme}},e.instance=function(){return null==e._instance&&(e._instance=new e),e._instance},e._osfOfficeThemeCacheValidPeriod=5e3,e._instance=null,e}();t.OfficeThemeManager=n,OSF.OUtil.setNamespace("OfficeTheme",OSF.DDA),OSF.DDA.OfficeTheme.getOfficeTheme=e.OfficeTheme.OfficeThemeManager.instance().getOfficeTheme}(e.OfficeTheme||(e.OfficeTheme={}))}(OfficeExt||(OfficeExt={})),OSF.initializeRichCommon=function(){OSF.DDA.ClientSettingsManager={getSettingsExecuteMethod:function(e){return function(t){var n;try{n=e(t.hostCallArgs,t.onCalling,(function(e,n){t.onReceiving&&t.onReceiving(),t.onComplete&&t.onComplete(e,n)}))}catch(e){var r=OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError;n={name:Strings.OfficeOM.L_InternalError,message:e},t.onComplete&&t.onComplete(r,n)}}},read:function(e,t){var n=[],r=[];e&&e(),"undefined"!=typeof OsfOMToken&&OsfOMToken?OSF.DDA._OsfControlContext.GetSettings(OsfOMToken).Read(n,r):OSF.DDA._OsfControlContext.GetSettings().Read(n,r);for(var o={},i=0;i<n.length;i++)o[n[i]]=r[i];return t&&t(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess,o),o},write:function(e,t,n,r){var o,i=[],a=[];for(var s in e)i.push(s),a.push(e[s]);n&&n(),"undefined"!=typeof(o="undefined"!=typeof OsfOMToken&&OsfOMToken?OSF.DDA._OsfControlContext.GetSettings(OsfOMToken):OSF.DDA._OsfControlContext.GetSettings()).WriteAsync?o.WriteAsync(i,a,r):(o.Write(i,a),r&&r(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess))},refresh:function(e,t){var n,r=[],o=[];e&&e(),n="undefined"!=typeof OsfOMToken&&OsfOMToken?OSF.DDA._OsfControlContext.GetSettings(OsfOMToken):OSF.DDA._OsfControlContext.GetSettings();var i=function(){n.Read(r,o);for(var e={},i=0;i<r.length;i++)e[r[i]]=o[i];t&&t(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess,e)};n.RefreshAsync?n.RefreshAsync((function(){i()})):i()}},OSF.InitializationHelper.prototype.initializeSettings=function(e){var t=OSF.DDA.ClientSettingsManager.read();return this.deserializeSettings(t,e)},OSF.InitializationHelper.prototype.getAppContext=function(e,t){var n,r,o="Warning: Office.js is loaded outside of Office client";try{if(!window.external||!OSF.OUtil.externalNativeFunctionExists(typeof window.external.GetContext))return void OsfMsAjaxFactory.msAjaxDebug.trace(o);r=OSF.DDA._OsfControlContext=window.external.GetContext()}catch(e){return void OsfMsAjaxFactory.msAjaxDebug.trace(o)}var i,a,s,c,l,u,p,f,d,h,m=r.GetAppType(),g=r.GetSolutionRef(),y=r.GetAppVersionMajor(),O=r.GetAppVersionMinor(),_=r.GetAppUILocale(),b=r.GetAppDataLocale(),v=r.GetDocUrl(),S=r.GetAppCapabilities(),A=r.GetActivationMode(),D=r.GetControlIntegrationLevel();try{i=r.GetSolutionToken()}catch(e){}if(OSF.OUtil.externalNativeFunctionExists(typeof r.GetCorrelationId)&&(a=r.GetCorrelationId()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetInstanceId)&&(s=r.GetInstanceId()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetTouchEnabled)&&(c=r.GetTouchEnabled()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetCommerceAllowed)&&(l=r.GetCommerceAllowed()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetSupportedMatrix)&&(u=r.GetSupportedMatrix()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetHostCustomMessage)&&(p=r.GetHostCustomMessage()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetHostFullVersion)&&(f=r.GetHostFullVersion()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetDialogRequirementMatrix)&&(d=r.GetDialogRequirementMatrix()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetFeaturesForSolution))try{var P=r.GetFeaturesForSolution();P&&(h=JSON.parse(P))}catch(e){OsfMsAjaxFactory.msAjaxDebug.trace("Exception while creating the SDX FeatureGates object. Details: "+e)}var I=0;OSF.OUtil.externalNativeFunctionExists(typeof r.GetInitialDisplayMode)&&(I=r.GetInitialDisplayMode()),i=i?i.toString():"",n=new OSF.OfficeAppContext(g,m,y,_,b,v,S,[],A,D,i,a,s,c,l,O,u,p,f,void 0,void 0,void 0,void 0,d,h,void 0,I),OSF.AppTelemetry&&OSF.AppTelemetry.initialize(n),t(n)}},function(){!function(){return window.webkit&&window.webkit.messageHandlers&&window.webkit.messageHandlers.Agave}()?(OSF.ClientHostController=new OfficeExt.MacRichClientHostController,OSF.initializeRichCommon(),OSF.InitializationHelper.prototype.initializeMacSettings=function(e,t){return this._initializeSettings(t)}):(OSF.ClientHostController=new OSFWebkit.WebkitHostController(OSF.ScriptMessaging.GetScriptMessenger()),OSF.initializeWebkitCommon(),OSF.InitializationHelper.prototype.initializeMacSettings=function(e,t){return this._initializeSettings(e,t)})}(),function(e){var t=function(){function e(e){this._table=e,this._fields={}}return Object.defineProperty(e.prototype,"Fields",{get:function(){return this._fields},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"Table",{get:function(){return this._table},enumerable:!0,configurable:!0}),e.prototype.SerializeFields=function(){},e.prototype.SetSerializedField=function(e,t){"undefined"!==typeof t&&null!==t&&(this._serializedFields[e]=t.toString())},e.prototype.SerializeRow=function(){return this._serializedFields={},this.SetSerializedField("Table",this._table),this.SerializeFields(),JSON.stringify(this._serializedFields)},e}();e.BaseUsageData=t;var n=function(e){function t(){return e.call(this,"AppActivated")||this}return __extends(t,e),Object.defineProperty(t.prototype,"CorrelationId",{get:function(){return this.Fields.CorrelationId},set:function(e){this.Fields.CorrelationId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"SessionId",{get:function(){return this.Fields.SessionId},set:function(e){this.Fields.SessionId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppId",{get:function(){return this.Fields.AppId},set:function(e){this.Fields.AppId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppInstanceId",{get:function(){return this.Fields.AppInstanceId},set:function(e){this.Fields.AppInstanceId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppURL",{get:function(){return this.Fields.AppURL},set:function(e){this.Fields.AppURL=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AssetId",{get:function(){return this.Fields.AssetId},set:function(e){this.Fields.AssetId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"Browser",{get:function(){return this.Fields.Browser},set:function(e){this.Fields.Browser=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"UserId",{get:function(){return this.Fields.UserId},set:function(e){this.Fields.UserId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"Host",{get:function(){return this.Fields.Host},set:function(e){this.Fields.Host=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"HostVersion",{get:function(){return this.Fields.HostVersion},set:function(e){this.Fields.HostVersion=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"ClientId",{get:function(){return this.Fields.ClientId},set:function(e){this.Fields.ClientId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppSizeWidth",{get:function(){return this.Fields.AppSizeWidth},set:function(e){this.Fields.AppSizeWidth=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppSizeHeight",{get:function(){return this.Fields.AppSizeHeight},set:function(e){this.Fields.AppSizeHeight=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"Message",{get:function(){return this.Fields.Message},set:function(e){this.Fields.Message=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"DocUrl",{get:function(){return this.Fields.DocUrl},set:function(e){this.Fields.DocUrl=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"OfficeJSVersion",{get:function(){return this.Fields.OfficeJSVersion},set:function(e){this.Fields.OfficeJSVersion=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"HostJSVersion",{get:function(){return this.Fields.HostJSVersion},set:function(e){this.Fields.HostJSVersion=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"WacHostEnvironment",{get:function(){return this.Fields.WacHostEnvironment},set:function(e){this.Fields.WacHostEnvironment=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"IsFromWacAutomation",{get:function(){return this.Fields.IsFromWacAutomation},set:function(e){this.Fields.IsFromWacAutomation=e},enumerable:!0,configurable:!0}),t.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId),this.SetSerializedField("SessionId",this.SessionId),this.SetSerializedField("AppId",this.AppId),this.SetSerializedField("AppInstanceId",this.AppInstanceId),this.SetSerializedField("AppURL",this.AppURL),this.SetSerializedField("AssetId",this.AssetId),this.SetSerializedField("Browser",this.Browser),this.SetSerializedField("UserId",this.UserId),this.SetSerializedField("Host",this.Host),this.SetSerializedField("HostVersion",this.HostVersion),this.SetSerializedField("ClientId",this.ClientId),this.SetSerializedField("AppSizeWidth",this.AppSizeWidth),this.SetSerializedField("AppSizeHeight",this.AppSizeHeight),this.SetSerializedField("Message",this.Message),this.SetSerializedField("DocUrl",this.DocUrl),this.SetSerializedField("OfficeJSVersion",this.OfficeJSVersion),this.SetSerializedField("HostJSVersion",this.HostJSVersion),this.SetSerializedField("WacHostEnvironment",this.WacHostEnvironment),this.SetSerializedField("IsFromWacAutomation",this.IsFromWacAutomation)},t}(t);e.AppActivatedUsageData=n;var r=function(e){function t(){return e.call(this,"ScriptLoad")||this}return __extends(t,e),Object.defineProperty(t.prototype,"CorrelationId",{get:function(){return this.Fields.CorrelationId},set:function(e){this.Fields.CorrelationId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"SessionId",{get:function(){return this.Fields.SessionId},set:function(e){this.Fields.SessionId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"ScriptId",{get:function(){return this.Fields.ScriptId},set:function(e){this.Fields.ScriptId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"StartTime",{get:function(){return this.Fields.StartTime},set:function(e){this.Fields.StartTime=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"ResponseTime",{get:function(){return this.Fields.ResponseTime},set:function(e){this.Fields.ResponseTime=e},enumerable:!0,configurable:!0}),t.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId),this.SetSerializedField("SessionId",this.SessionId),this.SetSerializedField("ScriptId",this.ScriptId),this.SetSerializedField("StartTime",this.StartTime),this.SetSerializedField("ResponseTime",this.ResponseTime)},t}(t);e.ScriptLoadUsageData=r;var o=function(e){function t(){return e.call(this,"AppClosed")||this}return __extends(t,e),Object.defineProperty(t.prototype,"CorrelationId",{get:function(){return this.Fields.CorrelationId},set:function(e){this.Fields.CorrelationId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"SessionId",{get:function(){return this.Fields.SessionId},set:function(e){this.Fields.SessionId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"FocusTime",{get:function(){return this.Fields.FocusTime},set:function(e){this.Fields.FocusTime=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppSizeFinalWidth",{get:function(){return this.Fields.AppSizeFinalWidth},set:function(e){this.Fields.AppSizeFinalWidth=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppSizeFinalHeight",{get:function(){return this.Fields.AppSizeFinalHeight},set:function(e){this.Fields.AppSizeFinalHeight=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"OpenTime",{get:function(){return this.Fields.OpenTime},set:function(e){this.Fields.OpenTime=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"CloseMethod",{get:function(){return this.Fields.CloseMethod},set:function(e){this.Fields.CloseMethod=e},enumerable:!0,configurable:!0}),t.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId),this.SetSerializedField("SessionId",this.SessionId),this.SetSerializedField("FocusTime",this.FocusTime),this.SetSerializedField("AppSizeFinalWidth",this.AppSizeFinalWidth),this.SetSerializedField("AppSizeFinalHeight",this.AppSizeFinalHeight),this.SetSerializedField("OpenTime",this.OpenTime),this.SetSerializedField("CloseMethod",this.CloseMethod)},t}(t);e.AppClosedUsageData=o;var i=function(e){function t(){return e.call(this,"APIUsage")||this}return __extends(t,e),Object.defineProperty(t.prototype,"CorrelationId",{get:function(){return this.Fields.CorrelationId},set:function(e){this.Fields.CorrelationId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"SessionId",{get:function(){return this.Fields.SessionId},set:function(e){this.Fields.SessionId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"APIType",{get:function(){return this.Fields.APIType},set:function(e){this.Fields.APIType=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"APIID",{get:function(){return this.Fields.APIID},set:function(e){this.Fields.APIID=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"Parameters",{get:function(){return this.Fields.Parameters},set:function(e){this.Fields.Parameters=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"ResponseTime",{get:function(){return this.Fields.ResponseTime},set:function(e){this.Fields.ResponseTime=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"ErrorType",{get:function(){return this.Fields.ErrorType},set:function(e){this.Fields.ErrorType=e},enumerable:!0,configurable:!0}),t.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId),this.SetSerializedField("SessionId",this.SessionId),this.SetSerializedField("APIType",this.APIType),this.SetSerializedField("APIID",this.APIID),this.SetSerializedField("Parameters",this.Parameters),this.SetSerializedField("ResponseTime",this.ResponseTime),this.SetSerializedField("ErrorType",this.ErrorType)},t}(t);e.APIUsageUsageData=i;var a=function(e){function t(){return e.call(this,"AppInitialization")||this}return __extends(t,e),Object.defineProperty(t.prototype,"CorrelationId",{get:function(){return this.Fields.CorrelationId},set:function(e){this.Fields.CorrelationId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"SessionId",{get:function(){return this.Fields.SessionId},set:function(e){this.Fields.SessionId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"SuccessCode",{get:function(){return this.Fields.SuccessCode},set:function(e){this.Fields.SuccessCode=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"Message",{get:function(){return this.Fields.Message},set:function(e){this.Fields.Message=e},enumerable:!0,configurable:!0}),t.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId),this.SetSerializedField("SessionId",this.SessionId),this.SetSerializedField("SuccessCode",this.SuccessCode),this.SetSerializedField("Message",this.Message)},t}(t);e.AppInitializationUsageData=a;var s=function(e){function t(){return e.call(this,"CheckWACHost")||this}return __extends(t,e),Object.defineProperty(t.prototype,"isWacKnownHost",{get:function(){return this.Fields.isWacKnownHost},set:function(e){this.Fields.isWacKnownHost=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"instanceId",{get:function(){return this.Fields.instanceId},set:function(e){this.Fields.instanceId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"hostType",{get:function(){return this.Fields.hostType},set:function(e){this.Fields.hostType=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"hostPlatform",{get:function(){return this.Fields.hostPlatform},set:function(e){this.Fields.hostPlatform=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"wacDomain",{get:function(){return this.Fields.wacDomain},set:function(e){this.Fields.wacDomain=e},enumerable:!0,configurable:!0}),t.prototype.SerializeFields=function(){this.SetSerializedField("isWacKnownHost",this.isWacKnownHost),this.SetSerializedField("instanceId",this.instanceId),this.SetSerializedField("hostType",this.hostType),this.SetSerializedField("hostPlatform",this.hostPlatform),this.SetSerializedField("wacDomain",this.wacDomain)},t}(t);e.CheckWACHostUsageData=s}(OSFLog||(OSFLog={})),function(e){"use strict";!function(e){e[e.info=0]="info",e[e.warning=1]="warning",e[e.error=2]="error"}(e.TraceLevel||(e.TraceLevel={})),function(e){e[e.none=0]="none",e[e.flush=1]="flush"}(e.SendFlag||(e.SendFlag={})),e.allowUploadingData=function(){},e.sendLog=function(e,t,n){};var t=function(){function e(){}return e.prototype.writeLog=function(e){},e.prototype.loadProxyFrame=function(){},e}();OSF.Logger||(OSF.Logger=e),e.ulsEndpoint=function(){try{return new t}catch(e){return null}}()}(Logger||(Logger={})),function(e){var t=[{name:"AppActivated",enabled:!0,critical:!0,points:[{name:"Browser",type:"string"},{name:"Message",type:"string"},{name:"Host",type:"string"},{name:"AppSizeWidth",type:"int64"},{name:"AppSizeHeight",type:"int64"},{name:"IsFromWacAutomation",type:"string"}]},{name:"ScriptLoad",enabled:!0,critical:!1,points:[{name:"ScriptId",type:"string"},{name:"StartTime",type:"double"},{name:"ResponseTime",type:"double"}]},{name:"APIUsage",enabled:function(){if(!OSF._OfficeAppFactory||!OSF._OfficeAppFactory.getHostInfo)return!1;var e=OSF._OfficeAppFactory.getHostInfo();if(!e)return!1;switch(e.hostType){case"outlook":switch(e.hostPlatform){case"mac":case"web":return!0;default:return!1}default:return!1}}(),critical:!1,points:[{name:"APIType",type:"string"},{name:"APIID",type:"int64"},{name:"Parameters",type:"string"},{name:"ResponseTime",type:"int64"},{name:"ErrorType",type:"int64"}]},{name:"AppInitialization",enabled:!0,critical:!1,points:[{name:"SuccessCode",type:"int64"},{name:"Message",type:"string"}]},{name:"AppClosed",enabled:!0,critical:!1,points:[{name:"FocusTime",type:"int64"},{name:"AppSizeFinalWidth",type:"int64"},{name:"AppSizeFinalHeight",type:"int64"},{name:"OpenTime",type:"int64"}]},{name:"CheckWACHost",enabled:!0,critical:!1,points:[{name:"isWacKnownHost",type:"int64"},{name:"solutionId",type:"string"},{name:"hostType",type:"string"},{name:"hostPlatform",type:"string"},{name:"correlationId",type:"string"}]}];function n(e,t){var n=void 0===t.rename?t.name:t.rename,r=void 0;switch(t.type){case"string":r=oteljs.makeStringDataField(n,e);break;case"double":"string"===typeof e&&(e=parseFloat(e)),r=oteljs.makeDoubleDataField(n,e);break;case"int64":"string"===typeof e&&(e=parseInt(e)),r=oteljs.makeInt64DataField(n,e);break;case"boolean":"string"===typeof e&&(e="true"===e),r=oteljs.makeBooleanDataField(n,e)}return r}function r(e){for(var n=0,r=t;n<r.length;n++){var o=r[n];if(o.name===e)return o}}function o(e,t){(function(e){var t=r(e);return void 0!==t&&t.enabled})(e)&&"undefined"!==typeof OTel&&OTel.OTelLogger.onTelemetryLoaded((function(){var o=function(e,t){var o=r(e);if(void 0!==o){for(var i=[],a=0,s=o.points;a<s.length;a++){var c=s[a],l=t[c.name];if(void 0!==l){var u=n(l,c);void 0!==u&&i.push(u)}}var p={dataCategories:oteljs.DataCategories.ProductServiceUsage};return o.critical&&(p.samplingPolicy=oteljs.SamplingPolicy.CriticalBusinessImpact),p.diagnosticLevel=oteljs.DiagnosticLevel.NecessaryServiceDataEvent,{eventName:"Office.Extensibility.OfficeJs."+e+"X",dataFields:i,eventFlags:p}}}(e,t);void 0!==o&&Microsoft.Office.WebExtension.sendTelemetryEvent(o)}))}var i=function(){function e(){}return e.prototype.getAriaCDNLocation=function(){return OSF._OfficeAppFactory.getLoadScriptHelper().getOfficeJsBasePath()+"ariatelemetry/aria-web-telemetry.js"},e.getInstance=function(){return void 0===e.AriaLoggerObj&&(e.AriaLoggerObj=new e),e.AriaLoggerObj},e.prototype.isIUsageData=function(e){return void 0!==e.Fields},e.prototype.shouldSendDirectToAria=function(e,t){var n;if(!e)return!1;if("win32"===e.toLowerCase())n=[16,0,11601];else{if("mac"!==e.toLowerCase())return!0;n=[16,28]}if(!t)return!1;for(var r=t.split("."),o=0;o<n.length&&o<r.length;o++){var i=parseInt(r[o],10);if(isNaN(i))return!1;if(i<n[o])return!0;if(i>n[o])return!1}return!1},e.prototype.isDirectToAriaEnabled=function(){if(void 0===this.EnableDirectToAria||null===this.EnableDirectToAria){var e=void 0,t=void 0;OSF._OfficeAppFactory&&OSF._OfficeAppFactory.getHostInfo&&(e=OSF._OfficeAppFactory.getHostInfo().hostPlatform),window.external&&"undefined"!==typeof window.external.GetContext&&"undefined"!==typeof window.external.GetContext().GetHostFullVersion&&(t=window.external.GetContext().GetHostFullVersion()),this.EnableDirectToAria=this.shouldSendDirectToAria(e,t)}return this.EnableDirectToAria},e.prototype.sendTelemetry=function(t,n){e.EnableSendingTelemetryWithLegacyAria&&this.isDirectToAriaEnabled()&&OSF.OUtil.loadScript(this.getAriaCDNLocation(),(function(){try{if(!this.ALogger){this.ALogger=AWTLogManager.initialize("db334b301e7b474db5e0f02f07c51a47-a1b5bc36-1bbe-482f-a64a-c2d9cb606706-7439")}var e=new AWTEventProperties;for(var r in e.setName("Office.Extensibility.OfficeJS."+t),n)"table"!==r.toLowerCase()&&e.setProperty(r,n[r]);var o=new Date;e.setProperty("Date",o.toISOString()),this.ALogger.logEvent(e)}catch(e){}}),1e3),e.EnableSendingTelemetryWithOTel&&o(t,n)},e.prototype.logData=function(e){this.isIUsageData(e)?this.sendTelemetry(e.Table,e.Fields):this.sendTelemetry(e.Table,e)},e.EnableSendingTelemetryWithOTel=!0,e.EnableSendingTelemetryWithLegacyAria=!1,e}();e.AriaLogger=i}(OSFAriaLogger||(OSFAriaLogger={})),function(e){"use strict";var t,n=OSF.OUtil.Guid.generateNewGuid(),r="",o=new RegExp("^https?://store\\.office(ppe|-int)?\\.com/","i");e.enableTelemetry=!0;var i=function(){return function(){}}();e.AppInfo=i;var a=function(){return function(e,t){this.name=e,this.handler=t}}(),s=function(){function e(){this.clientIDKey="Office API client",this.logIdSetKey="Office App Log Id Set"}return e.prototype.getClientId=function(){var e=this.getValue(this.clientIDKey);return(!e||e.length<=0||e.length>40)&&(e=OSF.OUtil.Guid.generateNewGuid(),this.setValue(this.clientIDKey,e)),e},e.prototype.saveLog=function(e,t){var n=this.getValue(this.logIdSetKey);n=(n&&n.length>0?n+";":"")+e,this.setValue(this.logIdSetKey,n),this.setValue(e,t)},e.prototype.enumerateLog=function(e,t){var n=this.getValue(this.logIdSetKey);if(n){var r=n.split(";");for(var o in r){var i=r[o],a=this.getValue(i);a&&(e&&e(i,a),t&&this.remove(i))}t&&this.remove(this.logIdSetKey)}},e.prototype.getValue=function(e){var t=OSF.OUtil.getLocalStorage(),n="";return t&&(n=t.getItem(e)),n},e.prototype.setValue=function(e,t){var n=OSF.OUtil.getLocalStorage();n&&n.setItem(e,t)},e.prototype.remove=function(e){var t=OSF.OUtil.getLocalStorage();if(t)try{t.removeItem(e)}catch(e){}},e}(),c=function(){function t(){}return t.prototype.LogData=function(t){if(e.enableTelemetry)try{OSFAriaLogger.AriaLogger.getInstance().logData(t)}catch(e){}},t.prototype.LogRawData=function(t){if(e.enableTelemetry)try{OSFAriaLogger.AriaLogger.getInstance().logData(JSON.parse(t))}catch(e){}},t}();function l(e){return e&&(e=e.replace(/[{}]/g,"").toLowerCase()),e||""}function u(e,t){var o=new OSFLog.AppInitializationUsageData;o.CorrelationId=l(r),o.SessionId=n,o.SuccessCode=e?1:0,o.Message=t,(new c).LogData(o)}function p(){var e=0!=(OSF._OfficeAppFactory.getHostInfo().flags&OSF.HostInfoFlags.PublicAddin);return e||!!t&&d(OSF._OfficeAppFactory.getHostInfo().hostPlatform,t.hostVersion)}function f(e,t){return p()||t!==e?t:"PRIVATE"}function d(e,t){var n=!1,r=/^(\d+)\.(\d+)\.(\d+)\.(\d+)$/.exec(t);if(r){var o=parseInt(r[1]),i=parseInt(r[2]),a=parseInt(r[3]);"win32"==e?(o<16||16==o&&a<14225)&&(n=!0):"mac"==e&&(o<16||16==o&&(i<52||52==i&&a<808))&&(n=!0)}return n}e.initialize=function(r){if(e.enableTelemetry&&!t){t=new i,r.get_hostFullVersion()?t.hostVersion=r.get_hostFullVersion():t.hostVersion=r.get_appVersion(),t.appId=p()?r.get_id():"PRIVATE",t.marketplaceType=r._marketplaceType,t.browser=window.navigator.userAgent,t.correlationId=l(r.get_correlationId()),t.clientId=(new s).getClientId(),t.appInstanceId=r.get_appInstanceId(),t.appInstanceId&&(t.appInstanceId=l(t.appInstanceId),t.appInstanceId=f(r.get_id(),t.appInstanceId)),t.message=r.get_hostCustomMessage(),t.officeJSVersion=OSF.ConstantNames.FileVersion,t.hostJSVersion="16.0.15407.10000",r._wacHostEnvironment&&(t.wacHostEnvironment=r._wacHostEnvironment),void 0!==r._isFromWacAutomation&&null!==r._isFromWacAutomation&&(t.isFromWacAutomation=r._isFromWacAutomation.toString().toLowerCase());var c=r.get_docUrl();t.docUrl=o.test(c)?c:"";var u=location.href;u&&(u=u.split("?")[0].split("#")[0]),t.appURL="",function(e,t){var n,r;t.assetId="",t.userId="";try{n=decodeURIComponent(e);var o=(r=(new DOMParser).parseFromString(n,"text/xml")).getElementsByTagName("t")[0].attributes.getNamedItem("cid"),i=r.getElementsByTagName("t")[0].attributes.getNamedItem("oid");o&&o.nodeValue?t.userId=o.nodeValue:i&&i.nodeValue&&(t.userId=i.nodeValue),t.assetId=r.getElementsByTagName("t")[0].attributes.getNamedItem("aid").nodeValue}catch(e){}finally{n=null,r=null,null}}(r.get_eToken(),t),t.sessionId=n,"undefined"!==typeof OTel&&OTel.OTelLogger.initialize(t),function(){var t=new Date,n=null,r=0,o=!1,i=function(){document.hasFocus()?null==n&&(n=new Date):n&&(r+=Math.abs((new Date).getTime()-n.getTime()),n=null)},s=[];s.push(new a("focus",i)),s.push(new a("blur",i)),s.push(new a("focusout",i)),s.push(new a("focusin",i));var c=function(){for(var i=0;i<s.length;i++)OSF.OUtil.removeEventListener(window,s[i].name,s[i].handler);s.length=0,o||(document.hasFocus()&&n&&(r+=Math.abs((new Date).getTime()-n.getTime()),n=null),e.onAppClosed(Math.abs((new Date).getTime()-t.getTime()),r),o=!0)};s.push(new a("beforeunload",c)),s.push(new a("unload",c));for(var l=0;l<s.length;l++)OSF.OUtil.addEventListener(window,s[l].name,s[l].handler);i()}(),e.onAppActivated()}},e.onAppActivated=function(){if(t){(new s).enumerateLog((function(e,t){return(new c).LogRawData(t)}),!0);var e=new OSFLog.AppActivatedUsageData;e.SessionId=n,e.AppId=t.appId,e.AssetId=t.assetId,e.AppURL="",e.UserId="",e.ClientId=t.clientId,e.Browser=t.browser,e.HostVersion=t.hostVersion,e.CorrelationId=l(t.correlationId),e.AppSizeWidth=window.innerWidth,e.AppSizeHeight=window.innerHeight,e.AppInstanceId=t.appInstanceId,e.Message=t.message,e.DocUrl=t.docUrl,e.OfficeJSVersion=t.officeJSVersion,e.HostJSVersion=t.hostJSVersion,t.wacHostEnvironment&&(e.WacHostEnvironment=t.wacHostEnvironment),void 0!==t.isFromWacAutomation&&null!==t.isFromWacAutomation&&(e.IsFromWacAutomation=t.isFromWacAutomation),(new c).LogData(e)}},e.onScriptDone=function(e,t,r,o){var i=new OSFLog.ScriptLoadUsageData;i.CorrelationId=l(o),i.SessionId=n,i.ScriptId=e,i.StartTime=t,i.ResponseTime=r,(new c).LogData(i)},e.onCallDone=function(e,o,i,a,s){if(t&&function(){if(!OSF._OfficeAppFactory||!OSF._OfficeAppFactory.getHostInfo)return!1;var e=OSF._OfficeAppFactory.getHostInfo();if(!e)return!1;switch(e.hostType){case"outlook":switch(e.hostPlatform){case"mac":case"web":return!0;default:return!1}default:return!1}}()&&function(e,t){if("method"===t)switch(e){case 3:case 4:case 38:case 37:case 10:case 12:return!0;default:return!1}return!1}(o,e)){var u=new OSFLog.APIUsageUsageData;u.CorrelationId=l(r),u.SessionId=n,u.APIType=e,u.APIID=o,u.Parameters=i,u.ResponseTime=a,u.ErrorType=s,(new c).LogData(u)}},e.onMethodDone=function(e,t,n,r){var o=null;if(t)if("number"==typeof t)o=String(t);else if("object"===typeof t)for(var i in t)null!==o?o+=",":o="","number"==typeof t[i]&&(o+=String(t[i]));else o="";OSF.AppTelemetry.onCallDone("method",e,o,n,r)},e.onPropertyDone=function(e,t){OSF.AppTelemetry.onCallDone("property",-1,e,t)},e.onCheckWACHost=function(e,t,n,r,o){var i=new OSFLog.CheckWACHostUsageData;i.isWacKnownHost=e,i.instanceId=t,i.hostType=n,i.hostPlatform=r,i.wacDomain="",(new c).LogData(i)},e.onEventDone=function(e,t){OSF.AppTelemetry.onCallDone("event",e,null,0,t)},e.onRegisterDone=function(e,t,n,r){OSF.AppTelemetry.onCallDone(e?"registerevent":"unregisterevent",t,null,n,r)},e.onAppClosed=function(e,o){if(t){var i=new OSFLog.AppClosedUsageData;i.CorrelationId=l(r),i.SessionId=n,i.FocusTime=o,i.OpenTime=e,i.AppSizeFinalWidth=window.innerWidth,i.AppSizeFinalHeight=window.innerHeight,(new s).saveLog(n,i.SerializeRow())}},e.setOsfControlAppCorrelationId=function(e){r=l(e)},e.doAppInitializationLogging=u,e.logAppCommonMessage=function(e){u(!1,e)},e.logAppException=function(e){u(!0,e)},e.canSendAddinId=p,e.getCompliantAppInstanceId=f,e._isComplianceExceptedHost=d,OSF.AppTelemetry=e}(OSFAppTelemetry||(OSFAppTelemetry={})),function(e){function t(e,t){if(t+="_Resource",void 0!==oteljs)return[oteljs.makeDoubleDataField(t+"_responseEnd",e.responseEnd),oteljs.makeDoubleDataField(t+"_responseStart",e.responseStart),oteljs.makeDoubleDataField(t+"_startTime",e.startTime),oteljs.makeDoubleDataField(t+"_transferSize",e.transferSize)]}e.sendPerformanceTelemetry=function(){var e,n;"undefined"!==typeof OTel&&OSF.AppTelemetry.enableTelemetry&&"undefined"!==typeof OSFPerformance&&"undefined"!=typeof performance&&performance.getEntriesByType&&(performance.getEntriesByType("resource").forEach((function(t){var r=t.name.toLowerCase();OSF.OUtil.stringEndsWith(r,OSFPerformance.hostSpecificFileName)?e=t:(OSF.OUtil.stringEndsWith(r,OSF.ConstantNames.OfficeDebugJS)||OSF.OUtil.stringEndsWith(r,OSF.ConstantNames.OfficeJS))&&(n=t)})),OTel.OTelLogger.onTelemetryLoaded((function(){var r=t(e,"HostJs");r=(r=r.concat(t(n,"OfficeJs"))).concat([oteljs.makeDoubleDataField("officeExecuteStartDate",OSFPerformance.officeExecuteStartDate),oteljs.makeDoubleDataField("officeExecuteStart",OSFPerformance.officeExecuteStart),oteljs.makeDoubleDataField("officeExecuteEnd",OSFPerformance.officeExecuteEnd),oteljs.makeDoubleDataField("hostInitializationStart",OSFPerformance.hostInitializationStart),oteljs.makeDoubleDataField("hostInitializationEnd",OSFPerformance.hostInitializationEnd),oteljs.makeDoubleDataField("totalJSHeapSize",OSFPerformance.totalJSHeapSize),oteljs.makeDoubleDataField("usedJSHeapSize",OSFPerformance.usedJSHeapSize),oteljs.makeDoubleDataField("jsHeapSizeLimit",OSFPerformance.jsHeapSizeLimit),oteljs.makeDoubleDataField("getAppContextStart",OSFPerformance.getAppContextStart),oteljs.makeDoubleDataField("getAppContextEnd",OSFPerformance.getAppContextEnd),oteljs.makeDoubleDataField("createOMEnd",OSFPerformance.createOMEnd),oteljs.makeDoubleDataField("officeOnReady",OSFPerformance.officeOnReady),oteljs.makeBooleanDataField("isSharedRuntime",0!==(OSF._OfficeAppFactory.getHostInfo().flags&OSF.HostInfoFlags.SharedApp))]),Microsoft.Office.WebExtension.sendTelemetryEvent({eventName:"Office.Extensibility.OfficeJs.JSPerformanceTelemetryV06",dataFields:r,eventFlags:{dataCategories:oteljs.DataCategories.ProductServiceUsage,diagnosticLevel:oteljs.DiagnosticLevel.NecessaryServiceDataEvent}})})))}}(OSFPerfUtil||(OSFPerfUtil={})),OSF.DDA.AsyncMethodNames.addNames({CloseContainerAsync:"closeContainer"}),function(e){var t=function(){return function(e){}}();e.Container=t}(OfficeExt||(OfficeExt={})),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.CloseContainerAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidCloseContainerMethod,fromHost:[],toHost:[]}),Microsoft.Office.WebExtension.EventType={},OSF.EventDispatch=function(e){if(this._eventHandlers={},this._objectEventHandlers={},this._queuedEventsArgs={},null!=e)for(var t=0;t<e.length;t++){var n=e[t];"objectDeleted"==n||"objectSelectionChanged"==n||"objectDataChanged"==n||"contentControlAdded"==n?this._objectEventHandlers[n]={}:this._eventHandlers[n]=[],this._queuedEventsArgs[n]=[]}},OSF.EventDispatch.prototype={getSupportedEvents:function(){var e=[];for(var t in this._eventHandlers)e.push(t);for(var t in this._objectEventHandlers)e.push(t);return e},supportsEvent:function(e){for(var t in this._eventHandlers)if(e==t)return!0;for(var t in this._objectEventHandlers)if(e==t)return!0;return!1},hasEventHandler:function(e,t){var n=this._eventHandlers[e];if(n&&n.length>0)for(var r=0;r<n.length;r++)if(n[r]===t)return!0;return!1},hasObjectEventHandler:function(e,t,n){var r=this._objectEventHandlers[e];if(null!=r)for(var o=r[t],i=0;null!=o&&i<o.length;i++)if(o[i]===n)return!0;return!1},addEventHandler:function(e,t){if("function"!=typeof t)return!1;var n=this._eventHandlers[e];return!(!n||this.hasEventHandler(e,t))&&(n.push(t),!0)},addObjectEventHandler:function(e,t,n){if("function"!=typeof n)return!1;var r=this._objectEventHandlers[e];return!(!r||this.hasObjectEventHandler(e,t,n))&&(null==r[t]&&(r[t]=[]),r[t].push(n),!0)},addEventHandlerAndFireQueuedEvent:function(e,t){var n=0==this._eventHandlers[e].length,r=this.addEventHandler(e,t);return n&&r&&this.fireQueuedEvent(e),r},removeEventHandler:function(e,t){var n=this._eventHandlers[e];if(n&&n.length>0)for(var r=0;r<n.length;r++)if(n[r]===t)return n.splice(r,1),!0;return!1},removeObjectEventHandler:function(e,t,n){var r=this._objectEventHandlers[e];if(null!=r)for(var o=r[t],i=0;null!=o&&i<o.length;i++)if(o[i]===n)return o.splice(i,1),!0;return!1},clearEventHandlers:function(e){return"undefined"!=typeof this._eventHandlers[e]&&this._eventHandlers[e].length>0&&(this._eventHandlers[e]=[],!0)},clearObjectEventHandlers:function(e,t){return null!=this._objectEventHandlers[e]&&null!=this._objectEventHandlers[e][t]&&(this._objectEventHandlers[e][t]=[],!0)},getEventHandlerCount:function(e){return void 0!=this._eventHandlers[e]?this._eventHandlers[e].length:-1},getObjectEventHandlerCount:function(e,t){return null==this._objectEventHandlers[e]||null==this._objectEventHandlers[e][t]?0:this._objectEventHandlers[e][t].length},fireEvent:function(e){if(void 0==e.type)return!1;var t=e.type;if(t&&this._eventHandlers[t]){for(var n=this._eventHandlers[t],r=0;r<n.length;r++)n[r](e);return!0}return!1},fireObjectEvent:function(e,t){if(void 0==t.type)return!1;var n=t.type;if(n&&this._objectEventHandlers[n]){var r=this._objectEventHandlers[n][e];if(null!=r){for(var o=0;o<r.length;o++)r[o](t);return!0}}return!1},fireOrQueueEvent:function(e){var t=e.type;if(t&&this._eventHandlers[t]){var n=this._eventHandlers[t],r=this._queuedEventsArgs[t];return 0==n.length?r.push(e):this.fireEvent(e),!0}return!1},fireQueuedEvent:function(e){if(e&&this._eventHandlers[e]){var t=this._eventHandlers[e],n=this._queuedEventsArgs[e];if(t.length>0){for(var r=t[0];n.length>0;){r(n.shift())}return!0}}return!1},clearQueuedEvent:function(e){e&&this._eventHandlers[e]&&(this._queuedEventsArgs[e]&&(this._queuedEventsArgs[e]=[]))}},OSF.DDA.OMFactory=OSF.DDA.OMFactory||{},OSF.DDA.OMFactory.manufactureEventArgs=function(e,t,n){var r;switch(e){case Microsoft.Office.WebExtension.EventType.DocumentSelectionChanged:r=new OSF.DDA.DocumentSelectionChangedEventArgs(t);break;case Microsoft.Office.WebExtension.EventType.BindingSelectionChanged:r=new OSF.DDA.BindingSelectionChangedEventArgs(this.manufactureBinding(n,t.document),n[OSF.DDA.PropertyDescriptors.Subset]);break;case Microsoft.Office.WebExtension.EventType.BindingDataChanged:r=new OSF.DDA.BindingDataChangedEventArgs(this.manufactureBinding(n,t.document));break;case Microsoft.Office.WebExtension.EventType.SettingsChanged:r=new OSF.DDA.SettingsChangedEventArgs(t);break;case Microsoft.Office.WebExtension.EventType.ActiveViewChanged:r=new OSF.DDA.ActiveViewChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.OfficeThemeChanged:r=new OSF.DDA.Theming.OfficeThemeChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.DocumentThemeChanged:r=new OSF.DDA.Theming.DocumentThemeChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.AppCommandInvoked:r=OSF.DDA.AppCommand.AppCommandInvokedEventArgs.create(n),"outlook"==OSF._OfficeAppFactory.getHostInfo().hostType&&"mac"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&OSF.DDA.convertOlkAppointmentTimeToDateFormat(r);break;case Microsoft.Office.WebExtension.EventType.ObjectDeleted:case Microsoft.Office.WebExtension.EventType.ObjectSelectionChanged:case Microsoft.Office.WebExtension.EventType.ObjectDataChanged:case Microsoft.Office.WebExtension.EventType.ContentControlAdded:r=new OSF.DDA.ObjectEventArgs(e,n[Microsoft.Office.WebExtension.Parameters.Id]);break;case Microsoft.Office.WebExtension.EventType.RichApiMessage:r=new OSF.DDA.RichApiMessageEventArgs(e,n);break;case Microsoft.Office.WebExtension.EventType.DataNodeInserted:r=new OSF.DDA.NodeInsertedEventArgs(this.manufactureDataNode(n[OSF.DDA.DataNodeEventProperties.NewNode]),n[OSF.DDA.DataNodeEventProperties.InUndoRedo]);break;case Microsoft.Office.WebExtension.EventType.DataNodeReplaced:r=new OSF.DDA.NodeReplacedEventArgs(this.manufactureDataNode(n[OSF.DDA.DataNodeEventProperties.OldNode]),this.manufactureDataNode(n[OSF.DDA.DataNodeEventProperties.NewNode]),n[OSF.DDA.DataNodeEventProperties.InUndoRedo]);break;case Microsoft.Office.WebExtension.EventType.DataNodeDeleted:r=new OSF.DDA.NodeDeletedEventArgs(this.manufactureDataNode(n[OSF.DDA.DataNodeEventProperties.OldNode]),this.manufactureDataNode(n[OSF.DDA.DataNodeEventProperties.NextSiblingNode]),n[OSF.DDA.DataNodeEventProperties.InUndoRedo]);break;case Microsoft.Office.WebExtension.EventType.TaskSelectionChanged:r=new OSF.DDA.TaskSelectionChangedEventArgs(t);break;case Microsoft.Office.WebExtension.EventType.ResourceSelectionChanged:r=new OSF.DDA.ResourceSelectionChangedEventArgs(t);break;case Microsoft.Office.WebExtension.EventType.ViewSelectionChanged:r=new OSF.DDA.ViewSelectionChangedEventArgs(t);break;case Microsoft.Office.WebExtension.EventType.DialogMessageReceived:r=new OSF.DDA.DialogEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived:r=new OSF.DDA.DialogParentEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.ItemChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkItemSelectedChangedEventArgs(n),t.initialize(r.initialData),"win32"!=OSF._OfficeAppFactory.getHostInfo().hostPlatform&&"mac"!=OSF._OfficeAppFactory.getHostInfo().hostPlatform||t.setCurrentItemNumber(r.itemNumber.itemNumber);break;case Microsoft.Office.WebExtension.EventType.RecipientsChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkRecipientsChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.AppointmentTimeChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkAppointmentTimeChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.RecurrenceChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkRecurrenceChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.AttachmentsChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkAttachmentsChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.EnhancedLocationsChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkEnhancedLocationsChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.InfobarClicked:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkInfobarClickedEventArgs(n);break;default:throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e))}return r},OSF.DDA.AsyncMethodNames.addNames({AddHandlerAsync:"addHandlerAsync",RemoveHandlerAsync:"removeHandlerAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AddHandlerAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.EventType,enum:Microsoft.Office.WebExtension.EventType,verify:function(e,t,n){return n.supportsEvent(e)}},{name:Microsoft.Office.WebExtension.Parameters.Handler,types:["function"]}],supportedOptions:[],privateStateCallbacks:[]}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.RemoveHandlerAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.EventType,enum:Microsoft.Office.WebExtension.EventType,verify:function(e,t,n){return n.supportsEvent(e)}}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.Handler,value:{types:["function","object"],defaultValue:null}}],privateStateCallbacks:[]}),OSF.DialogShownStatus={hasDialogShown:!1,isWindowDialog:!1},OSF.OUtil.augmentList(OSF.DDA.EventDescriptors,{DialogMessageReceivedEvent:"DialogMessageReceivedEvent"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{DialogMessageReceived:"dialogMessageReceived",DialogEventReceived:"dialogEventReceived"}),OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{MessageType:"messageType",MessageContent:"messageContent",MessageOrigin:"messageOrigin"}),OSF.DDA.DialogEventType={},OSF.OUtil.augmentList(OSF.DDA.DialogEventType,{DialogClosed:"dialogClosed",NavigationFailed:"naviationFailed"}),OSF.DDA.AsyncMethodNames.addNames({DisplayDialogAsync:"displayDialogAsync",DisplayModalDialogAsync:"displayModalDialogAsync",CloseAsync:"close"}),OSF.DDA.SyncMethodNames.addNames({MessageParent:"messageParent",MessageChild:"messageChild",SendMessage:"sendMessage",AddMessageHandler:"addEventHandler"}),OSF.DDA.UI.ParentUI=function(){var e;if(e=null!=Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived?new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.DialogMessageReceived,Microsoft.Office.WebExtension.EventType.DialogEventReceived,Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived]):new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.DialogMessageReceived,Microsoft.Office.WebExtension.EventType.DialogEventReceived]),Microsoft.Office.WebExtension.FeatureGates&&Microsoft.Office.WebExtension.FeatureGates.OfficeJsDialogRefactor){var t=this,n=function(n,r){t[n]||OSF.OUtil.defineEnumerableProperty(t,n,{value:function(){var n=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.OpenDialog];n(arguments,e,t,r)}})};n(OSF.DDA.AsyncMethodNames.DisplayDialogAsync.displayName,!1),Microsoft.Office.WebExtension.FeatureGates.ModalWebDialogAPI&&n(OSF.DDA.AsyncMethodNames.DisplayModalDialogAsync.displayName,!0)}else{var r=OSF.DDA.AsyncMethodNames.DisplayDialogAsync.displayName,o=this;o[r]||OSF.OUtil.defineEnumerableProperty(o,r,{value:function(){var t=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.OpenDialog];t(arguments,e,o,!1)}})}OSF.OUtil.finalizeProperties(this)},OSF.DDA.UI.ChildUI=function(e){var t=OSF.DDA.SyncMethodNames.MessageParent.displayName,n=this;n[t]||OSF.OUtil.defineEnumerableProperty(n,t,{value:function(){var e=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.MessageParent];return e(arguments,n)}});var r=OSF.DDA.SyncMethodNames.AddMessageHandler.displayName;n[r]||"undefined"==typeof OSF.DialogParentMessageEventDispatch||OSF.DDA.DispIdHost.addEventSupport(n,OSF.DialogParentMessageEventDispatch,e),OSF.OUtil.finalizeProperties(this)},OSF.DialogHandler=function(){},OSF.DDA.DialogEventArgs=function(e){e[OSF.DDA.PropertyDescriptors.MessageType]==OSF.DialogMessageType.DialogMessageReceived?OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DialogMessageReceived},message:{value:e[OSF.DDA.PropertyDescriptors.MessageContent]},origin:{value:e[OSF.DDA.PropertyDescriptors.MessageOrigin]}}):OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DialogEventReceived},error:{value:e[OSF.DDA.PropertyDescriptors.MessageType]}})},OSF.DDA.DialogParentEventArgs=function(e){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived},message:{value:e[OSF.DDA.PropertyDescriptors.MessageContent]},origin:{value:e[OSF.DDA.PropertyDescriptors.MessageOrigin]}})};var DialogApiManager=function(){function e(){}return e.defineApi=function(e,t){OSF.DDA.AsyncMethodCalls.define({method:e,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Url,types:["string"]}],supportedOptions:t,privateStateCallbacks:[],onSucceeded:function(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.Id],o=e[Microsoft.Office.WebExtension.Parameters.Data],i=new OSF.DialogHandler,a=OSF.DDA.AsyncMethodNames.CloseAsync.displayName;OSF.OUtil.defineEnumerableProperty(i,a,{value:function(){var e=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.CloseDialog];e(arguments,r,o,i)}});var s=OSF.DDA.SyncMethodNames.AddMessageHandler.displayName;if(OSF.OUtil.defineEnumerableProperty(i,s,{value:function(){var e=OSF.DDA.SyncMethodCalls[OSF.DDA.SyncMethodNames.AddMessageHandler.id],t=e.verifyAndExtractCall(arguments,i,o),n=t[Microsoft.Office.WebExtension.Parameters.EventType],r=t[Microsoft.Office.WebExtension.Parameters.Handler];return o.addEventHandlerAndFireQueuedEvent(n,r)}}),!0===OSF.DDA.UI.EnableSendMessageDialogAPI){var c=OSF.DDA.SyncMethodNames.SendMessage.displayName;OSF.OUtil.defineEnumerableProperty(i,c,{value:function(){var e=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.SendMessage];return e(arguments,o,i)}})}if(!0===OSF.DDA.UI.EnableMessageChildDialogAPI){var l=OSF.DDA.SyncMethodNames.MessageChild.displayName;OSF.OUtil.defineEnumerableProperty(i,l,{value:function(){var e=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.SendMessage];return e(arguments,o,i)}})}return i},checkCallArgs:function(e,t,n){return e[Microsoft.Office.WebExtension.Parameters.Width]<=0&&(e[Microsoft.Office.WebExtension.Parameters.Width]=1),!e[Microsoft.Office.WebExtension.Parameters.UseDeviceIndependentPixels]&&e[Microsoft.Office.WebExtension.Parameters.Width]>100&&(e[Microsoft.Office.WebExtension.Parameters.Width]=99),e[Microsoft.Office.WebExtension.Parameters.Height]<=0&&(e[Microsoft.Office.WebExtension.Parameters.Height]=1),!e[Microsoft.Office.WebExtension.Parameters.UseDeviceIndependentPixels]&&e[Microsoft.Office.WebExtension.Parameters.Height]>100&&(e[Microsoft.Office.WebExtension.Parameters.Height]=99),e[Microsoft.Office.WebExtension.Parameters.RequireHTTPs]||(e[Microsoft.Office.WebExtension.Parameters.RequireHTTPs]=!0),e}})},e.messageChildRichApiBridge=function(){if(!0===OSF.DDA.UI.EnableMessageChildDialogAPI){var e=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.SendMessage];return e(arguments,null,null)}},e.initOnce=function(){e.defineApi(OSF.DDA.AsyncMethodNames.DisplayDialogAsync,e.displayDialogAsyncApiSupportedOptions),e.defineApi(OSF.DDA.AsyncMethodNames.DisplayModalDialogAsync,e.displayModalDialogAsyncApiSupportedOptions)},e.displayDialogAsyncApiSupportedOptions=[{name:Microsoft.Office.WebExtension.Parameters.Width,value:{types:["number"],defaultValue:99}},{name:Microsoft.Office.WebExtension.Parameters.Height,value:{types:["number"],defaultValue:99}},{name:Microsoft.Office.WebExtension.Parameters.RequireHTTPs,value:{types:["boolean"],defaultValue:!0}},{name:Microsoft.Office.WebExtension.Parameters.DisplayInIframe,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.HideTitle,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.UseDeviceIndependentPixels,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.PromptBeforeOpen,value:{types:["boolean"],defaultValue:!0}},{name:Microsoft.Office.WebExtension.Parameters.EnforceAppDomain,value:{types:["boolean"],defaultValue:!0}},{name:Microsoft.Office.WebExtension.Parameters.UrlNoHostInfo,value:{types:["boolean"],defaultValue:!1}}],e.displayModalDialogAsyncApiSupportedOptions=e.displayDialogAsyncApiSupportedOptions.concat([{name:"abortWhenParentIsMinimized",value:{types:["boolean"],defaultValue:!1}},{name:"abortWhenDocIsInactive",value:{types:["boolean"],defaultValue:!1}}]),e}();DialogApiManager.initOnce(),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.CloseAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[]}),OSF.DDA.SyncMethodCalls.define({method:OSF.DDA.SyncMethodNames.MessageParent,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.MessageToParent,types:["string","number","boolean"]}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.TargetOrigin,value:{types:["string"],defaultValue:""}}]}),OSF.DDA.SyncMethodCalls.define({method:OSF.DDA.SyncMethodNames.AddMessageHandler,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.EventType,enum:Microsoft.Office.WebExtension.EventType,verify:function(e,t,n){return n.supportsEvent(e)}},{name:Microsoft.Office.WebExtension.Parameters.Handler,types:["function"]}],supportedOptions:[]}),OSF.DDA.SyncMethodCalls.define({method:OSF.DDA.SyncMethodNames.SendMessage,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.MessageContent,types:["string"]}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.TargetOrigin,value:{types:["string"],defaultValue:""}}],privateStateCallbacks:[]}),OSF.DDA.SafeArray.Delegate.openDialog=function(e){try{e.onCalling&&e.onCalling();var t=OSF.DDA.SafeArray.Delegate._getOnAfterRegisterEvent(!0,e);OSF.ClientHostController.openDialog(e.dispId,e.targetId,(function(t,n){e.onEvent&&e.onEvent(n),OSF.AppTelemetry&&OSF.AppTelemetry.onEventDone(e.dispId)}),t)}catch(t){OSF.DDA.SafeArray.Delegate._onException(t,e)}},OSF.DDA.SafeArray.Delegate.closeDialog=function(e){e.onCalling&&e.onCalling();var t=OSF.DDA.SafeArray.Delegate._getOnAfterRegisterEvent(!1,e);try{OSF.ClientHostController.closeDialog(e.dispId,e.targetId,t)}catch(t){OSF.DDA.SafeArray.Delegate._onException(t,e)}},OSF.DDA.SafeArray.Delegate.messageParent=function(e){try{e.onCalling&&e.onCalling();var t=(new Date).getTime(),n=OSF.ClientHostController.messageParent(e.hostCallArgs);return e.onReceiving&&e.onReceiving(),OSF.AppTelemetry&&OSF.AppTelemetry.onMethodDone(e.dispId,e.hostCallArgs,Math.abs((new Date).getTime()-t),n),n}catch(e){return OSF.DDA.SafeArray.Delegate._onExceptionSyncMethod(e)}},OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidDialogMessageReceivedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.DialogMessageReceivedEvent,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDescriptors.DialogMessageReceivedEvent,fromHost:[{name:OSF.DDA.PropertyDescriptors.MessageType,value:0},{name:OSF.DDA.PropertyDescriptors.MessageContent,value:1},{name:OSF.DDA.PropertyDescriptors.MessageOrigin,value:2}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.sendMessage=function(e){try{e.onCalling&&e.onCalling();(new Date).getTime();var t=OSF.ClientHostController.sendMessage(e.hostCallArgs);return e.onReceiving&&e.onReceiving(),t}catch(e){return OSF.DDA.SafeArray.Delegate._onExceptionSyncMethod(e)}},OSF.OUtil.augmentList(OSF.DDA.EventDescriptors,{DialogParentMessageReceivedEvent:"DialogParentMessageReceivedEvent"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{DialogParentMessageReceived:"dialogParentMessageReceived",DialogParentEventReceived:"dialogParentEventReceived"}),OSF.DialogParentMessageEventDispatch=new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived,Microsoft.Office.WebExtension.EventType.DialogParentEventReceived]),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidDialogParentMessageReceivedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.DialogParentMessageReceivedEvent,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDescriptors.DialogParentMessageReceivedEvent,fromHost:[{name:OSF.DDA.PropertyDescriptors.MessageType,value:0},{name:OSF.DDA.PropertyDescriptors.MessageContent,value:1},{name:OSF.DDA.PropertyDescriptors.MessageOrigin,value:2}],isComplexType:!0}),OSF.DDA.UI.EnableSendMessageDialogAPI=!0,Microsoft.Office.WebExtension.FileType={Text:"text",Compressed:"compressed",Pdf:"pdf"},OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{FileProperties:"FileProperties",FileSliceProperties:"FileSliceProperties"}),OSF.DDA.FileProperties={Handle:"FileHandle",FileSize:"FileSize",SliceSize:Microsoft.Office.WebExtension.Parameters.SliceSize},OSF.DDA.File=function(e,t,n){OSF.OUtil.defineEnumerableProperties(this,{size:{value:t},sliceCount:{value:Math.ceil(t/n)}});var r={};r[OSF.DDA.FileProperties.Handle]=e,r[OSF.DDA.FileProperties.SliceSize]=n;var o=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[o.GetDocumentCopyChunkAsync,o.ReleaseDocumentCopyAsync],r)},OSF.DDA.FileSliceOffset="fileSliceoffset",OSF.DDA.AsyncMethodNames.addNames({GetDocumentCopyAsync:"getFileAsync",GetDocumentCopyChunkAsync:"getSliceAsync",ReleaseDocumentCopyAsync:"closeAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetDocumentCopyAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.FileType,enum:Microsoft.Office.WebExtension.FileType}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.SliceSize,value:{types:["number"],defaultValue:4194304}}],checkCallArgs:function(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.SliceSize];if(r<=0||r>4194304)throw OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSliceSize;return e},onSucceeded:function(e,t,n){return new OSF.DDA.File(e[OSF.DDA.FileProperties.Handle],e[OSF.DDA.FileProperties.FileSize],n[Microsoft.Office.WebExtension.Parameters.SliceSize])}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetDocumentCopyChunkAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.SliceIndex,types:["number"]}],privateStateCallbacks:[{name:OSF.DDA.FileProperties.Handle,value:function(e,t){return t[OSF.DDA.FileProperties.Handle]}},{name:OSF.DDA.FileProperties.SliceSize,value:function(e,t){return t[OSF.DDA.FileProperties.SliceSize]}}],checkCallArgs:function(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.SliceIndex];if(r<0||r>=t.sliceCount)throw OSF.DDA.ErrorCodeManager.errorCodes.ooeIndexOutOfRange;return e[OSF.DDA.FileSliceOffset]=parseInt((r*n[OSF.DDA.FileProperties.SliceSize]).toString()),e},onSucceeded:function(e,t,n){var r={};return OSF.OUtil.defineEnumerableProperties(r,{data:{value:OSF.OUtil.shallowCopy(e[Microsoft.Office.WebExtension.Parameters.Data])},index:{value:n[Microsoft.Office.WebExtension.Parameters.SliceIndex]},size:{value:e[OSF.DDA.FileProperties.SliceSize]}}),r}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.ReleaseDocumentCopyAsync,privateStateCallbacks:[{name:OSF.DDA.FileProperties.Handle,value:function(e,t){return t[OSF.DDA.FileProperties.Handle]}}]}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.FileType,{Text:"text",Pdf:"pdf"}),OSF.DDA.FilePropertiesDescriptor={Url:"Url"},OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{FilePropertiesDescriptor:"FilePropertiesDescriptor"}),Microsoft.Office.WebExtension.FileProperties=function(e){OSF.OUtil.defineEnumerableProperties(this,{url:{value:e[OSF.DDA.FilePropertiesDescriptor.Url]}})},OSF.DDA.AsyncMethodNames.addNames({GetFilePropertiesAsync:"getFilePropertiesAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetFilePropertiesAsync,fromHost:[{name:OSF.DDA.PropertyDescriptors.FilePropertiesDescriptor,value:0}],requiredArguments:[],supportedOptions:[],onSucceeded:function(e,t,n){return new Microsoft.Office.WebExtension.FileProperties(e)}}),Microsoft.Office.WebExtension.GoToType={Binding:"binding",NamedItem:"namedItem",Slide:"slide",Index:"index"},Microsoft.Office.WebExtension.SelectionMode={Default:"default",Selected:"selected",None:"none"},Microsoft.Office.WebExtension.Index={First:"first",Last:"last",Next:"next",Previous:"previous"},OSF.DDA.AsyncMethodNames.addNames({GoToByIdAsync:"goToByIdAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GoToByIdAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Id,types:["string","number"]},{name:Microsoft.Office.WebExtension.Parameters.GoToType,enum:Microsoft.Office.WebExtension.GoToType}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.SelectionMode,value:{enum:Microsoft.Office.WebExtension.SelectionMode,defaultValue:Microsoft.Office.WebExtension.SelectionMode.Default}}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.GoToType,toHost:[{name:Microsoft.Office.WebExtension.GoToType.Binding,value:0},{name:Microsoft.Office.WebExtension.GoToType.NamedItem,value:1},{name:Microsoft.Office.WebExtension.GoToType.Slide,value:2},{name:Microsoft.Office.WebExtension.GoToType.Index,value:3}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.SelectionMode,toHost:[{name:Microsoft.Office.WebExtension.SelectionMode.Default,value:0},{name:Microsoft.Office.WebExtension.SelectionMode.Selected,value:1},{name:Microsoft.Office.WebExtension.SelectionMode.None,value:2}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidNavigateToMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0},{name:Microsoft.Office.WebExtension.Parameters.GoToType,value:1},{name:Microsoft.Office.WebExtension.Parameters.SelectionMode,value:2}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.FileProperties,fromHost:[{name:OSF.DDA.FileProperties.Handle,value:0},{name:OSF.DDA.FileProperties.FileSize,value:1}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.FileSliceProperties,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:0},{name:OSF.DDA.FileProperties.SliceSize,value:1}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.FileType,toHost:[{name:Microsoft.Office.WebExtension.FileType.Text,value:0},{name:Microsoft.Office.WebExtension.FileType.Compressed,value:5},{name:Microsoft.Office.WebExtension.FileType.Pdf,value:6}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDocumentCopyMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.FileType,value:0}],fromHost:[{name:OSF.DDA.PropertyDescriptors.FileProperties,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDocumentCopyChunkMethod,toHost:[{name:OSF.DDA.FileProperties.Handle,value:0},{name:OSF.DDA.FileSliceOffset,value:1},{name:OSF.DDA.FileProperties.SliceSize,value:2}],fromHost:[{name:OSF.DDA.PropertyDescriptors.FileSliceProperties,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidReleaseDocumentCopyMethod,toHost:[{name:OSF.DDA.FileProperties.Handle,value:0}]}),OSF.DDA.AsyncMethodNames.addNames({GetSelectedDataAsync:"getSelectedDataAsync",SetSelectedDataAsync:"setSelectedDataAsync"}),function(){OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetSelectedDataAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,enum:Microsoft.Office.WebExtension.CoercionType}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.ValueFormat,value:{enum:Microsoft.Office.WebExtension.ValueFormat,defaultValue:Microsoft.Office.WebExtension.ValueFormat.Unformatted}},{name:Microsoft.Office.WebExtension.Parameters.FilterType,value:{enum:Microsoft.Office.WebExtension.FilterType,defaultValue:Microsoft.Office.WebExtension.FilterType.All}}],privateStateCallbacks:[],onSucceeded:function(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.Data];return OSF.DDA.TableDataProperties&&r&&(void 0!=r[OSF.DDA.TableDataProperties.TableRows]||void 0!=r[OSF.DDA.TableDataProperties.TableHeaders])&&(r=OSF.DDA.OMFactory.manufactureTableData(r)),void 0==(r=OSF.DDA.DataCoercion.coerceData(r,n[Microsoft.Office.WebExtension.Parameters.CoercionType]))?null:r}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.SetSelectedDataAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["string","object","number","boolean"]}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:{enum:Microsoft.Office.WebExtension.CoercionType,calculate:function(e){return OSF.DDA.DataCoercion.determineCoercionType(e[Microsoft.Office.WebExtension.Parameters.Data])}}},{name:Microsoft.Office.WebExtension.Parameters.ImageLeft,value:{types:["number","boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.ImageTop,value:{types:["number","boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.ImageWidth,value:{types:["number","boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.ImageHeight,value:{types:["number","boolean"],defaultValue:!1}}],privateStateCallbacks:[]})}(),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetSelectedDataMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:0},{name:Microsoft.Office.WebExtension.Parameters.ValueFormat,value:1},{name:Microsoft.Office.WebExtension.Parameters.FilterType,value:2}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidSetSelectedDataMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:0},{name:Microsoft.Office.WebExtension.Parameters.Data,value:1},{name:Microsoft.Office.WebExtension.Parameters.ImageLeft,value:2},{name:Microsoft.Office.WebExtension.Parameters.ImageTop,value:3},{name:Microsoft.Office.WebExtension.Parameters.ImageWidth,value:4},{name:Microsoft.Office.WebExtension.Parameters.ImageHeight,value:5}]}),OSF.DDA.SettingsManager={SerializedSettings:"serializedSettings",RefreshingSettings:"refreshingSettings",DateJSONPrefix:"Date(",DataJSONSuffix:")",serializeSettings:function(e){return OSF.OUtil.serializeSettings(e)},deserializeSettings:function(e){return OSF.OUtil.deserializeSettings(e)}},OSF.DDA.Settings=function(e){e=e||{};var t=function(e){var t=OSF.OUtil.getSessionStorage();if(t){var n=OSF.DDA.SettingsManager.serializeSettings(e),r=JSON?JSON.stringify(n):Sys.Serialization.JavaScriptSerializer.serialize(n);t.setItem(OSF._OfficeAppFactory.getCachedSessionSettingsKey(),r)}};OSF.OUtil.defineEnumerableProperties(this,{get:{value:function(t){var n=Function._validateParams(arguments,[{name:"name",type:String,mayBeNull:!1}]);if(n)throw n;var r=e[t];return"undefined"===typeof r?null:r}},set:{value:function(n,r){var o=Function._validateParams(arguments,[{name:"name",type:String,mayBeNull:!1},{name:"value",mayBeNull:!0}]);if(o)throw o;e[n]=r,t(e)}},remove:{value:function(n){var r=Function._validateParams(arguments,[{name:"name",type:String,mayBeNull:!1}]);if(r)throw r;delete e[n],t(e)}}}),OSF.DDA.DispIdHost.addAsyncMethods(this,[OSF.DDA.AsyncMethodNames.SaveAsync],e)},OSF.DDA.RefreshableSettings=function(e){OSF.DDA.RefreshableSettings.uber.constructor.call(this,e),OSF.DDA.DispIdHost.addAsyncMethods(this,[OSF.DDA.AsyncMethodNames.RefreshAsync],e),OSF.DDA.DispIdHost.addEventSupport(this,new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.SettingsChanged]))},OSF.OUtil.extend(OSF.DDA.RefreshableSettings,OSF.DDA.Settings),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{SettingsChanged:"settingsChanged"}),OSF.DDA.SettingsChangedEventArgs=function(e){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.SettingsChanged},settings:{value:e}})},OSF.DDA.AsyncMethodNames.addNames({RefreshAsync:"refreshAsync",SaveAsync:"saveAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.RefreshAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[{name:OSF.DDA.SettingsManager.RefreshingSettings,value:function(e,t){return t}}],onSucceeded:function(e,t,n){var r=e[OSF.DDA.SettingsManager.SerializedSettings],o=OSF.DDA.SettingsManager.deserializeSettings(r),i=n[OSF.DDA.SettingsManager.RefreshingSettings];for(var a in i)t.remove(a);for(var a in o)t.set(a,o[a]);return t}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.SaveAsync,requiredArguments:[],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.OverwriteIfStale,value:{types:["boolean"],defaultValue:!0}}],privateStateCallbacks:[{name:OSF.DDA.SettingsManager.SerializedSettings,value:function(e,t){return OSF.DDA.SettingsManager.serializeSettings(t)}}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidLoadSettingsMethod,fromHost:[{name:OSF.DDA.SettingsManager.SerializedSettings,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidSaveSettingsMethod,toHost:[{name:OSF.DDA.SettingsManager.SerializedSettings,value:OSF.DDA.SettingsManager.SerializedSettings},{name:Microsoft.Office.WebExtension.Parameters.OverwriteIfStale,value:Microsoft.Office.WebExtension.Parameters.OverwriteIfStale}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidSettingsChangedEvent}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{DocumentSelectionChanged:"documentSelectionChanged"}),OSF.DDA.DocumentSelectionChangedEventArgs=function(e){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DocumentSelectionChanged},document:{value:e}})},OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{ObjectDeleted:"objectDeleted"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{ObjectSelectionChanged:"objectSelectionChanged"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{ObjectDataChanged:"objectDataChanged"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{ContentControlAdded:"contentControlAdded"}),OSF.DDA.ObjectEventArgs=function(e,t){OSF.OUtil.defineEnumerableProperties(this,{type:{value:e},object:{value:t}})},OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidDocumentSelectionChangedEvent}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidObjectDeletedEvent,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:OSF.DDA.SafeArray.Delegate.ParameterMap.sourceData}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidObjectSelectionChangedEvent,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:OSF.DDA.SafeArray.Delegate.ParameterMap.sourceData}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidObjectDataChangedEvent,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:OSF.DDA.SafeArray.Delegate.ParameterMap.sourceData}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidContentControlAddedEvent,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:OSF.DDA.SafeArray.Delegate.ParameterMap.sourceData}]}),Microsoft.Office.WebExtension.TableData=function(e,t){function n(e){if(null==e||void 0==e)return null;try{for(var t=OSF.DDA.DataCoercion.findArrayDimensionality(e,2);t<2;t++)e=[e];return e}catch(e){}}OSF.OUtil.defineEnumerableProperties(this,{headers:{get:function(){return t},set:function(e){t=n(e)}},rows:{get:function(){return e},set:function(t){e=null==t||OSF.OUtil.isArray(t)&&0==t.length?[]:n(t)}}}),this.headers=t,this.rows=e},OSF.DDA.OMFactory=OSF.DDA.OMFactory||{},OSF.DDA.OMFactory.manufactureTableData=function(e){return new Microsoft.Office.WebExtension.TableData(e[OSF.DDA.TableDataProperties.TableRows],e[OSF.DDA.TableDataProperties.TableHeaders])},Microsoft.Office.WebExtension.CoercionType={Text:"text",Matrix:"matrix",Table:"table"},OSF.DDA.DataCoercion=function(){return{findArrayDimensionality:function(e){if(OSF.OUtil.isArray(e)){for(var t=0,n=0;n<e.length;n++)t=Math.max(t,OSF.DDA.DataCoercion.findArrayDimensionality(e[n]));return t+1}return 0},getCoercionDefaultForBinding:function(e){switch(e){case Microsoft.Office.WebExtension.BindingType.Matrix:return Microsoft.Office.WebExtension.CoercionType.Matrix;case Microsoft.Office.WebExtension.BindingType.Table:return Microsoft.Office.WebExtension.CoercionType.Table;case Microsoft.Office.WebExtension.BindingType.Text:default:return Microsoft.Office.WebExtension.CoercionType.Text}},getBindingDefaultForCoercion:function(e){switch(e){case Microsoft.Office.WebExtension.CoercionType.Matrix:return Microsoft.Office.WebExtension.BindingType.Matrix;case Microsoft.Office.WebExtension.CoercionType.Table:return Microsoft.Office.WebExtension.BindingType.Table;case Microsoft.Office.WebExtension.CoercionType.Text:case Microsoft.Office.WebExtension.CoercionType.Html:case Microsoft.Office.WebExtension.CoercionType.Ooxml:default:return Microsoft.Office.WebExtension.BindingType.Text}},determineCoercionType:function(e){if(null==e||void 0==e)return null;var t=null,n=typeof e;if(void 0!==e.rows)t=Microsoft.Office.WebExtension.CoercionType.Table;else if(OSF.OUtil.isArray(e))t=Microsoft.Office.WebExtension.CoercionType.Matrix;else{if("string"!=n&&"number"!=n&&"boolean"!=n&&!OSF.OUtil.isDate(e))throw OSF.DDA.ErrorCodeManager.errorCodes.ooeUnsupportedDataObject;t=Microsoft.Office.WebExtension.CoercionType.Text}return t},coerceData:function(e,t,n){return(n=n||OSF.DDA.DataCoercion.determineCoercionType(e))&&n!=t&&(OSF.OUtil.writeProfilerMark(OSF.InternalPerfMarker.DataCoercionBegin),e=OSF.DDA.DataCoercion._coerceDataFromTable(t,OSF.DDA.DataCoercion._coerceDataToTable(e,n)),OSF.OUtil.writeProfilerMark(OSF.InternalPerfMarker.DataCoercionEnd)),e},_matrixToText:function(e){if(1==e.length&&1==e[0].length)return""+e[0][0];for(var t="",n=0;n<e.length;n++)t+=e[n].join("\t")+"\n";return t.substring(0,t.length-1)},_textToMatrix:function(e){for(var t=e.split("\n"),n=0;n<t.length;n++)t[n]=t[n].split("\t");return t},_tableToText:function(e){var t="";null!=e.headers&&(t=OSF.DDA.DataCoercion._matrixToText([e.headers])+"\n");var n=OSF.DDA.DataCoercion._matrixToText(e.rows);return""==n&&(t=t.substring(0,t.length-1)),t+n},_tableToMatrix:function(e){var t=e.rows;return null!=e.headers&&t.unshift(e.headers),t},_coerceDataFromTable:function(e,t){var n;switch(e){case Microsoft.Office.WebExtension.CoercionType.Table:n=t;break;case Microsoft.Office.WebExtension.CoercionType.Matrix:n=OSF.DDA.DataCoercion._tableToMatrix(t);break;case Microsoft.Office.WebExtension.CoercionType.SlideRange:n=null,OSF.DDA.OMFactory.manufactureSlideRange&&(n=OSF.DDA.OMFactory.manufactureSlideRange(OSF.DDA.DataCoercion._tableToText(t))),null==n&&(n=OSF.DDA.DataCoercion._tableToText(t));break;case Microsoft.Office.WebExtension.CoercionType.Text:case Microsoft.Office.WebExtension.CoercionType.Html:case Microsoft.Office.WebExtension.CoercionType.Ooxml:default:n=OSF.DDA.DataCoercion._tableToText(t)}return n},_coerceDataToTable:function(e,t){var n;switch(void 0==t&&(t=OSF.DDA.DataCoercion.determineCoercionType(e)),t){case Microsoft.Office.WebExtension.CoercionType.Table:n=e;break;case Microsoft.Office.WebExtension.CoercionType.Matrix:n=new Microsoft.Office.WebExtension.TableData(e);break;case Microsoft.Office.WebExtension.CoercionType.Text:case Microsoft.Office.WebExtension.CoercionType.Html:case Microsoft.Office.WebExtension.CoercionType.Ooxml:default:n=new Microsoft.Office.WebExtension.TableData(OSF.DDA.DataCoercion._textToMatrix(e))}return n}}}(),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.CoercionType,toHost:[{name:Microsoft.Office.WebExtension.CoercionType.Text,value:0},{name:Microsoft.Office.WebExtension.CoercionType.Matrix,value:1},{name:Microsoft.Office.WebExtension.CoercionType.Table,value:2}]}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.CoercionType,{Html:"html"}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.CoercionType,toHost:[{name:Microsoft.Office.WebExtension.CoercionType.Html,value:3}]}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.FilterType,{OnlyVisible:"onlyVisible"}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.FilterType,toHost:[{name:Microsoft.Office.WebExtension.FilterType.OnlyVisible,value:1}]}),OSF.DDA.DataPartProperties={Id:Microsoft.Office.WebExtension.Parameters.Id,BuiltIn:"DataPartBuiltIn"},OSF.DDA.DataNodeProperties={Handle:"DataNodeHandle",BaseName:"DataNodeBaseName",NamespaceUri:"DataNodeNamespaceUri",NodeType:"DataNodeType"},OSF.DDA.DataNodeEventProperties={OldNode:"OldNode",NewNode:"NewNode",NextSiblingNode:"NextSiblingNode",InUndoRedo:"InUndoRedo"},OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{DataPartProperties:"DataPartProperties",DataNodeProperties:"DataNodeProperties"}),OSF.OUtil.augmentList(OSF.DDA.ListDescriptors,{DataPartList:"DataPartList",DataNodeList:"DataNodeList"}),OSF.DDA.ListType.setListType(OSF.DDA.ListDescriptors.DataPartList,OSF.DDA.PropertyDescriptors.DataPartProperties),OSF.DDA.ListType.setListType(OSF.DDA.ListDescriptors.DataNodeList,OSF.DDA.PropertyDescriptors.DataNodeProperties),OSF.OUtil.augmentList(OSF.DDA.EventDescriptors,{DataNodeInsertedEvent:"DataNodeInsertedEvent",DataNodeReplacedEvent:"DataNodeReplacedEvent",DataNodeDeletedEvent:"DataNodeDeletedEvent"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{DataNodeDeleted:"nodeDeleted",DataNodeInserted:"nodeInserted",DataNodeReplaced:"nodeReplaced",NodeDeleted:"nodeDeleted",NodeInserted:"nodeInserted",NodeReplaced:"nodeReplaced"}),OSF.DDA.CustomXmlParts=function(){this._eventDispatches=[];var e=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[e.AddDataPartAsync,e.GetDataPartByIdAsync,e.GetDataPartsByNameSpaceAsync])},OSF.DDA.CustomXmlPart=function(e,t,n){OSF.OUtil.defineEnumerableProperties(this,{builtIn:{value:n},id:{value:t},namespaceManager:{value:new OSF.DDA.CustomXmlPrefixMappings(t)}});var r=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[r.DeleteDataPartAsync,r.GetPartNodesAsync,r.GetPartXmlAsync]);var o=e._eventDispatches,i=o[t];if(!i){var a=Microsoft.Office.WebExtension.EventType;i=new OSF.EventDispatch([a.DataNodeDeleted,a.DataNodeInserted,a.DataNodeReplaced]),o[t]=i}OSF.DDA.DispIdHost.addEventSupport(this,i)},OSF.DDA.CustomXmlPrefixMappings=function(e){var t=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[t.AddDataPartNamespaceAsync,t.GetDataPartNamespaceAsync,t.GetDataPartPrefixAsync],e)},OSF.DDA.CustomXmlNode=function(e,t,n,r){OSF.OUtil.defineEnumerableProperties(this,{baseName:{value:r},namespaceUri:{value:n},nodeType:{value:t}});var o=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[o.GetRelativeNodesAsync,o.GetNodeValueAsync,o.GetNodeXmlAsync,o.SetNodeValueAsync,o.SetNodeXmlAsync,o.GetNodeTextAsync,o.SetNodeTextAsync],e)},OSF.DDA.NodeInsertedEventArgs=function(e,t){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DataNodeInserted},newNode:{value:e},inUndoRedo:{value:t}})},OSF.DDA.NodeReplacedEventArgs=function(e,t,n){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DataNodeReplaced},oldNode:{value:e},newNode:{value:t},inUndoRedo:{value:n}})},OSF.DDA.NodeDeletedEventArgs=function(e,t,n){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DataNodeDeleted},oldNode:{value:e},oldNextSibling:{value:t},inUndoRedo:{value:n}})},OSF.DDA.OMFactory=OSF.DDA.OMFactory||{},OSF.DDA.OMFactory.manufactureDataNode=function(e){if(e)return new OSF.DDA.CustomXmlNode(e[OSF.DDA.DataNodeProperties.Handle],e[OSF.DDA.DataNodeProperties.NodeType],e[OSF.DDA.DataNodeProperties.NamespaceUri],e[OSF.DDA.DataNodeProperties.BaseName])},OSF.DDA.OMFactory.manufactureDataPart=function(e,t){return new OSF.DDA.CustomXmlPart(t,e[OSF.DDA.DataPartProperties.Id],e[OSF.DDA.DataPartProperties.BuiltIn])},OSF.DDA.AsyncMethodNames.addNames({AddDataPartAsync:"addAsync",GetDataPartByIdAsync:"getByIdAsync",GetDataPartsByNameSpaceAsync:"getByNamespaceAsync",DeleteDataPartAsync:"deleteAsync",GetPartNodesAsync:"getNodesAsync",GetPartXmlAsync:"getXmlAsync",AddDataPartNamespaceAsync:"addNamespaceAsync",GetDataPartNamespaceAsync:"getNamespaceAsync",GetDataPartPrefixAsync:"getPrefixAsync",GetRelativeNodesAsync:"getNodesAsync",GetNodeValueAsync:"getNodeValueAsync",GetNodeXmlAsync:"getXmlAsync",SetNodeValueAsync:"setNodeValueAsync",SetNodeXmlAsync:"setXmlAsync",GetNodeTextAsync:"getTextAsync",SetNodeTextAsync:"setTextAsync"}),function(){function e(e){return OSF.DDA.OMFactory.manufactureDataPart(e,Microsoft.Office.WebExtension.context.document.customXmlParts)}function t(e){return OSF.DDA.OMFactory.manufactureDataNode(e)}function n(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.Data];return void 0==r?null:r}function r(e){return e.id}function o(e,t){return t}function i(e,t){return t}OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AddDataPartAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Xml,types:["string"]}],supportedOptions:[],privateStateCallbacks:[],onSucceeded:e}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetDataPartByIdAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Id,types:["string"]}],supportedOptions:[],privateStateCallbacks:[],onSucceeded:e}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetDataPartsByNameSpaceAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Namespace,types:["string"]}],supportedOptions:[],privateStateCallbacks:[],onSucceeded:function(t){return OSF.OUtil.mapList(t[OSF.DDA.ListDescriptors.DataPartList],e)}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.DeleteDataPartAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[{name:OSF.DDA.DataPartProperties.Id,value:r}]}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetPartNodesAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.XPath,types:["string"]}],supportedOptions:[],privateStateCallbacks:[{name:OSF.DDA.DataPartProperties.Id,value:r}],onSucceeded:function(e){return OSF.OUtil.mapList(e[OSF.DDA.ListDescriptors.DataNodeList],t)}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetPartXmlAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[{name:OSF.DDA.DataPartProperties.Id,value:r}],onSucceeded:n}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AddDataPartNamespaceAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Prefix,types:["string"]},{name:Microsoft.Office.WebExtension.Parameters.Namespace,types:["string"]}],supportedOptions:[],privateStateCallbacks:[{name:OSF.DDA.DataPartProperties.Id,value:o}]}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetDataPartNamespaceAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Prefix,types:["string"]}],supportedOptions:[],privateStateCallbacks:[{name:OSF.DDA.DataPartProperties.Id,value:o}],onSucceeded:n}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetDataPartPrefixAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Namespace,types:["string"]}],supportedOptions:[],privateStateCallbacks:[{name:OSF.DDA.DataPartProperties.Id,value:o}],onSucceeded:n}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetRelativeNodesAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.XPath,types:["string"]}],supportedOptions:[],privateStateCallbacks:[{name:OSF.DDA.DataNodeProperties.Handle,value:i}],onSucceeded:function(e){return OSF.OUtil.mapList(e[OSF.DDA.ListDescriptors.DataNodeList],t)}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetNodeValueAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[{name:OSF.DDA.DataNodeProperties.Handle,value:i}],onSucceeded:n}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetNodeXmlAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[{name:OSF.DDA.DataNodeProperties.Handle,value:i}],onSucceeded:n}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.SetNodeValueAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["string"]}],supportedOptions:[],privateStateCallbacks:[{name:OSF.DDA.DataNodeProperties.Handle,value:i}]}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.SetNodeXmlAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Xml,types:["string"]}],supportedOptions:[],privateStateCallbacks:[{name:OSF.DDA.DataNodeProperties.Handle,value:i}]}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetNodeTextAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[{name:OSF.DDA.DataNodeProperties.Handle,value:i}],onSucceeded:n}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.SetNodeTextAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Text,types:["string"]}],supportedOptions:[],privateStateCallbacks:[{name:OSF.DDA.DataNodeProperties.Handle,value:i}]})}(),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.DataPartProperties,fromHost:[{name:OSF.DDA.DataPartProperties.Id,value:0},{name:OSF.DDA.DataPartProperties.BuiltIn,value:1}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.DataNodeProperties,fromHost:[{name:OSF.DDA.DataNodeProperties.Handle,value:0},{name:OSF.DDA.DataNodeProperties.BaseName,value:1},{name:OSF.DDA.DataNodeProperties.NamespaceUri,value:2},{name:OSF.DDA.DataNodeProperties.NodeType,value:3}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDescriptors.DataNodeInsertedEvent,fromHost:[{name:OSF.DDA.DataNodeEventProperties.InUndoRedo,value:0},{name:OSF.DDA.DataNodeEventProperties.NewNode,value:1}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDescriptors.DataNodeReplacedEvent,fromHost:[{name:OSF.DDA.DataNodeEventProperties.InUndoRedo,value:0},{name:OSF.DDA.DataNodeEventProperties.OldNode,value:1},{name:OSF.DDA.DataNodeEventProperties.NewNode,value:2}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDescriptors.DataNodeDeletedEvent,fromHost:[{name:OSF.DDA.DataNodeEventProperties.InUndoRedo,value:0},{name:OSF.DDA.DataNodeEventProperties.OldNode,value:1},{name:OSF.DDA.DataNodeEventProperties.NextSiblingNode,value:2}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.DataNodeEventProperties.OldNode,fromHost:[{name:OSF.DDA.PropertyDescriptors.DataNodeProperties,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.DataNodeEventProperties.NewNode,fromHost:[{name:OSF.DDA.PropertyDescriptors.DataNodeProperties,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.DataNodeEventProperties.NextSiblingNode,fromHost:[{name:OSF.DDA.PropertyDescriptors.DataNodeProperties,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidAddDataPartMethod,fromHost:[{name:OSF.DDA.PropertyDescriptors.DataPartProperties,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:Microsoft.Office.WebExtension.Parameters.Xml,value:0}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDataPartByIdMethod,fromHost:[{name:OSF.DDA.PropertyDescriptors.DataPartProperties,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDataPartsByNamespaceMethod,fromHost:[{name:OSF.DDA.ListDescriptors.DataPartList,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:Microsoft.Office.WebExtension.Parameters.Namespace,value:0}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDataPartXmlMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDataPartNodesMethod,fromHost:[{name:OSF.DDA.ListDescriptors.DataNodeList,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0},{name:Microsoft.Office.WebExtension.Parameters.XPath,value:1}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidDeleteDataPartMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDataNodeValueMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:OSF.DDA.DataNodeProperties.Handle,value:0}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDataNodeXmlMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:OSF.DDA.DataNodeProperties.Handle,value:0}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDataNodesMethod,fromHost:[{name:OSF.DDA.ListDescriptors.DataNodeList,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:OSF.DDA.DataNodeProperties.Handle,value:0},{name:Microsoft.Office.WebExtension.Parameters.XPath,value:1}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidSetDataNodeValueMethod,toHost:[{name:OSF.DDA.DataNodeProperties.Handle,value:0},{name:Microsoft.Office.WebExtension.Parameters.Data,value:1}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidSetDataNodeXmlMethod,toHost:[{name:OSF.DDA.DataNodeProperties.Handle,value:0},{name:Microsoft.Office.WebExtension.Parameters.Xml,value:1}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidAddDataNamespaceMethod,toHost:[{name:OSF.DDA.DataPartProperties.Id,value:0},{name:Microsoft.Office.WebExtension.Parameters.Prefix,value:1},{name:Microsoft.Office.WebExtension.Parameters.Namespace,value:2}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDataUriByPrefixMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:OSF.DDA.DataPartProperties.Id,value:0},{name:Microsoft.Office.WebExtension.Parameters.Prefix,value:1}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDataPrefixByUriMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:OSF.DDA.DataPartProperties.Id,value:0},{name:Microsoft.Office.WebExtension.Parameters.Namespace,value:1}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDataNodeTextMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:OSF.DDA.DataNodeProperties.Handle,value:0}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidSetDataNodeTextMethod,toHost:[{name:OSF.DDA.DataNodeProperties.Handle,value:0},{name:Microsoft.Office.WebExtension.Parameters.Text,value:1}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidDataNodeAddedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.DataNodeInsertedEvent,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidDataNodeReplacedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.DataNodeReplacedEvent,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidDataNodeDeletedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.DataNodeDeletedEvent,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.FilePropertiesDescriptor,fromHost:[{name:OSF.DDA.FilePropertiesDescriptor.Url,value:0}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetFilePropertiesMethod,fromHost:[{name:OSF.DDA.PropertyDescriptors.FilePropertiesDescriptor,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.AsyncMethodNames.addNames({ExecuteRichApiRequestAsync:"executeRichApiRequestAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.ExecuteRichApiRequestAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["object"]}],supportedOptions:[]}),OSF.OUtil.setNamespace("RichApi",OSF.DDA),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidExecuteRichApiRequestMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:0}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{RichApiMessage:"richApiMessage"}),OSF.DDA.RichApiMessageEventArgs=function(e,t){var n=t[Microsoft.Office.WebExtension.Parameters.Data],r=[];if(n)for(var o=0;o<n.length;o++){var i=n[o];i.toArray&&(i=i.toArray()),r.push({messageCategory:i[0],messageType:i[1],targetId:i[2],message:i[3],id:i[4],isRemoteOverride:i[5]})}OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.RichApiMessage},entries:{value:r}})},function(e){var t=function(){function e(){this._eventDispatch=null,this._registerHandlers=[],this._eventDispatch=new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.RichApiMessage]),OSF.DDA.DispIdHost.addEventSupport(this,this._eventDispatch)}return e.prototype.register=function(e){var t=this;return this._registerWithHostPromise||(this._registerWithHostPromise=new Office.Promise((function(e,n){t.addHandlerAsync(Microsoft.Office.WebExtension.EventType.RichApiMessage,(function(e){t._registerHandlers.forEach((function(t){t&&t(e)}))}),(function(t){"failed"==t.status?n(t.error):e()}))}))),this._registerWithHostPromise.then((function(){t._registerHandlers.push(e)}))},e}();e.RichApiMessageManager=t}(OfficeExt||(OfficeExt={})),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidRichApiMessageEvent,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:0}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.SafeArray.Delegate.ParameterMap.sourceData}]}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.CoercionType,{Image:"image"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.CoercionType,{XmlSvg:"xmlSvg"}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.CoercionType,toHost:[{name:Microsoft.Office.WebExtension.CoercionType.Image,value:8},{name:Microsoft.Office.WebExtension.CoercionType.XmlSvg,value:9}]}),function(e){!function(t){var n=function(){function n(){var e=this;this._pseudoDocument=null,this._eventDispatch=null,this._useAssociatedActionsOnly=null,this._processAppCommandInvocation=function(t){var n=e._verifyManifestCallback(t.callbackName);if(n.errorCode==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess){var r=e._constructEventObjectForCallback(t);r?window.setTimeout((function(){n.callback(r)}),0):e._invokeAppCommandCompletedMethod(t.appCommandId,OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError,"")}else e._invokeAppCommandCompletedMethod(t.appCommandId,n.errorCode,"")}}return n.initializeOsfDda=function(){OSF.DDA.AsyncMethodNames.addNames({AppCommandInvocationCompletedAsync:"appCommandInvocationCompletedAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AppCommandInvocationCompletedAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Id,types:["string"]},{name:Microsoft.Office.WebExtension.Parameters.Status,types:["number"]},{name:Microsoft.Office.WebExtension.Parameters.AppCommandInvocationCompletedData,types:["string"]}]}),OSF.OUtil.augmentList(OSF.DDA.EventDescriptors,{AppCommandInvokedEvent:"AppCommandInvokedEvent"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{AppCommandInvoked:"appCommandInvoked"}),OSF.OUtil.setNamespace("AppCommand",OSF.DDA),OSF.DDA.AppCommand.AppCommandInvokedEventArgs=e.AppCommand.AppCommandInvokedEventArgs},n.prototype.initializeAndChangeOnce=function(e){t.registerDdaFacade(),this._pseudoDocument={},OSF.DDA.DispIdHost.addAsyncMethods(this._pseudoDocument,[OSF.DDA.AsyncMethodNames.AppCommandInvocationCompletedAsync]),this._eventDispatch=new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.AppCommandInvoked]);OSF.DDA.DispIdHost.addEventSupport(this._pseudoDocument,this._eventDispatch),this._pseudoDocument.addHandlerAsync(Microsoft.Office.WebExtension.EventType.AppCommandInvoked,this._processAppCommandInvocation,(function(t){e&&("succeeded"==t.status?e(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess):e(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError))}))},n.prototype._verifyManifestCallback=function(e){var t={callback:null,errorCode:OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidCallback};e=e.trim();try{var n=this._getCallbackFunc(e);if("function"!=typeof n)return t}catch(e){return t}return{callback:n,errorCode:OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess}},n.prototype._getUseAssociatedActionsOnly=function(){var e=this;if(null==this._useAssociatedActionsOnly){this._useAssociatedActionsOnly=!1;try{!0===window.useAssociatedActionsOnly?this._useAssociatedActionsOnly=!0:this._useAssociatedActionsOnly=OSF._OfficeAppFactory.getLoadScriptHelper().getUseAssociatedActionsOnlyDefined(),OTel&&oteljs&&Microsoft.Office.WebExtension.sendTelemetryEvent&&OTel.OTelLogger.onTelemetryLoaded((function(){var t=[oteljs.makeBooleanDataField("UseAction",!0===e._useAssociatedActionsOnly)];Microsoft.Office.WebExtension.sendTelemetryEvent({eventName:"Office.Extensibility.OfficeJs.AppCommandDefinition",dataFields:t,eventFlags:{dataCategories:oteljs.DataCategories.ProductServiceUsage,diagnosticLevel:oteljs.DiagnosticLevel.NecessaryServiceDataEvent}})}))}catch(e){}}return this._useAssociatedActionsOnly},n.prototype._getCallbackFuncFromWindow=function(e){for(var t=e.split("."),n=window,r=0;r<t.length-1;r++){if(!n[t[r]]||"object"!=typeof n[t[r]]&&"function"!=typeof n[t[r]])return null;n=n[t[r]]}return n[t[t.length-1]]},n.prototype._getCallbackFuncFromActionAssociateTable=function(e){var t=e.toUpperCase();return Office.actions._association.mappings[t]},n.prototype._getCallbackFunc=function(e){var t=null;return this._getUseAssociatedActionsOnly()||(t=this._getCallbackFuncFromWindow(e)),t||(t=this._getCallbackFuncFromActionAssociateTable(e)),t},n.prototype._invokeAppCommandCompletedMethod=function(e,t,n){this._pseudoDocument.appCommandInvocationCompletedAsync(e,t,n)},n.prototype._constructEventObjectForCallback=function(e){var t=this,n=new o;try{var r=JSON.parse(e.eventObjStr);this._translateEventObjectInternal(r,n),Object.defineProperty(n,"completed",{value:function(r){n.completedContext=r;var o=JSON.stringify(n);t._invokeAppCommandCompletedMethod(e.appCommandId,OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess,o)},enumerable:!0})}catch(e){n=null}return n},n.prototype._translateEventObjectInternal=function(e,t){for(var n in e)if(e.hasOwnProperty(n)){var r=e[n];"object"==typeof r&&null!=r?(OSF.OUtil.defineEnumerableProperty(t,n,{value:{}}),this._translateEventObjectInternal(r,t[n])):Object.defineProperty(t,n,{value:r,enumerable:!0,writable:!0})}},n.prototype._constructObjectByTemplate=function(e,t){var n={};if(!e||!t)return n;for(var r in e)if(e.hasOwnProperty(r)&&(n[r]=null,null!=t[r])){var o=e[r],i=t[r],a=typeof i;"object"==typeof o&&null!=o?n[r]=this._constructObjectByTemplate(o,i):"number"!=a&&"string"!=a&&"boolean"!=a||(n[r]=i)}return n},n.instance=function(){return null==n._instance&&(n._instance=new n),n._instance},n._instance=null,n}();t.AppCommandManager=n;var r=function(){function e(e,t,n){this.type=Microsoft.Office.WebExtension.EventType.AppCommandInvoked,this.appCommandId=e,this.callbackName=t,this.eventObjStr=n}return e.create=function(n){return new e(n[t.AppCommandInvokedEventEnums.AppCommandId],n[t.AppCommandInvokedEventEnums.CallbackName],n[t.AppCommandInvokedEventEnums.EventObjStr])},e}();t.AppCommandInvokedEventArgs=r;var o=function(){return function(){}}();t.AppCommandCallbackEventArgs=o,t.AppCommandInvokedEventEnums={AppCommandId:"appCommandId",CallbackName:"callbackName",EventObjStr:"eventObjStr"}}(e.AppCommand||(e.AppCommand={}))}(OfficeExt||(OfficeExt={})),OfficeExt.AppCommand.AppCommandManager.initializeOsfDda(),function(e){!function(t){t.registerDdaFacade=function(){if(OSF.DDA.SafeArray){var t=OSF.DDA.SafeArray.Delegate.ParameterMap;t.define({type:OSF.DDA.MethodDispId.dispidAppCommandInvocationCompletedMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0},{name:Microsoft.Office.WebExtension.Parameters.Status,value:1},{name:Microsoft.Office.WebExtension.Parameters.AppCommandInvocationCompletedData,value:2}]}),t.define({type:OSF.DDA.EventDispId.dispidAppCommandInvokedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.AppCommandInvokedEvent,value:t.self}],isComplexType:!0}),t.define({type:OSF.DDA.EventDescriptors.AppCommandInvokedEvent,fromHost:[{name:e.AppCommand.AppCommandInvokedEventEnums.AppCommandId,value:0},{name:e.AppCommand.AppCommandInvokedEventEnums.CallbackName,value:1},{name:e.AppCommand.AppCommandInvokedEventEnums.EventObjStr,value:2}],isComplexType:!0})}}}(e.AppCommand||(e.AppCommand={}))}(OfficeExt||(OfficeExt={})),OSF.DDA.AsyncMethodNames.addNames({GetOfficeThemeAsync:"getOfficeThemeAsync",GetDocumentThemeAsync:"getDocumentThemeAsync"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{OfficeThemeChanged:"officeThemeChanged",DocumentThemeChanged:"documentThemeChanged"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.Parameters,{DocumentTheme:"documentTheme",OfficeTheme:"officeTheme"}),OSF.OUtil.augmentList(OSF.DDA.EventDescriptors,{DocumentThemeChangedEvent:"DocumentThemeChangedEvent",OfficeThemeChangedEvent:"OfficeThemeChangedEvent"}),OSF.OUtil.setNamespace("Theming",OSF.DDA),OSF.DDA.Theming.OfficeThemeEnum={PrimaryFontColor:"primaryFontColor",PrimaryBackgroundColor:"primaryBackgroundColor",SecondaryFontColor:"secondaryFontColor",SecondaryBackgroundColor:"secondaryBackgroundColor"},OSF.DDA.Theming.DocumentThemeEnum={PrimaryFontColor:"primaryFontColor",PrimaryBackgroundColor:"primaryBackgroundColor",SecondaryFontColor:"secondaryFontColor",SecondaryBackgroundColor:"secondaryBackgroundColor",Accent1:"accent1",Accent2:"accent2",Accent3:"accent3",Accent4:"accent4",Accent5:"accent5",Accent6:"accent6",Hyperlink:"hyperlink",FollowedHyperlink:"followedHyperlink",HeaderLatinFont:"headerLatinFont",HeaderEastAsianFont:"headerEastAsianFont",HeaderScriptFont:"headerScriptFont",HeaderLocalizedFont:"headerLocalizedFont",BodyLatinFont:"bodyLatinFont",BodyEastAsianFont:"bodyEastAsianFont",BodyScriptFont:"bodyScriptFont",BodyLocalizedFont:"bodyLocalizedFont"},OSF.DDA.Theming.ConvertToDocumentTheme=function(e){for(var t=[{name:"primaryFontColor",needToConvertToHex:!0},{name:"primaryBackgroundColor",needToConvertToHex:!0},{name:"secondaryFontColor",needToConvertToHex:!0},{name:"secondaryBackgroundColor",needToConvertToHex:!0},{name:"accent1",needToConvertToHex:!0},{name:"accent2",needToConvertToHex:!0},{name:"accent3",needToConvertToHex:!0},{name:"accent4",needToConvertToHex:!0},{name:"accent5",needToConvertToHex:!0},{name:"accent6",needToConvertToHex:!0},{name:"hyperlink",needToConvertToHex:!0},{name:"followedHyperlink",needToConvertToHex:!0},{name:"headerLatinFont",needToConvertToHex:!1},{name:"headerEastAsianFont",needToConvertToHex:!1},{name:"headerScriptFont",needToConvertToHex:!1},{name:"headerLocalizedFont",needToConvertToHex:!1},{name:"bodyLatinFont",needToConvertToHex:!1},{name:"bodyEastAsianFont",needToConvertToHex:!1},{name:"bodyScriptFont",needToConvertToHex:!1},{name:"bodyLocalizedFont",needToConvertToHex:!1}],n={},r=0;r<t.length;r++)t[r].needToConvertToHex?n[t[r].name]=OSF.OUtil.convertIntToCssHexColor(e[t[r].name]):n[t[r].name]=e[t[r].name];return n},OSF.DDA.Theming.ConvertToOfficeTheme=function(e){var t={};for(var n in e)t[n]=OSF.OUtil.convertIntToCssHexColor(e[n]);return t},OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[],onSucceeded:OSF.DDA.Theming.ConvertToDocumentTheme}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[],onSucceeded:OSF.DDA.Theming.ConvertToOfficeTheme}),OSF.DDA.Theming.OfficeThemeChangedEventArgs=function(e){var t=OSF.DDA.Theming.ConvertToOfficeTheme(e);OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.OfficeThemeChanged},officeTheme:{value:t}})},OSF.DDA.Theming.DocumentThemeChangedEventArgs=function(e){var t=OSF.DDA.Theming.ConvertToDocumentTheme(e);OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DocumentThemeChanged},documentTheme:{value:t}})};var OSF_DDA_Theming_InternalThemeHandler=function(){function e(){this._pseudoDocumentObject=null,this._previousDocumentThemeData=null,this._previousOfficeThemeData=null,this._officeCss=null,this._asyncCallsCompleted=null,this._onAsyncCallsCompleted=null}return e.prototype.InitializeAndChangeOnce=function(e){if(this._officeCss=this._getOfficeThemesCss(),this._officeCss){this._onAsyncCallsCompleted=e,this._pseudoDocumentObject={};var t=this._pseudoDocumentObject;OSF.DDA.DispIdHost.addAsyncMethods(t,[OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync,OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync]),OSF.DDA.DispIdHost.addEventSupport(t,new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.OfficeThemeChanged,Microsoft.Office.WebExtension.EventType.DocumentThemeChanged])),this._asyncCallsCompleted={},this._asyncCallsCompleted[OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync]=!1,this._asyncCallsCompleted[OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync]=!1,this._getAndProcessThemeData(t.getDocumentThemeAsync,Function.createDelegate(this,this._processDocumentThemeData),OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync),this._getAndProcessThemeData(t.getOfficeThemeAsync,Function.createDelegate(this,this._processOfficeThemeData),OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync)}else e&&e()},e.prototype._getOfficeThemesCss=function(){try{return function(){for(var e=0;e<document.styleSheets.length;e++){var t=document.styleSheets[e];if(!t.disabled&&t.href&&"officethemes.css"==t.href.substring(t.href.length-"officethemes.css".length,t.href.length).toLowerCase())return t.cssRules||t.rules?t:null}}()}catch(e){return null}},e.prototype._changeCss=function(e,t,n){for(var r=e.cssRules?e.cssRules.length:e.rules.length,o=0;o<r;o++){var i=(e.cssRules?e.cssRules[o]:e.rules[o]).selectorText;i&&i.toLowerCase()==t.toLowerCase()&&(e.cssRules?(e.deleteRule(o),e.insertRule(i+n,o)):(e.removeRule(o),e.addRule(i,n,o)))}},e.prototype._changeDocumentThemeData=function(e){for(var t=[{name:"primaryFontColor",cssSelector:".office-docTheme-primary-fontColor",cssProperty:"color"},{name:"primaryBackgroundColor",cssSelector:".office-docTheme-primary-bgColor",cssProperty:"background-color"},{name:"secondaryFontColor",cssSelector:".office-docTheme-secondary-fontColor",cssProperty:"color"},{name:"secondaryBackgroundColor",cssSelector:".office-docTheme-secondary-bgColor",cssProperty:"background-color"},{name:"accent1",cssSelector:".office-contentAccent1-color",cssProperty:"color"},{name:"accent2",cssSelector:".office-contentAccent2-color",cssProperty:"color"},{name:"accent3",cssSelector:".office-contentAccent3-color",cssProperty:"color"},{name:"accent4",cssSelector:".office-contentAccent4-color",cssProperty:"color"},{name:"accent5",cssSelector:".office-contentAccent5-color",cssProperty:"color"},{name:"accent6",cssSelector:".office-contentAccent6-color",cssProperty:"color"},{name:"accent1",cssSelector:".office-contentAccent1-bgColor",cssProperty:"background-color"},{name:"accent2",cssSelector:".office-contentAccent2-bgColor",cssProperty:"background-color"},{name:"accent3",cssSelector:".office-contentAccent3-bgColor",cssProperty:"background-color"},{name:"accent4",cssSelector:".office-contentAccent4-bgColor",cssProperty:"background-color"},{name:"accent5",cssSelector:".office-contentAccent5-bgColor",cssProperty:"background-color"},{name:"accent6",cssSelector:".office-contentAccent6-bgColor",cssProperty:"background-color"},{name:"accent1",cssSelector:".office-contentAccent1-borderColor",cssProperty:"border-color"},{name:"accent2",cssSelector:".office-contentAccent2-borderColor",cssProperty:"border-color"},{name:"accent3",cssSelector:".office-contentAccent3-borderColor",cssProperty:"border-color"},{name:"accent4",cssSelector:".office-contentAccent4-borderColor",cssProperty:"border-color"},{name:"accent5",cssSelector:".office-contentAccent5-borderColor",cssProperty:"border-color"},{name:"accent6",cssSelector:".office-contentAccent6-borderColor",cssProperty:"border-color"},{name:"hyperlink",cssSelector:".office-a",cssProperty:"color"},{name:"followedHyperlink",cssSelector:".office-a:visited",cssProperty:"color"},{name:"headerLatinFont",cssSelector:".office-headerFont-latin",cssProperty:"font-family"},{name:"headerEastAsianFont",cssSelector:".office-headerFont-eastAsian",cssProperty:"font-family"},{name:"headerScriptFont",cssSelector:".office-headerFont-script",cssProperty:"font-family"},{name:"headerLocalizedFont",cssSelector:".office-headerFont-localized",cssProperty:"font-family"},{name:"bodyLatinFont",cssSelector:".office-bodyFont-latin",cssProperty:"font-family"},{name:"bodyEastAsianFont",cssSelector:".office-bodyFont-eastAsian",cssProperty:"font-family"},{name:"bodyScriptFont",cssSelector:".office-bodyFont-script",cssProperty:"font-family"},{name:"bodyLocalizedFont",cssSelector:".office-bodyFont-localized",cssProperty:"font-family"}],n="documentThemeChanged"==e.type?e.documentTheme:e,r=0;r<t.length;r++)if(null===this._previousDocumentThemeData||this._previousDocumentThemeData[t[r].name]!=n[t[r].name])if(null!=n[t[r].name]&&""!=n[t[r].name]){var o=n[t[r].name];"font-family"===t[r].cssProperty&&(o='"'+o.replace(/"/g,'\\"')+'"'),this._changeCss(this._officeCss,t[r].cssSelector,"{"+t[r].cssProperty+":"+o+";}")}else this._changeCss(this._officeCss,t[r].cssSelector,"{}");this._previousDocumentThemeData=n},e.prototype._changeOfficeThemeData=function(e){for(var t=[{name:"primaryFontColor",cssSelector:".office-officeTheme-primary-fontColor",cssProperty:"color"},{name:"primaryBackgroundColor",cssSelector:".office-officeTheme-primary-bgColor",cssProperty:"background-color"},{name:"secondaryFontColor",cssSelector:".office-officeTheme-secondary-fontColor",cssProperty:"color"},{name:"secondaryBackgroundColor",cssSelector:".office-officeTheme-secondary-bgColor",cssProperty:"background-color"}],n="officeThemeChanged"==e.type?e.officeTheme:e,r=0;r<t.length;r++)null!==this._previousOfficeThemeData&&this._previousOfficeThemeData[t[r].name]==n[t[r].name]||void 0!==n[t[r].name]&&this._changeCss(this._officeCss,t[r].cssSelector,"{"+t[r].cssProperty+":"+n[t[r].name]+";}");this._previousOfficeThemeData=n},e.prototype._getAndProcessThemeData=function(e,t,n){e(Function.createDelegate(this,(function(e){if("succeeded"==e.status){var r=e.value;t(r)}this._areAllCallsCompleted(n)&&this._onAsyncCallsCompleted&&(this._onAsyncCallsCompleted(),this._onAsyncCallsCompleted=null)})))},e.prototype._processOfficeThemeData=function(e){this._changeOfficeThemeData(e),this._pseudoDocumentObject.addHandlerAsync(Microsoft.Office.WebExtension.EventType.OfficeThemeChanged,Function.createDelegate(this,this._changeOfficeThemeData),null)},e.prototype._processDocumentThemeData=function(e){this._changeDocumentThemeData(e),this._pseudoDocumentObject.addHandlerAsync(Microsoft.Office.WebExtension.EventType.DocumentThemeChanged,Function.createDelegate(this,this._changeDocumentThemeData),null)},e.prototype._areAllCallsCompleted=function(e){var t;if(!(t=this._asyncCallsCompleted))return!0;for(var n in e&&t.hasOwnProperty(e)&&(t[e]=!0),t)if(!t.hasOwnProperty(n)||!t[n])return!1;return!0},e}();OSF.DDA.Theming.InternalThemeHandler=OSF_DDA_Theming_InternalThemeHandler;var parameterMap=OSF.DDA.SafeArray.Delegate.ParameterMap;parameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDocumentThemeMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.DocumentTheme,value:parameterMap.self}]}),parameterMap.define({type:OSF.DDA.MethodDispId.dispidGetOfficeThemeMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.OfficeTheme,value:parameterMap.self}]}),parameterMap.define({type:OSF.DDA.EventDispId.dispidDocumentThemeChangedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.DocumentThemeChangedEvent,value:parameterMap.self}],isComplexType:!0}),parameterMap.define({type:OSF.DDA.EventDispId.dispidOfficeThemeChangedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.OfficeThemeChangedEvent,value:parameterMap.self}],isComplexType:!0});var destKeys=OSF.DDA.Theming.DocumentThemeEnum;parameterMap.define({type:Microsoft.Office.WebExtension.Parameters.DocumentTheme,fromHost:[{name:destKeys.PrimaryBackgroundColor,value:0},{name:destKeys.PrimaryFontColor,value:1},{name:destKeys.SecondaryBackgroundColor,value:2},{name:destKeys.SecondaryFontColor,value:3},{name:destKeys.Accent1,value:4},{name:destKeys.Accent2,value:5},{name:destKeys.Accent3,value:6},{name:destKeys.Accent4,value:7},{name:destKeys.Accent5,value:8},{name:destKeys.Accent6,value:9},{name:destKeys.Hyperlink,value:10},{name:destKeys.FollowedHyperlink,value:11},{name:destKeys.HeaderLatinFont,value:12},{name:destKeys.HeaderEastAsianFont,value:13},{name:destKeys.HeaderScriptFont,value:14},{name:destKeys.HeaderLocalizedFont,value:15},{name:destKeys.BodyLatinFont,value:16},{name:destKeys.BodyEastAsianFont,value:17},{name:destKeys.BodyScriptFont,value:18},{name:destKeys.BodyLocalizedFont,value:19}],isComplexType:!0}),destKeys=OSF.DDA.Theming.OfficeThemeEnum,parameterMap.define({type:Microsoft.Office.WebExtension.Parameters.OfficeTheme,fromHost:[{name:destKeys.PrimaryFontColor,value:0},{name:destKeys.PrimaryBackgroundColor,value:1},{name:destKeys.SecondaryFontColor,value:2},{name:destKeys.SecondaryBackgroundColor,value:3}],isComplexType:!0}),parameterMap.define({type:OSF.DDA.EventDescriptors.DocumentThemeChangedEvent,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.DocumentTheme,value:parameterMap.self}],isComplexType:!0}),parameterMap.define({type:OSF.DDA.EventDescriptors.OfficeThemeChangedEvent,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.OfficeTheme,value:parameterMap.self}],isComplexType:!0}),Microsoft.Office.WebExtension.AccountTypeFilter={NoFilter:"noFilter",AAD:"aad",MSA:"msa"},OSF.DDA.AsyncMethodNames.addNames({GetAccessTokenAsync:"getAccessTokenAsync"}),OSF.DDA.Auth=function(){},OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetAccessTokenAsync,requiredArguments:[],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.ForceConsent,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.ForceAddAccount,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.AuthChallenge,value:{types:["string"],defaultValue:""}},{name:Microsoft.Office.WebExtension.Parameters.AllowConsentPrompt,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.ForMSGraphAccess,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.AllowSignInPrompt,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.EnableNewHosts,value:{types:["number"],defaultValue:0}},{name:Microsoft.Office.WebExtension.Parameters.AccountTypeFilter,value:{enum:Microsoft.Office.WebExtension.AccountTypeFilter,defaultValue:Microsoft.Office.WebExtension.AccountTypeFilter.NoFilter}}],checkCallArgs:function(e,t,n){var r,o=OSF._OfficeAppFactory.getInitializationHelper()._appContext;if(o&&o._wopiHostOriginForSingleSignOn){var i=OSF.OUtil.Guid.generateNewGuid();window.parent.parent.postMessage('{"MessageId":"AddinTrustedOrigin","AddinTrustId":"'+i+'"}',o._wopiHostOriginForSingleSignOn),e[Microsoft.Office.WebExtension.Parameters.AddinTrustId]=i}if(window.Office.context.requirements.isSetSupported("JsonPayloadSSO")){for(var a=((r={})[Microsoft.Office.WebExtension.Parameters.ForceConsent]=!1,r[Microsoft.Office.WebExtension.Parameters.ForceAddAccount]=!1,r[Microsoft.Office.WebExtension.Parameters.AuthChallenge]=!0,r[Microsoft.Office.WebExtension.Parameters.AllowConsentPrompt]=!0,r[Microsoft.Office.WebExtension.Parameters.ForMSGraphAccess]=!0,r[Microsoft.Office.WebExtension.Parameters.AllowSignInPrompt]=!0,r[Microsoft.Office.WebExtension.Parameters.EnableNewHosts]=!0,r[Microsoft.Office.WebExtension.Parameters.AccountTypeFilter]=!0,r),s={},c=0,l=Object.keys(a);c<l.length;c++){var u=l[c];a[u]&&(s[u]=e[u]),delete e[u]}e[Microsoft.Office.WebExtension.Parameters.JsonPayload]=JSON.stringify(s)}return e},onSucceeded:function(e,t,n){return e[Microsoft.Office.WebExtension.Parameters.Data]}}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetAccessTokenMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.JsonPayload,value:0},{name:Microsoft.Office.WebExtension.Parameters.ForceConsent,value:0},{name:Microsoft.Office.WebExtension.Parameters.ForceAddAccount,value:1},{name:Microsoft.Office.WebExtension.Parameters.AuthChallenge,value:2},{name:Microsoft.Office.WebExtension.Parameters.AllowConsentPrompt,value:3},{name:Microsoft.Office.WebExtension.Parameters.ForMSGraphAccess,value:4},{name:Microsoft.Office.WebExtension.Parameters.AllowSignInPrompt,value:5}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.InitializationHelper.prototype.prepareRightAfterWebExtensionInitialize=function(){OfficeExt.AppCommand.AppCommandManager.instance().initializeAndChangeOnce(),OSF.ScriptMessaging.GetScriptMessenger().invokeMethod(OSF.Webkit.MessageHandlerName,OSF.Webkit.MethodId.AddinInitialized,{})},OSF.DDA.OneNoteDocument=function(e,t){OSF.DDA.OneNoteDocument.uber.constructor.call(this,e,null,t),OSF.OUtil.finalizeProperties(this)},OSF.OUtil.extend(OSF.DDA.OneNoteDocument,OSF.DDA.JsomDocument),OSF.InitializationHelper.prototype.loadAppSpecificScriptAndCreateOM=function(e,t,n){OSF.DDA.ErrorCodeManager.initializeErrorMessages(Strings.OfficeOM),e.doc=new OSF.DDA.OneNoteDocument(e,this.initializeMacSettings(e,!1)),e.application=new OSF.DDA.Application(e),OSF.DDA.DispIdHost.addEventSupport(e.application,new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.OfficeThemeChanged])),OSF.OUtil.finalizeProperties(e.application),OSF.DDA.DispIdHost.addAsyncMethods(OSF.DDA.RichApi,[OSF.DDA.AsyncMethodNames.ExecuteRichApiRequestAsync]),OSF.DDA.RichApi.richApiMessageManager=new OfficeExt.RichApiMessageManager,t()};var OfficeExtension;__extends=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();!function(e){var t;!function(e){e.OfficeRequire=function(){return null}()}(e._Internal||(e._Internal={})),function(e){!function(t){t.Init=function(){return function(){"use strict";function t(e){return"function"===typeof e}var n,r=Array.isArray?Array.isArray:function(e){return"[object Array]"===Object.prototype.toString.call(e)},o=0,i=function(e,t){u[o]=e,u[o+1]=t,2===(o+=2)&&(n?n(p):l())};var a=("undefined"!==typeof window?window:void 0)||{},s=(a.MutationObserver||a.WebKitMutationObserver,"undefined"!==typeof process&&"[object process]"==={}.toString.call(process)),c="undefined"!==typeof Uint8ClampedArray&&"undefined"!==typeof importScripts&&"undefined"!==typeof MessageChannel;var l,u=new Array(1e3);function p(){for(var e=0;e<o;e+=2){(0,u[e])(u[e+1]),u[e]=void 0,u[e+1]=void 0}o=0}function f(){}l=s?function(){var e=process.nextTick,t=process.versions.node.match(/^(?:(\d+)\.)?(?:(\d+)\.)?(\*|\d+)$/);return Array.isArray(t)&&"0"===t[1]&&"10"===t[2]&&(e=window.setImmediate),function(){e(p)}}():c?function(){var e=new MessageChannel;return e.port1.onmessage=p,function(){e.port2.postMessage(0)}}():function(){return function(){setTimeout(p,1)}}();var d=new v;function h(e,n){if(n.constructor===e.constructor)!function(e,t){1===t._state?y(e,t._result):2===t._state?O(e,t._result):_(t,void 0,(function(t){m(e,t)}),(function(t){O(e,t)}))}(e,n);else{var r=function(e){try{return e.then}catch(e){return d.error=e,d}}(n);r===d?O(e,d.error):void 0===r?y(e,n):t(r)?function(e,t,n){i((function(e){var r=!1,o=function(e,t,n,r){try{e.call(t,n,r)}catch(e){return e}}(n,t,(function(n){r||(r=!0,t!==n?m(e,n):y(e,n))}),(function(t){r||(r=!0,O(e,t))}),e._label);!r&&o&&(r=!0,O(e,o))}),e)}(e,n,r):y(e,n)}}function m(e,t){e===t?O(e,function(){return new TypeError("You cannot resolve a promise with itself")}()):!function(e){return"function"===typeof e||"object"===typeof e&&null!==e}(t)?y(e,t):h(e,t)}function g(e){e._onerror&&e._onerror(e._result),b(e)}function y(e,t){void 0===e._state&&(e._result=t,e._state=1,0!==e._subscribers.length&&i(b,e))}function O(e,t){void 0===e._state&&(e._state=2,e._result=t,i(g,e))}function _(e,t,n,r){var o=e._subscribers,a=o.length;e._onerror=null,o[a]=t,o[a+1]=n,o[a+2]=r,0===a&&e._state&&i(b,e)}function b(e){var t=e._subscribers,n=e._state;if(0!==t.length){for(var r,o,i=e._result,a=0;a<t.length;a+=3)r=t[a],o=t[a+n],r?A(n,r,o,i):o(i);e._subscribers.length=0}}function v(){this.error=null}var S=new v;function A(e,n,r,o){var i,a,s,c,l=t(r);if(l){if((i=function(e,t){try{return e(t)}catch(e){return S.error=e,S}}(r,o))===S?(c=!0,a=i.error,i=null):s=!0,n===i)return void O(n,function(){return new TypeError("A promises callback cannot return that same promise.")}())}else i=o,s=!0;void 0!==n._state||(l&&s?m(n,i):c?O(n,a):1===e?y(n,i):2===e&&O(n,i))}function D(e,t){this._instanceConstructor=e,this.promise=new e(f),this._validateInput(t)?(this._input=t,this.length=t.length,this._remaining=t.length,this._init(),0===this.length?y(this.promise,this._result):(this.length=this.length||0,this._enumerate(),0===this._remaining&&y(this.promise,this._result))):O(this.promise,this._validationError())}D.prototype._validateInput=function(e){return r(e)},D.prototype._validationError=function(){return new e.Error("Array Methods must be provided an Array")},D.prototype._init=function(){this._result=new Array(this.length)};var P=D;D.prototype._enumerate=function(){for(var e=this.length,t=this.promise,n=this._input,r=0;void 0===t._state&&r<e;r++)this._eachEntry(n[r],r)},D.prototype._eachEntry=function(e,t){var n=this._instanceConstructor;!function(e){return"object"===typeof e&&null!==e}(e)?(this._remaining--,this._result[t]=e):e.constructor===n&&void 0!==e._state?(e._onerror=null,this._settledAt(e._state,t,e._result)):this._willSettleAt(n.resolve(e),t)},D.prototype._settledAt=function(e,t,n){var r=this.promise;void 0===r._state&&(this._remaining--,2===e?O(r,n):this._result[t]=n),0===this._remaining&&y(r,this._result)},D.prototype._willSettleAt=function(e,t){var n=this;_(e,void 0,(function(e){n._settledAt(1,t,e)}),(function(e){n._settledAt(2,t,e)}))};var I=function(e){return new P(this,e).promise};var C=function(e){var t=new this(f);if(!r(e))return O(t,new TypeError("You must pass an array to race.")),t;var n=e.length;function o(e){m(t,e)}function i(e){O(t,e)}for(var a=0;void 0===t._state&&a<n;a++)_(this.resolve(e[a]),void 0,o,i);return t};var F=function(e){if(e&&"object"===typeof e&&e.constructor===this)return e;var t=new this(f);return m(t,e),t};var E=function(e){var t=new this(f);return O(t,e),t},R=0;var N=x;function x(e){this._id=R++,this._state=void 0,this._result=void 0,this._subscribers=[],f!==e&&(t(e)||function(){throw new TypeError("You must pass a resolver function as the first argument to the promise constructor")}(),this instanceof x||function(){throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.")}(),function(e,t){try{t((function(t){m(e,t)}),(function(t){O(e,t)}))}catch(t){O(e,t)}}(this,e))}return x.all=I,x.race=C,x.resolve=F,x.reject=E,x._setScheduler=function(e){n=e},x._setAsap=function(e){i=e},x._asap=i,x.prototype={constructor:x,then:function(e,t){var n=this,r=n._state;if(1===r&&!e||2===r&&!t)return this;var o=new this.constructor(f),a=n._result;if(r){var s=arguments[r-1];i((function(){A(r,o,s,a)}))}else _(n,o,e,t);return o},catch:function(e){return this.then(null,e)}},N}.call(this)}}(e.PromiseImpl||(e.PromiseImpl={}))}(e._Internal||(e._Internal={})),function(e){e.OfficePromise=function(){return"undefined"===typeof window&&"function"===typeof Promise?Promise:"undefined"!==typeof window&&window.Promise?function(){var e=window.navigator.userAgent,t=e.indexOf("Edge/");return t>=0&&(e=e.substring(t+5,e.length))<"14.14393"}()?e.PromiseImpl.Init():window.Promise:e.PromiseImpl.Init()}()}(t=e._Internal||(e._Internal={}));var n=t.OfficePromise;e.Promise=n}(OfficeExtension||(OfficeExtension={})),function(e){var t=function(){function e(){}return e.prototype._resolveRequestUrlAndHeaderInfo=function(){return l._createPromiseFromResult(null)},e.prototype._createRequestExecutorOrNull=function(){return null},e.prototype.getEventRegistration=function(e){return null},e}();e.SessionBase=t;var n=function(){function e(){}return e.setCustomSendRequestFunc=function(t){e.s_customSendRequestFunc=t},e.xhrSendRequestFunc=function(e){return l.createPromise((function(t,n){var o=new XMLHttpRequest;if(o.open(e.method,e.url),o.onload=function(){var e={statusCode:o.status,headers:l._parseHttpResponseHeaders(o.getAllResponseHeaders()),body:o.responseText};t(e)},o.onerror=function(){n(new r.RuntimeError({code:i.connectionFailure,httpStatusCode:o.status,message:l._getResourceString(a.connectionFailureWithStatus,o.statusText)}))},e.headers)for(var s in e.headers)o.setRequestHeader(s,e.headers[s]);o.send(l._getRequestBodyText(e))}))},e.fetchSendRequestFunc=function(e){var t=l._getRequestBodyText(e);return""===t&&(t=void 0),fetch(e.url,{method:e.method,headers:e.headers,body:t}).then((function(e){return e.text().then((function(t){var n=e.status,r={};return e.headers.forEach((function(e,t){r[t]=e})),{statusCode:n,headers:r,body:t}}))}))},e.sendRequest=function(t){e.validateAndNormalizeRequest(t);var n=e.s_customSendRequestFunc;return n||(n="undefined"!==typeof fetch?e.fetchSendRequestFunc:e.xhrSendRequestFunc),n(t)},e.setCustomSendLocalDocumentRequestFunc=function(t){e.s_customSendLocalDocumentRequestFunc=t},e.sendLocalDocumentRequest=function(t){return e.validateAndNormalizeRequest(t),(e.s_customSendLocalDocumentRequestFunc||e.officeJsSendLocalDocumentRequestFunc)(t)},e.officeJsSendLocalDocumentRequestFunc=function(e){e=l._validateLocalDocumentRequest(e);var t=l._buildRequestMessageSafeArray(e);return l.createPromise((function(e,n){OSF.DDA.RichApi.executeRichApiRequestAsync(t,(function(t){var n;n="succeeded"==t.status?{statusCode:c.getResponseStatusCode(t),headers:c.getResponseHeaders(t),body:c.getResponseBody(t)}:c.buildHttpResponseFromOfficeJsError(t.error.code,t.error.message),l.log("Response:"),l.log(JSON.stringify(n)),e(n)}))}))},e.validateAndNormalizeRequest=function(e){if(l.isNullOrUndefined(e))throw r.RuntimeError._createInvalidArgError({argumentName:"request"});l.isNullOrEmptyString(e.method)&&(e.method="GET"),e.method=e.method.toUpperCase();var t=!1;if("object"===typeof e.headers&&e.headers[s.testRequestNameHeader]&&(t=!0),!t){var n=u._getCurrentTestNameWithSequenceId();n&&(e.headers||(e.headers={}),e.headers[s.testRequestNameHeader]=n)}},e.logRequest=function(t){if(l._logEnabled){if(l.log("---HTTP Request---"),l.log(t.method+" "+t.url),t.headers)for(var n in t.headers)l.log(n+": "+t.headers[n]);e._logBodyEnabled&&l.log(l._getRequestBodyText(t))}},e.logResponse=function(t){if(l._logEnabled){if(l.log("---HTTP Response---"),l.log(""+t.statusCode),t.headers)for(var n in t.headers)l.log(n+": "+t.headers[n]);e._logBodyEnabled&&l.log(t.body)}},e._logBodyEnabled=!1,e}();e.HttpUtility=n;var r,o=function(){function e(e){var t=this;this.m_bridge=e,this.m_promiseResolver={},this.m_handlers=[],this.m_bridge.onMessageFromHost=function(e){var n=JSON.parse(e);if(3==n.type){var r=n.message;if(r&&r.entries)for(var o=0;o<r.entries.length;o++){var i=r.entries[o];if(Array.isArray(i)){var a={messageCategory:i[0],messageType:i[1],targetId:i[2],message:i[3],id:i[4]};r.entries[o]=a}}}t.dispatchMessage(n)}}return e.init=function(t){if("object"===typeof t&&t){var r=new e(t);e.s_instance=r,n.setCustomSendLocalDocumentRequestFunc((function(t){t=l._validateLocalDocumentRequest(t);var n=0;l.isReadonlyRestRequest(t.method)||(n=1);var o=t.url.indexOf("?");if(o>=0){var i=t.url.substr(o+1),a=l._parseRequestFlagsAndCustomDataFromQueryStringIfAny(i);a.flags>=0&&(n=a.flags)}"string"===typeof t.body&&(t.body=JSON.parse(t.body));var s={id:e.nextId(),type:1,flags:n,message:t};return r.sendMessageToHostAndExpectResponse(s).then((function(e){return e.message}))}));for(var o=0;o<e.s_onInitedHandlers.length;o++)e.s_onInitedHandlers[o](r)}},Object.defineProperty(e,"instance",{get:function(){return e.s_instance},enumerable:!0,configurable:!0}),e.prototype.sendMessageToHost=function(e){this.m_bridge.sendMessageToHost(JSON.stringify(e))},e.prototype.sendMessageToHostAndExpectResponse=function(e){var t=this,n=l.createPromise((function(n,r){t.m_promiseResolver[e.id]=n}));return this.m_bridge.sendMessageToHost(JSON.stringify(e)),n},e.prototype.addHostMessageHandler=function(e){this.m_handlers.push(e)},e.prototype.removeHostMessageHandler=function(e){var t=this.m_handlers.indexOf(e);t>=0&&this.m_handlers.splice(t,1)},e.onInited=function(t){e.s_onInitedHandlers.push(t),e.s_instance&&t(e.s_instance)},e.prototype.dispatchMessage=function(e){if("number"===typeof e.id){var t=this.m_promiseResolver[e.id];if(t)return t(e),void delete this.m_promiseResolver[e.id]}for(var n=0;n<this.m_handlers.length;n++)this.m_handlers[n](e)},e.nextId=function(){return e.s_nextId++},e.s_onInitedHandlers=[],e.s_nextId=1,e}();e.HostBridge=o,"object"===typeof _richApiNativeBridge&&_richApiNativeBridge&&o.init(_richApiNativeBridge),function(e){var t=function(t){function n(e){var r=t.call(this,"string"===typeof e?e:e.message)||this;if(Object.setPrototypeOf(r,n.prototype),r.name="RichApi.Error","string"===typeof e?r.message=e:(r.code=e.code,r.message=e.message,r.traceMessages=e.traceMessages||[],r.innerError=e.innerError||null,r.debugInfo=r._createDebugInfo(e.debugInfo||{}),r.httpStatusCode=e.httpStatusCode,r.data=e.data),l.isNullOrUndefined(r.httpStatusCode)||200===r.httpStatusCode){var o={};o[i.accessDenied]=401,o[i.connectionFailure]=500,o[i.generalException]=500,o[i.invalidArgument]=400,o[i.invalidObjectPath]=400,o[i.invalidOrTimedOutSession]=408,o[i.invalidRequestContext]=400,o[i.timeout]=408,o[i.valueNotLoaded]=400,r.httpStatusCode=o[r.code]}return l.isNullOrUndefined(r.httpStatusCode)&&(r.httpStatusCode=500),r}return __extends(n,t),n.prototype.toString=function(){return this.code+": "+this.message},n.prototype._createDebugInfo=function(t){var n={code:this.code,message:this.message,toString:function(){return JSON.stringify(this)}};for(var r in t)n[r]=t[r];return this.innerError&&(this.innerError instanceof e.RuntimeError?n.innerError=this.innerError.debugInfo:n.innerError=this.innerError),n},n._createInvalidArgError=function(t){return new e.RuntimeError({code:i.invalidArgument,httpStatusCode:400,message:l.isNullOrEmptyString(t.argumentName)?l._getResourceString(a.invalidArgumentGeneric):l._getResourceString(a.invalidArgument,t.argumentName),debugInfo:t.errorLocation?{errorLocation:t.errorLocation}:{},innerError:t.innerError})},n}(Error);e.RuntimeError=t}(r=e._Internal||(e._Internal={})),e.Error=r.RuntimeError;var i=function(){function e(){}return e.apiNotFound="ApiNotFound",e.accessDenied="AccessDenied",e.generalException="GeneralException",e.activityLimitReached="ActivityLimitReached",e.invalidArgument="InvalidArgument",e.connectionFailure="ConnectionFailure",e.timeout="Timeout",e.invalidOrTimedOutSession="InvalidOrTimedOutSession",e.invalidObjectPath="InvalidObjectPath",e.invalidRequestContext="InvalidRequestContext",e.valueNotLoaded="ValueNotLoaded",e.requestPayloadSizeLimitExceeded="RequestPayloadSizeLimitExceeded",e.responsePayloadSizeLimitExceeded="ResponsePayloadSizeLimitExceeded",e.writeNotSupportedWhenModalDialogOpen="WriteNotSupportedWhenModalDialogOpen",e}();e.CoreErrorCodes=i;var a=function(){function e(){}return e.apiNotFoundDetails="ApiNotFoundDetails",e.connectionFailureWithStatus="ConnectionFailureWithStatus",e.connectionFailureWithDetails="ConnectionFailureWithDetails",e.invalidArgument="InvalidArgument",e.invalidArgumentGeneric="InvalidArgumentGeneric",e.timeout="Timeout",e.invalidOrTimedOutSessionMessage="InvalidOrTimedOutSessionMessage",e.invalidSheetName="InvalidSheetName",e.invalidObjectPath="InvalidObjectPath",e.invalidRequestContext="InvalidRequestContext",e.valueNotLoaded="ValueNotLoaded",e}();e.CoreResourceStrings=a;var s=function(){function e(){}return e.flags="flags",e.sourceLibHeader="SdkVersion",e.processQuery="ProcessQuery",e.localDocument="http://document.localhost/",e.localDocumentApiPrefix="http://document.localhost/_api/",e.customData="customdata",e.testRequestNameHeader="x-test-request-name",e}();e.CoreConstants=s;var c=function(){function e(){}return e.buildMessageArrayForIRequestExecutor=function(t,n,r,o){var i=JSON.stringify(r.Body);l.log("Request:"),l.log(i);var a={};return l._copyHeaders(r.Headers,a),a[s.sourceLibHeader]=o,e.buildRequestMessageSafeArray(t,n,"POST",s.processQuery,a,i)},e.buildResponseOnSuccess=function(e,t){var n={HttpStatusCode:200,ErrorCode:"",ErrorMessage:"",Headers:null,Body:null};return n.Body=JSON.parse(e),n.Headers=t,n},e.buildResponseOnError=function(t,n){var r={HttpStatusCode:500,ErrorCode:"",ErrorMessage:"",Headers:null,Body:null};return r.ErrorCode=i.generalException,r.ErrorMessage=n,t==e.OfficeJsErrorCode_ooeNoCapability?(r.ErrorCode=i.accessDenied,r.HttpStatusCode=401):t==e.OfficeJsErrorCode_ooeActivityLimitReached?(r.ErrorCode=i.activityLimitReached,r.HttpStatusCode=429):t==e.OfficeJsErrorCode_ooeInvalidOrTimedOutSession?(r.ErrorCode=i.invalidOrTimedOutSession,r.HttpStatusCode=408,r.ErrorMessage=l._getResourceString(a.invalidOrTimedOutSessionMessage)):t==e.OfficeJsErrorCode_ooeRequestPayloadSizeLimitExceeded?(r.ErrorCode=i.requestPayloadSizeLimitExceeded,r.HttpStatusCode=400):t==e.OfficeJsErrorCode_ooeResponsePayloadSizeLimitExceeded?(r.ErrorCode=i.responsePayloadSizeLimitExceeded,r.HttpStatusCode=400):t==e.OfficeJsErrorCode_ooeWriteNotSupportedWhenModalDialogOpen?(r.ErrorCode=i.writeNotSupportedWhenModalDialogOpen,r.HttpStatusCode=400):t==e.OfficeJsErrorCode_ooeInvalidSheetName&&(r.ErrorCode=i.invalidRequestContext,r.HttpStatusCode=400,r.ErrorMessage=l._getResourceString(a.invalidSheetName)),r},e.buildHttpResponseFromOfficeJsError=function(t,n){var r=500,o={error:{}};return o.error.code=i.generalException,o.error.message=n,t===e.OfficeJsErrorCode_ooeNoCapability?(r=403,o.error.code=i.accessDenied):t===e.OfficeJsErrorCode_ooeActivityLimitReached&&(r=429,o.error.code=i.activityLimitReached),{statusCode:r,headers:{},body:JSON.stringify(o)}},e.buildRequestMessageSafeArray=function(e,t,n,r,o,i){var a=[];if(o)for(var s in o)a.push(s),a.push(o[s]);return[e,n,r,a,i,0,t,"","","","","",""]},e.getResponseBody=function(t){return e.getResponseBodyFromSafeArray(t.value.data)},e.getResponseHeaders=function(t){return e.getResponseHeadersFromSafeArray(t.value.data)},e.getResponseBodyFromSafeArray=function(e){var t=e[2];return"string"===typeof t?t:t.join("")},e.getResponseHeadersFromSafeArray=function(e){var t=e[1];if(!t)return null;for(var n={},r=0;r<t.length-1;r+=2)n[t[r]]=t[r+1];return n},e.getResponseStatusCode=function(t){return e.getResponseStatusCodeFromSafeArray(t.value.data)},e.getResponseStatusCodeFromSafeArray=function(e){return e[0]},e.OfficeJsErrorCode_ooeInvalidOrTimedOutSession=5012,e.OfficeJsErrorCode_ooeActivityLimitReached=5102,e.OfficeJsErrorCode_ooeNoCapability=7e3,e.OfficeJsErrorCode_ooeRequestPayloadSizeLimitExceeded=5103,e.OfficeJsErrorCode_ooeResponsePayloadSizeLimitExceeded=5104,e.OfficeJsErrorCode_ooeWriteNotSupportedWhenModalDialogOpen=5016,e.OfficeJsErrorCode_ooeInvalidSheetName=1014,e}();e.RichApiMessageUtility=c,function(e){e.getPromiseType=function(){if("undefined"!==typeof Promise)return Promise;if("undefined"!==typeof Office&&Office.Promise)return Office.Promise;if("undefined"!==typeof OfficeExtension&&OfficeExtension.Promise)return OfficeExtension.Promise;throw new e.Error("No Promise implementation found")}}(r=e._Internal||(e._Internal={}));var l=function(){function e(){}return e.log=function(t){e._logEnabled&&"undefined"!==typeof console&&console.log&&console.log(t)},e.checkArgumentNull=function(t,n){if(e.isNullOrUndefined(t))throw r.RuntimeError._createInvalidArgError({argumentName:n})},e.isNullOrUndefined=function(e){return null===e||"undefined"===typeof e},e.isUndefined=function(e){return"undefined"===typeof e},e.isNullOrEmptyString=function(e){return null===e||("undefined"===typeof e||0==e.length)},e.isPlainJsonObject=function(t){if(e.isNullOrUndefined(t))return!1;if("object"!==typeof t)return!1;if("[object Object]"!==Object.prototype.toString.apply(t))return!1;if(t.constructor&&!Object.prototype.hasOwnProperty.call(t,"constructor")&&!Object.prototype.hasOwnProperty.call(t.constructor.prototype,"hasOwnProperty"))return!1;for(var n in t)if(!Object.prototype.hasOwnProperty.call(t,n))return!1;return!0},e.trim=function(e){return e.replace(new RegExp("^\\s+|\\s+$","g"),"")},e.caseInsensitiveCompareString=function(t,n){return e.isNullOrUndefined(t)?e.isNullOrUndefined(n):!e.isNullOrUndefined(n)&&t.toUpperCase()==n.toUpperCase()},e.isReadonlyRestRequest=function(t){return e.caseInsensitiveCompareString(t,"GET")},e._getResourceString=function(t,n){var r;if("undefined"!==typeof window&&window.Strings&&window.Strings.OfficeOM){var o="L_"+t,i=window.Strings.OfficeOM[o];i&&(r=i)}if(r||(r=e.s_resourceStringValues[t]),r||(r=t),!e.isNullOrUndefined(n))if(Array.isArray(n)){var a=n;r=e._formatString(r,a)}else r=r.replace("{0}",n);return r},e._formatString=function(e,t){return e.replace(/\{\d\}/g,(function(e){var n=parseInt(e.substr(1,e.length-2));if(n<t.length)return t[n];throw r.RuntimeError._createInvalidArgError({argumentName:"format"})}))},Object.defineProperty(e,"Promise",{get:function(){return r.getPromiseType()},enumerable:!0,configurable:!0}),e.createPromise=function(t){return new e.Promise(t)},e._createPromiseFromResult=function(t){return e.createPromise((function(e,n){e(t)}))},e._createPromiseFromException=function(t){return e.createPromise((function(e,n){n(t)}))},e._createTimeoutPromise=function(t){return e.createPromise((function(e,n){setTimeout((function(){e(null)}),t)}))},e._createInvalidArgError=function(e){return r.RuntimeError._createInvalidArgError(e)},e._isLocalDocumentUrl=function(t){return e._getLocalDocumentUrlPrefixLength(t)>0},e._getLocalDocumentUrlPrefixLength=function(e){for(var t=["http://document.localhost","https://document.localhost","//document.localhost"],n=e.toLowerCase().trim(),r=0;r<t.length;r++){if(n===t[r])return t[r].length;if(n.substr(0,t[r].length+1)===t[r]+"/")return t[r].length+1}return 0},e._validateLocalDocumentRequest=function(t){var n=e._getLocalDocumentUrlPrefixLength(t.url);if(n<=0)throw r.RuntimeError._createInvalidArgError({argumentName:"request"});var o=t.url.substr(n),i=o.toLowerCase();return"_api"===i?o="":"_api/"===i.substr(0,"_api/".length)&&(o=o.substr("_api/".length)),{method:t.method,url:o,headers:t.headers,body:t.body}},e._parseRequestFlagsAndCustomDataFromQueryStringIfAny=function(e){for(var t={flags:-1,customData:""},n=e.split("&"),r=0;r<n.length;r++){var o=n[r].split("=");if(o[0].toLowerCase()===s.flags){var i=parseInt(o[1]);i&=8191,t.flags=i}else o[0].toLowerCase()===s.customData&&(t.customData=decodeURIComponent(o[1]))}return t},e._getRequestBodyText=function(e){var t="";return"string"===typeof e.body?t=e.body:e.body&&"object"===typeof e.body&&(t=JSON.stringify(e.body)),t},e._parseResponseBody=function(t){if("string"===typeof t.body){var n=e.trim(t.body);return JSON.parse(n)}return t.body},e._buildRequestMessageSafeArray=function(t){var n=0;e.isReadonlyRestRequest(t.method)||(n=1);var r="";if(t.url.substr(0,s.processQuery.length).toLowerCase()===s.processQuery.toLowerCase()){var o=t.url.indexOf("?");if(o>0){var i=t.url.substr(o+1),a=e._parseRequestFlagsAndCustomDataFromQueryStringIfAny(i);a.flags>=0&&(n=a.flags),r=a.customData}}return c.buildRequestMessageSafeArray(r,n,t.method,t.url,t.headers,e._getRequestBodyText(t))},e._parseHttpResponseHeaders=function(t){var n={};if(!e.isNullOrEmptyString(t))for(var r=new RegExp("\r?\n"),o=t.split(r),i=0;i<o.length;i++){var a=o[i];if(null!=a){var s=a.indexOf(":");if(s>0){var c=a.substr(0,s),l=a.substr(s+1);c=e.trim(c),l=e.trim(l),n[c.toUpperCase()]=l}}}return n},e._parseErrorResponse=function(t){var n=e._parseErrorResponseBody(t),r=t.statusCode.toString();if(e.isNullOrUndefined(n)||"object"!==typeof n||!n.error)return e._createDefaultErrorResponse(r);var o=n.error,i=o.innerError;return i&&i.code?e._createErrorResponse(i.code,r,i.message):o.code?e._createErrorResponse(o.code,r,o.message):e._createDefaultErrorResponse(r)},e._parseErrorResponseBody=function(t){if(e.isPlainJsonObject(t.body))return t.body;if(!e.isNullOrEmptyString(t.body)){var n=e.trim(t.body);try{return JSON.parse(n)}catch(t){e.log("Error when parse "+n)}}},e._createDefaultErrorResponse=function(t){return{errorCode:i.connectionFailure,errorMessage:e._getResourceString(a.connectionFailureWithStatus,t)}},e._createErrorResponse=function(t,n,r){return{errorCode:t,errorMessage:e._getResourceString(a.connectionFailureWithDetails,[n,t,r])}},e._copyHeaders=function(e,t){if(e&&t)for(var n in e)t[n]=e[n]},e.addResourceStringValues=function(t){for(var n in t)e.s_resourceStringValues[n]=t[n]},e._logEnabled=!1,e.s_resourceStringValues={ApiNotFoundDetails:"The method or property {0} is part of the {1} requirement set, which is not available in your version of {2}.",ConnectionFailureWithStatus:"The request failed with status code of {0}.",ConnectionFailureWithDetails:"The request failed with status code of {0}, error code {1} and the following error message: {2}",InvalidArgument:"The argument '{0}' doesn't work for this situation, is missing, or isn't in the right format.",InvalidObjectPath:'The object path \'{0}\' isn\'t working for what you\'re trying to do. If you\'re using the object across multiple "context.sync" calls and outside the sequential execution of a ".run" batch, please use the "context.trackedObjects.add()" and "context.trackedObjects.remove()" methods to manage the object\'s lifetime.',InvalidRequestContext:"Cannot use the object across different request contexts.",Timeout:"The operation has timed out.",ValueNotLoaded:'The value of the result object has not been loaded yet. Before reading the value property, call "context.sync()" on the associated request context.'},e}();e.CoreUtility=l;var u=function(){function e(){}return e.setMock=function(t){e.s_isMock=t},e.isMock=function(){return e.s_isMock},e._setCurrentTestName=function(t){e.s_currentTestName=t,e.s_currentTestSequenceId=0},e._getCurrentTestNameWithSequenceId=function(){return e.s_currentTestName?(e.s_currentTestSequenceId++,e.s_currentTestName+"."+e.s_currentTestSequenceId):null},e}();e.TestUtility=u,e._internalConfig={showDisposeInfoInDebugInfo:!1,showInternalApiInDebugInfo:!1,enableEarlyDispose:!0,alwaysPolyfillClientObjectUpdateMethod:!1,alwaysPolyfillClientObjectRetrieveMethod:!1,enableConcurrentFlag:!0,enableUndoableFlag:!0,appendTypeNameToObjectPathInfo:!1,enablePreviewExecution:!1},e.config={extendedErrorLogging:!1};var p=function(){function t(){}return t.createSetPropertyAction=function(t,n,r,o,i){S.validateObjectPath(n);var a={Id:t._nextId(),ActionType:4,Name:r,ObjectPathId:n._objectPath.objectPathInfo.Id,ArgumentInfo:{}},s=[o],c=S.setMethodArguments(t,a.ArgumentInfo,s);S.validateReferencedObjectPaths(c);var l=new d(a,0,i);if(l.referencedObjectPath=n._objectPath,l.referencedArgumentObjectPaths=c,e._internalConfig.enablePreviewExecution&&0!==(16&i)){var u={Id:t._nextId(),ActionType:4,Name:r,ObjectId:"",ObjectType:"",Arguments:[o]};n._addPreviewExecutionAction(u)}return n._addAction(l)},t.createQueryAction=function(e,t,n,r){S.validateObjectPath(t);var o={Id:e._nextId(),ActionType:2,Name:"",ObjectPathId:t._objectPath.objectPathInfo.Id,QueryInfo:n},i=new d(o,1,4);return i.referencedObjectPath=t._objectPath,t._addAction(i,r)},t.createQueryAsJsonAction=function(e,t,n,r){S.validateObjectPath(t);var o={Id:e._nextId(),ActionType:7,Name:"",ObjectPathId:t._objectPath.objectPathInfo.Id,QueryInfo:n},i=new d(o,1,4);return i.referencedObjectPath=t._objectPath,t._addAction(i,r)},t.createUpdateAction=function(e,t,n){S.validateObjectPath(t);var r={Id:e._nextId(),ActionType:9,Name:"",ObjectPathId:t._objectPath.objectPathInfo.Id,ObjectState:n},o=new d(r,0,0);return o.referencedObjectPath=t._objectPath,t._addAction(o)},t}();e.CommonActionFactory=p;var f=function(){function t(e,t){this.m_contextBase=e,this.m_objectPath=t}return Object.defineProperty(t.prototype,"_objectPath",{get:function(){return this.m_objectPath},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_context",{get:function(){return this.m_contextBase},enumerable:!0,configurable:!0}),t.prototype._addAction=function(e,t){var n=this;return void 0===t&&(t=null),l.createPromise((function(r,o){n._context._addServiceApiAction(e,t,r,o)}))},t.prototype._addPreviewExecutionAction=function(e){},t.prototype._retrieve=function(t,n){var r=e._internalConfig.alwaysPolyfillClientObjectRetrieveMethod;r||(r=!S.isSetSupported("RichApiRuntime","1.1"));var o=m._parseQueryOption(t);return r?p.createQueryAction(this._context,this,o,n):p.createQueryAsJsonAction(this._context,this,o,n)},t.prototype._recursivelyUpdate=function(t){var n=e._internalConfig.alwaysPolyfillClientObjectUpdateMethod;n||(n=!S.isSetSupported("RichApiRuntime","1.2"));try{var o=this[v.scalarPropertyNames];o||(o=[]);var s=this[v.scalarPropertyUpdateable];if(!s){s=[];for(var c=0;c<o.length;c++)s.push(!1)}var u=this[v.navigationPropertyNames];u||(u=[]);var f={},d={},h=0;for(var m in t){var g=o.indexOf(m);if(g>=0){if(!s[g])throw new r.RuntimeError({code:i.invalidArgument,httpStatusCode:400,message:l._getResourceString(A.attemptingToSetReadOnlyProperty,m),debugInfo:{errorLocation:m}});f[m]=t[m],++h}else{if(!(u.indexOf(m)>=0))throw new r.RuntimeError({code:i.invalidArgument,httpStatusCode:400,message:l._getResourceString(A.propertyDoesNotExist,m),debugInfo:{errorLocation:m}});d[m]=t[m]}}if(h>0)if(n)for(c=0;c<o.length;c++){var y=f[m=o[c]];S.isUndefined(y)||p.createSetPropertyAction(this._context,this,m,y)}else p.createUpdateAction(this._context,this,f);for(var m in d){var O=this[m],_=d[m];O._recursivelyUpdate(_)}}catch(e){throw new r.RuntimeError({code:i.invalidArgument,httpStatusCode:400,message:l._getResourceString(a.invalidArgument,"properties"),debugInfo:{errorLocation:this._className+".update"},innerError:e})}},t}();e.ClientObjectBase=f;var d=function(){function e(e,t,n){this.m_actionInfo=e,this.m_operationType=t,this.m_flags=n}return Object.defineProperty(e.prototype,"actionInfo",{get:function(){return this.m_actionInfo},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"operationType",{get:function(){return this.m_operationType},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"flags",{get:function(){return this.m_flags},enumerable:!0,configurable:!0}),e}();e.Action=d;var h=function(){function t(e,t,n,r,o,i){this.m_objectPathInfo=e,this.m_parentObjectPath=t,this.m_isCollection=n,this.m_isInvalidAfterRequest=r,this.m_isValid=!0,this.m_operationType=o,this.m_flags=i}return Object.defineProperty(t.prototype,"id",{get:function(){var e=this.m_objectPathInfo.ArgumentInfo;if(e){var t=e.Arguments;if(t)return t[0]}},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"parent",{get:function(){var e=this.m_parentObjectPath;if(e)return e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"parentId",{get:function(){return this.parent?this.parent.id:void 0},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"objectPathInfo",{get:function(){return this.m_objectPathInfo},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"operationType",{get:function(){return this.m_operationType},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"flags",{get:function(){return this.m_flags},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isCollection",{get:function(){return this.m_isCollection},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isInvalidAfterRequest",{get:function(){return this.m_isInvalidAfterRequest},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"parentObjectPath",{get:function(){return this.m_parentObjectPath},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"argumentObjectPaths",{get:function(){return this.m_argumentObjectPaths},set:function(e){this.m_argumentObjectPaths=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isValid",{get:function(){return this.m_isValid},set:function(e){this.m_isValid=e,!e&&6===this.m_objectPathInfo.ObjectPathType&&this.m_savedObjectPathInfo&&(t.copyObjectPathInfo(this.m_savedObjectPathInfo.pathInfo,this.m_objectPathInfo),this.m_parentObjectPath=this.m_savedObjectPathInfo.parent,this.m_isValid=!0,this.m_savedObjectPathInfo=null)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"originalObjectPathInfo",{get:function(){return this.m_originalObjectPathInfo},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"getByIdMethodName",{get:function(){return this.m_getByIdMethodName},set:function(e){this.m_getByIdMethodName=e},enumerable:!0,configurable:!0}),t.prototype._updateAsNullObject=function(){this.resetForUpdateUsingObjectData(),this.m_objectPathInfo.ObjectPathType=7,this.m_objectPathInfo.Name="",this.m_parentObjectPath=null},t.prototype.saveOriginalObjectPathInfo=function(){e.config.extendedErrorLogging&&!this.m_originalObjectPathInfo&&(this.m_originalObjectPathInfo={},t.copyObjectPathInfo(this.m_objectPathInfo,this.m_originalObjectPathInfo))},t.prototype.updateUsingObjectData=function(e,n){var r=e[v.referenceId];if(!l.isNullOrEmptyString(r)){if(!this.m_savedObjectPathInfo&&!this.isInvalidAfterRequest&&t.isRestorableObjectPath(this.m_objectPathInfo.ObjectPathType)){var o={};t.copyObjectPathInfo(this.m_objectPathInfo,o),this.m_savedObjectPathInfo={pathInfo:o,parent:this.m_parentObjectPath}}return this.saveOriginalObjectPathInfo(),this.resetForUpdateUsingObjectData(),this.m_objectPathInfo.ObjectPathType=6,this.m_objectPathInfo.Name=r,delete this.m_objectPathInfo.ParentObjectPathId,void(this.m_parentObjectPath=null)}if(n){var i=n[v.collectionPropertyPath];if(!l.isNullOrEmptyString(i)&&n.context){var a=S.tryGetObjectIdFromLoadOrRetrieveResult(e);if(!l.isNullOrUndefined(a)){for(var s=i.split("."),c=n.context[s[0]],u=1;u<s.length;u++)c=c[s[u]];return this.saveOriginalObjectPathInfo(),this.resetForUpdateUsingObjectData(),this.m_parentObjectPath=c._objectPath,this.m_objectPathInfo.ParentObjectPathId=this.m_parentObjectPath.objectPathInfo.Id,this.m_objectPathInfo.ObjectPathType=5,this.m_objectPathInfo.Name="",void(this.m_objectPathInfo.ArgumentInfo.Arguments=[a])}}}var p=this.parentObjectPath&&this.parentObjectPath.isCollection,f=this.getByIdMethodName;if(p||!l.isNullOrEmptyString(f)){a=S.tryGetObjectIdFromLoadOrRetrieveResult(e);if(!l.isNullOrUndefined(a))return this.saveOriginalObjectPathInfo(),this.resetForUpdateUsingObjectData(),l.isNullOrEmptyString(f)?(this.m_objectPathInfo.ObjectPathType=5,this.m_objectPathInfo.Name=""):(this.m_objectPathInfo.ObjectPathType=3,this.m_objectPathInfo.Name=f),void(this.m_objectPathInfo.ArgumentInfo.Arguments=[a])}},t.prototype.resetForUpdateUsingObjectData=function(){this.m_isInvalidAfterRequest=!1,this.m_isValid=!0,this.m_operationType=1,this.m_flags=4,this.m_objectPathInfo.ArgumentInfo={},this.m_argumentObjectPaths=null,this.m_getByIdMethodName=null},t.isRestorableObjectPath=function(e){return 1===e||5===e||3===e||4===e},t.copyObjectPathInfo=function(e,t){t.Id=e.Id,t.ArgumentInfo=e.ArgumentInfo,t.Name=e.Name,t.ObjectPathType=e.ObjectPathType,t.ParentObjectPathId=e.ParentObjectPathId},t}();e.ObjectPath=h;var m=function(){function e(){this.m_nextId=0}return e.prototype._nextId=function(){return++this.m_nextId},e.prototype._addServiceApiAction=function(e,t,n,r){this.m_serviceApiQueue||(this.m_serviceApiQueue=new _(this)),this.m_serviceApiQueue.add(e,t,n,r)},e._parseQueryOption=function(t){var n={};if("string"===typeof t){var o=t;n.Select=S._parseSelectExpand(o)}else if(Array.isArray(t))n.Select=t;else if("object"===typeof t){var i=t;if(e.isLoadOption(i)){if("string"===typeof i.select)n.Select=S._parseSelectExpand(i.select);else if(Array.isArray(i.select))n.Select=i.select;else if(!S.isNullOrUndefined(i.select))throw r.RuntimeError._createInvalidArgError({argumentName:"option.select"});if("string"===typeof i.expand)n.Expand=S._parseSelectExpand(i.expand);else if(Array.isArray(i.expand))n.Expand=i.expand;else if(!S.isNullOrUndefined(i.expand))throw r.RuntimeError._createInvalidArgError({argumentName:"option.expand"});if("number"===typeof i.top)n.Top=i.top;else if(!S.isNullOrUndefined(i.top))throw r.RuntimeError._createInvalidArgError({argumentName:"option.top"});if("number"===typeof i.skip)n.Skip=i.skip;else if(!S.isNullOrUndefined(i.skip))throw r.RuntimeError._createInvalidArgError({argumentName:"option.skip"})}else n=e.parseStrictLoadOption(t)}else if(!S.isNullOrUndefined(t))throw r.RuntimeError._createInvalidArgError({argumentName:"option"});return n},e.isLoadOption=function(e){if(!S.isUndefined(e.select)&&("string"===typeof e.select||Array.isArray(e.select)))return!0;if(!S.isUndefined(e.expand)&&("string"===typeof e.expand||Array.isArray(e.expand)))return!0;if(!S.isUndefined(e.top)&&"number"===typeof e.top)return!0;if(!S.isUndefined(e.skip)&&"number"===typeof e.skip)return!0;for(var t in e)return!1;return!0},e.parseStrictLoadOption=function(t){var n={Select:[]};return e.parseStrictLoadOptionHelper(n,"","option",t),n},e.combineQueryPath=function(e,t,n){return 0===e.length?t:e+n+t},e.parseStrictLoadOptionHelper=function(t,n,o,i){for(var a in i){var s=i[a];if("$all"===a){if("boolean"!==typeof s)throw r.RuntimeError._createInvalidArgError({argumentName:e.combineQueryPath(o,a,".")});s&&t.Select.push(e.combineQueryPath(n,"*","/"))}else if("$top"===a){if("number"!==typeof s||n.length>0)throw r.RuntimeError._createInvalidArgError({argumentName:e.combineQueryPath(o,a,".")});t.Top=s}else if("$skip"===a){if("number"!==typeof s||n.length>0)throw r.RuntimeError._createInvalidArgError({argumentName:e.combineQueryPath(o,a,".")});t.Skip=s}else if("boolean"===typeof s)s&&t.Select.push(e.combineQueryPath(n,a,"/"));else{if("object"!==typeof s)throw r.RuntimeError._createInvalidArgError({argumentName:e.combineQueryPath(o,a,".")});e.parseStrictLoadOptionHelper(t,e.combineQueryPath(n,a,"/"),e.combineQueryPath(o,a,"."),s)}}},e}();e.ClientRequestContextBase=m;var g=function(){function e(e){this.m_objectPath=e}return e.prototype._handleResult=function(e){l.isNullOrUndefined(e)?this.m_objectPath._updateAsNullObject():this.m_objectPath.updateUsingObjectData(e,null)},e}(),y=function(){function t(e){this.m_contextBase=e,this.m_actions=[],this.m_actionResultHandler={},this.m_referencedObjectPaths={},this.m_instantiatedObjectPaths={},this.m_preSyncPromises=[],this.m_previewExecutionActions=[]}return t.prototype.addAction=function(e){this.m_actions.push(e),1==e.actionInfo.ActionType&&(this.m_instantiatedObjectPaths[e.actionInfo.ObjectPathId]=e)},t.prototype.addPreviewExecutionAction=function(e){this.m_previewExecutionActions.push(e)},Object.defineProperty(t.prototype,"hasActions",{get:function(){return this.m_actions.length>0},enumerable:!0,configurable:!0}),t.prototype._getLastAction=function(){return this.m_actions[this.m_actions.length-1]},t.prototype.ensureInstantiateObjectPath=function(e){if(e){if(this.m_instantiatedObjectPaths[e.objectPathInfo.Id])return;if(this.ensureInstantiateObjectPath(e.parentObjectPath),this.ensureInstantiateObjectPaths(e.argumentObjectPaths),!this.m_instantiatedObjectPaths[e.objectPathInfo.Id]){var t={Id:this.m_contextBase._nextId(),ActionType:1,Name:"",ObjectPathId:e.objectPathInfo.Id},n=new d(t,1,4);n.referencedObjectPath=e,this.addReferencedObjectPath(e),this.addAction(n);var r=new g(e);this.addActionResultHandler(n,r)}}},t.prototype.ensureInstantiateObjectPaths=function(e){if(e)for(var t=0;t<e.length;t++)this.ensureInstantiateObjectPath(e[t])},t.prototype.addReferencedObjectPath=function(e){if(e&&!this.m_referencedObjectPaths[e.objectPathInfo.Id]){if(!e.isValid)throw new r.RuntimeError({code:i.invalidObjectPath,httpStatusCode:400,message:l._getResourceString(a.invalidObjectPath,S.getObjectPathExpression(e)),debugInfo:{errorLocation:S.getObjectPathExpression(e)}});for(;e;)this.m_referencedObjectPaths[e.objectPathInfo.Id]=e,3==e.objectPathInfo.ObjectPathType&&this.addReferencedObjectPaths(e.argumentObjectPaths),e=e.parentObjectPath}},t.prototype.addReferencedObjectPaths=function(e){if(e)for(var t=0;t<e.length;t++)this.addReferencedObjectPath(e[t])},t.prototype.addActionResultHandler=function(e,t){this.m_actionResultHandler[e.actionInfo.Id]=t},t.prototype.aggregrateRequestFlags=function(e,t,n){return 0===t&&(e|=1,0===(2&n)&&(e&=-17),0===(8&n)&&(e&=-257),e&=-5),1&n&&(e|=2),0===(4&n)&&(e&=-5),e},t.prototype.finallyNormalizeFlags=function(t){return 0===(1&t)&&(t&=-17,t&=-257),e._internalConfig.enableConcurrentFlag||(t&=-5),e._internalConfig.enableUndoableFlag||(t&=-17),S.isSetSupported("RichApiRuntimeFlag","1.1")||(t&=-5,t&=-17),S.isSetSupported("RichApiRuntimeFlag","1.2")||(t&=-257),"number"===typeof this.m_flagsForTesting&&(t=this.m_flagsForTesting),t},t.prototype.buildRequestMessageBodyAndRequestFlags=function(){e._internalConfig.enableEarlyDispose&&t._calculateLastUsedObjectPathIds(this.m_actions);var n=276,r={};for(var o in this.m_referencedObjectPaths)n=this.aggregrateRequestFlags(n,this.m_referencedObjectPaths[o].operationType,this.m_referencedObjectPaths[o].flags),r[o]=this.m_referencedObjectPaths[o].objectPathInfo;for(var i=[],a=!1,s=0;s<this.m_actions.length;s++){var c=this.m_actions[s];3===c.actionInfo.ActionType&&c.actionInfo.Name===v.keepReference&&(a=!0),n=this.aggregrateRequestFlags(n,c.operationType,c.flags),i.push(c.actionInfo)}n=this.finallyNormalizeFlags(n);var l={AutoKeepReference:this.m_contextBase._autoCleanup&&a,Actions:i,ObjectPaths:r};return this.m_previewExecutionActions.length>0&&(l.PreviewExecutionActions=this.m_previewExecutionActions,n|=4096),{body:l,flags:n}},t.prototype.processResponse=function(e){if(e)for(var t=0;t<e.length;t++){var n=e[t],r=this.m_actionResultHandler[n.ActionId];r&&r._handleResult(n.Value)}},t.prototype.invalidatePendingInvalidObjectPaths=function(){for(var e in this.m_referencedObjectPaths)this.m_referencedObjectPaths[e].isInvalidAfterRequest&&(this.m_referencedObjectPaths[e].isValid=!1)},t.prototype._addPreSyncPromise=function(e){this.m_preSyncPromises.push(e)},Object.defineProperty(t.prototype,"_preSyncPromises",{get:function(){return this.m_preSyncPromises},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_actions",{get:function(){return this.m_actions},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_objectPaths",{get:function(){return this.m_referencedObjectPaths},enumerable:!0,configurable:!0}),t.prototype._removeKeepReferenceAction=function(e){for(var t=this.m_actions.length-1;t>=0;t--){var n=this.m_actions[t].actionInfo;if(n.ObjectPathId===e&&3===n.ActionType&&n.Name===v.keepReference){this.m_actions.splice(t,1);break}}},t._updateLastUsedActionIdOfObjectPathId=function(e,n,r){for(;n;){if(e[n.objectPathInfo.Id])return;e[n.objectPathInfo.Id]=r;var o=n.argumentObjectPaths;if(o)for(var i=o.length,a=0;a<i;a++)t._updateLastUsedActionIdOfObjectPathId(e,o[a],r);n=n.parentObjectPath}},t._calculateLastUsedObjectPathIds=function(e){for(var n={},r=e.length,o=r-1;o>=0;--o){var i=(f=e[o]).actionInfo.Id;f.referencedObjectPath&&t._updateLastUsedActionIdOfObjectPathId(n,f.referencedObjectPath,i);var a=f.referencedArgumentObjectPaths;if(a)for(var s=a.length,c=0;c<s;c++)t._updateLastUsedActionIdOfObjectPathId(n,a[c],i)}var l={};for(var u in n){var p=l[i=n[u]];p||(p=[],l[i]=p),p.push(parseInt(u))}for(o=0;o<r;o++){var f,d=l[(f=e[o]).actionInfo.Id];d&&d.length>0?f.actionInfo.L=d:f.actionInfo.L&&delete f.actionInfo.L}},t}();e.ClientRequestBase=y;var O=function(){function e(e){this.m_type=e}return Object.defineProperty(e.prototype,"value",{get:function(){if(!this.m_isLoaded)throw new r.RuntimeError({code:i.valueNotLoaded,httpStatusCode:400,message:l._getResourceString(a.valueNotLoaded),debugInfo:{errorLocation:"clientResult.value"}});return this.m_value},enumerable:!0,configurable:!0}),e.prototype._handleResult=function(e){this.m_isLoaded=!0,"object"===typeof e&&e&&e._IsNull||(1===this.m_type?this.m_value=S.adjustToDateTime(e):this.m_value=e)},e}();e.ClientResult=O;var _=function(){function e(e){this.m_context=e,this.m_actions=[]}return e.prototype.add=function(e,t,n,r){var o=this;this.m_actions.push({action:e,resultHandler:t,resolve:n,reject:r}),1===this.m_actions.length&&setTimeout((function(){return o.processActions()}),0)},e.prototype.processActions=function(){var e=this;if(0!==this.m_actions.length){var t=this.m_actions;this.m_actions=[];for(var n=new y(this.m_context),r=0;r<t.length;r++){var o=t[r];n.ensureInstantiateObjectPath(o.action.referencedObjectPath),n.ensureInstantiateObjectPaths(o.action.referencedArgumentObjectPaths),n.addAction(o.action),n.addReferencedObjectPath(o.action.referencedObjectPath),n.addReferencedObjectPaths(o.action.referencedArgumentObjectPaths)}var i=n.buildRequestMessageBodyAndRequestFlags(),a=i.body,c=i.flags,u={Url:s.localDocumentApiPrefix,Headers:null,Body:a};l.log("Request:"),l.log(JSON.stringify(a)),(new b).executeAsync(this.m_context._customData,c,u).then((function(r){e.processResponse(n,t,r)})).catch((function(e){for(var n=0;n<t.length;n++){t[n].reject(e)}}))}},e.prototype.processResponse=function(e,t,n){var r=this.getErrorFromResponse(n),o=null;n.Body.Results?o=n.Body.Results:n.Body.ProcessedResults&&n.Body.ProcessedResults.Results&&(o=n.Body.ProcessedResults.Results),o||(o=[]),this.processActionResults(e,t,o,r)},e.prototype.getErrorFromResponse=function(e){return l.isNullOrEmptyString(e.ErrorCode)?e.Body&&e.Body.Error?new r.RuntimeError({code:e.Body.Error.Code,httpStatusCode:e.Body.Error.HttpStatusCode,message:e.Body.Error.Message}):null:new r.RuntimeError({code:e.ErrorCode,httpStatusCode:e.HttpStatusCode,message:e.ErrorMessage})},e.prototype.processActionResults=function(e,t,n,r){e.processResponse(n);for(var o=0;o<t.length;o++){for(var i=t[o],a=i.action.actionInfo.Id,s=!1,c=0;c<n.length;c++)if(a==n[c].ActionId){var l=n[c].Value;i.resultHandler&&(i.resultHandler._handleResult(l),l=i.resultHandler.value),i.resolve&&i.resolve(l),s=!0;break}!s&&i.reject&&(r?i.reject(r):i.reject("No response for the action."))}},e}(),b=function(){function e(){}return e.prototype.getRequestUrl=function(e,t){return"/"!=e.charAt(e.length-1)&&(e+="/"),e=(e+=s.processQuery)+"?"+s.flags+"="+t.toString()},e.prototype.executeAsync=function(t,r,o){var i={method:"POST",url:this.getRequestUrl(o.Url,r),headers:{},body:o.Body};if(i.headers[s.sourceLibHeader]=e.SourceLibHeaderValue,i.headers["CONTENT-TYPE"]="application/json",o.Headers)for(var a in o.Headers)i.headers[a]=o.Headers[a];return(l._isLocalDocumentUrl(i.url)?n.sendLocalDocumentRequest:n.sendRequest)(i).then((function(e){var t;if(200===e.statusCode)t={HttpStatusCode:e.statusCode,ErrorCode:null,ErrorMessage:null,Headers:e.headers,Body:l._parseResponseBody(e)};else{l.log("Error Response:"+e.body);var n=l._parseErrorResponse(e);t={HttpStatusCode:e.statusCode,ErrorCode:n.errorCode,ErrorMessage:n.errorMessage,Headers:e.headers,Body:null,RawErrorResponseBody:l._parseErrorResponseBody(e)}}return t}))},e.SourceLibHeaderValue="officejs-rest",e}();e.HttpRequestExecutor=b;var v=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.collectionPropertyPath="_collectionPropertyPath",t.id="Id",t.idLowerCase="id",t.idPrivate="_Id",t.keepReference="_KeepReference",t.objectPathIdPrivate="_ObjectPathId",t.referenceId="_ReferenceId",t.items="_Items",t.itemsLowerCase="items",t.scalarPropertyNames="_scalarPropertyNames",t.scalarPropertyOriginalNames="_scalarPropertyOriginalNames",t.navigationPropertyNames="_navigationPropertyNames",t.scalarPropertyUpdateable="_scalarPropertyUpdateable",t.previewExecutionObjectId="_previewExecutionObjectId",t}(s);e.CommonConstants=v;var S=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.validateObjectPath=function(e){for(var n=e._objectPath;n;){if(!n.isValid)throw new r.RuntimeError({code:i.invalidObjectPath,httpStatusCode:400,message:l._getResourceString(a.invalidObjectPath,t.getObjectPathExpression(n)),debugInfo:{errorLocation:t.getObjectPathExpression(n)}});n=n.parentObjectPath}},t.validateReferencedObjectPaths=function(e){if(e)for(var n=0;n<e.length;n++)for(var o=e[n];o;){if(!o.isValid)throw new r.RuntimeError({code:i.invalidObjectPath,httpStatusCode:400,message:l._getResourceString(a.invalidObjectPath,t.getObjectPathExpression(o))});o=o.parentObjectPath}},t._toCamelLowerCase=function(e){if(l.isNullOrEmptyString(e))return e;for(var t=0;t<e.length&&e.charCodeAt(t)>=65&&e.charCodeAt(t)<=90;)t++;return t<e.length?e.substr(0,t).toLowerCase()+e.substr(t):e.toLowerCase()},t.adjustToDateTime=function(e){if(l.isNullOrUndefined(e))return null;if("string"===typeof e)return new Date(e);if(Array.isArray(e)){for(var n=e,r=0;r<n.length;r++)n[r]=t.adjustToDateTime(n[r]);return n}throw l._createInvalidArgError({argumentName:"date"})},t.tryGetObjectIdFromLoadOrRetrieveResult=function(e){var t=e[v.id];return l.isNullOrUndefined(t)&&(t=e[v.idLowerCase]),l.isNullOrUndefined(t)&&(t=e[v.idPrivate]),t},t.getObjectPathExpression=function(e){for(var n="";e;){switch(e.objectPathInfo.ObjectPathType){case 1:n=n;break;case 2:n="new()"+(n.length>0?".":"")+n;break;case 3:n=t.normalizeName(e.objectPathInfo.Name)+"()"+(n.length>0?".":"")+n;break;case 4:n=t.normalizeName(e.objectPathInfo.Name)+(n.length>0?".":"")+n;break;case 5:n="getItem()"+(n.length>0?".":"")+n;break;case 6:n="_reference()"+(n.length>0?".":"")+n}e=e.parentObjectPath}return n},t.setMethodArguments=function(e,n,r){if(l.isNullOrUndefined(r))return null;var o=new Array,i=new Array,a=t.collectObjectPathInfos(e,r,o,i);return n.Arguments=r,a&&(n.ReferencedObjectPathIds=i),o},t.validateContext=function(e,t){if(e&&t&&t._context!==e)throw new r.RuntimeError({code:i.invalidRequestContext,httpStatusCode:400,message:l._getResourceString(a.invalidRequestContext)})},t.isSetSupported=function(e,t){return!("undefined"!==typeof window&&window.Office&&window.Office.context&&window.Office.context.requirements)||window.Office.context.requirements.isSetSupported(e,t)},t.throwIfApiNotSupported=function(e,n,o,s){if(t._doApiNotSupportedCheck&&!t.isSetSupported(n,o)){var c=l._getResourceString(a.apiNotFoundDetails,[e,n+" "+o,s]);throw new r.RuntimeError({code:i.apiNotFound,httpStatusCode:404,message:c,debugInfo:{errorLocation:e}})}},t.calculateApiFlags=function(e,n,r){return t.isSetSupported(n,r)||(e&=-3),e},t._parseSelectExpand=function(e){var t=[];if(!l.isNullOrEmptyString(e))for(var n=e.split(","),r=0;r<n.length;r++){var o=n[r];(o=i(o.trim())).length>0&&t.push(o)}return t;function i(e){var t=e.toLowerCase();if("items"===t||"items/"===t)return"*";return("items/"===t.substr(0,6)||"items."===t.substr(0,6))&&(e=e.substr(6)),e.replace(new RegExp("[/.]items[/.]","gi"),"/")}},t.changePropertyNameToCamelLowerCase=function(e){if(Array.isArray(e)){for(var n=[],r=0;r<e.length;r++)n.push(this.changePropertyNameToCamelLowerCase(e[r]));return n}if("object"===typeof e&&null!==e){n={};for(var o in e){var i=e[o];if(o===v.items){(n={})[v.itemsLowerCase]=this.changePropertyNameToCamelLowerCase(i);break}n[t._toCamelLowerCase(o)]=this.changePropertyNameToCamelLowerCase(i)}return n}return e},t.purifyJson=function(e){if(Array.isArray(e)){for(var t=[],n=0;n<e.length;n++)t.push(this.purifyJson(e[n]));return t}if("object"===typeof e&&null!==e){t={};for(var r in e)if(95!==r.charCodeAt(0)){var o=e[r];"object"===typeof o&&null!==o&&Array.isArray(o.items)&&(o=o.items),t[r]=this.purifyJson(o)}return t}return e},t.collectObjectPathInfos=function(e,n,r,o){for(var i=!1,a=0;a<n.length;a++)if(n[a]instanceof f){var s=n[a];t.validateContext(e,s),n[a]=s._objectPath.objectPathInfo.Id,o.push(s._objectPath.objectPathInfo.Id),r.push(s._objectPath),i=!0}else if(Array.isArray(n[a])){var c=new Array;t.collectObjectPathInfos(e,n[a],r,c)?(o.push(c),i=!0):o.push(0)}else l.isPlainJsonObject(n[a])?(o.push(0),t.replaceClientObjectPropertiesWithObjectPathIds(n[a],r)):o.push(0);return i},t.replaceClientObjectPropertiesWithObjectPathIds=function(e,n){var r,o;for(var i in e){var a=e[i];if(a instanceof f)n.push(a._objectPath),e[i]=((r={})[v.objectPathIdPrivate]=a._objectPath.objectPathInfo.Id,r);else if(Array.isArray(a))for(var s=0;s<a.length;s++)if(a[s]instanceof f){var c=a[s];n.push(c._objectPath),a[s]=((o={})[v.objectPathIdPrivate]=c._objectPath.objectPathInfo.Id,o)}else l.isPlainJsonObject(a[s])&&t.replaceClientObjectPropertiesWithObjectPathIds(a[s],n);else l.isPlainJsonObject(a)&&t.replaceClientObjectPropertiesWithObjectPathIds(a,n)}},t.normalizeName=function(e){return e.substr(0,1).toLowerCase()+e.substr(1)},t._doApiNotSupportedCheck=!1,t}(l);e.CommonUtility=S;var A=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.propertyDoesNotExist="PropertyDoesNotExist",t.attemptingToSetReadOnlyProperty="AttemptingToSetReadOnlyProperty",t}(a);e.CommonResourceStrings=A;var D=function(e){function t(t){var n=e.call(this)||this;return n.m_shouldPolyfill=t,n}return __extends(t,e),t.prototype._handleResult=function(t){e.prototype._handleResult.call(this,t),this.m_shouldPolyfill&&(this.m_value=S.changePropertyNameToCamelLowerCase(this.m_value)),this.m_value=this.removeItemNodes(this.m_value)},t.prototype.removeItemNodes=function(e){return"object"===typeof e&&null!==e&&e[v.itemsLowerCase]&&(e=e[v.itemsLowerCase]),S.purifyJson(e)},t}(O);e.ClientRetrieveResult=D;var P=function(){function e(e){this.callback=e}return e.prototype._handleResult=function(e){this.callback&&this.callback()},e}(),I=function(e){function t(t){var n=e.call(this)||this;return n.callback=t,n}return __extends(t,e),t.prototype._handleResult=function(t){e.prototype._handleResult.call(this,t),this.callback()},t}(O);e.ClientResultCallback=I;var C=function(){function t(){}return t.invokeMethod=function(e,t,n,r,o,i){return void 0===n&&(n=0),void 0===r&&(r=[]),void 0===o&&(o=0),void 0===i&&(i=0),l.createPromise((function(i,a){var s=new O,c={Id:e._context._nextId(),ActionType:3,Name:t,ObjectPathId:e._objectPath.objectPathInfo.Id,ArgumentInfo:{}},l=S.setMethodArguments(e._context,c.ArgumentInfo,r),u=new d(c,n,o);u.referencedObjectPath=e._objectPath,u.referencedArgumentObjectPaths=l,e._context._addServiceApiAction(u,s,i,a)}))},t.invokeMethodWithClientResultCallback=function(e,t,n){var r=[];return l.createPromise((function(o,i){var a=new I(e),s={Id:t._context._nextId(),ActionType:3,Name:n,ObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}},c=S.setMethodArguments(t._context,s.ArgumentInfo,r),l=new d(s,0,0);l.referencedObjectPath=t._objectPath,l.referencedArgumentObjectPaths=c,t._context._addServiceApiAction(l,a,o,i)}))},t.invokeRetrieve=function(n,r){var o,i=e._internalConfig.alwaysPolyfillClientObjectRetrieveMethod;if(i||(i=!S.isSetSupported("RichApiRuntime","1.1")),"object"===typeof r[0]&&r[0].hasOwnProperty("$all")){if(!r[0].$all)throw e.Error._createInvalidArgError({});o=r[0]}else o=t._parseSelectOption(r);return n._retrieve(o,new D(i))},t._parseSelectOption=function(n){if(!n||!n[0])throw e.Error._createInvalidArgError({});var r=n[0]&&"string"!==typeof n[0]?n[0]:n;return Array.isArray(r)?r:t.parseRecursiveSelect(r)},t.parseRecursiveSelect=function(e){var t=function(e){return Object.keys(e).reduce((function(n,r){var o=e[r];return"object"===typeof o?n.concat(t(o).map((function(e){return r+"/"+e}))):o?n.concat(r):n}),[])};return t(e)},t.invokeRecursiveUpdate=function(e,t){return l.createPromise((function(n,r){e._recursivelyUpdate(t);var o={Id:e._context._nextId(),ActionType:5,Name:"Trace",ObjectPathId:0},i=new d(o,1,4);e._context._addServiceApiAction(i,null,n,r)}))},t.createRootServiceObject=function(e,t){var n={Id:t._nextId(),ObjectPathType:1,Name:""};return new e(t,new h(n,null,!1,!1,1,4))},t.createTopLevelServiceObject=function(e,t,n,r,o){var i={Id:t._nextId(),ObjectPathType:2,Name:n};return new e(t,new h(i,null,r,!1,1,4|o))},t.createPropertyObject=function(e,t,n,r,o){var i={Id:t._context._nextId(),ObjectPathType:4,Name:n,ParentObjectPathId:t._objectPath.objectPathInfo.Id},a=new h(i,t._objectPath,r,!1,1,4|o);return new e(t._context,a)},t.createIndexerObject=function(e,t,n){var r={Id:t._context._nextId(),ObjectPathType:5,Name:"",ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}};r.ArgumentInfo.Arguments=n;var o=new h(r,t._objectPath,!1,!1,1,4);return new e(t._context,o)},t.createMethodObject=function(e,t,n,r,o,i,a,s,c){var l={Id:t._context._nextId(),ObjectPathType:3,Name:n,ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}},u=S.setMethodArguments(t._context,l.ArgumentInfo,o),p=new h(l,t._objectPath,i,a,r,c);return p.argumentObjectPaths=u,p.getByIdMethodName=s,new e(t._context,p)},t.createAndInstantiateMethodObject=function(e,t,n,r,o,i,a,s,c){return l.createPromise((function(l,u){var p={Id:t._context._nextId(),ObjectPathType:3,Name:n,ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}},f=S.setMethodArguments(t._context,p.ArgumentInfo,o),m=new h(p,t._objectPath,i,a,r,c);m.argumentObjectPaths=f,m.getByIdMethodName=s;var g=new O,y={Id:t._context._nextId(),ActionType:1,Name:"",ObjectPathId:m.objectPathInfo.Id,QueryInfo:{}},_=new d(y,1,4);_.referencedObjectPath=m,t._context._addServiceApiAction(_,g,(function(){return l(new e(t._context,m))}),u)}))},t.createTraceAction=function(e,t){return l.createPromise((function(n,r){var o={Id:e._nextId(),ActionType:5,Name:"Trace",ObjectPathId:0},i=new d(o,1,4),a=new P(t);e._addServiceApiAction(i,a,n,r)}))},t.localDocumentContext=new m,t}();e.OperationalApiHelper=C;var F=function(){function e(e,t,n){this.eventId=e,this.targetId=t,this.eventArgumentTransform=n,this.registeredCallbacks=[]}return e.prototype.add=function(e){this.hasZero()&&q.getGenericEventRegistration("").register(this.eventId,this.targetId,this.registerCallback),this.registeredCallbacks.push(e)},e.prototype.remove=function(e){var t=this.registeredCallbacks.lastIndexOf(e);-1!==t&&this.registeredCallbacks.splice(t,1)},e.prototype.removeAll=function(){this.registeredCallbacks=[],q.getGenericEventRegistration("").unregister(this.eventId,this.targetId,this.registerCallback)},e.prototype.hasZero=function(){return 0===this.registeredCallbacks.length},Object.defineProperty(e.prototype,"registerCallback",{get:function(){var e=this;return this.outsideCallback||(this.outsideCallback=function(t){e.call(t)}),this.outsideCallback},enumerable:!0,configurable:!0}),e.prototype.call=function(t){var n=this;this.eventArgumentTransform(t).then((function(t){var r=n.registeredCallbacks.map((function(n){return e.callCallback(n,t)}));l.Promise.all(r)}))},e.callCallback=function(t,n){return l._createPromiseFromResult(null).then(e.wrapCallbackInFunction(t,n)).catch((function(e){l.log("Error when invoke handler: "+JSON.stringify(e))}))},e.wrapCallbackInFunction=function(e,t){return function(){return e(t)}},e}();e.GenericEventRegistryOperational=F;var E=function(){function e(){this.eventToTargetToHandlerMap={}}return Object.defineProperty(e,"globalEventRegistry",{get:function(){return e.singleton||(e.singleton=new e),e.singleton},enumerable:!0,configurable:!0}),e.getGlobalEventRegistry=function(t,n,r){var o=e.globalEventRegistry.eventToTargetToHandlerMap;o.hasOwnProperty(t)||(o[t]={});var i=o[t];return i.hasOwnProperty(n)||(i[n]=new F(t,n,r)),i[n]},e.singleton=void 0,e}();e.GlobalEventRegistryOperational=E;var R=function(){function e(e){this.genericEventInfo=e}return e.prototype.add=function(e){var t=this,n=void 0,r=l.createPromise((function(e){n=e}));return this.register(),this.createTrace((function(){var r=t.genericEventInfo.eventType,o=t.genericEventInfo.getTargetIdFunc();E.getGlobalEventRegistry(r,o,t.genericEventInfo.eventArgsTransformFunc).add(e),n()})),r},e.prototype.remove=function(e){var t=this;this.register(),this.createTrace((function(){var n=t.genericEventInfo.eventType,r=t.genericEventInfo.getTargetIdFunc();E.getGlobalEventRegistry(n,r,t.genericEventInfo.eventArgsTransformFunc).remove(e)}))},e.prototype.removeAll=function(){var e=this;this.unregister(),this.createTrace((function(){var t=e.genericEventInfo.eventType,n=e.genericEventInfo.getTargetIdFunc();E.getGlobalEventRegistry(t,n,e.genericEventInfo.eventArgsTransformFunc).removeAll()}))},e.prototype.createTrace=function(e){C.createTraceAction(this.genericEventInfo.object._context,e)},e.prototype.register=function(){C.invokeMethod(this.genericEventInfo.object,this.genericEventInfo.register,0,[],0),q.getGenericEventRegistration("").isReady||q.getGenericEventRegistration("").ready()},e.prototype.unregister=function(){C.invokeMethod(this.genericEventInfo.object,this.genericEventInfo.unregister)},e}();e.GenericEventHandlerOperational=R;var N=function(){function e(){}return e.invokeOn=function(e,t,n){var r=void 0,o=l.createPromise((function(e,t){r=e}));return e.add(t).then((function(){r({})})),o},e.invokeOff=function(t,n,r,o){if(!r&&!o){var i=Object.keys(t).map((function(e){return t[e]}));return e.invokeAllOff(i)}return r?(o?n.remove(o):n.removeAll(),l.createPromise((function(e,t){return e()}))):l._createPromiseFromException(r+" must be supplied if handler is supplied.")},e.invokeAllOff=function(e){return e.forEach((function(e){e.removeAll()})),l.createPromise((function(e,t){return e()}))},e}();e.EventHelper=N;var x=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.propertyNotLoaded="PropertyNotLoaded",t.runMustReturnPromise="RunMustReturnPromise",t.cannotRegisterEvent="CannotRegisterEvent",t.invalidOrTimedOutSession="InvalidOrTimedOutSession",t.cannotUpdateReadOnlyProperty="CannotUpdateReadOnlyProperty",t}(i);e.ErrorCodes=x;var M=function(){function e(e){this.m_callback=e}return e.prototype._handleResult=function(e){this.m_callback&&this.m_callback()},e}(),T=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),n.createMethodAction=function(t,n,r,o,i,a){Z.validateObjectPath(n);var s={Id:t._nextId(),ActionType:3,Name:r,ObjectPathId:n._objectPath.objectPathInfo.Id,ArgumentInfo:{}},c=Z.setMethodArguments(t,s.ArgumentInfo,i);Z.validateReferencedObjectPaths(c);var l=Z._fixupApiFlags(a),u=new d(s,o,l);if(u.referencedObjectPath=n._objectPath,u.referencedArgumentObjectPaths=c,n._addAction(u),e._internalConfig.enablePreviewExecution&&0!==(16&l)){var p={Id:t._nextId(),ActionType:3,Name:r,Arguments:i,ObjectId:"",ObjectType:""};n._addPreviewExecutionAction(p)}return u},n.createRecursiveQueryAction=function(e,t,n){Z.validateObjectPath(t);var r={Id:e._nextId(),ActionType:6,Name:"",ObjectPathId:t._objectPath.objectPathInfo.Id,RecursiveQueryInfo:n},o=new d(r,1,4);return o.referencedObjectPath=t._objectPath,t._addAction(o),o},n.createEnsureUnchangedAction=function(e,t,n){Z.validateObjectPath(t);var r={Id:e._nextId(),ActionType:8,Name:"",ObjectPathId:t._objectPath.objectPathInfo.Id,ObjectState:n},o=new d(r,1,4);return o.referencedObjectPath=t._objectPath,t._addAction(o),o},n.createInstantiateAction=function(e,t){Z.validateObjectPath(t),e._pendingRequest.ensureInstantiateObjectPath(t._objectPath.parentObjectPath),e._pendingRequest.ensureInstantiateObjectPaths(t._objectPath.argumentObjectPaths);var n={Id:e._nextId(),ActionType:1,Name:"",ObjectPathId:t._objectPath.objectPathInfo.Id},r=new d(n,1,4);return r.referencedObjectPath=t._objectPath,t._addAction(r,new J(t),!0),r},n.createTraceAction=function(e,t,n){var r={Id:e._nextId(),ActionType:5,Name:"Trace",ObjectPathId:0},o=new d(r,1,4);return e._pendingRequest.addAction(o),n&&e._pendingRequest.addTrace(r.Id,t),o},n.createTraceMarkerForCallback=function(e,t){var r=n.createTraceAction(e,null,!1);e._pendingRequest.addActionResultHandler(r,new M(t))},n}(p);e.ActionFactory=T;var j=function(t){function n(n,r){var o=t.call(this,n,r)||this;return Z.checkArgumentNull(n,"context"),o.m_context=n,o._objectPath&&(!n._processingResult&&n._pendingRequest&&(T.createInstantiateAction(n,o),n._autoCleanup&&o._KeepReference&&n.trackedObjects._autoAdd(o)),e._internalConfig.appendTypeNameToObjectPathInfo&&o._objectPath.objectPathInfo&&o._className&&(o._objectPath.objectPathInfo.T=o._className)),o}return __extends(n,t),Object.defineProperty(n.prototype,"context",{get:function(){return this.m_context},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"isNull",{get:function(){return("undefined"!==typeof this.m_isNull||!u.isMock())&&(Z.throwIfNotLoaded("isNull",this._isNull,null,this._isNull),this._isNull)},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"isNullObject",{get:function(){return("undefined"!==typeof this.m_isNull||!u.isMock())&&(Z.throwIfNotLoaded("isNullObject",this._isNull,null,this._isNull),this._isNull)},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_isNull",{get:function(){return this.m_isNull},set:function(e){this.m_isNull=e,e&&this._objectPath&&this._objectPath._updateAsNullObject()},enumerable:!0,configurable:!0}),n.prototype._addAction=function(e,t,n){return void 0===t&&(t=null),n||(this.context._pendingRequest.ensureInstantiateObjectPath(this._objectPath),this.context._pendingRequest.ensureInstantiateObjectPaths(e.referencedArgumentObjectPaths)),this.context._pendingRequest.addAction(e),this.context._pendingRequest.addReferencedObjectPath(this._objectPath),this.context._pendingRequest.addReferencedObjectPaths(e.referencedArgumentObjectPaths),this.context._pendingRequest.addActionResultHandler(e,t),l._createPromiseFromResult(null)},n.prototype._addPreviewExecutionAction=function(e){if(!Z.isUndefined(this._className)){e.ObjectType=this._className;var t=Z._getPropertyValueWithoutCheckLoaded(this,H.idLowerCase);Z.isUndefined(t)&&(t=Z._getPropertyValueWithoutCheckLoaded(this,H.idPrivate)),Z.isUndefined(t)&&(t=Z._getPropertyValueWithoutCheckLoaded(this,H.previewExecutionObjectId)),e.ObjectId=t,this.context._pendingRequest.addPreviewExecutionAction(e)}},n.prototype._handleResult=function(e){this._isNull=Z.isNullOrUndefined(e),this.context.trackedObjects._autoTrackIfNecessaryWhenHandleObjectResultValue(this,e)},n.prototype._handleIdResult=function(e){this._isNull=Z.isNullOrUndefined(e),Z.fixObjectPathIfNecessary(this,e),this.context.trackedObjects._autoTrackIfNecessaryWhenHandleObjectResultValue(this,e)},n.prototype._handleRetrieveResult=function(e,t){this._handleIdResult(e)},n.prototype._recursivelySet=function(e,t,o,s,c){var u=e instanceof n,p=e;if(u){if(Object.getPrototypeOf(this)!==Object.getPrototypeOf(e))throw r.RuntimeError._createInvalidArgError({argumentName:"properties",errorLocation:this._className+".set"});e=JSON.parse(JSON.stringify(e))}try{for(var f,d=0;d<o.length;d++)f=o[d],e.hasOwnProperty(f)&&"undefined"!==typeof e[f]&&(this[f]=e[f]);for(d=0;d<s.length;d++)if(f=s[d],e.hasOwnProperty(f)&&"undefined"!==typeof e[f]){var h=u?p[f]:e[f];this[f].set(h,t)}var m=!u;t&&!Z.isNullOrUndefined(m)&&(m=t.throwOnReadOnly);for(d=0;d<c.length;d++)if(f=c[d],e.hasOwnProperty(f)&&"undefined"!==typeof e[f]&&m)throw new r.RuntimeError({code:i.invalidArgument,httpStatusCode:400,message:l._getResourceString($.cannotApplyPropertyThroughSetMethod,f),debugInfo:{errorLocation:f}});for(f in e)if(o.indexOf(f)<0&&s.indexOf(f)<0){var g=Object.getOwnPropertyDescriptor(Object.getPrototypeOf(this),f);if(!g)throw new r.RuntimeError({code:i.invalidArgument,httpStatusCode:400,message:l._getResourceString(A.propertyDoesNotExist,f),debugInfo:{errorLocation:f}});if(m&&!g.set)throw new r.RuntimeError({code:i.invalidArgument,httpStatusCode:400,message:l._getResourceString(A.attemptingToSetReadOnlyProperty,f),debugInfo:{errorLocation:f}})}}catch(e){throw new r.RuntimeError({code:i.invalidArgument,httpStatusCode:400,message:l._getResourceString(a.invalidArgument,"properties"),debugInfo:{errorLocation:this._className+".set"},innerError:e})}},n}(f);e.ClientObject=j;var w=function(){function e(e){this.m_session=e}return e.prototype.executeAsync=function(e,t,n){var r={url:s.processQuery,method:"POST",headers:n.Headers,body:n.Body},i="";n.Headers&&(i=n.Headers[H.officeControlId]);var a={id:o.nextId(),type:1,flags:t,controlId:i,message:r};return l.log(JSON.stringify(a)),this.m_session.sendMessageToHost(a).then((function(e){l.log("Received response: "+JSON.stringify(e));var t,n=e.message;if(200===n.statusCode)t={HttpStatusCode:n.statusCode,ErrorCode:null,ErrorMessage:null,Headers:n.headers,Body:l._parseResponseBody(n)};else{l.log("Error Response:"+n.body);var r=l._parseErrorResponse(n);t={HttpStatusCode:n.statusCode,ErrorCode:r.errorCode,ErrorMessage:r.errorMessage,Headers:n.headers,Body:null}}return t}))},e}(),k=function(e){function t(t){var n=e.call(this)||this;return n.m_bridge=t,n.m_bridge.addHostMessageHandler((function(e){if(3===e.type){var t=e.controlId;if(l.isNullOrEmptyString(t))q.getGenericEventRegistration(t)._handleRichApiMessage(e.message);else{var n=q.peekGenericEventRegistrationOrNull(t);n&&n._handleRichApiMessage(e.message),(n=q.peekGenericEventRegistrationOrNull(""))&&n._handleRichApiMessage(e.message)}}})),n}return __extends(t,e),t.getInstanceIfHostBridgeInited=function(){return o.instance?((l.isNullOrUndefined(t.s_instance)||t.s_instance.m_bridge!==o.instance)&&(t.s_instance=new t(o.instance)),t.s_instance):null},t.prototype._resolveRequestUrlAndHeaderInfo=function(){return l._createPromiseFromResult(null)},t.prototype._createRequestExecutorOrNull=function(){return l.log("NativeBridgeSession::CreateRequestExecutor"),new w(this)},t.prototype.getEventRegistration=function(e){return q.getGenericEventRegistration(e)},t.prototype.sendMessageToHost=function(e){return this.m_bridge.sendMessageToHostAndExpectResponse(e)},t}(t);e.HostBridgeSession=k;var U=function(n){function o(e){var i=n.call(this)||this;if(i.m_customRequestHeaders={},i.m_batchMode=0,i._onRunFinishedNotifiers=[],t._overrideSession)i.m_requestUrlAndHeaderInfoResolver=t._overrideSession;else if((Z.isNullOrUndefined(e)||"string"===typeof e&&0===e.length)&&((e=o.defaultRequestUrlAndHeaders)||(e={url:s.localDocument,headers:{}})),"string"===typeof e)i.m_requestUrlAndHeaderInfo={url:e,headers:{}};else if(o.isRequestUrlAndHeaderInfoResolver(e))i.m_requestUrlAndHeaderInfoResolver=e;else{if(!o.isRequestUrlAndHeaderInfo(e))throw r.RuntimeError._createInvalidArgError({argumentName:"url"});var a=e;i.m_requestUrlAndHeaderInfo={url:a.url,headers:{}},l._copyHeaders(a.headers,i.m_requestUrlAndHeaderInfo.headers)}return!i.m_requestUrlAndHeaderInfoResolver&&i.m_requestUrlAndHeaderInfo&&l._isLocalDocumentUrl(i.m_requestUrlAndHeaderInfo.url)&&k.getInstanceIfHostBridgeInited()&&(i.m_requestUrlAndHeaderInfo=null,i.m_requestUrlAndHeaderInfoResolver=k.getInstanceIfHostBridgeInited()),i.m_requestUrlAndHeaderInfoResolver instanceof t&&(i.m_session=i.m_requestUrlAndHeaderInfoResolver),i._processingResult=!1,i._customData=H.iterativeExecutor,i.sync=i.sync.bind(i),i}return __extends(o,n),Object.defineProperty(o.prototype,"session",{get:function(){return this.m_session},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"eventRegistration",{get:function(){return this.m_session?this.m_session.getEventRegistration(this._controlId):r.officeJsEventRegistration},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_url",{get:function(){return this.m_requestUrlAndHeaderInfo?this.m_requestUrlAndHeaderInfo.url:null},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_pendingRequest",{get:function(){return null==this.m_pendingRequest&&(this.m_pendingRequest=new W(this)),this.m_pendingRequest},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_controlId",{get:function(){var e=this.m_customRequestHeaders[H.officeControlId];return l.isNullOrUndefined(e)&&(e=""),e},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"debugInfo",{get:function(){return{pendingStatements:new Y(this._rootObjectPropertyName,this._pendingRequest._objectPaths,this._pendingRequest._actions,e._internalConfig.showDisposeInfoInDebugInfo).process()}},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"trackedObjects",{get:function(){return this.m_trackedObjects||(this.m_trackedObjects=new Q(this)),this.m_trackedObjects},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"requestHeaders",{get:function(){return this.m_customRequestHeaders},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"batchMode",{get:function(){return this.m_batchMode},enumerable:!0,configurable:!0}),o.prototype.ensureInProgressBatchIfBatchMode=function(){if(1===this.m_batchMode&&!this.m_explicitBatchInProgress)throw Z.createRuntimeError(i.generalException,l._getResourceString($.notInsideBatch),null)},o.prototype.load=function(e,t){Z.validateContext(this,e);var n=o._parseQueryOption(t);p.createQueryAction(this,e,n,e)},o.prototype.loadRecursive=function(e,t,n){if(!Z.isPlainJsonObject(t))throw r.RuntimeError._createInvalidArgError({argumentName:"options"});var i={};for(var a in t)i[a]=o._parseQueryOption(t[a]);var s=T.createRecursiveQueryAction(this,e,{Queries:i,MaxDepth:n});this._pendingRequest.addActionResultHandler(s,e)},o.prototype.trace=function(e){T.createTraceAction(this,e,!0)},o.prototype._processOfficeJsErrorResponse=function(e,t){},o.prototype.ensureRequestUrlAndHeaderInfo=function(){var e=this;return Z._createPromiseFromResult(null).then((function(){if(!e.m_requestUrlAndHeaderInfo)return e.m_requestUrlAndHeaderInfoResolver._resolveRequestUrlAndHeaderInfo().then((function(t){if(e.m_requestUrlAndHeaderInfo=t,e.m_requestUrlAndHeaderInfo||(e.m_requestUrlAndHeaderInfo={url:s.localDocument,headers:{}}),Z.isNullOrEmptyString(e.m_requestUrlAndHeaderInfo.url)&&(e.m_requestUrlAndHeaderInfo.url=s.localDocument),e.m_requestUrlAndHeaderInfo.headers||(e.m_requestUrlAndHeaderInfo.headers={}),"function"===typeof e.m_requestUrlAndHeaderInfoResolver._createRequestExecutorOrNull){var n=e.m_requestUrlAndHeaderInfoResolver._createRequestExecutorOrNull();n&&(e._requestExecutor=n)}}))}))},o.prototype.syncPrivateMain=function(){var e=this;return this.ensureRequestUrlAndHeaderInfo().then((function(){var t=e._pendingRequest;return e.m_pendingRequest=null,e.processPreSyncPromises(t).then((function(){return e.syncPrivate(t)}))}))},o.prototype.syncPrivate=function(t){var n=this;if(u.isMock())return l._createPromiseFromResult(null);if(!t.hasActions)return this.processPendingEventHandlers(t);var o=t.buildRequestMessageBodyAndRequestFlags(),i=o.body,a=o.flags;this._requestFlagModifier&&(a|=this._requestFlagModifier),this._requestExecutor||(l._isLocalDocumentUrl(this.m_requestUrlAndHeaderInfo.url)?this._requestExecutor=new X(this):this._requestExecutor=new b);var c=this._requestExecutor,p={};l._copyHeaders(this.m_requestUrlAndHeaderInfo.headers,p),l._copyHeaders(this.m_customRequestHeaders,p),delete this.m_customRequestHeaders[H.officeScriptEventId];var f=u._getCurrentTestNameWithSequenceId();f&&(p[s.testRequestNameHeader]=f);var d={Url:this.m_requestUrlAndHeaderInfo.url,Headers:p,Body:i};t.invalidatePendingInvalidObjectPaths();var h=null,m=null;return this._lastSyncStart="undefined"===typeof performance?Date.now():performance.now(),this._lastRequestFlags=a,c.executeAsync(this._customData,a,d).then((function(r){return n._lastSyncEnd="undefined"===typeof performance?Date.now():performance.now(),e.config.executePerfLogFunc&&e.config.executePerfLogFunc({syncStart:n._lastSyncStart,syncEnd:n._lastSyncEnd}),h=n.processRequestExecutorResponseMessage(t,r),n.processPendingEventHandlers(t).catch((function(e){l.log("Error in processPendingEventHandlers"),l.log(JSON.stringify(e)),m=e}))})).then((function(){if(h)throw l.log("Throw error from response: "+JSON.stringify(h)),h;if(m){l.log("Throw error from ProcessEventHandler: "+JSON.stringify(m));var e=null;if(m instanceof r.RuntimeError)(e=m).traceMessages=t._responseTraceMessages;else{var n=null;n="string"===typeof m?m:m.message,Z.isNullOrEmptyString(n)&&(n=l._getResourceString($.cannotRegisterEvent)),e=new r.RuntimeError({code:x.cannotRegisterEvent,httpStatusCode:400,message:n,traceMessages:t._responseTraceMessages})}throw e}}))},o.prototype.processRequestExecutorResponseMessage=function(t,n){n.Body&&n.Body.TraceIds&&t._setResponseTraceIds(n.Body.TraceIds);var o=t._responseTraceMessages,i=null;if(n.Body){if(n.Body.Error&&n.Body.Error.ActionIndex>=0){var a=new Y(this._rootObjectPropertyName,t._objectPaths,t._actions,!1,!0),s=a.processForDebugStatementInfo(n.Body.Error.ActionIndex);i={statement:s.statement,surroundingStatements:s.surroundingStatements,fullStatements:["Please enable config.extendedErrorLogging to see full statements."]},e.config.extendedErrorLogging&&(a=new Y(this._rootObjectPropertyName,t._objectPaths,t._actions,!1,!1),i.fullStatements=a.process())}var c=null;if(n.Body.Results?c=n.Body.Results:n.Body.ProcessedResults&&n.Body.ProcessedResults.Results&&(c=n.Body.ProcessedResults.Results),c){this._processingResult=!0;try{t.processResponse(c)}finally{this._processingResult=!1}}}if(!Z.isNullOrEmptyString(n.ErrorCode))return new r.RuntimeError({code:n.ErrorCode,httpStatusCode:n.HttpStatusCode,message:n.ErrorMessage,traceMessages:o,data:{responseBody:n.RawErrorResponseBody}});if(n.Body&&n.Body.Error){var l={errorLocation:n.Body.Error.Location};return i&&(l.statement=i.statement,l.surroundingStatements=i.surroundingStatements,l.fullStatements=i.fullStatements),new r.RuntimeError({code:n.Body.Error.Code,httpStatusCode:n.Body.Error.HttpStatusCode,message:n.Body.Error.Message,traceMessages:o,debugInfo:l})}return null},o.prototype.processPendingEventHandlers=function(e){for(var t=Z._createPromiseFromResult(null),n=0;n<e._pendingProcessEventHandlers.length;n++){var r=e._pendingProcessEventHandlers[n];t=t.then(this.createProcessOneEventHandlersFunc(r,e))}return t},o.prototype.createProcessOneEventHandlersFunc=function(e,t){return function(){return e._processRegistration(t)}},o.prototype.processPreSyncPromises=function(e){for(var t=Z._createPromiseFromResult(null),n=0;n<e._preSyncPromises.length;n++){var r=e._preSyncPromises[n];t=t.then(this.createProcessOneProSyncFunc(r))}return t},o.prototype.createProcessOneProSyncFunc=function(e){return function(){return e}},o.prototype.sync=function(e){return u.isMock()?l._createPromiseFromResult(e):this.syncPrivateMain().then((function(){return e}))},o.prototype.batch=function(e){var t=this;if(1!==this.m_batchMode)return l._createPromiseFromException(Z.createRuntimeError(i.generalException,null,null));if(this.m_explicitBatchInProgress)return l._createPromiseFromException(Z.createRuntimeError(i.generalException,l._getResourceString($.pendingBatchInProgress),null));if(Z.isNullOrUndefined(e))return Z._createPromiseFromResult(null);this.m_explicitBatchInProgress=!0;var n,r,o,a=this.m_pendingRequest;this.m_pendingRequest=new W(this);try{n=e(this._rootObject,this)}catch(e){return this.m_explicitBatchInProgress=!1,this.m_pendingRequest=a,l._createPromiseFromException(e)}return"object"===typeof n&&n&&"function"===typeof n.then?o=Z._createPromiseFromResult(null).then((function(){return n})).then((function(e){return t.m_explicitBatchInProgress=!1,r=t.m_pendingRequest,t.m_pendingRequest=a,e})).catch((function(e){return t.m_explicitBatchInProgress=!1,r=t.m_pendingRequest,t.m_pendingRequest=a,l._createPromiseFromException(e)})):(this.m_explicitBatchInProgress=!1,r=this.m_pendingRequest,this.m_pendingRequest=a,o=Z._createPromiseFromResult(n)),o.then((function(e){return t.ensureRequestUrlAndHeaderInfo().then((function(){return t.syncPrivate(r)})).then((function(){return e}))}))},o._run=function(e,t,n,r,i,a){return void 0===n&&(n=3),void 0===r&&(r=5e3),o._runCommon("run",null,e,0,t,n,r,null,i,a)},o.isValidRequestInfo=function(e){return"string"===typeof e||o.isRequestUrlAndHeaderInfo(e)||o.isRequestUrlAndHeaderInfoResolver(e)},o.isRequestUrlAndHeaderInfo=function(e){return"object"===typeof e&&null!==e&&Object.getPrototypeOf(e)===Object.getPrototypeOf({})&&!Z.isNullOrUndefined(e.url)},o.isRequestUrlAndHeaderInfoResolver=function(e){return"object"===typeof e&&null!==e&&"function"===typeof e._resolveRequestUrlAndHeaderInfo},o._runBatch=function(e,t,n,r,i,a,s,c){return void 0===i&&(i=3),void 0===a&&(a=5e3),o._runBatchCommon(0,e,t,n,i,a,r,s,c)},o._runExplicitBatch=function(e,t,n,r,i,a,s,c){return void 0===i&&(i=3),void 0===a&&(a=5e3),o._runBatchCommon(1,e,t,n,i,a,r,s,c)},o._runBatchCommon=function(e,t,n,r,i,a,s,c,l){var u,p;void 0===i&&(i=3),void 0===a&&(a=5e3);var f=null,d=null,h=0,m=null;if(n.length>0)if(o.isValidRequestInfo(n[0]))f=n[0],h=1;else if(Z.isPlainJsonObject(n[0])){if(null!=(f=(m=n[0]).session)&&!o.isValidRequestInfo(f))return o.createErrorPromise(t);d=m.previousObjects,h=1}if(n.length==h+1)p=n[h+0];else{if(null!=m||n.length!=h+2)return o.createErrorPromise(t);d=n[h+0],p=n[h+1]}if(null!=d)if(d instanceof j)u=function(){return d.context};else if(d instanceof o)u=function(){return d};else{if(!Array.isArray(d))return o.createErrorPromise(t);var g=d;if(0==g.length)return o.createErrorPromise(t);for(var y=0;y<g.length;y++){if(!(g[y]instanceof j))return o.createErrorPromise(t);if(g[y].context!=g[0].context)return o.createErrorPromise(t,$.invalidRequestContext)}u=function(){return g[0].context}}else u=r;var O=null;return s&&(O=function(e){return s(m||{},e)}),o._runCommon(t,f,u,e,p,i,a,O,c,l)},o.createErrorPromise=function(e,t){return void 0===t&&(t=a.invalidArgument),l._createPromiseFromException(Z.createRuntimeError(t,l._getResourceString(t),e))},o._runCommon=function(n,r,i,a,s,c,u,p,f,d){t._overrideSession&&(r=t._overrideSession);var h,m,g,y=l.createPromise((function(e,t){e()})),O=!1;return y.then((function(){if((h=i(r))._autoCleanup)return new e.Promise((function(e,t){h._onRunFinishedNotifiers.push((function(){h._autoCleanup=!0,e()}))}));h._autoCleanup=!0})).then((function(){return"function"!==typeof s?o.createErrorPromise(n):(g=h.m_batchMode,h.m_batchMode=a,p&&p(h),e=s(1==a?h.batch.bind(h):h),(Z.isNullOrUndefined(e)||"function"!==typeof e.then)&&Z.throwError($.runMustReturnPromise),e);var e})).then((function(e){return 1===a?e:h.sync(e)})).then((function(e){O=!0,m=e})).catch((function(e){m=e})).then((function(){var e=h.trackedObjects._retrieveAndClearAutoCleanupList();for(var t in h._autoCleanup=!1,h.m_batchMode=g,e)e[t]._objectPath.isValid=!1;var n=0;if(Z._synchronousCleanup||o.isRequestUrlAndHeaderInfoResolver(r))return i();function i(){n++;var t=h.m_pendingRequest,r=h.m_batchMode,o=new W(h);h.m_pendingRequest=o,h.m_batchMode=0;try{for(var a in e)h.trackedObjects.remove(e[a])}finally{h.m_batchMode=r,h.m_pendingRequest=t}return h.syncPrivate(o).then((function(){f&&f(n)})).catch((function(){d&&d(n),n<c&&setTimeout((function(){i()}),u)}))}i()})).then((function(){h._onRunFinishedNotifiers&&h._onRunFinishedNotifiers.length>0&&h._onRunFinishedNotifiers.shift()();if(O)return m;throw m}))},o}(m);e.ClientRequestContext=U;var L=function(){function e(e,t){this.m_proxy=e,this.m_shouldPolyfill=t;var n=e[H.scalarPropertyNames],r=e[H.navigationPropertyNames],o=e[H.className],i=e[H.isCollection];if(n)for(var a=0;a<n.length;a++)Z.definePropertyThrowUnloadedException(this,o,n[a]);if(r)for(a=0;a<r.length;a++)Z.definePropertyThrowUnloadedException(this,o,r[a]);i&&Z.definePropertyThrowUnloadedException(this,o,H.itemsLowerCase)}return Object.defineProperty(e.prototype,"$proxy",{get:function(){return this.m_proxy},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"$isNullObject",{get:function(){if(!this.m_isLoaded)throw new r.RuntimeError({code:x.valueNotLoaded,httpStatusCode:400,message:l._getResourceString($.valueNotLoaded),debugInfo:{errorLocation:"retrieveResult.$isNullObject"}});return this.m_isNullObject},enumerable:!0,configurable:!0}),e.prototype.toJSON=function(){if(this.m_isLoaded)return this.m_isNullObject?null:(Z.isUndefined(this.m_json)&&(this.m_json=Z.purifyJson(this.m_value)),this.m_json)},e.prototype.toString=function(){return JSON.stringify(this.toJSON())},e.prototype._handleResult=function(e){this.m_isLoaded=!0,null===e||"object"===typeof e&&e&&e._IsNull?(this.m_isNullObject=!0,e=null):this.m_isNullObject=!1,this.m_shouldPolyfill&&(e=Z.changePropertyNameToCamelLowerCase(e)),this.m_value=e,this.m_proxy._handleRetrieveResult(e,this)},e}(),H=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.getItemAt="GetItemAt",t.index="_Index",t.iterativeExecutor="IterativeExecutor",t.isTracked="_IsTracked",t.eventMessageCategory=65536,t.eventWorkbookId="Workbook",t.eventSourceRemote="Remote",t.proxy="$proxy",t.className="_className",t.isCollection="_isCollection",t.collectionPropertyPath="_collectionPropertyPath",t.objectPathInfoDoNotKeepReferenceFieldName="D",t.officeScriptEventId="X-OfficeScriptEventId",t.officeScriptFireRecordingEvent="X-OfficeScriptFireRecordingEvent",t.officeControlId="X-OfficeControlId",t}(v);e.Constants=H;var W=function(e){function t(t){var n=e.call(this,t)||this;return n.m_context=t,n.m_pendingProcessEventHandlers=[],n.m_pendingEventHandlerActions={},n.m_traceInfos={},n.m_responseTraceIds={},n.m_responseTraceMessages=[],n}return __extends(t,e),Object.defineProperty(t.prototype,"traceInfos",{get:function(){return this.m_traceInfos},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_responseTraceMessages",{get:function(){return this.m_responseTraceMessages},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_responseTraceIds",{get:function(){return this.m_responseTraceIds},enumerable:!0,configurable:!0}),t.prototype._setResponseTraceIds=function(e){if(e)for(var t=0;t<e.length;t++){var n=e[t];this.m_responseTraceIds[n]=n;var r=this.m_traceInfos[n];l.isNullOrUndefined(r)||this.m_responseTraceMessages.push(r)}},t.prototype.addTrace=function(e,t){this.m_traceInfos[e]=t},t.prototype._addPendingEventHandlerAction=function(e,t){this.m_pendingEventHandlerActions[e._id]||(this.m_pendingEventHandlerActions[e._id]=[],this.m_pendingProcessEventHandlers.push(e)),this.m_pendingEventHandlerActions[e._id].push(t)},Object.defineProperty(t.prototype,"_pendingProcessEventHandlers",{get:function(){return this.m_pendingProcessEventHandlers},enumerable:!0,configurable:!0}),t.prototype._getPendingEventHandlerActions=function(e){return this.m_pendingEventHandlerActions[e._id]},t}(y);e.ClientRequest=W;var B=function(){function e(e,t,n,r){var o=this;this.m_id=e._nextId(),this.m_context=e,this.m_name=n,this.m_handlers=[],this.m_registered=!1,this.m_eventInfo=r,this.m_callback=function(e){o.m_eventInfo.eventArgsTransformFunc(e).then((function(e){return o.fireEvent(e)}))}}return Object.defineProperty(e.prototype,"_registered",{get:function(){return this.m_registered},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_id",{get:function(){return this.m_id},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_handlers",{get:function(){return this.m_handlers},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_context",{get:function(){return this.m_context},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_callback",{get:function(){return this.m_callback},enumerable:!0,configurable:!0}),e.prototype.add=function(e){var t=T.createTraceAction(this.m_context,null,!1);return this.m_context._pendingRequest._addPendingEventHandlerAction(this,{id:t.actionInfo.Id,handler:e,operation:0}),new G(this.m_context,this,e)},e.prototype.remove=function(e){var t=T.createTraceAction(this.m_context,null,!1);this.m_context._pendingRequest._addPendingEventHandlerAction(this,{id:t.actionInfo.Id,handler:e,operation:1})},e.prototype.removeAll=function(){var e=T.createTraceAction(this.m_context,null,!1);this.m_context._pendingRequest._addPendingEventHandlerAction(this,{id:e.actionInfo.Id,handler:null,operation:2})},e.prototype._processRegistration=function(e){var t=this,n=l._createPromiseFromResult(null),r=e._getPendingEventHandlerActions(this);if(!r)return n;for(var o=[],i=0;i<this.m_handlers.length;i++)o.push(this.m_handlers[i]);var a=!1;for(i=0;i<r.length;i++)if(e._responseTraceIds[r[i].id])switch(a=!0,r[i].operation){case 0:o.push(r[i].handler);break;case 1:for(var s=o.length-1;s>=0;s--)if(o[s]===r[i].handler){o.splice(s,1);break}break;case 2:o=[]}return a&&(!this.m_registered&&o.length>0?n=n.then((function(){return t.m_eventInfo.registerFunc(t.m_callback)})).then((function(){return t.m_registered=!0})):this.m_registered&&0==o.length&&(n=n.then((function(){return t.m_eventInfo.unregisterFunc(t.m_callback)})).catch((function(e){l.log("Error when unregister event: "+JSON.stringify(e))})).then((function(){return t.m_registered=!1}))),n=n.then((function(){return t.m_handlers=o}))),n},e.prototype.fireEvent=function(e){for(var t=[],n=0;n<this.m_handlers.length;n++){var r=this.m_handlers[n],o=l._createPromiseFromResult(null).then(this.createFireOneEventHandlerFunc(r,e)).catch((function(e){l.log("Error when invoke handler: "+JSON.stringify(e))}));t.push(o)}l.Promise.all(t)},e.prototype.createFireOneEventHandlerFunc=function(e,t){return function(){return e(t)}},e}();e.EventHandlers=B;var G=function(){function e(e,t,n){this.m_context=e,this.m_allHandlers=t,this.m_handler=n}return Object.defineProperty(e.prototype,"context",{get:function(){return this.m_context},enumerable:!0,configurable:!0}),e.prototype.remove=function(){this.m_allHandlers&&this.m_handler&&(this.m_allHandlers.remove(this.m_handler),this.m_allHandlers=null,this.m_handler=null)},e}();e.EventHandlerResult=G,function(e){var t=function(){function t(){}return t.prototype.register=function(t,n,r){switch(t){case 4:return Z.promisify((function(e){return Office.context.document.bindings.getByIdAsync(n,e)})).then((function(e){return Z.promisify((function(t){return e.addHandlerAsync(Office.EventType.BindingDataChanged,r,t)}))}));case 3:return Z.promisify((function(e){return Office.context.document.bindings.getByIdAsync(n,e)})).then((function(e){return Z.promisify((function(t){return e.addHandlerAsync(Office.EventType.BindingSelectionChanged,r,t)}))}));case 2:return Z.promisify((function(e){return Office.context.document.addHandlerAsync(Office.EventType.DocumentSelectionChanged,r,e)}));case 1:return Z.promisify((function(e){return Office.context.document.settings.addHandlerAsync(Office.EventType.SettingsChanged,r,e)}));case 5:return OSF.DDA.RichApi.richApiMessageManager.register(r);case 13:return Z.promisify((function(e){return Office.context.document.addHandlerAsync(Office.EventType.ObjectDeleted,r,{id:n},e)}));case 14:return Z.promisify((function(e){return Office.context.document.addHandlerAsync(Office.EventType.ObjectSelectionChanged,r,{id:n},e)}));case 15:return Z.promisify((function(e){return Office.context.document.addHandlerAsync(Office.EventType.ObjectDataChanged,r,{id:n},e)}));case 16:return Z.promisify((function(e){return Office.context.document.addHandlerAsync(Office.EventType.ContentControlAdded,r,{id:n},e)}));default:throw e.RuntimeError._createInvalidArgError({argumentName:"eventId"})}},t.prototype.unregister=function(t,n,r){switch(t){case 4:return Z.promisify((function(e){return Office.context.document.bindings.getByIdAsync(n,e)})).then((function(e){return Z.promisify((function(t){return e.removeHandlerAsync(Office.EventType.BindingDataChanged,{handler:r},t)}))}));case 3:return Z.promisify((function(e){return Office.context.document.bindings.getByIdAsync(n,e)})).then((function(e){return Z.promisify((function(t){return e.removeHandlerAsync(Office.EventType.BindingSelectionChanged,{handler:r},t)}))}));case 2:return Z.promisify((function(e){return Office.context.document.removeHandlerAsync(Office.EventType.DocumentSelectionChanged,{handler:r},e)}));case 1:return Z.promisify((function(e){return Office.context.document.settings.removeHandlerAsync(Office.EventType.SettingsChanged,{handler:r},e)}));case 5:return Z.promisify((function(e){return OSF.DDA.RichApi.richApiMessageManager.removeHandlerAsync("richApiMessage",{handler:r},e)}));case 13:return Z.promisify((function(e){return Office.context.document.removeHandlerAsync(Office.EventType.ObjectDeleted,{id:n,handler:r},e)}));case 14:return Z.promisify((function(e){return Office.context.document.removeHandlerAsync(Office.EventType.ObjectSelectionChanged,{id:n,handler:r},e)}));case 15:return Z.promisify((function(e){return Office.context.document.removeHandlerAsync(Office.EventType.ObjectDataChanged,{id:n,handler:r},e)}));case 16:return Z.promisify((function(e){return Office.context.document.removeHandlerAsync(Office.EventType.ContentControlAdded,{id:n,handler:r},e)}));default:throw e.RuntimeError._createInvalidArgError({argumentName:"eventId"})}},t}();e.officeJsEventRegistration=new t}(r=e._Internal||(e._Internal={}));var V=function(){function e(e,t){this.m_handlersByEventByTarget={},this.m_registerEventImpl=e,this.m_unregisterEventImpl=t}return e.getTargetIdOrDefault=function(e){return Z.isNullOrUndefined(e)?"":e},e.prototype.getHandlers=function(t,n){n=e.getTargetIdOrDefault(n);var r=this.m_handlersByEventByTarget[t];r||(r={},this.m_handlersByEventByTarget[t]=r);var o=r[n];return o||(o=[],r[n]=o),o},e.prototype.callHandlers=function(e,t,n){for(var r=this.getHandlers(e,t),o=0;o<r.length;o++)r[o](n)},e.prototype.hasHandlers=function(e,t){return this.getHandlers(e,t).length>0},e.prototype.register=function(e,t,n){if(!n)throw r.RuntimeError._createInvalidArgError({argumentName:"handler"});var o=this.getHandlers(e,t);return o.push(n),1===o.length?this.m_registerEventImpl(e,t):Z._createPromiseFromResult(null)},e.prototype.unregister=function(e,t,n){if(!n)throw r.RuntimeError._createInvalidArgError({argumentName:"handler"});for(var o=this.getHandlers(e,t),i=o.length-1;i>=0;i--)if(o[i]===n){o.splice(i,1);break}return 0===o.length?this.m_unregisterEventImpl(e,t):Z._createPromiseFromResult(null)},e}();e.EventRegistration=V;var q=function(){function e(){this.m_eventRegistration=new V(this._registerEventImpl.bind(this),this._unregisterEventImpl.bind(this)),this.m_richApiMessageHandler=this._handleRichApiMessage.bind(this)}return e.prototype.ready=function(){var t=this;return this.m_ready||(e._testReadyImpl?this.m_ready=e._testReadyImpl().then((function(){t.m_isReady=!0})):o.instance?this.m_ready=Z._createPromiseFromResult(null).then((function(){t.m_isReady=!0})):this.m_ready=r.officeJsEventRegistration.register(5,"",this.m_richApiMessageHandler).then((function(){t.m_isReady=!0}))),this.m_ready},Object.defineProperty(e.prototype,"isReady",{get:function(){return this.m_isReady},enumerable:!0,configurable:!0}),e.prototype.register=function(e,t,n){var r=this;return this.ready().then((function(){return r.m_eventRegistration.register(e,t,n)}))},e.prototype.unregister=function(e,t,n){var r=this;return this.ready().then((function(){return r.m_eventRegistration.unregister(e,t,n)}))},e.prototype._registerEventImpl=function(e,t){return Z._createPromiseFromResult(null)},e.prototype._unregisterEventImpl=function(e,t){return Z._createPromiseFromResult(null)},e.prototype._handleRichApiMessage=function(e){if(e&&e.entries)for(var t=0;t<e.entries.length;t++){var n=e.entries[t];if(n.messageCategory==H.eventMessageCategory){l._logEnabled&&l.log(JSON.stringify(n));var r=n.messageType,o=n.targetId;if(this.m_eventRegistration.hasHandlers(r,o)){var i=JSON.parse(n.message);n.isRemoteOverride&&(i.source=H.eventSourceRemote),this.m_eventRegistration.callHandlers(r,o,i)}}}},e.getGenericEventRegistration=function(t){l.isNullOrUndefined(t)&&(t="");var n=e.s_genericEventRegistrations[t];return n||(n=new e,e.s_genericEventRegistrations[t]=n),n},e.peekGenericEventRegistrationOrNull=function(t){return l.isNullOrUndefined(t)&&(t=""),e.s_genericEventRegistrations[t]},e.richApiMessageEventCategory=65536,e.s_genericEventRegistrations={},e}();e.GenericEventRegistration=q,e._testSetRichApiMessageReadyImpl=function(e){q._testReadyImpl=e},e._testTriggerRichApiMessageEvent=function(e){q.getGenericEventRegistration("")._handleRichApiMessage(e)};var z=function(e){function t(t,n,r,o){var i=e.call(this,t,n,r,o)||this;return i.m_genericEventInfo=o,i}return __extends(t,e),t.prototype.add=function(e){var t=this;0==this._handlers.length&&this.m_genericEventInfo.registerFunc&&this.m_genericEventInfo.registerFunc();var n=this._context._controlId;return q.getGenericEventRegistration(n).isReady||this._context._pendingRequest._addPreSyncPromise(q.getGenericEventRegistration(n).ready()),T.createTraceMarkerForCallback(this._context,(function(){t._handlers.push(e),1==t._handlers.length&&q.getGenericEventRegistration(n).register(t.m_genericEventInfo.eventType,t.m_genericEventInfo.getTargetIdFunc(),t._callback)})),new G(this._context,this,e)},t.prototype.remove=function(e){var t=this;1==this._handlers.length&&this.m_genericEventInfo.unregisterFunc&&this.m_genericEventInfo.unregisterFunc();var n=this._context._controlId;T.createTraceMarkerForCallback(this._context,(function(){for(var r=t._handlers,o=r.length-1;o>=0;o--)if(r[o]===e){r.splice(o,1);break}0==r.length&&q.getGenericEventRegistration(n).unregister(t.m_genericEventInfo.eventType,t.m_genericEventInfo.getTargetIdFunc(),t._callback)}))},t.prototype.removeAll=function(){},t}(B);e.GenericEventHandlers=z;var J=function(){function e(e){this.m_clientObject=e}return e.prototype._handleResult=function(e){this.m_clientObject._handleIdResult(e)},e}(),K=function(){function e(){}return e.createGlobalObjectObjectPath=function(e){var t={Id:e._nextId(),ObjectPathType:1,Name:""};return new h(t,null,!1,!1,1,4)},e.createNewObjectObjectPath=function(e,t,n,r){var o={Id:e._nextId(),ObjectPathType:2,Name:t};return new h(o,null,n,!1,1,Z._fixupApiFlags(r))},e.createPropertyObjectPath=function(e,t,n,r,o,i){var a={Id:e._nextId(),ObjectPathType:4,Name:n,ParentObjectPathId:t._objectPath.objectPathInfo.Id};return new h(a,t._objectPath,r,o,1,Z._fixupApiFlags(i))},e.createIndexerObjectPath=function(e,t,n){var r={Id:e._nextId(),ObjectPathType:5,Name:"",ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}};return r.ArgumentInfo.Arguments=n,new h(r,t._objectPath,!1,!1,1,4)},e.createIndexerObjectPathUsingParentPath=function(e,t,n){var r={Id:e._nextId(),ObjectPathType:5,Name:"",ParentObjectPathId:t.objectPathInfo.Id,ArgumentInfo:{}};return r.ArgumentInfo.Arguments=n,new h(r,t,!1,!1,1,4)},e.createMethodObjectPath=function(e,t,n,r,o,i,a,s,c){var l={Id:e._nextId(),ObjectPathType:3,Name:n,ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}},u=Z.setMethodArguments(e,l.ArgumentInfo,o),p=new h(l,t._objectPath,i,a,r,Z._fixupApiFlags(c));return p.argumentObjectPaths=u,p.getByIdMethodName=s,p},e.createReferenceIdObjectPath=function(e,t){var n={Id:e._nextId(),ObjectPathType:6,Name:t,ArgumentInfo:{}};return new h(n,null,!1,!1,1,4)},e.createChildItemObjectPathUsingIndexerOrGetItemAt=function(t,n,r,o,i){var a=Z.tryGetObjectIdFromLoadOrRetrieveResult(o);return t&&!Z.isNullOrUndefined(a)?e.createChildItemObjectPathUsingIndexer(n,r,o):e.createChildItemObjectPathUsingGetItemAt(n,r,o,i)},e.createChildItemObjectPathUsingIndexer=function(e,t,n){var r=Z.tryGetObjectIdFromLoadOrRetrieveResult(n),o=o={Id:e._nextId(),ObjectPathType:5,Name:"",ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}};return o.ArgumentInfo.Arguments=[r],new h(o,t._objectPath,!1,!1,1,4)},e.createChildItemObjectPathUsingGetItemAt=function(e,t,n,r){var o=n[H.index];o&&(r=o);var i={Id:e._nextId(),ObjectPathType:3,Name:H.getItemAt,ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}};return i.ArgumentInfo.Arguments=[r],new h(i,t._objectPath,!1,!1,1,4)},e}();e.ObjectPathFactory=K;var X=function(){function t(e){this.m_context=e}return t.prototype.executeAsync=function(n,r,o){var i=this,a=c.buildMessageArrayForIRequestExecutor(n,r,o,t.SourceLibHeaderValue);return new e.Promise((function(e,t){OSF.DDA.RichApi.executeRichApiRequestAsync(a,(function(t){var n;l.log("Response:"),l.log(JSON.stringify(t)),"succeeded"==t.status?n=c.buildResponseOnSuccess(c.getResponseBody(t),c.getResponseHeaders(t)):(n=c.buildResponseOnError(t.error.code,t.error.message),i.m_context._processOfficeJsErrorResponse(t.error.code,n)),e(n)}))}))},t.SourceLibHeaderValue="officejs",t}(),Q=function(){function e(e){this._autoCleanupList={},this.m_context=e}return e.prototype.add=function(e){var t=this;Array.isArray(e)?e.forEach((function(e){return t._addCommon(e,!0)})):this._addCommon(e,!0)},e.prototype._autoAdd=function(e){this._addCommon(e,!1),this._autoCleanupList[e._objectPath.objectPathInfo.Id]=e},e.prototype._autoTrackIfNecessaryWhenHandleObjectResultValue=function(e,t){this.m_context._autoCleanup&&!e[H.isTracked]&&e!==this.m_context._rootObject&&t&&!Z.isNullOrEmptyString(t[H.referenceId])&&(this._autoCleanupList[e._objectPath.objectPathInfo.Id]=e,e[H.isTracked]=!0)},e.prototype._addCommon=function(e,t){if(e[H.isTracked])t&&this.m_context._autoCleanup&&delete this._autoCleanupList[e._objectPath.objectPathInfo.Id];else{var n=e[H.referenceId];if(e._objectPath.objectPathInfo[H.objectPathInfoDoNotKeepReferenceFieldName])throw Z.createRuntimeError(i.generalException,l._getResourceString($.objectIsUntracked),null);Z.isNullOrEmptyString(n)&&e._KeepReference&&(e._KeepReference(),T.createInstantiateAction(this.m_context,e),t&&this.m_context._autoCleanup&&delete this._autoCleanupList[e._objectPath.objectPathInfo.Id],e[H.isTracked]=!0)}},e.prototype.remove=function(e){var t=this;Array.isArray(e)?e.forEach((function(e){return t._removeCommon(e)})):this._removeCommon(e)},e.prototype._removeCommon=function(e){e._objectPath.objectPathInfo[H.objectPathInfoDoNotKeepReferenceFieldName]=!0,e.context._pendingRequest._removeKeepReferenceAction(e._objectPath.objectPathInfo.Id);var t=e[H.referenceId];if(!Z.isNullOrEmptyString(t)){var n=this.m_context._rootObject;n._RemoveReference&&n._RemoveReference(t)}delete e[H.isTracked]},e.prototype._retrieveAndClearAutoCleanupList=function(){var e=this._autoCleanupList;return this._autoCleanupList={},e},e}();e.TrackedObjects=Q;var Y=function(){function t(e,t,n,r,o){e||(e="root"),this.m_globalObjName=e,this.m_referencedObjectPaths=t,this.m_actions=n,this.m_statements=[],this.m_variableNameForObjectPathMap={},this.m_variableNameToObjectPathMap={},this.m_declaredObjectPathMap={},this.m_showDispose=r,this.m_removePII=o}return t.prototype.process=function(){this.m_showDispose&&W._calculateLastUsedObjectPathIds(this.m_actions);for(var e=0;e<this.m_actions.length;e++)this.processOneAction(this.m_actions[e]);return this.m_statements},t.prototype.processForDebugStatementInfo=function(e){this.m_showDispose&&W._calculateLastUsedObjectPathIds(this.m_actions);this.m_statements=[];for(var t=-1,n=0;n<this.m_actions.length&&(this.processOneAction(this.m_actions[n]),e==n&&(t=this.m_statements.length-1),!(t>=0&&this.m_statements.length>t+5+1));n++);if(t<0)return null;var r=t-5;r<0&&(r=0);var o=t+1+5;o>this.m_statements.length&&(o=this.m_statements.length);var i=[];0!=r&&i.push("...");for(var a=r;a<t;a++)i.push(this.m_statements[a]);i.push("// >>>>>"),i.push(this.m_statements[t]),i.push("// <<<<<");for(var s=t+1;s<o;s++)i.push(this.m_statements[s]);return o<this.m_statements.length&&i.push("..."),{statement:this.m_statements[t],surroundingStatements:i}},t.prototype.processOneAction=function(e){switch(e.actionInfo.ActionType){case 1:this.processInstantiateAction(e);break;case 3:this.processMethodAction(e);break;case 2:this.processQueryAction(e);break;case 7:this.processQueryAsJsonAction(e);break;case 6:this.processRecursiveQueryAction(e);break;case 4:this.processSetPropertyAction(e);break;case 5:this.processTraceAction(e);break;case 8:this.processEnsureUnchangedAction(e);break;case 9:this.processUpdateAction(e)}},t.prototype.processInstantiateAction=function(e){var t=e.actionInfo.ObjectPathId,n=this.m_referencedObjectPaths[t],r=this.getObjVarName(t);if(this.m_declaredObjectPathMap[t]){o="// Instantiate {"+r+"}";o=this.appendDisposeCommentIfRelevant(o,e),this.m_statements.push(o)}else{var o="var "+r+" = "+this.buildObjectPathExpressionWithParent(n)+";";o=this.appendDisposeCommentIfRelevant(o,e),this.m_statements.push(o),this.m_declaredObjectPathMap[t]=r}},t.prototype.processMethodAction=function(t){var n=t.actionInfo.Name;if("_KeepReference"===n){if(!e._internalConfig.showInternalApiInDebugInfo)return;n="track"}var r=this.getObjVarName(t.actionInfo.ObjectPathId)+"."+Z._toCamelLowerCase(n)+"("+this.buildArgumentsExpression(t.actionInfo.ArgumentInfo)+");";r=this.appendDisposeCommentIfRelevant(r,t),this.m_statements.push(r)},t.prototype.processQueryAction=function(e){var t=this.buildQueryExpression(e),n=this.getObjVarName(e.actionInfo.ObjectPathId)+".load("+t+");";n=this.appendDisposeCommentIfRelevant(n,e),this.m_statements.push(n)},t.prototype.processQueryAsJsonAction=function(e){var t=this.buildQueryExpression(e),n=this.getObjVarName(e.actionInfo.ObjectPathId)+".retrieve("+t+");";n=this.appendDisposeCommentIfRelevant(n,e),this.m_statements.push(n)},t.prototype.processRecursiveQueryAction=function(e){var t="";e.actionInfo.RecursiveQueryInfo&&(t=JSON.stringify(e.actionInfo.RecursiveQueryInfo));var n=this.getObjVarName(e.actionInfo.ObjectPathId)+".loadRecursive("+t+");";n=this.appendDisposeCommentIfRelevant(n,e),this.m_statements.push(n)},t.prototype.processSetPropertyAction=function(e){var t=this.getObjVarName(e.actionInfo.ObjectPathId)+"."+Z._toCamelLowerCase(e.actionInfo.Name)+" = "+this.buildArgumentsExpression(e.actionInfo.ArgumentInfo)+";";t=this.appendDisposeCommentIfRelevant(t,e),this.m_statements.push(t)},t.prototype.processTraceAction=function(e){var t="context.trace();";t=this.appendDisposeCommentIfRelevant(t,e),this.m_statements.push(t)},t.prototype.processEnsureUnchangedAction=function(e){var t=this.getObjVarName(e.actionInfo.ObjectPathId)+".ensureUnchanged("+JSON.stringify(e.actionInfo.ObjectState)+");";t=this.appendDisposeCommentIfRelevant(t,e),this.m_statements.push(t)},t.prototype.processUpdateAction=function(e){var t=this.getObjVarName(e.actionInfo.ObjectPathId)+".update("+JSON.stringify(e.actionInfo.ObjectState)+");";t=this.appendDisposeCommentIfRelevant(t,e),this.m_statements.push(t)},t.prototype.appendDisposeCommentIfRelevant=function(e,t){var n=this;if(this.m_showDispose){var r=t.actionInfo.L;if(r&&r.length>0)return e+" // And then dispose {"+r.map((function(e){return n.getObjVarName(e)})).join(", ")+"}"}return e},t.prototype.buildQueryExpression=function(e){if(e.actionInfo.QueryInfo){var t={};return t.select=e.actionInfo.QueryInfo.Select,t.expand=e.actionInfo.QueryInfo.Expand,t.skip=e.actionInfo.QueryInfo.Skip,t.top=e.actionInfo.QueryInfo.Top,"undefined"===typeof t.top&&"undefined"===typeof t.skip&&"undefined"===typeof t.expand?"undefined"===typeof t.select?"":JSON.stringify(t.select):JSON.stringify(t)}return""},t.prototype.buildObjectPathExpressionWithParent=function(e){return(5==e.objectPathInfo.ObjectPathType||3==e.objectPathInfo.ObjectPathType||4==e.objectPathInfo.ObjectPathType)&&e.objectPathInfo.ParentObjectPathId?this.getObjVarName(e.objectPathInfo.ParentObjectPathId)+"."+this.buildObjectPathExpression(e):this.buildObjectPathExpression(e)},t.prototype.buildObjectPathExpression=function(e){var t=this.buildObjectPathInfoExpression(e.objectPathInfo),n=e.originalObjectPathInfo;return n&&(t=t+" /* originally "+this.buildObjectPathInfoExpression(n)+" */"),t},t.prototype.buildObjectPathInfoExpression=function(e){switch(e.ObjectPathType){case 1:return"context."+this.m_globalObjName;case 5:return"getItem("+this.buildArgumentsExpression(e.ArgumentInfo)+")";case 3:return Z._toCamelLowerCase(e.Name)+"("+this.buildArgumentsExpression(e.ArgumentInfo)+")";case 2:return e.Name+".newObject()";case 7:return"null";case 4:return Z._toCamelLowerCase(e.Name);case 6:return"context."+this.m_globalObjName+"._getObjectByReferenceId("+JSON.stringify(e.Name)+")"}},t.prototype.buildArgumentsExpression=function(e){var t="";if(!e.Arguments||0===e.Arguments.length)return t;if(this.m_removePII)return"undefined"===typeof e.Arguments[0]?t:"...";for(var n=0;n<e.Arguments.length;n++)n>0&&(t+=", "),t+=this.buildArgumentLiteral(e.Arguments[n],e.ReferencedObjectPathIds?e.ReferencedObjectPathIds[n]:null);return"undefined"===t&&(t=""),t},t.prototype.buildArgumentLiteral=function(e,t){return"number"==typeof e&&e===t?this.getObjVarName(t):JSON.stringify(e)},t.prototype.getObjVarNameBase=function(e){var t="v",n=this.m_referencedObjectPaths[e];if(n)switch(n.objectPathInfo.ObjectPathType){case 1:t=this.m_globalObjName;break;case 4:t=Z._toCamelLowerCase(n.objectPathInfo.Name);break;case 3:var r=n.objectPathInfo.Name;r.length>3&&"Get"===r.substr(0,3)&&(r=r.substr(3)),t=Z._toCamelLowerCase(r);break;case 5:var o=this.getObjVarNameBase(n.objectPathInfo.ParentObjectPathId);t="s"===o.charAt(o.length-1)?o.substr(0,o.length-1):o+"Item"}return t},t.prototype.getObjVarName=function(e){if(this.m_variableNameForObjectPathMap[e])return this.m_variableNameForObjectPathMap[e];var t=this.getObjVarNameBase(e);if(!this.m_variableNameToObjectPathMap[t])return this.m_variableNameForObjectPathMap[e]=t,this.m_variableNameToObjectPathMap[t]=e,t;for(var n=1;this.m_variableNameToObjectPathMap[t+n.toString()];)n++;return t+=n.toString(),this.m_variableNameForObjectPathMap[e]=t,this.m_variableNameToObjectPathMap[t]=e,t},t}(),$=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.cannotRegisterEvent="CannotRegisterEvent",t.connectionFailureWithStatus="ConnectionFailureWithStatus",t.connectionFailureWithDetails="ConnectionFailureWithDetails",t.propertyNotLoaded="PropertyNotLoaded",t.runMustReturnPromise="RunMustReturnPromise",t.moreInfoInnerError="MoreInfoInnerError",t.cannotApplyPropertyThroughSetMethod="CannotApplyPropertyThroughSetMethod",t.invalidOperationInCellEditMode="InvalidOperationInCellEditMode",t.objectIsUntracked="ObjectIsUntracked",t.customFunctionDefintionMissing="CustomFunctionDefintionMissing",t.customFunctionImplementationMissing="CustomFunctionImplementationMissing",t.customFunctionNameContainsBadChars="CustomFunctionNameContainsBadChars",t.customFunctionNameCannotSplit="CustomFunctionNameCannotSplit",t.customFunctionUnexpectedNumberOfEntriesInResultBatch="CustomFunctionUnexpectedNumberOfEntriesInResultBatch",t.customFunctionCancellationHandlerMissing="CustomFunctionCancellationHandlerMissing",t.customFunctionInvalidFunction="CustomFunctionInvalidFunction",t.customFunctionInvalidFunctionMapping="CustomFunctionInvalidFunctionMapping",t.customFunctionWindowMissing="CustomFunctionWindowMissing",t.customFunctionDefintionMissingOnWindow="CustomFunctionDefintionMissingOnWindow",t.pendingBatchInProgress="PendingBatchInProgress",t.notInsideBatch="NotInsideBatch",t.cannotUpdateReadOnlyProperty="CannotUpdateReadOnlyProperty",t}(A);e.ResourceStrings=$,l.addResourceStringValues({CannotRegisterEvent:"The event handler cannot be registered.",PropertyNotLoaded:"The property '{0}' is not available. Before reading the property's value, call the load method on the containing object and call \"context.sync()\" on the associated request context.",RunMustReturnPromise:'The batch function passed to the ".run" method didn\'t return a promise. The function must return a promise, so that any automatically-tracked objects can be released at the completion of the batch operation. Typically, you return a promise by returning the response from "context.sync()".',InvalidOrTimedOutSessionMessage:"Your Office Online session has expired or is invalid. To continue, refresh the page.",InvalidOperationInCellEditMode:"Excel is in cell-editing mode. Please exit the edit mode by pressing ENTER or TAB or selecting another cell, and then try again.",InvalidSheetName:"The request cannot be processed because the specified worksheet cannot be found. Please try again.",CustomFunctionDefintionMissing:"A property with the name '{0}' that represents the function's definition must exist on Excel.Script.CustomFunctions.",CustomFunctionDefintionMissingOnWindow:"A property with the name '{0}' that represents the function's definition must exist on the window object.",CustomFunctionImplementationMissing:"The property with the name '{0}' on Excel.Script.CustomFunctions that represents the function's definition must contain a 'call' property that implements the function.",CustomFunctionNameContainsBadChars:"The function name may only contain letters, digits, underscores, and periods.",CustomFunctionNameCannotSplit:"The function name must contain a non-empty namespace and a non-empty short name.",CustomFunctionUnexpectedNumberOfEntriesInResultBatch:"The batching function returned a number of results that doesn't match the number of parameter value sets that were passed into it.",CustomFunctionCancellationHandlerMissing:"The cancellation handler onCanceled is missing in the function. The handler must be present as the function is defined as cancelable.",CustomFunctionInvalidFunction:"The property with the name '{0}' that represents the function's definition is not a valid function.",CustomFunctionInvalidFunctionMapping:"The property with the name '{0}' on CustomFunctionMappings that represents the function's definition is not a valid function.",CustomFunctionWindowMissing:"The window object was not found.",PendingBatchInProgress:"There is a pending batch in progress. The batch method may not be called inside another batch, or simultaneously with another batch.",NotInsideBatch:"Operations may not be invoked outside of a batch method.",CannotUpdateReadOnlyProperty:"The property '{0}' is read-only and it cannot be updated.",ObjectIsUntracked:"The object is untracked."});var Z=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),n.fixObjectPathIfNecessary=function(e,t){e&&e._objectPath&&t&&e._objectPath.updateUsingObjectData(t,e)},n.load=function(e,t){return e.context.load(e,t),e},n.loadAndSync=function(e,t){return e.context.load(e,t),e.context.sync().then((function(){return e}))},n.retrieve=function(t,r){var o=e._internalConfig.alwaysPolyfillClientObjectRetrieveMethod;o||(o=!n.isSetSupported("RichApiRuntime","1.1"));var i=new L(t,o);return t._retrieve(r,i),i},n.retrieveAndSync=function(e,t){var r=n.retrieve(e,t);return e.context.sync().then((function(){return r}))},n.toJson=function(e,t,r,o){var i={};for(var a in t){"undefined"!==typeof(s=t[a])&&(i[a]=s)}for(var a in r){var s;"undefined"!==typeof(s=r[a])&&(s[n.fieldName_isCollection]&&"undefined"!==typeof s[n.fieldName_m__items]?i[a]=s.toJSON().items:i[a]=s.toJSON())}return o&&(i.items=o.map((function(e){return e.toJSON()}))),i},n.throwError=function(e,t,n){throw new r.RuntimeError({code:e,httpStatusCode:400,message:l._getResourceString(e,t),debugInfo:n?{errorLocation:n}:void 0})},n.createRuntimeError=function(e,t,n,o,i){return new r.RuntimeError({code:e,httpStatusCode:o,message:t,debugInfo:{errorLocation:n},data:i})},n.throwIfNotLoaded=function(e,t,r,o){if(!o&&l.isUndefined(t)&&e.charCodeAt(0)!=n.s_underscoreCharCode&&!n.s_suppressPropertyNotLoadedException)throw n.createPropertyNotLoadedException(r,e)},n._getPropertyValueWithoutCheckLoaded=function(e,t){n.s_suppressPropertyNotLoadedException=!0;try{return e[t]}finally{n.s_suppressPropertyNotLoadedException=!1}},n.createPropertyNotLoadedException=function(e,t){return new r.RuntimeError({code:x.propertyNotLoaded,httpStatusCode:400,message:l._getResourceString($.propertyNotLoaded,t),debugInfo:e?{errorLocation:e+"."+t}:void 0})},n.createCannotUpdateReadOnlyPropertyException=function(e,t){return new r.RuntimeError({code:x.cannotUpdateReadOnlyProperty,httpStatusCode:400,message:l._getResourceString($.cannotUpdateReadOnlyProperty,t),debugInfo:e?{errorLocation:e+"."+t}:void 0})},n.promisify=function(t){return new e.Promise((function(e,n){t((function(t){"failed"==t.status?n(t.error):e(t.value)}))}))},n._addActionResultHandler=function(e,t,n){e.context._pendingRequest.addActionResultHandler(t,n)},n._handleNavigationPropertyResults=function(e,t,n){for(var r=0;r<n.length-1;r+=2)l.isUndefined(t[n[r+1]])||e[n[r]]._handleResult(t[n[r+1]])},n._fixupApiFlags=function(e){return"boolean"===typeof e&&(e=e?1:0),e},n.definePropertyThrowUnloadedException=function(e,t,r){Object.defineProperty(e,r,{configurable:!0,enumerable:!0,get:function(){throw n.createPropertyNotLoadedException(t,r)},set:function(){throw n.createCannotUpdateReadOnlyPropertyException(t,r)}})},n.defineReadOnlyPropertyWithValue=function(e,t,r){Object.defineProperty(e,t,{configurable:!0,enumerable:!0,get:function(){return r},set:function(){throw n.createCannotUpdateReadOnlyPropertyException(null,t)}})},n.processRetrieveResult=function(e,t,r,o){if(!l.isNullOrUndefined(t))if(o){var i=t[H.itemsLowerCase];if(Array.isArray(i)){for(var a=[],s=0;s<i.length;s++){var c=o(i[s],s),u={};u[H.proxy]=c,c._handleRetrieveResult(i[s],u),a.push(u)}n.defineReadOnlyPropertyWithValue(r,H.itemsLowerCase,a)}}else{var p=e[H.scalarPropertyNames],f=e[H.navigationPropertyNames],d=e[H.className];if(p)for(s=0;s<p.length;s++){var h=t[m=p[s]];l.isUndefined(h)?n.definePropertyThrowUnloadedException(r,d,m):n.defineReadOnlyPropertyWithValue(r,m,h)}if(f)for(s=0;s<f.length;s++){var m;h=t[m=f[s]];if(l.isUndefined(h))n.definePropertyThrowUnloadedException(r,d,m);else{var g=e[m],y={};g._handleRetrieveResult(h,y),y[H.proxy]=g,Array.isArray(y[H.itemsLowerCase])&&(y=y[H.itemsLowerCase]),n.defineReadOnlyPropertyWithValue(r,m,y)}}}},n.setMockData=function(e,t,r,o){if(l.isNullOrUndefined(t))e._handleResult(t);else{if(e[H.scalarPropertyOriginalNames]){for(var i={},a=e[H.scalarPropertyOriginalNames],s=e[H.scalarPropertyNames],c=0;c<s.length;c++)"undefined"!==typeof t[s[c]]&&(i[a[c]]=t[s[c]]);e._handleResult(i)}if(e[H.navigationPropertyNames]){var u=e[H.navigationPropertyNames];for(c=0;c<u.length;c++)if("undefined"!==typeof t[u[c]]){var p=e[u[c]];p.setMockData&&p.setMockData(t[u[c]])}}if(e[H.isCollection]&&r){var f=Array.isArray(t)?t:t[H.itemsLowerCase];if(Array.isArray(f)){var d=[];for(c=0;c<f.length;c++){var h=r(f,c);n.setMockData(h,f[c]),d.push(h)}o(d)}}}},n.applyMixin=function(e,t){Object.getOwnPropertyNames(t.prototype).forEach((function(n){"constructor"!==n&&Object.defineProperty(e.prototype,n,Object.getOwnPropertyDescriptor(t.prototype,n))}))},n.ensureTypeInitialized=function(e){var t=new U;new e(t,K.createNewObjectObjectPath(t,"Temp",!1,0))},n.fieldName_m__items="m__items",n.fieldName_isCollection="_isCollection",n._synchronousCleanup=!1,n.s_underscoreCharCode="_".charCodeAt(0),n.s_suppressPropertyNotLoadedException=!1,n}(S);e.Utility=Z;var ee=function(){function e(){}return e.invokeMethod=function(e,t,n,r,o,i){var a=T.createMethodAction(e.context,e,t,n,r,o),s=new O(i);return Z._addActionResultHandler(e,a,s),s},e.invokeEnsureUnchanged=function(e,t){T.createEnsureUnchangedAction(e.context,e,t)},e.invokeSetProperty=function(e,t,n,r){T.createSetPropertyAction(e.context,e,t,n,r)},e.createRootServiceObject=function(e,t){return new e(t,K.createGlobalObjectObjectPath(t))},e.createObjectFromReferenceId=function(e,t,n){return new e(t,K.createReferenceIdObjectPath(t,n))},e.createTopLevelServiceObject=function(e,t,n,r,o){return new e(t,K.createNewObjectObjectPath(t,n,r,o))},e.createPropertyObject=function(e,t,n,r,o){var i=K.createPropertyObjectPath(t.context,t,n,r,!1,o);return new e(t.context,i)},e.createIndexerObject=function(e,t,n){var r=K.createIndexerObjectPath(t.context,t,n);return new e(t.context,r)},e.createMethodObject=function(e,t,n,r,o,i,a,s,c){var l=K.createMethodObjectPath(t.context,t,n,r,o,i,a,s,c);return new e(t.context,l)},e.createChildItemObject=function(e,t,n,r,o){var i=K.createChildItemObjectPathUsingIndexerOrGetItemAt(t,n.context,n,r,o);return new e(n.context,i)},e}();e.BatchApiHelper=ee;var te=function(){function t(e){if(this.m_namespaceMap={},this.m_namespace=e.metadata.name,this.m_targetNamespaceObject=e.targetNamespaceObject,this.m_namespaceMap[this.m_namespace]=e.targetNamespaceObject,e.namespaceMap)for(var t in e.namespaceMap)this.m_namespaceMap[t]=e.namespaceMap[t];this.m_defaultApiSetName=e.metadata.defaultApiSetName,this.m_hostName=e.metadata.hostName;var n=e.metadata;if(n.enumTypes)for(var r=0;r<n.enumTypes.length;r++)this.buildEnumType(n.enumTypes[r]);if(n.apiSets){for(r=0;r<n.apiSets.length;r++){var o=n.apiSets[r];Array.isArray(o)&&(n.apiSets[r]={version:o[0],name:o[1]||this.m_defaultApiSetName})}this.m_apiSets=n.apiSets}if(this.m_strings=n.strings,n.clientObjectTypes)for(r=0;r<n.clientObjectTypes.length;r++){o=n.clientObjectTypes[r];Array.isArray(o)&&(this.ensureArraySize(o,11),n.clientObjectTypes[r]={name:this.getString(o[0]),behaviorFlags:o[1],collectionPropertyPath:this.getString(o[6]),newObjectServerTypeFullName:this.getString(o[9]),newObjectApiFlags:o[10],childItemTypeFullName:this.getString(o[7]),scalarProperties:o[2],navigationProperties:o[3],scalarMethods:o[4],navigationMethods:o[5],events:o[8]}),this.buildClientObjectType(n.clientObjectTypes[r],e.fullyInitialize)}}return t.prototype.ensureArraySize=function(e,t){for(var n=t-e.length;n>0;)e.push(0),n--},t.prototype.getString=function(e){return"number"===typeof e?e>0?this.m_strings[e-1]:null:e},t.prototype.buildEnumType=function(e){var t;if(Array.isArray(e)){(t={name:e[0],fields:e[2]}).fields||(t.fields={});var n=e[1];if(Array.isArray(n))for(var r=0;r<n.length;r++)t.fields[n[r]]=this.toSimpleCamelUpperCase(n[r])}else t=e;this.m_targetNamespaceObject[t.name]=t.fields},t.prototype.buildClientObjectType=function(n,r){var o=this,i=function(t,r){j.apply(this,arguments),o.m_targetNamespaceObject[n.name]._typeInited||(o.buildPrototype(o.m_targetNamespaceObject[n.name],n),o.m_targetNamespaceObject[n.name]._typeInited=!0),e._internalConfig.appendTypeNameToObjectPathInfo&&this._objectPath&&this._objectPath.objectPathInfo&&this._className&&(this._objectPath.objectPathInfo.T=this._className)};(this.m_targetNamespaceObject[n.name]=i,this.extendsType(i,j),this.buildNewObject(i,n),0!==(2&n.behaviorFlags)&&(i.prototype._KeepReference=function(){ee.invokeMethod(this,"_KeepReference",1,[],0,0)}),0!==(32&n.behaviorFlags))&&this.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_StaticCustomize").call(null,i);r&&(this.buildPrototype(i,n),i._typeInited=!0)},t.prototype.extendsType=function(e,t){function n(){this.constructor=e}e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},t.prototype.findObjectUnderPath=function(t,n,r){for(var o=t,i=r;i<n.length;i++){if("object"!==typeof o)throw new e.Error("Cannot find "+n.join("."));o=o[n[i]]}return o},t.prototype.getFunction=function(t){var n=this.resolveObjectByFullName(t);if("function"!==typeof n)throw new e.Error("Cannot find function or type: "+t);return n},t.prototype.resolveObjectByFullName=function(e){var t=e.split(".");if(1===t.length)return this.m_targetNamespaceObject[t[0]];var n=t[0];return n===this.m_namespace?this.findObjectUnderPath(this.m_targetNamespaceObject,t,1):this.m_namespaceMap[n]?this.findObjectUnderPath(this.m_namespaceMap[n],t,1):this.findObjectUnderPath(this.m_targetNamespaceObject,t,0)},t.prototype.evaluateSimpleExpression=function(t,n){if(Z.isNullOrUndefined(t))return null;var r=t.split(".");if(3===r.length&&"OfficeExtension"===r[0]&&"Constants"===r[1])return H[r[2]];if("this"===r[0]){for(var o=n,i=1;i<r.length;i++)o="toString()"==r[i]?o.toString():"()"===r[i].substr(r[i].length-2)?o[r[i].substr(0,r[i].length-2)]():o[r[i]];return o}throw new e.Error("Cannot evaluate: "+t)},t.prototype.evaluateEventTargetId=function(e,t){return Z.isNullOrEmptyString(e)?"":this.evaluateSimpleExpression(e,t)},t.prototype.isAllDigits=function(e){for(var t="0".charCodeAt(0),n="9".charCodeAt(0),r=0;r<e.length;r++)if(e.charCodeAt(r)<t||e.charCodeAt(r)>n)return!1;return!0},t.prototype.evaluateEventType=function(t){if(Z.isNullOrEmptyString(t))return 0;if(this.isAllDigits(t))return parseInt(t);var n=this.resolveObjectByFullName(t);if("number"!==typeof n)throw new e.Error("Invalid event type: "+t);return n},t.prototype.buildPrototype=function(e,t){this.buildScalarProperties(e,t),this.buildNavigationProperties(e,t),this.buildScalarMethods(e,t),this.buildNavigationMethods(e,t),this.buildEvents(e,t),this.buildHandleResult(e,t),this.buildHandleIdResult(e,t),this.buildHandleRetrieveResult(e,t),this.buildLoad(e,t),this.buildRetrieve(e,t),this.buildSetMockData(e,t),this.buildEnsureUnchanged(e,t),this.buildUpdate(e,t),this.buildSet(e,t),this.buildToJSON(e,t),this.buildItems(e,t),this.buildTypeMetadataInfo(e,t),this.buildTrackUntrack(e,t),this.buildMixin(e,t)},t.prototype.toSimpleCamelUpperCase=function(e){return e.substr(0,1).toUpperCase()+e.substr(1)},t.prototype.ensureOriginalName=function(e){null===e.originalName&&(e.originalName=this.toSimpleCamelUpperCase(e.name))},t.prototype.getFieldName=function(e){return"m_"+e.name},t.prototype.throwIfApiNotSupported=function(e,t){if(this.m_apiSets&&t.apiSetInfoOrdinal>0){var n=this.m_apiSets[t.apiSetInfoOrdinal-1];n&&Z.throwIfApiNotSupported(e.name+"."+t.name,n.name,n.version,this.m_hostName)}},t.prototype.buildScalarProperties=function(e,t){if(Array.isArray(t.scalarProperties))for(var n=0;n<t.scalarProperties.length;n++){var r=t.scalarProperties[n];Array.isArray(r)&&(this.ensureArraySize(r,6),t.scalarProperties[n]={name:this.getString(r[0]),behaviorFlags:r[1],apiSetInfoOrdinal:r[2],originalName:this.getString(r[3]),setMethodApiFlags:r[4],undoableApiSetInfoOrdinal:r[5]}),this.buildScalarProperty(e,t,t.scalarProperties[n])}},t.prototype.calculateApiFlags=function(e,t){if(t>0){var n=this.m_apiSets[t-1];n&&(e=S.calculateApiFlags(e,n.name,n.version))}return e},t.prototype.buildScalarProperty=function(e,n,r){this.ensureOriginalName(r);var o=this,i=this.getFieldName(r),a={get:function(){return Z.throwIfNotLoaded(r.name,this[i],n.name,this._isNull),o.throwIfApiNotSupported(n,r),this[i]},enumerable:!0,configurable:!0};0===(2&r.behaviorFlags)&&(a.set=function(e){if(4&r.behaviorFlags&&o.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.originalName+"_Set").call(this,this,e).handled)return;this[i]=e;var a=o.calculateApiFlags(r.setMethodApiFlags,r.undoableApiSetInfoOrdinal);ee.invokeSetProperty(this,r.originalName,e,a)}),Object.defineProperty(e.prototype,r.name,a)},t.prototype.buildNavigationProperties=function(e,t){if(Array.isArray(t.navigationProperties))for(var n=0;n<t.navigationProperties.length;n++){var r=t.navigationProperties[n];Array.isArray(r)&&(this.ensureArraySize(r,8),t.navigationProperties[n]={name:this.getString(r[0]),behaviorFlags:r[2],apiSetInfoOrdinal:r[3],originalName:this.getString(r[4]),getMethodApiFlags:r[5],setMethodApiFlags:r[6],propertyTypeFullName:this.getString(r[1]),undoableApiSetInfoOrdinal:r[7]}),this.buildNavigationProperty(e,t,t.navigationProperties[n])}},t.prototype.buildNavigationProperty=function(e,n,r){this.ensureOriginalName(r);var o=this,i=this.getFieldName(r),a={get:function(){(this[o.getFieldName(r)]||(o.throwIfApiNotSupported(n,r),this[i]=ee.createPropertyObject(o.getFunction(r.propertyTypeFullName),this,r.originalName,0!==(16&r.behaviorFlags),r.getMethodApiFlags)),64&r.behaviorFlags)&&o.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.originalName+"_Get").call(this,this,this[i]);return this[i]},enumerable:!0,configurable:!0};0===(2&r.behaviorFlags)&&(a.set=function(e){if(4&r.behaviorFlags&&o.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.originalName+"_Set").call(this,this,e).handled)return;this[i]=e;var a=o.calculateApiFlags(r.setMethodApiFlags,r.undoableApiSetInfoOrdinal);ee.invokeSetProperty(this,r.originalName,e,a)}),Object.defineProperty(e.prototype,r.name,a)},t.prototype.buildScalarMethods=function(e,t){if(Array.isArray(t.scalarMethods))for(var n=0;n<t.scalarMethods.length;n++){var r=t.scalarMethods[n];Array.isArray(r)&&(this.ensureArraySize(r,7),t.scalarMethods[n]={name:this.getString(r[0]),behaviorFlags:r[2],apiSetInfoOrdinal:r[3],originalName:this.getString(r[5]),apiFlags:r[4],parameterCount:r[1],undoableApiSetInfoOrdinal:r[6]}),this.buildScalarMethod(e,t,t.scalarMethods[n])}},t.prototype.buildScalarMethod=function(e,n,r){this.ensureOriginalName(r);var o=this;e.prototype[r.name]=function(){var e=[];if(64&r.behaviorFlags&&r.parameterCount>0){for(var i=0;i<r.parameterCount-1;i++)e.push(arguments[i]);var a=[];for(i=r.parameterCount-1;i<arguments.length;i++)a.push(arguments[i]);e.push(a)}else for(i=0;i<arguments.length;i++)e.push(arguments[i]);if(1&r.behaviorFlags){var s=o.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.originalName),c=[this];for(i=0;i<e.length;i++)c.push(e[i]);var l=s.apply(this,c),u=l.handled,p=l.result;if(u)return p}o.throwIfApiNotSupported(n,r);var f=0;32&r.behaviorFlags&&(f=1);var d=0;2&r.behaviorFlags&&(d=1);var h=o.calculateApiFlags(r.apiFlags,r.undoableApiSetInfoOrdinal);return ee.invokeMethod(this,r.originalName,d,e,h,f)}},t.prototype.buildNavigationMethods=function(e,t){if(Array.isArray(t.navigationMethods))for(var n=0;n<t.navigationMethods.length;n++){var r=t.navigationMethods[n];Array.isArray(r)&&(this.ensureArraySize(r,9),t.navigationMethods[n]={name:this.getString(r[0]),behaviorFlags:r[3],apiSetInfoOrdinal:r[4],originalName:this.getString(r[6]),apiFlags:r[5],parameterCount:r[2],returnTypeFullName:this.getString(r[1]),returnObjectGetByIdMethodName:this.getString(r[7]),undoableApiSetInfoOrdinal:r[8]}),this.buildNavigationMethod(e,t,t.navigationMethods[n])}},t.prototype.buildNavigationMethod=function(e,n,r){this.ensureOriginalName(r);var o=this;e.prototype[r.name]=function(){var e=[];if(64&r.behaviorFlags&&r.parameterCount>0){for(var i=0;i<r.parameterCount-1;i++)e.push(arguments[i]);var a=[];for(i=r.parameterCount-1;i<arguments.length;i++)a.push(arguments[i]);e.push(a)}else for(i=0;i<arguments.length;i++)e.push(arguments[i]);if(1&r.behaviorFlags){var s=o.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.originalName),c=[this];for(i=0;i<e.length;i++)c.push(e[i]);var l=s.apply(this,c),u=l.handled,p=l.result;if(u)return p}if(o.throwIfApiNotSupported(n,r),0!==(16&r.behaviorFlags))return ee.createIndexerObject(o.getFunction(r.returnTypeFullName),this,e);var f=0;2&r.behaviorFlags&&(f=1);var d=o.calculateApiFlags(r.apiFlags,r.undoableApiSetInfoOrdinal);return ee.createMethodObject(o.getFunction(r.returnTypeFullName),this,r.originalName,f,e,0!==(4&r.behaviorFlags),0!==(8&r.behaviorFlags),r.returnObjectGetByIdMethodName,d)}},t.prototype.buildHandleResult=function(e,n){var r=this;e.prototype._handleResult=function(e){if(j.prototype._handleResult.call(this,e),!Z.isNullOrUndefined(e)){if(Z.fixObjectPathIfNecessary(this,e),8&n.behaviorFlags)r.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_HandleResult").call(this,this,e);if(n.scalarProperties)for(var o=0;o<n.scalarProperties.length;o++)Z.isUndefined(e[n.scalarProperties[o].originalName])||(0!==(8&n.scalarProperties[o].behaviorFlags)?this[r.getFieldName(n.scalarProperties[o])]=Z.adjustToDateTime(e[n.scalarProperties[o].originalName]):this[r.getFieldName(n.scalarProperties[o])]=e[n.scalarProperties[o].originalName]);if(n.navigationProperties){for(var i=[],a=0;a<n.navigationProperties.length;a++)i.push(n.navigationProperties[a].name),i.push(n.navigationProperties[a].originalName);Z._handleNavigationPropertyResults(this,e,i)}if(0!==(1&n.behaviorFlags)){var s=r.hasIndexMethod(n);if(!Z.isNullOrUndefined(e[H.items])){this.m__items=[];for(var c=e[H.items],l=r.getFunction(n.childItemTypeFullName),u=0;u<c.length;u++){var p=ee.createChildItemObject(l,s,this,c[u],u);p._handleResult(c[u]),this.m__items.push(p)}}}}}},t.prototype.buildHandleRetrieveResult=function(e,t){var n=this;e.prototype._handleRetrieveResult=function(e,r){if(j.prototype._handleRetrieveResult.call(this,e,r),!Z.isNullOrUndefined(e)){if(t.scalarProperties)for(var o=0;o<t.scalarProperties.length;o++)8&t.scalarProperties[o].behaviorFlags&&(Z.isNullOrUndefined(e[t.scalarProperties[o].name])||(e[t.scalarProperties[o].name]=Z.adjustToDateTime(e[t.scalarProperties[o].name])));if(1&t.behaviorFlags){var i=n.hasIndexMethod(t),a=n.getFunction(t.childItemTypeFullName),s=this;Z.processRetrieveResult(s,e,r,(function(e,t){return ee.createChildItemObject(a,i,s,e,t)}))}else Z.processRetrieveResult(this,e,r)}}},t.prototype.buildHandleIdResult=function(e,n){var r=this;e.prototype._handleIdResult=function(e){if(j.prototype._handleIdResult.call(this,e),!Z.isNullOrUndefined(e)){if(16&n.behaviorFlags)r.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_HandleIdResult").call(this,this,e);if(n.scalarProperties)for(var o=0;o<n.scalarProperties.length;o++){var i=n.scalarProperties[o].originalName;"Id"!==i&&"_Id"!==i&&"_ReferenceId"!==i||Z.isNullOrUndefined(e[n.scalarProperties[o].originalName])||(this[r.getFieldName(n.scalarProperties[o])]=e[n.scalarProperties[o].originalName])}}}},t.prototype.buildLoad=function(e,t){e.prototype.load=function(e){return Z.load(this,e)}},t.prototype.buildRetrieve=function(e,t){e.prototype.retrieve=function(e){return Z.retrieve(this,e)}},t.prototype.buildNewObject=function(e,t){Z.isNullOrEmptyString(t.newObjectServerTypeFullName)||(e.newObject=function(n){return ee.createTopLevelServiceObject(e,n,t.newObjectServerTypeFullName,0!==(1&t.behaviorFlags),t.newObjectApiFlags)})},t.prototype.buildSetMockData=function(e,t){var n=this;if(1&t.behaviorFlags){var r=n.hasIndexMethod(t);e.prototype.setMockData=function(e){var o=this;Z.setMockData(o,e,(function(e,i){return ee.createChildItemObject(n.getFunction(t.childItemTypeFullName),r,o,e,i)}),(function(e){o.m__items=e}))}}else e.prototype.setMockData=function(e){Z.setMockData(this,e)}},t.prototype.buildEnsureUnchanged=function(e,t){e.prototype.ensureUnchanged=function(e){ee.invokeEnsureUnchanged(this,e)}},t.prototype.buildUpdate=function(e,t){e.prototype.update=function(e){this._recursivelyUpdate(e)}},t.prototype.buildSet=function(e,t){if(0===(1&t.behaviorFlags)){var n=[],r=[];if(t.scalarProperties)for(var o=0;o<t.scalarProperties.length;o++)0===(2&t.scalarProperties[o].behaviorFlags)&&0!==(1&t.scalarProperties[o].behaviorFlags)?r.push(t.scalarProperties[o].name):n.push(t.scalarProperties[o].name);var i=[];if(t.navigationProperties)for(o=0;o<t.navigationProperties.length;o++)0!==(16&t.navigationProperties[o].behaviorFlags)||0===(1&t.navigationProperties[o].behaviorFlags)||0===(32&t.navigationProperties[o].behaviorFlags)?n.push(t.navigationProperties[o].name):i.push(t.navigationProperties[o].name);0===i.length&&0===r.length||(e.prototype.set=function(e,t){this._recursivelySet(e,t,r,i,n)})}},t.prototype.buildItems=function(e,t){0!==(1&t.behaviorFlags)&&Object.defineProperty(e.prototype,"items",{get:function(){return Z.throwIfNotLoaded("items",this.m__items,t.name,this._isNull),this.m__items},enumerable:!0,configurable:!0})},t.prototype.buildToJSON=function(e,t){var n=this;0===(1&t.behaviorFlags)?e.prototype.toJSON=function(){var e={};if(t.scalarProperties)for(var r=0;r<t.scalarProperties.length;r++)0!==(1&t.scalarProperties[r].behaviorFlags)&&(e[t.scalarProperties[r].name]=this[n.getFieldName(t.scalarProperties[r])]);var o={};if(t.navigationProperties)for(r=0;r<t.navigationProperties.length;r++)0!==(1&t.navigationProperties[r].behaviorFlags)&&(o[t.navigationProperties[r].name]=this[n.getFieldName(t.navigationProperties[r])]);return Z.toJson(this,e,o)}:e.prototype.toJSON=function(){return Z.toJson(this,{},{},this.m__items)}},t.prototype.buildTypeMetadataInfo=function(e,t){Object.defineProperty(e.prototype,"_className",{get:function(){return t.name},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_isCollection",{get:function(){return 0!==(1&t.behaviorFlags)},enumerable:!0,configurable:!0}),Z.isNullOrEmptyString(t.collectionPropertyPath)||Object.defineProperty(e.prototype,"_collectionPropertyPath",{get:function(){return t.collectionPropertyPath},enumerable:!0,configurable:!0}),t.scalarProperties&&t.scalarProperties.length>0&&(Object.defineProperty(e.prototype,"_scalarPropertyNames",{get:function(){return this.m__scalarPropertyNames||(this.m__scalarPropertyNames=t.scalarProperties.map((function(e){return e.name}))),this.m__scalarPropertyNames},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_scalarPropertyOriginalNames",{get:function(){return this.m__scalarPropertyOriginalNames||(this.m__scalarPropertyOriginalNames=t.scalarProperties.map((function(e){return e.originalName}))),this.m__scalarPropertyOriginalNames},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_scalarPropertyUpdateable",{get:function(){return this.m__scalarPropertyUpdateable||(this.m__scalarPropertyUpdateable=t.scalarProperties.map((function(e){return 0===(2&e.behaviorFlags)}))),this.m__scalarPropertyUpdateable},enumerable:!0,configurable:!0})),t.navigationProperties&&t.navigationProperties.length>0&&Object.defineProperty(e.prototype,"_navigationPropertyNames",{get:function(){return this.m__navigationPropertyNames||(this.m__navigationPropertyNames=t.navigationProperties.map((function(e){return e.name}))),this.m__navigationPropertyNames},enumerable:!0,configurable:!0})},t.prototype.buildTrackUntrack=function(e,t){2&t.behaviorFlags&&(e.prototype.track=function(){return this.context.trackedObjects.add(this),this},e.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this})},t.prototype.buildMixin=function(e,t){if(4&t.behaviorFlags){var n=this.getFunction(t.name+"Custom");Z.applyMixin(e,n)}},t.prototype.getOnEventName=function(e){return"_"===e[0]?"_on"+e.substr(1):"on"+e},t.prototype.buildEvents=function(e,t){if(t.events)for(var n=0;n<t.events.length;n++){var r=t.events[n];Array.isArray(r)&&(this.ensureArraySize(r,7),t.events[n]={name:this.getString(r[0]),behaviorFlags:r[1],apiSetInfoOrdinal:r[2],typeExpression:this.getString(r[3]),targetIdExpression:this.getString(r[4]),register:this.getString(r[5]),unregister:this.getString(r[6])}),this.buildEvent(e,t,t.events[n])}},t.prototype.buildEvent=function(e,t,n){1&n.behaviorFlags?this.buildV0Event(e,t,n):this.buildV2Event(e,t,n)},t.prototype.buildV2Event=function(e,n,r){var o=this,i=this.getOnEventName(r.name),a=this.getFieldName(r);Object.defineProperty(e.prototype,i,{get:function(){if(!this[a]){o.throwIfApiNotSupported(n,r);var e=this,i=null;"null"!==r.register&&(i=this[r.register].bind(this));var s=null;"null"!==r.unregister&&(s=this[r.unregister].bind(this));var c=null;2&r.behaviorFlags&&(c=o.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.name+"_EventArgsTransform"));var l=o.evaluateEventType(r.typeExpression);this[a]=new z(this.context,this,r.name,{eventType:l,getTargetIdFunc:function(){return o.evaluateEventTargetId(r.targetIdExpression,e)},registerFunc:i,unregisterFunc:s,eventArgsTransformFunc:function(t){return c&&(t=c.call(e,e,t)),Z._createPromiseFromResult(t)}})}return this[a]},enumerable:!0,configurable:!0})},t.prototype.buildV0Event=function(e,n,r){var o=this,i=this.getOnEventName(r.name),a=this.getFieldName(r);Object.defineProperty(e.prototype,i,{get:function(){if(!this[a]){o.throwIfApiNotSupported(n,r);var e=this,i=null;if(Z.isNullOrEmptyString(r.register)){var s=o.evaluateEventType(r.typeExpression);i=function(t){var n=o.evaluateEventTargetId(r.targetIdExpression,e);return e.context.eventRegistration.register(s,n,t)}}else if("null"!==r.register){var c=o.getFunction(r.register);i=function(t){return c.call(e,e,t)}}var l=null;if(Z.isNullOrEmptyString(r.unregister)){var u=o.evaluateEventType(r.typeExpression);l=function(t){var n=o.evaluateEventTargetId(r.targetIdExpression,e);return e.context.eventRegistration.unregister(u,n,t)}}else if("null"!==r.unregister){var p=o.getFunction(r.unregister);l=function(t){return p.call(e,e,t)}}var f=null;2&r.behaviorFlags&&(f=o.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.name+"_EventArgsTransform"));this[a]=new B(this.context,this,r.name,{registerFunc:i,unregisterFunc:l,eventArgsTransformFunc:function(t){return f&&(t=f.call(e,e,t)),Z._createPromiseFromResult(t)}})}return this[a]},enumerable:!0,configurable:!0})},t.prototype.hasIndexMethod=function(e){var t=!1;if(e.navigationMethods)for(var n=0;n<e.navigationMethods.length;n++)if(0!==(16&e.navigationMethods[n].behaviorFlags)){t=!0;break}return t},t.CustomizationCodeNamespace="_CC",t}();e.LibraryBuilder=te;var ne,re=1,oe=function(e){return e.DdaMethod.Version=re,e},ie=function(e){return re=e.Version,e.Error&&(e.error={},e.error.Code=e.Error),e};!function(e){e.SendingId="sId",e.RespondingId="rId",e.CommandKey="command",e.SessionInfoKey="sessionInfo",e.ParamsKey="params",e.ApiReadyCommand="apiready",e.ExecuteMethodCommand="executeMethod",e.GetAppContextCommand="getAppContext",e.RegisterEventCommand="registerEvent",e.UnregisterEventCommand="unregisterEvent",e.FireEventCommand="fireEvent"}(ne||(ne={}));var ae=function(){function e(){}return e.sessionContext="sc",e.embeddingPageOrigin="EmbeddingPageOrigin",e.embeddingPageSessionInfo="EmbeddingPageSessionInfo",e}();e.EmbeddedConstants=ae;var se=function(e){function t(t,n){var r=e.call(this)||this;return r.m_chosenWindow=null,r.m_chosenOrigin=null,r.m_enabled=!0,r.m_onMessageHandler=r._onMessage.bind(r),r.m_callbackList={},r.m_id=0,r.m_timeoutId=-1,r.m_appContext=null,r.m_url=t,r.m_options=n,r.m_options||(r.m_options={sessionKey:Math.random().toString()}),r.m_options.sessionKey||(r.m_options.sessionKey=Math.random().toString()),r.m_options.container||(r.m_options.container=document.body),r.m_options.timeoutInMilliseconds||(r.m_options.timeoutInMilliseconds=6e4),r.m_options.height||(r.m_options.height="400px"),r.m_options.width||(r.m_options.width="100%"),r.m_options.webApplication&&r.m_options.webApplication.accessToken&&r.m_options.webApplication.accessTokenTtl||(r.m_options.webApplication=null),r}return __extends(t,e),t.prototype._getIFrameSrc=function(){var e=window.location.protocol+"//"+window.location.host,t=ae.embeddingPageOrigin+"="+encodeURIComponent(e)+"&"+ae.embeddingPageSessionInfo+"="+encodeURIComponent(this.m_options.sessionKey),n=!1;(this.m_url.toLowerCase().indexOf("/_layouts/preauth.aspx")>0||this.m_url.toLowerCase().indexOf("/_layouts/15/preauth.aspx")>0)&&(n=!0);var r=document.createElement("a");if(r.href=this.m_url,this.m_options.webApplication){var o=ae.embeddingPageOrigin+"="+e+"&"+ae.embeddingPageSessionInfo+"="+this.m_options.sessionKey;0===r.search.length||"?"===r.search?r.search="?"+ae.sessionContext+"="+encodeURIComponent(o):r.search=r.search+"&"+ae.sessionContext+"="+encodeURIComponent(o)}else n?0===r.hash.length||"#"===r.hash?r.hash="#"+t:r.hash=r.hash+"&"+t:0===r.search.length||"?"===r.search?r.search="?"+t:r.search=r.search+"&"+t;return r.href},t.prototype.init=function(){var e=this;window.addEventListener("message",this.m_onMessageHandler);var t=this._getIFrameSrc();return l.createPromise((function(n,r){var o=document.createElement("iframe");if(e.m_options.id&&(o.id=e.m_options.id,o.name=e.m_options.id),o.style.height=e.m_options.height,o.style.width=e.m_options.width,e.m_options.webApplication){var s=document.createElement("form");s.setAttribute("action",t),s.setAttribute("method","post"),s.setAttribute("target",o.name),e.m_options.container.appendChild(s);var c=document.createElement("input");c.setAttribute("type","hidden"),c.setAttribute("name","access_token"),c.setAttribute("value",e.m_options.webApplication.accessToken),s.appendChild(c);var u=document.createElement("input");u.setAttribute("type","hidden"),u.setAttribute("name","access_token_ttl"),u.setAttribute("value",e.m_options.webApplication.accessTokenTtl),s.appendChild(u),e.m_options.container.appendChild(o),s.submit()}else o.src=t,e.m_options.container.appendChild(o);e.m_timeoutId=window.setTimeout((function(){e.close();var t=Z.createRuntimeError(i.timeout,l._getResourceString(a.timeout),"EmbeddedSession.init");r(t)}),e.m_options.timeoutInMilliseconds),e.m_promiseResolver=n}))},t.prototype._invoke=function(e,t,n){this.m_enabled?(oe&&(n=oe(n)),this._sendMessageWithCallback(this.m_id++,e,n,(function(e){ie&&(e=ie(e));var n=e.Error;delete e.Error,t(n||0,e)}))):t(5001,null)},t.prototype.close=function(){window.removeEventListener("message",this.m_onMessageHandler),window.clearTimeout(this.m_timeoutId),this.m_enabled=!1},t.prototype.getEventRegistration=function(e){return this.m_sessionEventManager||(this.m_sessionEventManager=new V(this._registerEventImpl.bind(this),this._unregisterEventImpl.bind(this))),this.m_sessionEventManager},t.prototype._createRequestExecutorOrNull=function(){return new ce(this)},t.prototype._resolveRequestUrlAndHeaderInfo=function(){return l._createPromiseFromResult(null)},t.prototype._registerEventImpl=function(e,t){var n=this;return l.createPromise((function(r,o){n._sendMessageWithCallback(n.m_id++,ne.RegisterEventCommand,{EventId:e,TargetId:t},(function(){r(null)}))}))},t.prototype._unregisterEventImpl=function(e,t){var n=this;return l.createPromise((function(r,o){n._sendMessageWithCallback(n.m_id++,ne.UnregisterEventCommand,{EventId:e,TargetId:t},(function(){r()}))}))},t.prototype._onMessage=function(e){var t=this;if(this.m_enabled&&(!this.m_chosenWindow||this.m_chosenWindow===e.source&&this.m_chosenOrigin===e.origin)){var n=e.data;if(n&&n[ne.CommandKey]===ne.ApiReadyCommand)!this.m_chosenWindow&&this._isValidDescendant(e.source)&&n[ne.SessionInfoKey]===this.m_options.sessionKey&&(this.m_chosenWindow=e.source,this.m_chosenOrigin=e.origin,this._sendMessageWithCallback(this.m_id++,ne.GetAppContextCommand,null,(function(e){t._setupContext(e),window.clearTimeout(t.m_timeoutId),t.m_promiseResolver()})));else if(n&&n[ne.CommandKey]===ne.FireEventCommand){var r=n[ne.ParamsKey],o=r.EventId,i=r.TargetId,a=r.Data;if(this.m_sessionEventManager)for(var s=this.m_sessionEventManager.getHandlers(o,i),c=0;c<s.length;c++)s[c](a)}else if(n&&n.hasOwnProperty(ne.RespondingId)){var l=n[ne.RespondingId],u=this.m_callbackList[l];"function"===typeof u&&u(n[ne.ParamsKey]),delete this.m_callbackList[l]}}},t.prototype._sendMessageWithCallback=function(e,t,n,r){this.m_callbackList[e]=r;var o={};o[ne.SendingId]=e,o[ne.CommandKey]=t,o[ne.ParamsKey]=n,this.m_chosenWindow.postMessage(JSON.stringify(o),this.m_chosenOrigin)},t.prototype._isValidDescendant=function(e){function t(n){if(n===e)return!0;for(var r=0,o=n.frames.length;r<o;r++)if(t(n.frames[r]))return!0;return!1}for(var n=(this.m_options.container||document.body).getElementsByTagName("iframe"),r=0,o=n.length;r<o;r++)if(t(n[r].contentWindow))return!0;return!1},t.prototype._setupContext=function(e){this.m_appContext=e},t}(t);e.EmbeddedSession=se;var ce=function(){function e(e){this.m_session=e}return e.prototype.executeAsync=function(t,n,r){var o=this,i=c.buildMessageArrayForIRequestExecutor(t,n,r,e.SourceLibHeaderValue);return l.createPromise((function(t,n){o.m_session._invoke(ne.ExecuteMethodCommand,(function(e,n){var r;l.log("Response:"),l.log(JSON.stringify(n)),r=0==e?c.buildResponseOnSuccess(c.getResponseBodyFromSafeArray(n.Data),c.getResponseHeadersFromSafeArray(n.Data)):c.buildResponseOnError(n.error.Code,n.error.Message),t(r)}),e._transformMessageArrayIntoParams(i))}))},e._transformMessageArrayIntoParams=function(t){return{ArrayData:t,DdaMethod:{DispatchId:e.DispidExecuteRichApiRequestMethod}}},e.DispidExecuteRichApiRequestMethod=93,e.SourceLibHeaderValue="Embedded",e}()}(OfficeExtension||(OfficeExtension={}));__extends=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();var OfficeFirstPartyDialog,OfficeFirstPartyAuth,OfficeCore,Office,__awaiter=this&&this.__awaiter||function(e,t,n,r){return new(n||(n=Promise))((function(o,i){function a(e){try{c(r.next(e))}catch(e){i(e)}}function s(e){try{c(r.throw(e))}catch(e){i(e)}}function c(e){e.done?o(e.value):new n((function(t){t(e.value)})).then(a,s)}c((r=r.apply(e,t||[])).next())}))},__generator=this&&this.__generator||function(e,t){var n,r,o,i,a={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]};return i={next:s(0),throw:s(1),return:s(2)},"function"===typeof Symbol&&(i[Symbol.iterator]=function(){return this}),i;function s(i){return function(s){return function(i){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(o=2&i[0]?r.return:i[0]?r.throw||((o=r.return)&&o.call(r),0):r.next)&&!(o=o.call(r,i[1])).done)return o;switch(r=0,o&&(i=[2&i[0],o.value]),i[0]){case 0:case 1:o=i;break;case 4:return a.label++,{value:i[1],done:!1};case 5:a.label++,r=i[1],i=[0];continue;case 7:i=a.ops.pop(),a.trys.pop();continue;default:if(!(o=(o=a.trys).length>0&&o[o.length-1])&&(6===i[0]||2===i[0])){a=0;continue}if(3===i[0]&&(!o||i[1]>o[0]&&i[1]<o[3])){a.label=i[1];break}if(6===i[0]&&a.label<o[1]){a.label=o[1],o=i;break}if(o&&a.label<o[2]){a.label=o[2],a.ops.push(i);break}o[2]&&a.ops.pop(),a.trys.pop();continue}i=t.call(e,a)}catch(e){i=[6,e],r=0}finally{n=o=0}if(5&i[0])throw i[1];return{value:i[0]?i[1]:void 0,done:!0}}([i,s])}}};!function(e){OfficeExtension.BatchApiHelper.createPropertyObject,OfficeExtension.BatchApiHelper.createMethodObject,OfficeExtension.BatchApiHelper.createIndexerObject,OfficeExtension.BatchApiHelper.createRootServiceObject;var t=OfficeExtension.BatchApiHelper.createTopLevelServiceObject,n=(OfficeExtension.BatchApiHelper.createChildItemObject,OfficeExtension.BatchApiHelper.invokeMethod),r=(OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,OfficeExtension.BatchApiHelper.invokeSetProperty,OfficeExtension.Utility.isNullOrUndefined),o=(OfficeExtension.Utility.isUndefined,OfficeExtension.Utility.throwIfNotLoaded,OfficeExtension.Utility.throwIfApiNotSupported,OfficeExtension.Utility.load,OfficeExtension.Utility.retrieve,OfficeExtension.Utility.toJson),i=OfficeExtension.Utility.fixObjectPathIfNecessary,a=(OfficeExtension.Utility._handleNavigationPropertyResults,OfficeExtension.Utility.adjustToDateTime,OfficeExtension.Utility.processRetrieveResult),s=function(s){function c(){return null!==s&&s.apply(this,arguments)||this}return __extends(c,s),Object.defineProperty(c.prototype,"_className",{get:function(){return"BiShim"},enumerable:!0,configurable:!0}),c.prototype.initialize=function(e){n(this,"Initialize",0,[e],0,0)},c.prototype.getData=function(){return n(this,"getData",1,[],4,0)},c.prototype.setVisualObjects=function(e){n(this,"setVisualObjects",0,[e],2,0)},c.prototype.setVisualObjectsToPersist=function(e){n(this,"setVisualObjectsToPersist",0,[e],2,0)},c.prototype._handleResult=function(e){(s.prototype._handleResult.call(this,e),r(e))||i(this,e)},c.prototype._handleRetrieveResult=function(e,t){s.prototype._handleRetrieveResult.call(this,e,t),a(this,e,t)},c.newObject=function(n){return t(e.BiShim,n,"Microsoft.AgaveVisual.BiShim",!1,4)},c.prototype.toJSON=function(){return o(this,{},{})},c}(OfficeExtension.ClientObject);e.BiShim=s,function(e){e.generalException1="GeneralException"}(e.AgaveVisualErrorCodes||(e.AgaveVisualErrorCodes={}))}(OfficeCore||(OfficeCore={})),function(e){OfficeExtension.BatchApiHelper.createPropertyObject;var t=OfficeExtension.BatchApiHelper.createMethodObject,n=(OfficeExtension.BatchApiHelper.createIndexerObject,OfficeExtension.BatchApiHelper.createRootServiceObject,OfficeExtension.BatchApiHelper.createTopLevelServiceObject),r=(OfficeExtension.BatchApiHelper.createChildItemObject,OfficeExtension.BatchApiHelper.invokeMethod),o=OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,i=(OfficeExtension.BatchApiHelper.invokeSetProperty,OfficeExtension.Utility.isNullOrUndefined),a=OfficeExtension.Utility.isUndefined,s=OfficeExtension.Utility.throwIfNotLoaded,c=(OfficeExtension.Utility.throwIfApiNotSupported,OfficeExtension.Utility.load),l=OfficeExtension.Utility.retrieve,u=OfficeExtension.Utility.toJson,p=OfficeExtension.Utility.fixObjectPathIfNecessary,f=(OfficeExtension.Utility._handleNavigationPropertyResults,OfficeExtension.Utility.adjustToDateTime,OfficeExtension.Utility.processRetrieveResult),d=function(o){function a(){return null!==o&&o.apply(this,arguments)||this}return __extends(a,o),Object.defineProperty(a.prototype,"_className",{get:function(){return"FlightingService"},enumerable:!0,configurable:!0}),a.prototype.getClientSessionId=function(){return r(this,"GetClientSessionId",1,[],4,0)},a.prototype.getDeferredFlights=function(){return r(this,"GetDeferredFlights",1,[],4,0)},a.prototype.getFeature=function(n,r,o,i){return t(e.ABType,this,"GetFeature",1,[n,r,o,i],!1,!1,null,4)},a.prototype.getFeatureGate=function(n,r){return t(e.ABType,this,"GetFeatureGate",1,[n,r],!1,!1,null,4)},a.prototype.resetOverride=function(e){r(this,"ResetOverride",0,[e],0,0)},a.prototype.setOverride=function(e,t,n){r(this,"SetOverride",0,[e,t,n],0,0)},a.prototype._handleResult=function(e){(o.prototype._handleResult.call(this,e),i(e))||p(this,e)},a.prototype._handleRetrieveResult=function(e,t){o.prototype._handleRetrieveResult.call(this,e,t),f(this,e,t)},a.newObject=function(t){return n(e.FlightingService,t,"Microsoft.Experiment.FlightingService",!1,4)},a.prototype.toJSON=function(){return u(this,{},{})},a}(OfficeExtension.ClientObject);e.FlightingService=d;var h=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"ABType"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["value"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"value",{get:function(){return s("value",this._V,"ABType",this._isNull),this._V},enumerable:!0,configurable:!0}),t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!i(t)){var n=t;p(this,n),a(n.Value)||(this._V=n.Value)}},t.prototype.load=function(e){return c(this,e)},t.prototype.retrieve=function(e){return l(this,e)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),f(this,t,n)},t.prototype.toJSON=function(){return u(this,{value:this._V},{})},t.prototype.ensureUnchanged=function(e){o(this,e)},t}(OfficeExtension.ClientObject);e.ABType=h,function(e){e.boolean="Boolean",e.integer="Integer",e.string="String"}(e.FeatureType||(e.FeatureType={})),function(e){e.generalException="GeneralException"}(e.ExperimentErrorCodes||(e.ExperimentErrorCodes={}))}(OfficeCore||(OfficeCore={})),function(e){var t,n=function(){function e(e){this._dialogService=e}return e.prototype.close=function(){return this._dialogService.close(),this._dialogService.context.sync()},e.prototype.messageChild=function(e,t){DialogApiManager&&DialogApiManager.messageChildRichApiBridge&&DialogApiManager.messageChildRichApiBridge(e,t)},e}();e.Dialog=n,e.displayWebDialog=function(t,n){return void 0===n&&(n={}),new OfficeExtension.CoreUtility.Promise((function(o,i){if(n.width&&n.height&&(!r(n.width)||!r(n.height)))throw new OfficeExtension.Error({code:"InvalidArgument",message:'Dimensions must be "number%" or number.'});var a=new OfficeExtension.ClientRequestContext,s=OfficeCore.FirstPartyDialogService.newObject(a),c=new e.Dialog(s),l=s.onDialogMessage.add((function(e){OfficeExtension.Utility.log("dialogMessageHandler:"+JSON.stringify(e));var t=JSON.parse(e.message),r=t.errorCode?new OfficeExtension.Error(function(e){var t,n=((t={})[12002]={code:"InvalidUrl",message:"Cannot load URL, no such page or bad URL syntax."},t[12003]={code:"InvalidUrl",message:"HTTPS is required."},t[12004]={code:"Untrusted",message:"Domain is not trusted."},t[12005]={code:"InvalidUrl",message:"HTTPS is required."},t[12007]={code:"FailedToOpen",message:"Another dialog is already opened."},t);return n[e]?n[e]:{code:"Unknown",message:"An unknown error has occured with code: "+e}}(t.errorCode)):null,s=t.type,u=t.origin,p=t.message;switch(s){case 17:r?i(r):o(c);break;case 12:n.onMessage&&n.onMessage(p,c,u);break;case 10:default:12006===t.errorCode?(l&&(l.remove(),a.sync()),n.onClose&&n.onClose()):n.onRuntimeError&&(n.onRuntimeError(r,c),i(r))}return OfficeExtension.CoreUtility.Promise.resolve()}));return a.sync().then((function(){var e={width:n.width?parseInt(n.width):50,height:n.height?parseInt(n.height):50,displayInIFrame:n.displayInIFrame,dialogTitle:n.dialogTitle};return s.displayDialog(t,e),a.sync()})).catch((function(e){i(e)}))}));function r(e){return/^(\-|\+)?([0-9]+)%?$/.test(e)}},function(e){e[e.dialogMessageReceived=0]="dialogMessageReceived",e[e.dialogEventReceived=1]="dialogEventReceived"}(t||(t={}))}(OfficeFirstPartyDialog||(OfficeFirstPartyDialog={})),function(e){e.OfficeOnlineDomainList=["*.dod.online.office365.us","*.gov.online.office365.us","*.officeapps-df.live.com","*.officeapps.live.com","*.online.office.de","*.partner.officewebapps.cn"],e.isHostOriginTrusted=function(){if("undefined"===typeof window.external||"undefined"===typeof window.external.GetContext){var t=OSF.getClientEndPoint()._targetUrl,n=function(e){return e.split("/")[2].split(":")[0].split("?")[0]}(t);return 0!=t.indexOf("https:")||e.OfficeOnlineDomainList.forEach((function(e){if(0==e.indexOf("*.")&&(e=e.substring(2)),n.indexOf(e)==n.length-e.length)return!0})),!1}return!0}}(OfficeCore||(OfficeCore={})),function(e){var t=function(){function t(e){this.context=e}return Object.defineProperty(t.prototype,"roamingSettings",{get:function(){return this.m_roamingSettings||(this.m_roamingSettings=e.AuthenticationService.newObject(this.context).roamingSettings),this.m_roamingSettings},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"tap",{get:function(){return this.m_tap||(this.m_tap=e.Tap.newObject(this.context)),this.m_tap},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"skill",{get:function(){return this.m_skill||(this.m_skill=e.Skill.newObject(this.context)),this.m_skill},enumerable:!0,configurable:!0}),t}();e.FirstPartyApis=t;var n=function(n){function r(e){return n.call(this,e)||this}return __extends(r,n),Object.defineProperty(r.prototype,"firstParty",{get:function(){return this.m_firstPartyApis||(this.m_firstPartyApis=new t(this)),this.m_firstPartyApis},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"flighting",{get:function(){return this.flightingService},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"telemetry",{get:function(){return this.m_telemetry||(this.m_telemetry=e.TelemetryService.newObject(this)),this.m_telemetry},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"ribbon",{get:function(){return this.m_ribbon||(this.m_ribbon=e.DynamicRibbon.newObject(this)),this.m_ribbon},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"bi",{get:function(){return this.m_biShim||(this.m_biShim=e.BiShim.newObject(this)),this.m_biShim},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"flightingService",{get:function(){return this.m_flightingService||(this.m_flightingService=e.FlightingService.newObject(this)),this.m_flightingService},enumerable:!0,configurable:!0}),r}(OfficeExtension.ClientRequestContext);e.RequestContext=n,e.run=function(t,n){return OfficeExtension.ClientRequestContext._runBatch("OfficeCore.run",arguments,(function(t){return new e.RequestContext(t)}))}}(OfficeCore||(OfficeCore={})),function(e){!function(e){function t(){var e=new OfficeCore.RequestContext;return"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(e._customData="WacPartition"),e}e.isFeatureEnabled=function(e,n){return __awaiter(this,void 0,void 0,(function(){var r,o,i;return __generator(this,(function(a){switch(a.label){case 0:return r=t(),o=OfficeCore.License.newObject(r),i=o.isFeatureEnabled(e,n),[4,r.sync()];case 1:return a.sent(),[2,i.value]}}))}))},e.getFeatureTier=function(e,n){return __awaiter(this,void 0,void 0,(function(){var r,o,i;return __generator(this,(function(a){switch(a.label){case 0:return r=t(),o=OfficeCore.License.newObject(r),i=o.getFeatureTier(e,n),[4,r.sync()];case 1:return a.sent(),[2,i.value]}}))}))},e.isFreemiumUpsellEnabled=function(){return __awaiter(this,void 0,void 0,(function(){var e,n,r;return __generator(this,(function(o){switch(o.label){case 0:return e=t(),n=OfficeCore.License.newObject(e),r=n.isFreemiumUpsellEnabled(),[4,e.sync()];case 1:return o.sent(),[2,r.value]}}))}))},e.launchUpsellExperience=function(e){return __awaiter(this,void 0,void 0,(function(){var n;return __generator(this,(function(r){switch(r.label){case 0:return n=t(),OfficeCore.License.newObject(n).launchUpsellExperience(e),[4,n.sync()];case 1:return r.sent(),[2]}}))}))},e.onFeatureStateChanged=function(e,n){return __awaiter(this,void 0,void 0,(function(){var r,o,i,a;return __generator(this,(function(s){switch(s.label){case 0:return r=t(),o=OfficeCore.License.newObject(r),(i=o.getLicenseFeature(e)).onStateChanged.add(n),a=function(){return i.onStateChanged.remove(n),null},[4,r.sync()];case 1:return s.sent(),[2,a]}}))}))},e.getMsaDeviceTicket=function(e,n,r){return __awaiter(this,void 0,void 0,(function(){var o,i,a;return __generator(this,(function(s){switch(s.label){case 0:return o=t(),i=OfficeCore.License.newObject(o),a=i.getMsaDeviceTicket(e,n,r),[4,o.sync()];case 1:return s.sent(),[2,a.value]}}))}))}}(e.license||(e.license={}))}(Office||(Office={})),function(e){OfficeExtension.BatchApiHelper.createPropertyObject,OfficeExtension.BatchApiHelper.createMethodObject,OfficeExtension.BatchApiHelper.createIndexerObject,OfficeExtension.BatchApiHelper.createRootServiceObject;var t,n=OfficeExtension.BatchApiHelper.createTopLevelServiceObject,r=(OfficeExtension.BatchApiHelper.createChildItemObject,OfficeExtension.BatchApiHelper.invokeMethod),o=(OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,OfficeExtension.BatchApiHelper.invokeSetProperty,OfficeExtension.Utility.isNullOrUndefined),i=(OfficeExtension.Utility.isUndefined,OfficeExtension.Utility.throwIfNotLoaded,OfficeExtension.Utility.throwIfApiNotSupported,OfficeExtension.Utility.load,OfficeExtension.Utility.retrieve,OfficeExtension.Utility.toJson),a=OfficeExtension.Utility.fixObjectPathIfNecessary,s=(OfficeExtension.Utility._handleNavigationPropertyResults,OfficeExtension.Utility.adjustToDateTime,OfficeExtension.Utility.processRetrieveResult),c=(OfficeExtension.Utility.setMockData,OfficeExtension.CommonUtility.calculateApiFlags,function(c){function l(){return null!==c&&c.apply(this,arguments)||this}return __extends(l,c),Object.defineProperty(l.prototype,"_className",{get:function(){return"Skill"},enumerable:!0,configurable:!0}),l.prototype.executeAction=function(e,t,n){return r(this,"ExecuteAction",1,[e,t,n],5,0)},l.prototype.notifyPaneEvent=function(e,t){r(this,"NotifyPaneEvent",1,[e,t],5,0)},l.prototype.registerHostSkillEvent=function(){r(this,"RegisterHostSkillEvent",0,[],1,0)},l.prototype.testFireEvent=function(){r(this,"TestFireEvent",0,[],1,0)},l.prototype.unregisterHostSkillEvent=function(){r(this,"UnregisterHostSkillEvent",0,[],1,0)},l.prototype._handleResult=function(e){(c.prototype._handleResult.call(this,e),o(e))||a(this,e)},l.prototype._handleRetrieveResult=function(e,t){c.prototype._handleRetrieveResult.call(this,e,t),s(this,e,t)},l.newObject=function(t){return n(e.Skill,t,"Microsoft.SkillApi.Skill",!1,4)},Object.defineProperty(l.prototype,"onHostSkillEvent",{get:function(){var e=this;return this.m_hostSkillEvent||(this.m_hostSkillEvent=new OfficeExtension.GenericEventHandlers(this.context,this,"HostSkillEvent",{eventType:65538,registerFunc:function(){return e.registerHostSkillEvent()},unregisterFunc:function(){return e.unregisterHostSkillEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(n){var r=t.Skill_HostSkillEvent_EventArgsTransform(e,n);return OfficeExtension.Utility._createPromiseFromResult(r)}})),this.m_hostSkillEvent},enumerable:!0,configurable:!0}),l.prototype.toJSON=function(){return i(this,{},{})},l}(OfficeExtension.ClientObject));e.Skill=c,function(e){e.Skill_HostSkillEvent_EventArgsTransform=function(e,t){return{type:t.type,data:t.data}}}(t=e._CC||(e._CC={})),function(e){e.generalException="GeneralException"}(e.SkillErrorCodes||(e.SkillErrorCodes={}))}(OfficeCore||(OfficeCore={})),function(e){OfficeExtension.BatchApiHelper.createPropertyObject,OfficeExtension.BatchApiHelper.createMethodObject,OfficeExtension.BatchApiHelper.createIndexerObject,OfficeExtension.BatchApiHelper.createRootServiceObject;var t=OfficeExtension.BatchApiHelper.createTopLevelServiceObject,n=(OfficeExtension.BatchApiHelper.createChildItemObject,OfficeExtension.BatchApiHelper.invokeMethod),r=(OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,OfficeExtension.BatchApiHelper.invokeSetProperty,OfficeExtension.Utility.isNullOrUndefined),o=(OfficeExtension.Utility.isUndefined,OfficeExtension.Utility.throwIfNotLoaded,OfficeExtension.Utility.throwIfApiNotSupported),i=(OfficeExtension.Utility.load,OfficeExtension.Utility.retrieve,OfficeExtension.Utility.toJson),a=OfficeExtension.Utility.fixObjectPathIfNecessary,s=(OfficeExtension.Utility._handleNavigationPropertyResults,OfficeExtension.Utility.adjustToDateTime,OfficeExtension.Utility.processRetrieveResult),c=(OfficeExtension.Utility.setMockData,OfficeExtension.CommonUtility.calculateApiFlags,function(c){function l(){return null!==c&&c.apply(this,arguments)||this}return __extends(l,c),Object.defineProperty(l.prototype,"_className",{get:function(){return"TelemetryService"},enumerable:!0,configurable:!0}),l.prototype.sendCustomerContent=function(e,t,r,i,a){o("TelemetryService.sendCustomerContent","Telemetry","1.3","OfficeCore"),n(this,"SendCustomerContent",1,[e,t,r,i,a],4,0)},l.prototype.sendTelemetryEvent=function(e,t,r,o,i){n(this,"SendTelemetryEvent",1,[e,t,r,o,i],4,0)},l.prototype._handleResult=function(e){(c.prototype._handleResult.call(this,e),r(e))||a(this,e)},l.prototype._handleRetrieveResult=function(e,t){c.prototype._handleRetrieveResult.call(this,e,t),s(this,e,t)},l.newObject=function(n){return t(e.TelemetryService,n,"Microsoft.Telemetry.TelemetryService",!1,4)},l.prototype.toJSON=function(){return i(this,{},{})},l}(OfficeExtension.ClientObject));e.TelemetryService=c,function(e){e.unset="Unset",e.string="String",e.boolean="Boolean",e.int64="Int64",e.double="Double"}(e.DataFieldType||(e.DataFieldType={})),function(e){e.generalException="GeneralException"}(e.TelemetryErrorCodes||(e.TelemetryErrorCodes={}))}(OfficeCore||(OfficeCore={})),function(e){var t=!1;function n(n){return new OfficeExtension.CoreUtility.Promise((function(o,i){if(OSF.WebAuth&&"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform){var a=!1;try{if(!Office||!Office.context||!Office.context.webAuth)return void i({code:"GetAuthContextAsyncMissing",message:"Office:["+!Office+"],Office.context:["+!Office.context+"],Office.context.webAuth:["+!Office.context.webAuth+"]"});Office.context.webAuth.getAuthContextAsync((function(s){if("succeeded"===s.status){a=!0;var c=s.value;if(!c||c.isAnonymous)return void i({code:"CannotGetAuthContext",message:c.Error});var l="msa"===c.authorityType.toLowerCase();if(OSF.WebAuth.config={authFlow:e.authFlow,authVersion:e.authVersion?e.authVersion:null,msal:"flight"===e.authVersion?e.msal:null,delayWebAuth:e.delay,delayMsal:e.delayMsal,debugging:e.debugging,authority:e.authorityOverride?e.authorityOverride:c.authority,idp:c.authorityType.toLowerCase(),appIds:[l&&c.msaAppId?c.msaAppId:c.appId],redirectUri:n||null,upn:c.upn,telemetryInstance:"otel",autoPopup:e.autoPopup,enableUpnCheck:e.upnCheck,enableConsoleLogging:e.debugging},OSF.WebAuth.load().then((function(e){r(e,t=!0),o()})).catch((function(e){r(e,t),i({code:"PackageNotLoaded",message:e instanceof Event?e.type:e})})),"implicit"===e.authFlow){var u=n||window.location.href.split("?")[0],p=sessionStorage.getItem("officeWebAuthReplyUrls");p||""===p?p=u:p+=", "+u,p&&sessionStorage.setItem("officeWebAuthReplyUrls",p)}}else OSF.WebAuth.config=null,i({code:"CannotGetAuthContext",message:s.status})}))}catch(e){OSF.WebAuth.config=null,OSF.WebAuth.load().then((function(){o()})).catch((function(){i({code:a?"CannotGetAuthContext":"FailedToLoad",message:e})}))}}else o()}))}function r(e,t){"undefined"!==typeof OTel&&OTel.OTelLogger.onTelemetryLoaded((function(){var n=[oteljs.makeStringDataField("IdentityProvider",OSF.WebAuth.config.idp),oteljs.makeStringDataField("AppId",OSF.WebAuth.config.appIds[0]),oteljs.makeStringDataField("Target",OSF.WebAuth.config.authFlow),oteljs.makeBooleanDataField("Result",t),oteljs.makeStringDataField("Error",e instanceof Event?e.type:"")];if(e&&!(e instanceof Event)&&e.Telemetry)for(var r in e.Telemetry)if(e.Telemetry[r])switch(r){case"succeeded":n.push(oteljs.makeBooleanDataField(r,e.Telemetry[r]));break;case"loadedApplicationCount":case"timeToLoad":n.push(oteljs.makeInt64DataField(r,e.Telemetry[r]));break;default:n.push(oteljs.makeStringDataField(r,e.Telemetry[r]))}OTel.OTelLogger.sendTelemetryEvent({eventName:"Office.Extensibility.OfficeJs.OfficeFirstPartyAuth.Load",dataFields:n,eventFlags:{dataCategories:oteljs.DataCategories.ProductServiceUsage}})}))}function o(e,t,n){"undefined"!==typeof OTel&&OTel.OTelLogger.onTelemetryLoaded((function(){var r=[oteljs.makeStringDataField("IdentityProvider",OSF.WebAuth.config.idp),oteljs.makeStringDataField("AppId",OSF.WebAuth.config.appIds[0]),oteljs.makeStringDataField("Target",OSF.WebAuth.config.authFlow),oteljs.makeBooleanDataField("Result",t),oteljs.makeStringDataField("Error",e instanceof Event?e.type:e.ErrorCode),oteljs.makeBooleanDataField("Popup","boolean"===typeof n&&n)];if(e&&!(e instanceof Event)&&e.Telemetry)for(var o in e.Telemetry)if(e.Telemetry[o])switch(o){case"succeeded":r.push(oteljs.makeBooleanDataField(o,e.Telemetry[o]));break;case"timeToGetToken":r.push(oteljs.makeInt64DataField(o,e.Telemetry[o]));break;default:r.push(oteljs.makeStringDataField(o,e.Telemetry[o]))}OTel.OTelLogger.sendTelemetryEvent({eventName:"Office.Extensibility.OfficeJs.OfficeFirstPartyAuth.GetAccessToken",dataFields:r,eventFlags:{dataCategories:oteljs.DataCategories.ProductServiceUsage}})}))}e.authFlow="authcode",e.autoPopup=!1,e.upnCheck=!0,e.msal="https://alcdn.msauth.net/browser/2.21.0/js/msal-browser.min.js",e.debugging=!1,e.delay=0,e.delayMsal=0,e.load=n,e.getAccessToken=function(e,n){return new OfficeExtension.CoreUtility.Promise((function(r,i){if("web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform)Office.context.webAuth.getAuthContextAsync((function(a){var s=!1;"succeeded"===a.status&&(a.value.supportsAuthToken&&(s=!0));if(s){var c=new OfficeCore.RequestContext,l=OfficeCore.AuthenticationService.newObject(c);c._customData="WacPartition";var u=l.getAccessToken(e,null);c.sync().then((function(){r(u.value)}))}else OSF.WebAuth&&t?OSF.WebAuth.config.appIds[0]&&OSF.WebAuth.getToken(e.resource,OSF.WebAuth.config.appIds[0],OSF._OfficeAppFactory.getHostInfo().osfControlAppCorrelationId,n&&n.popup?n.popup:null).then((function(e){o(e,!0,!(!n||!n.popup)&&n.popup),r({accessToken:e.Token,tokenIdenityType:"msa"==OSF.WebAuth.config.idp.toLowerCase()?OfficeCore.IdentityType.microsoftAccount:OfficeCore.IdentityType.organizationAccount})})).catch((function(e){o(e,!1,!(!n||!n.popup)&&n.popup),i({code:e.ErrorCode,message:e instanceof Event?e.type:e.ErrorMessage})})):function(e,t){"undefined"!==typeof OTel&&OTel.OTelLogger.onTelemetryLoaded((function(){var n=[oteljs.makeBooleanDataField("Loaded",e),oteljs.makeInt64DataField("LoadAttempts","number"===typeof t?t:0)];OTel.OTelLogger.sendTelemetryEvent({eventName:"Office.Extensibility.OfficeJs.OfficeFirstPartyAuth.UnexpectedAcquire",dataFields:n,eventFlags:{dataCategories:oteljs.DataCategories.ProductServiceUsage}})}))}(t,OSF.WebAuth.loadAttempts)}));else{var a=new OfficeCore.RequestContext,s=OfficeCore.AuthenticationService.newObject(a),c=s.onTokenReceived.add((function(e){if(!OfficeExtension.CoreUtility.isNullOrUndefined(e))if(c.remove(),a.sync().catch((function(){})),0==e.code)r(e.tokenValue);else if(OfficeExtension.CoreUtility.isNullOrUndefined(e.errorInfo))i({code:e.code});else try{i(JSON.parse(e.errorInfo))}catch(t){i({code:e.code,message:e.errorInfo})}return null}));a.sync().then((function(){var t=s.getAccessToken(e,s._targetId);return a.sync().then((function(){if(OfficeExtension.CoreUtility.isNullOrUndefined(t.value))return null;var e=t.value.accessToken;OfficeExtension.CoreUtility.isNullOrUndefined(e)||r(t.value)}))})).catch((function(e){i(e)}))}}))},e.getPrimaryIdentityInfo=function(){var e=new OfficeCore.RequestContext,t=OfficeCore.AuthenticationService.newObject(e);e._customData="WacPartition";var n=t.getPrimaryIdentityInfo();return e.sync().then((function(){return n.value}))},e.getIdentities=function(){var e=new OfficeCore.RequestContext,t=OfficeCore.AuthenticationService.newObject(e).getIdentities();return e.sync().then((function(){return t.value}))},"undefined"!==typeof window&&window.OSF&&function(){try{if("undefined"===typeof window||!window.sessionStorage)return;var e=sessionStorage.getItem("officeWebAuthReplyUrls");null!==e&&-1!==e.indexOf(window.location.origin+window.location.pathname)&&n()}catch(e){console.error(e)}}()}(OfficeFirstPartyAuth||(OfficeFirstPartyAuth={})),function(e){var t=OfficeExtension.BatchApiHelper.createPropertyObject,n=OfficeExtension.BatchApiHelper.createMethodObject,r=OfficeExtension.BatchApiHelper.createIndexerObject,o=(OfficeExtension.BatchApiHelper.createRootServiceObject,OfficeExtension.BatchApiHelper.createTopLevelServiceObject),i=OfficeExtension.BatchApiHelper.createChildItemObject,a=OfficeExtension.BatchApiHelper.invokeMethod,s=OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,c=OfficeExtension.BatchApiHelper.invokeSetProperty,l=OfficeExtension.Utility.isNullOrUndefined,u=OfficeExtension.Utility.isUndefined,p=OfficeExtension.Utility.throwIfNotLoaded,f=OfficeExtension.Utility.throwIfApiNotSupported,d=OfficeExtension.Utility.load,h=OfficeExtension.Utility.retrieve,m=OfficeExtension.Utility.toJson,g=OfficeExtension.Utility.fixObjectPathIfNecessary,y=OfficeExtension.Utility._handleNavigationPropertyResults,O=OfficeExtension.Utility.adjustToDateTime,_=OfficeExtension.Utility.processRetrieveResult,b=OfficeExtension.Utility.setMockData,v=OfficeExtension.CommonUtility.calculateApiFlags;!function(e){e.organizationAccount="OrganizationAccount",e.microsoftAccount="MicrosoftAccount",e.unsupported="Unsupported"}(e.IdentityType||(e.IdentityType={}));var S=function(n){function r(){return null!==n&&n.apply(this,arguments)||this}return __extends(r,n),Object.defineProperty(r.prototype,"_className",{get:function(){return"AuthenticationService"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["roamingSettings"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"roamingSettings",{get:function(){return this._R||(this._R=t(e.RoamingSettingCollection,this,"RoamingSettings",!1,4)),this._R},enumerable:!0,configurable:!0}),r.prototype.getAccessToken=function(e,t){return a(this,"GetAccessToken",1,[e,t],5,0)},r.prototype.getIdentities=function(){return f("AuthenticationService.getIdentities","FirstPartyAuthentication","1.3","Office"),a(this,"GetIdentities",1,[],5,0)},r.prototype.getPrimaryIdentityInfo=function(){return f("AuthenticationService.getPrimaryIdentityInfo","FirstPartyAuthentication","1.2","Office"),a(this,"GetPrimaryIdentityInfo",1,[],5,0)},r.prototype._handleResult=function(e){if(n.prototype._handleResult.call(this,e),!l(e)){var t=e;g(this,t),y(this,t,["roamingSettings","RoamingSettings"])}},r.prototype.load=function(e){return d(this,e)},r.prototype.retrieve=function(e){return h(this,e)},r.prototype._handleRetrieveResult=function(e,t){n.prototype._handleRetrieveResult.call(this,e,t),_(this,e,t)},r.newObject=function(t){return o(e.AuthenticationService,t,"Microsoft.Authentication.AuthenticationService",!1,4)},Object.defineProperty(r.prototype,"onTokenReceived",{get:function(){var e=this;return f("AuthenticationService.onTokenReceived","FirstPartyAuthentication","1.2","Office"),this.m_tokenReceived||(this.m_tokenReceived=new OfficeExtension.GenericEventHandlers(this.context,this,"TokenReceived",{eventType:3001,registerFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},unregisterFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},getTargetIdFunc:function(){return e._targetId},eventArgsTransformFunc:function(t){var n=A.AuthenticationService_TokenReceived_EventArgsTransform(e,t);return OfficeExtension.Utility._createPromiseFromResult(n)}})),this.m_tokenReceived},enumerable:!0,configurable:!0}),r.prototype.toJSON=function(){return m(this,{},{})},r}(OfficeExtension.ClientObject);e.AuthenticationService=S;var A,D=function(){function e(){}return Object.defineProperty(e.prototype,"_targetId",{get:function(){return void 0==this.m_targetId&&("undefined"!==typeof OSF&&OSF.OUtil?this.m_targetId=OSF.OUtil.Guid.generateNewGuid():this.m_targetId=""+this.context._nextId()),this.m_targetId},enumerable:!0,configurable:!0}),e}();e.AuthenticationServiceCustom=D,OfficeExtension.Utility.applyMixin(S,D),function(e){e.AuthenticationService_TokenReceived_EventArgsTransform=function(e,t){var n=t;return{tokenValue:n.tokenValue,code:n.code,errorInfo:n.errorInfo}}}(A=e._CC||(e._CC={}));var P=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"RoamingSetting"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["id","value"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Value"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyUpdateable",{get:function(){return[!1,!0]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"id",{get:function(){return p("id",this._I,"RoamingSetting",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"value",{get:function(){return p("value",this._V,"RoamingSetting",this._isNull),this._V},set:function(e){this._V=e,c(this,"Value",e,0)},enumerable:!0,configurable:!0}),t.prototype.set=function(e,t){this._recursivelySet(e,t,["value"],[],[])},t.prototype.update=function(e){this._recursivelyUpdate(e)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;g(this,n),u(n.Id)||(this._I=n.Id),u(n.Value)||(this._V=n.Value)}},t.prototype.load=function(e){return d(this,e)},t.prototype.retrieve=function(e){return h(this,e)},t.prototype._handleIdResult=function(t){e.prototype._handleIdResult.call(this,t),l(t)||u(t.Id)||(this._I=t.Id)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),_(this,t,n)},t.prototype.toJSON=function(){return m(this,{id:this._I,value:this._V},{})},t.prototype.setMockData=function(e){b(this,e)},t.prototype.ensureUnchanged=function(e){s(this,e)},t}(OfficeExtension.ClientObject);e.RoamingSetting=P;var I=function(t){function r(){return null!==t&&t.apply(this,arguments)||this}return __extends(r,t),Object.defineProperty(r.prototype,"_className",{get:function(){return"RoamingSettingCollection"},enumerable:!0,configurable:!0}),r.prototype.getItem=function(t){return n(e.RoamingSetting,this,"GetItem",1,[t],!1,!1,null,4)},r.prototype.getItemOrNullObject=function(t){return n(e.RoamingSetting,this,"GetItemOrNullObject",1,[t],!1,!1,null,4)},r.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||g(this,e)},r.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},r.prototype.toJSON=function(){return m(this,{},{})},r}(OfficeExtension.ClientObject);e.RoamingSettingCollection=I;var C=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"BeforeDocumentCloseNotification"},enumerable:!0,configurable:!0}),n.prototype.disable=function(){a(this,"Disable",1,[],4,0)},n.prototype.enable=function(){a(this,"Enable",1,[],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||g(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},n.newObject=function(t){return o(e.BeforeDocumentCloseNotification,t,"Microsoft.BeforeDocumentCloseNotification.BeforeDocumentCloseNotification",!1,4)},Object.defineProperty(n.prototype,"onBeforeCloseNotificationCancelled",{get:function(){return this.m_beforeCloseNotificationCancelled||(this.m_beforeCloseNotificationCancelled=new OfficeExtension.GenericEventHandlers(this.context,this,"BeforeCloseNotificationCancelled",{eventType:65540,registerFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},unregisterFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){return OfficeExtension.Utility._createPromiseFromResult({})}})),this.m_beforeCloseNotificationCancelled},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return m(this,{},{})},n}(OfficeExtension.ClientObject);e.BeforeDocumentCloseNotification=C,function(e){e.ariaBrowserPipeUrl="AriaBrowserPipeUrl",e.ariaUploadUrl="AriaUploadUrl",e.ariaVNextUploadUrl="AriaVNextUploadUrl",e.lokiAutoDiscoverUrl="LokiAutoDiscoverUrl"}(e.ServiceProvider||(e.ServiceProvider={}));var F=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"ServiceUrlProvider"},enumerable:!0,configurable:!0}),n.prototype.getServiceUrl=function(e,t){return a(this,"GetServiceUrl",1,[e,t],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||g(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},n.newObject=function(t){return o(e.ServiceUrlProvider,t,"Microsoft.DesktopCompliance.ServiceUrlProvider",!1,4)},n.prototype.toJSON=function(){return m(this,{},{})},n}(OfficeExtension.ClientObject);e.ServiceUrlProvider=F;var E=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"LinkedIn"},enumerable:!0,configurable:!0}),n.prototype.isEnabledForOffice=function(){return a(this,"IsEnabledForOffice",1,[],4,0)},n.prototype.recordLinkedInSettingsCompliance=function(e,t){a(this,"RecordLinkedInSettingsCompliance",0,[e,t],0,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||g(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},n.newObject=function(t){return o(e.LinkedIn,t,"Microsoft.DesktopCompliance.LinkedIn",!1,4)},n.prototype.toJSON=function(){return m(this,{},{})},n}(OfficeExtension.ClientObject);e.LinkedIn=E;var R=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"NetworkUsage"},enumerable:!0,configurable:!0}),n.prototype.isInDisconnectedMode=function(){return a(this,"IsInDisconnectedMode",1,[],4,0)},n.prototype.isInOnlineMode=function(){return a(this,"IsInOnlineMode",1,[],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||g(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},n.newObject=function(t){return o(e.NetworkUsage,t,"Microsoft.DesktopCompliance.NetworkUsage",!1,4)},n.prototype.toJSON=function(){return m(this,{},{})},n}(OfficeExtension.ClientObject);e.NetworkUsage=R;var N=function(r){function i(){return null!==r&&r.apply(this,arguments)||this}return __extends(i,r),Object.defineProperty(i.prototype,"_className",{get:function(){return"DynamicRibbon"},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"_navigationPropertyNames",{get:function(){return["buttons"]},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"buttons",{get:function(){return this._B||(this._B=t(e.RibbonButtonCollection,this,"Buttons",!0,4)),this._B},enumerable:!0,configurable:!0}),i.prototype.executeRequestCreate=function(e){f("DynamicRibbon.executeRequestCreate","DynamicRibbon","1.2","Office"),a(this,"ExecuteRequestCreate",1,[e],4,0)},i.prototype.executeRequestUpdate=function(e){a(this,"ExecuteRequestUpdate",1,[e],4,0)},i.prototype.getButton=function(t){return n(e.RibbonButton,this,"GetButton",1,[t],!1,!1,null,4)},i.prototype.getTab=function(t){return n(e.RibbonTab,this,"GetTab",1,[t],!1,!1,null,4)},i.prototype._handleResult=function(e){if(r.prototype._handleResult.call(this,e),!l(e)){var t=e;g(this,t),y(this,t,["buttons","Buttons"])}},i.prototype.load=function(e){return d(this,e)},i.prototype.retrieve=function(e){return h(this,e)},i.prototype._handleRetrieveResult=function(e,t){r.prototype._handleRetrieveResult.call(this,e,t),_(this,e,t)},i.newObject=function(t){return o(e.DynamicRibbon,t,"Microsoft.DynamicRibbon.DynamicRibbon",!1,4)},i.prototype.toJSON=function(){return m(this,{},{buttons:this._B})},i}(OfficeExtension.ClientObject);e.DynamicRibbon=N;var x=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"RibbonTab"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["id"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"id",{get:function(){return p("id",this._I,"RibbonTab",this._isNull),this._I},enumerable:!0,configurable:!0}),t.prototype.setVisibility=function(e){a(this,"SetVisibility",0,[e],0,0)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;g(this,n),u(n.Id)||(this._I=n.Id)}},t.prototype.load=function(e){return d(this,e)},t.prototype.retrieve=function(e){return h(this,e)},t.prototype._handleIdResult=function(t){e.prototype._handleIdResult.call(this,t),l(t)||u(t.Id)||(this._I=t.Id)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),_(this,t,n)},t.prototype.toJSON=function(){return m(this,{id:this._I},{})},t.prototype.setMockData=function(e){b(this,e)},t.prototype.ensureUnchanged=function(e){s(this,e)},t}(OfficeExtension.ClientObject);e.RibbonTab=x;var M=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"RibbonButton"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["id","enabled","label"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Enabled","Label"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyUpdateable",{get:function(){return[!1,!0,!1]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"enabled",{get:function(){return p("enabled",this._E,"RibbonButton",this._isNull),this._E},set:function(e){this._E=e,c(this,"Enabled",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"id",{get:function(){return p("id",this._I,"RibbonButton",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"label",{get:function(){return p("label",this._L,"RibbonButton",this._isNull),this._L},enumerable:!0,configurable:!0}),t.prototype.set=function(e,t){this._recursivelySet(e,t,["enabled"],[],[])},t.prototype.update=function(e){this._recursivelyUpdate(e)},t.prototype.setEnabled=function(e){a(this,"SetEnabled",0,[e],0,0)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;g(this,n),u(n.Enabled)||(this._E=n.Enabled),u(n.Id)||(this._I=n.Id),u(n.Label)||(this._L=n.Label)}},t.prototype.load=function(e){return d(this,e)},t.prototype.retrieve=function(e){return h(this,e)},t.prototype._handleIdResult=function(t){e.prototype._handleIdResult.call(this,t),l(t)||u(t.Id)||(this._I=t.Id)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),_(this,t,n)},t.prototype.toJSON=function(){return m(this,{enabled:this._E,id:this._I,label:this._L},{})},t.prototype.setMockData=function(e){b(this,e)},t.prototype.ensureUnchanged=function(e){s(this,e)},t}(OfficeExtension.ClientObject);e.RibbonButton=M;var T=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"RibbonButtonCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"items",{get:function(){return p("items",this.m__items,"RibbonButtonCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),n.prototype.getCount=function(){return a(this,"GetCount",1,[],4,0)},n.prototype.getItem=function(t){return r(e.RibbonButton,this,[t])},n.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!l(n)){var r=n;if(g(this,r),!l(r[OfficeExtension.Constants.items])){this.m__items=[];for(var o=r[OfficeExtension.Constants.items],a=0;a<o.length;a++){var s=i(e.RibbonButton,!0,this,o[a],a);s._handleResult(o[a]),this.m__items.push(s)}}}},n.prototype.load=function(e){return d(this,e)},n.prototype.retrieve=function(e){return h(this,e)},n.prototype._handleRetrieveResult=function(n,r){var o=this;t.prototype._handleRetrieveResult.call(this,n,r),_(this,n,r,(function(t,n){return i(e.RibbonButton,!0,o,t,n)}))},n.prototype.toJSON=function(){return m(this,{},{},this.m__items)},n.prototype.setMockData=function(t){var n=this;b(this,t,(function(t,r){return i(e.RibbonButton,!0,n,t,r)}),(function(e){return n.m__items=e}))},n}(OfficeExtension.ClientObject);e.RibbonButtonCollection=T;var j=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"FirstPartyDialogService"},enumerable:!0,configurable:!0}),n.prototype.close=function(){a(this,"Close",1,[],5,0)},n.prototype.displayDialog=function(e,t){a(this,"DisplayDialog",1,[e,t],5,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||g(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},n.newObject=function(t){return o(e.FirstPartyDialogService,t,"Microsoft.FirstPartyDialog.FirstPartyDialogService",!1,4)},Object.defineProperty(n.prototype,"onDialogMessage",{get:function(){var e=this;return this.m_dialogMessage||(this.m_dialogMessage=new OfficeExtension.GenericEventHandlers(this.context,this,"DialogMessage",{eventType:65536,registerFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},unregisterFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(t){var n=A.FirstPartyDialogService_DialogMessage_EventArgsTransform(e,t);return OfficeExtension.Utility._createPromiseFromResult(n)}})),this.m_dialogMessage},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return m(this,{},{})},n}(OfficeExtension.ClientObject);e.FirstPartyDialogService=j,function(e){e.FirstPartyDialogService_DialogMessage_EventArgsTransform=function(e,t){return{message:t.message}}}(A=e._CC||(e._CC={})),function(e){e.shortTime="ShortTime",e.longTime="LongTime",e.shortDate="ShortDate",e.longDate="LongDate"}(e.TimeStringFormat||(e.TimeStringFormat={}));var w=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"LocaleApi"},enumerable:!0,configurable:!0}),n.prototype.formatDateTimeString=function(e,t,n){return a(this,"FormatDateTimeString",1,[e,t,n],4,0)},n.prototype.getLocaleDateTimeFormattingInfo=function(e){return a(this,"GetLocaleDateTimeFormattingInfo",1,[e],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||g(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},n.newObject=function(t){return o(e.LocaleApi,t,"Microsoft.LocaleApi.LocaleApi",!1,4)},n.prototype.toJSON=function(){return m(this,{},{})},n}(OfficeExtension.ClientObject);e.LocaleApi=w;var k=function(r){function o(){return null!==r&&r.apply(this,arguments)||this}return __extends(o,r),Object.defineProperty(o.prototype,"_className",{get:function(){return"Comment"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyNames",{get:function(){return["id","text","created","level","resolved","author","mentions"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Text","Created","Level","Resolved","Author","Mentions"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyUpdateable",{get:function(){return[!1,!0,!1,!1,!0,!1,!1]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_navigationPropertyNames",{get:function(){return["parent","parentOrNullObject","replies"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"parent",{get:function(){return this._P||(this._P=t(e.Comment,this,"Parent",!1,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"parentOrNullObject",{get:function(){return this._Pa||(this._Pa=t(e.Comment,this,"ParentOrNullObject",!1,4)),this._Pa},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"replies",{get:function(){return this._R||(this._R=t(e.CommentCollection,this,"Replies",!0,4)),this._R},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"author",{get:function(){return p("author",this._A,"Comment",this._isNull),this._A},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"created",{get:function(){return p("created",this._C,"Comment",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"id",{get:function(){return p("id",this._I,"Comment",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"level",{get:function(){return p("level",this._L,"Comment",this._isNull),this._L},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"mentions",{get:function(){return p("mentions",this._M,"Comment",this._isNull),this._M},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"resolved",{get:function(){return p("resolved",this._Re,"Comment",this._isNull),this._Re},set:function(e){this._Re=e,c(this,"Resolved",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"text",{get:function(){return p("text",this._T,"Comment",this._isNull),this._T},set:function(e){this._T=e,c(this,"Text",e,0)},enumerable:!0,configurable:!0}),o.prototype.set=function(e,t){this._recursivelySet(e,t,["text","resolved"],[],["parent","parentOrNullObject","replies"])},o.prototype.update=function(e){this._recursivelyUpdate(e)},o.prototype.delete=function(){a(this,"Delete",0,[],0,0)},o.prototype.getParentOrSelf=function(){return n(e.Comment,this,"GetParentOrSelf",1,[],!1,!1,null,4)},o.prototype.getRichText=function(e){return a(this,"GetRichText",1,[e],4,0)},o.prototype.reply=function(t,r){return n(e.Comment,this,"Reply",0,[t,r],!1,!1,null,0)},o.prototype.setRichText=function(e,t){return a(this,"SetRichText",0,[e,t],0,0)},o.prototype._handleResult=function(e){if(r.prototype._handleResult.call(this,e),!l(e)){var t=e;g(this,t),u(t.Author)||(this._A=t.Author),u(t.Created)||(this._C=O(t.Created)),u(t.Id)||(this._I=t.Id),u(t.Level)||(this._L=t.Level),u(t.Mentions)||(this._M=t.Mentions),u(t.Resolved)||(this._Re=t.Resolved),u(t.Text)||(this._T=t.Text),y(this,t,["parent","Parent","parentOrNullObject","ParentOrNullObject","replies","Replies"])}},o.prototype.load=function(e){return d(this,e)},o.prototype.retrieve=function(e){return h(this,e)},o.prototype._handleIdResult=function(e){r.prototype._handleIdResult.call(this,e),l(e)||u(e.Id)||(this._I=e.Id)},o.prototype._handleRetrieveResult=function(e,t){if(r.prototype._handleRetrieveResult.call(this,e,t),!l(e)){var n=e;u(n.Created)||(n.created=O(n.created)),_(this,e,t)}},o.prototype.toJSON=function(){return m(this,{author:this._A,created:this._C,id:this._I,level:this._L,mentions:this._M,resolved:this._Re,text:this._T},{replies:this._R})},o.prototype.setMockData=function(e){b(this,e)},o.prototype.ensureUnchanged=function(e){s(this,e)},o}(OfficeExtension.ClientObject);e.Comment=k;var U=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"CommentCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"items",{get:function(){return p("items",this.m__items,"CommentCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),n.prototype.getCount=function(){return a(this,"GetCount",1,[],4,0)},n.prototype.getItem=function(t){return r(e.Comment,this,[t])},n.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!l(n)){var r=n;if(g(this,r),!l(r[OfficeExtension.Constants.items])){this.m__items=[];for(var o=r[OfficeExtension.Constants.items],a=0;a<o.length;a++){var s=i(e.Comment,!0,this,o[a],a);s._handleResult(o[a]),this.m__items.push(s)}}}},n.prototype.load=function(e){return d(this,e)},n.prototype.retrieve=function(e){return h(this,e)},n.prototype._handleRetrieveResult=function(n,r){var o=this;t.prototype._handleRetrieveResult.call(this,n,r),_(this,n,r,(function(t,n){return i(e.Comment,!0,o,t,n)}))},n.prototype.toJSON=function(){return m(this,{},{},this.m__items)},n.prototype.setMockData=function(t){var n=this;b(this,t,(function(t,r){return i(e.Comment,!0,n,t,r)}),(function(e){return n.m__items=e}))},n}(OfficeExtension.ClientObject);e.CommentCollection=U;var L=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"ExtensionLifeCycle"},enumerable:!0,configurable:!0}),n.prototype.launchExtensionComponent=function(e,t,n){a(this,"LaunchExtensionComponent",1,[e,t,n],5,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||g(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},n.newObject=function(t){return o(e.ExtensionLifeCycle,t,"Microsoft.OfficeSharedApi.ExtensionLifeCycle",!1,4)},n.prototype.toJSON=function(){return m(this,{},{})},n}(OfficeExtension.ClientObject);e.ExtensionLifeCycle=L,function(e){e.plain="Plain",e.markdown="Markdown",e.delta="Delta"}(e.CommentTextFormat||(e.CommentTextFormat={})),function(e){e.placeHolderRendered="PlaceHolderRendered",e.initialCardRendered="InitialCardRendered"}(e.PersonaCardPerfPoint||(e.PersonaCardPerfPoint={})),function(e){e.notSet="NotSet",e.free="Free",e.idle="Idle",e.busy="Busy",e.idleBusy="IdleBusy",e.doNotDisturb="DoNotDisturb",e.unalertable="Unalertable",e.unavailable="Unavailable"}(e.UnifiedCommunicationAvailability||(e.UnifiedCommunicationAvailability={})),function(e){e.online="Online",e.notOnline="NotOnline",e.away="Away",e.busy="Busy",e.beRightBack="BeRightBack",e.onThePhone="OnThePhone",e.outToLunch="OutToLunch",e.inAMeeting="InAMeeting",e.outOfOffice="OutOfOffice",e.doNotDisturb="DoNotDisturb",e.inAConference="InAConference",e.getting="Getting",e.notABuddy="NotABuddy",e.disconnected="Disconnected",e.notInstalled="NotInstalled",e.urgentInterruptionsOnly="UrgentInterruptionsOnly",e.mayBeAvailable="MayBeAvailable",e.idle="Idle",e.inPresentation="InPresentation"}(e.UnifiedCommunicationStatus||(e.UnifiedCommunicationStatus={})),function(e){e.free="Free",e.busy="Busy",e.idle="Idle",e.doNotDistrub="DoNotDistrub",e.blocked="Blocked",e.notSet="NotSet",e.outOfOffice="OutOfOffice"}(e.UnifiedCommunicationPresence||(e.UnifiedCommunicationPresence={})),function(e){e.unknown="Unknown",e.free="Free",e.busy="Busy",e.elsewhere="Elsewhere",e.tentative="Tentative",e.outOfOffice="OutOfOffice"}(e.FreeBusyCalendarState||(e.FreeBusyCalendarState={})),function(e){e.unknown="Unknown",e.enterprise="Enterprise",e.contact="Contact",e.bot="Bot",e.phoneOnly="PhoneOnly",e.oneOff="OneOff",e.distributionList="DistributionList",e.personalDistributionList="PersonalDistributionList",e.anonymous="Anonymous",e.unifiedGroup="UnifiedGroup"}(e.PersonaType||(e.PersonaType={})),function(e){e.workPhone="WorkPhone",e.homePhone="HomePhone",e.mobilePhone="MobilePhone",e.businessFax="BusinessFax",e.otherPhone="OtherPhone"}(e.PhoneType||(e.PhoneType={})),function(e){e.workAddress="WorkAddress",e.homeAddress="HomeAddress",e.otherAddress="OtherAddress"}(e.AddressType||(e.AddressType={})),function(e){e.unknown="Unknown",e.individual="Individual",e.group="Group"}(e.MemberType||(e.MemberType={}));var H,W=function(t){function r(){return null!==t&&t.apply(this,arguments)||this}return __extends(r,t),Object.defineProperty(r.prototype,"_className",{get:function(){return"MemberInfoList"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["isWarmedUp","isWarmingUp"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["IsWarmedUp","IsWarmingUp"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"isWarmedUp",{get:function(){return p("isWarmedUp",this._I,"MemberInfoList",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"isWarmingUp",{get:function(){return p("isWarmingUp",this._Is,"MemberInfoList",this._isNull),this._Is},enumerable:!0,configurable:!0}),r.prototype.getPersonaForMember=function(t){return n(e.Persona,this,"GetPersonaForMember",1,[t],!1,!1,null,4)},r.prototype.items=function(){return a(this,"Items",1,[],4,0)},r.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!l(e)){var n=e;g(this,n),u(n.IsWarmedUp)||(this._I=n.IsWarmedUp),u(n.IsWarmingUp)||(this._Is=n.IsWarmingUp)}},r.prototype.load=function(e){return d(this,e)},r.prototype.retrieve=function(e){return h(this,e)},r.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},r.prototype.toJSON=function(){return m(this,{isWarmedUp:this._I,isWarmingUp:this._Is},{})},r.prototype.setMockData=function(e){b(this,e)},r.prototype.ensureUnchanged=function(e){s(this,e)},r}(OfficeExtension.ClientObject);e.MemberInfoList=W,function(e){e.hostId="HostId",e.type="Type",e.photo="Photo",e.personaInfo="PersonaInfo",e.unifiedCommunicationInfo="UnifiedCommunicationInfo",e.organization="Organization",e.unifiedGroupInfo="UnifiedGroupInfo",e.members="Members",e.membership="Membership",e.capabilities="Capabilities",e.customizations="Customizations",e.viewableSources="ViewableSources",e.placeholder="Placeholder"}(H=e.PersonaDataUpdated||(e.PersonaDataUpdated={}));var B=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"PersonaActions"},enumerable:!0,configurable:!0}),t.prototype.addContact=function(){a(this,"AddContact",0,[],0,0)},t.prototype.callPhoneNumber=function(e){a(this,"CallPhoneNumber",0,[e],0,0)},t.prototype.composeEmail=function(e){a(this,"ComposeEmail",0,[e],0,0)},t.prototype.composeInstantMessage=function(e){a(this,"ComposeInstantMessage",0,[e],0,0)},t.prototype.editContact=function(){a(this,"EditContact",0,[],0,0)},t.prototype.editContactByIdentifier=function(e){a(this,"EditContactByIdentifier",0,[e],0,0)},t.prototype.editUnifiedGroup=function(){a(this,"EditUnifiedGroup",0,[],0,0)},t.prototype.getChangePhotoUrlAndOpenInBrowser=function(){a(this,"GetChangePhotoUrlAndOpenInBrowser",0,[],0,0)},t.prototype.hideHoverCardForPersona=function(){a(this,"HideHoverCardForPersona",0,[],0,0)},t.prototype.joinUnifiedGroup=function(){a(this,"JoinUnifiedGroup",0,[],0,0)},t.prototype.leaveUnifiedGroup=function(){a(this,"LeaveUnifiedGroup",0,[],0,0)},t.prototype.openGroupCalendar=function(){a(this,"OpenGroupCalendar",0,[],0,0)},t.prototype.openLinkContactUx=function(){a(this,"OpenLinkContactUx",0,[],0,0)},t.prototype.openOutlookProperties=function(){a(this,"OpenOutlookProperties",0,[],0,0)},t.prototype.pinPersonaToQuickContacts=function(){a(this,"PinPersonaToQuickContacts",0,[],0,0)},t.prototype.scheduleMeeting=function(){a(this,"ScheduleMeeting",0,[],0,0)},t.prototype.showContactCard=function(e,t,n,r,o,i){a(this,"ShowContactCard",0,[e,t,n,r,o,i],0,0)},t.prototype.showContextMenu=function(e,t,n,r,o,i){a(this,"ShowContextMenu",0,[e,t,n,r,o,i],0,0)},t.prototype.showExpandedCard=function(e,t,n,r,o,i){a(this,"ShowExpandedCard",0,[e,t,n,r,o,i],0,0)},t.prototype.showHoverCardForPersona=function(e,t,n,r,o,i){a(this,"ShowHoverCardForPersona",0,[e,t,n,r,o,i],0,0)},t.prototype.startAudioCall=function(){a(this,"StartAudioCall",0,[],0,0)},t.prototype.startVideoCall=function(){a(this,"StartVideoCall",0,[],0,0)},t.prototype.subscribeToGroup=function(){a(this,"SubscribeToGroup",0,[],0,0)},t.prototype.toggleTagForAlerts=function(){a(this,"ToggleTagForAlerts",0,[],0,0)},t.prototype.unsubscribeFromGroup=function(){a(this,"UnsubscribeFromGroup",0,[],0,0)},t.prototype._handleResult=function(t){(e.prototype._handleResult.call(this,t),l(t))||g(this,t)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),_(this,t,n)},t.prototype.toJSON=function(){return m(this,{},{})},t}(OfficeExtension.ClientObject);e.PersonaActions=B;var G=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"PersonaInfoSource"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["displayName","email","emailAddresses","sipAddresses","birthday","birthdays","title","jobInfoDepartment","companyName","office","linkedTitles","linkedDepartments","linkedCompanyNames","linkedOffices","phones","addresses","webSites","notes"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["DisplayName","Email","EmailAddresses","SipAddresses","Birthday","Birthdays","Title","JobInfoDepartment","CompanyName","Office","LinkedTitles","LinkedDepartments","LinkedCompanyNames","LinkedOffices","Phones","Addresses","WebSites","Notes"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"addresses",{get:function(){return p("addresses",this._A,"PersonaInfoSource",this._isNull),this._A},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"birthday",{get:function(){return p("birthday",this._B,"PersonaInfoSource",this._isNull),this._B},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"birthdays",{get:function(){return p("birthdays",this._Bi,"PersonaInfoSource",this._isNull),this._Bi},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"companyName",{get:function(){return p("companyName",this._C,"PersonaInfoSource",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"displayName",{get:function(){return p("displayName",this._D,"PersonaInfoSource",this._isNull),this._D},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"email",{get:function(){return p("email",this._E,"PersonaInfoSource",this._isNull),this._E},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"emailAddresses",{get:function(){return p("emailAddresses",this._Em,"PersonaInfoSource",this._isNull),this._Em},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"jobInfoDepartment",{get:function(){return p("jobInfoDepartment",this._J,"PersonaInfoSource",this._isNull),this._J},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"linkedCompanyNames",{get:function(){return p("linkedCompanyNames",this._L,"PersonaInfoSource",this._isNull),this._L},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"linkedDepartments",{get:function(){return p("linkedDepartments",this._Li,"PersonaInfoSource",this._isNull),this._Li},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"linkedOffices",{get:function(){return p("linkedOffices",this._Lin,"PersonaInfoSource",this._isNull),this._Lin},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"linkedTitles",{get:function(){return p("linkedTitles",this._Link,"PersonaInfoSource",this._isNull),this._Link},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"notes",{get:function(){return p("notes",this._N,"PersonaInfoSource",this._isNull),this._N},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"office",{get:function(){return p("office",this._O,"PersonaInfoSource",this._isNull),this._O},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"phones",{get:function(){return p("phones",this._P,"PersonaInfoSource",this._isNull),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"sipAddresses",{get:function(){return p("sipAddresses",this._S,"PersonaInfoSource",this._isNull),this._S},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"title",{get:function(){return p("title",this._T,"PersonaInfoSource",this._isNull),this._T},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"webSites",{get:function(){return p("webSites",this._W,"PersonaInfoSource",this._isNull),this._W},enumerable:!0,configurable:!0}),t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;g(this,n),u(n.Addresses)||(this._A=n.Addresses),u(n.Birthday)||(this._B=n.Birthday),u(n.Birthdays)||(this._Bi=n.Birthdays),u(n.CompanyName)||(this._C=n.CompanyName),u(n.DisplayName)||(this._D=n.DisplayName),u(n.Email)||(this._E=n.Email),u(n.EmailAddresses)||(this._Em=n.EmailAddresses),u(n.JobInfoDepartment)||(this._J=n.JobInfoDepartment),u(n.LinkedCompanyNames)||(this._L=n.LinkedCompanyNames),u(n.LinkedDepartments)||(this._Li=n.LinkedDepartments),u(n.LinkedOffices)||(this._Lin=n.LinkedOffices),u(n.LinkedTitles)||(this._Link=n.LinkedTitles),u(n.Notes)||(this._N=n.Notes),u(n.Office)||(this._O=n.Office),u(n.Phones)||(this._P=n.Phones),u(n.SipAddresses)||(this._S=n.SipAddresses),u(n.Title)||(this._T=n.Title),u(n.WebSites)||(this._W=n.WebSites)}},t.prototype.load=function(e){return d(this,e)},t.prototype.retrieve=function(e){return h(this,e)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),_(this,t,n)},t.prototype.toJSON=function(){return m(this,{addresses:this._A,birthday:this._B,birthdays:this._Bi,companyName:this._C,displayName:this._D,email:this._E,emailAddresses:this._Em,jobInfoDepartment:this._J,linkedCompanyNames:this._L,linkedDepartments:this._Li,linkedOffices:this._Lin,linkedTitles:this._Link,notes:this._N,office:this._O,phones:this._P,sipAddresses:this._S,title:this._T,webSites:this._W},{})},t.prototype.setMockData=function(e){b(this,e)},t.prototype.ensureUnchanged=function(e){s(this,e)},t}(OfficeExtension.ClientObject);e.PersonaInfoSource=G;var V=function(n){function r(){return null!==n&&n.apply(this,arguments)||this}return __extends(r,n),Object.defineProperty(r.prototype,"_className",{get:function(){return"PersonaInfo"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["displayName","email","emailAddresses","sipAddresses","birthday","birthdays","title","jobInfoDepartment","companyName","office","linkedTitles","linkedDepartments","linkedCompanyNames","linkedOffices","webSites","notes","isPersonResolved"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["DisplayName","Email","EmailAddresses","SipAddresses","Birthday","Birthdays","Title","JobInfoDepartment","CompanyName","Office","LinkedTitles","LinkedDepartments","LinkedCompanyNames","LinkedOffices","WebSites","Notes","IsPersonResolved"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["sources"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"sources",{get:function(){return this._So||(this._So=t(e.PersonaInfoSource,this,"Sources",!1,4)),this._So},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"birthday",{get:function(){return p("birthday",this._B,"PersonaInfo",this._isNull),this._B},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"birthdays",{get:function(){return p("birthdays",this._Bi,"PersonaInfo",this._isNull),this._Bi},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"companyName",{get:function(){return p("companyName",this._C,"PersonaInfo",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"displayName",{get:function(){return p("displayName",this._D,"PersonaInfo",this._isNull),this._D},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"email",{get:function(){return p("email",this._E,"PersonaInfo",this._isNull),this._E},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"emailAddresses",{get:function(){return p("emailAddresses",this._Em,"PersonaInfo",this._isNull),this._Em},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"isPersonResolved",{get:function(){return p("isPersonResolved",this._I,"PersonaInfo",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"jobInfoDepartment",{get:function(){return p("jobInfoDepartment",this._J,"PersonaInfo",this._isNull),this._J},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"linkedCompanyNames",{get:function(){return p("linkedCompanyNames",this._L,"PersonaInfo",this._isNull),this._L},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"linkedDepartments",{get:function(){return p("linkedDepartments",this._Li,"PersonaInfo",this._isNull),this._Li},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"linkedOffices",{get:function(){return p("linkedOffices",this._Lin,"PersonaInfo",this._isNull),this._Lin},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"linkedTitles",{get:function(){return p("linkedTitles",this._Link,"PersonaInfo",this._isNull),this._Link},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"notes",{get:function(){return p("notes",this._N,"PersonaInfo",this._isNull),this._N},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"office",{get:function(){return p("office",this._O,"PersonaInfo",this._isNull),this._O},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"sipAddresses",{get:function(){return p("sipAddresses",this._S,"PersonaInfo",this._isNull),this._S},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"title",{get:function(){return p("title",this._T,"PersonaInfo",this._isNull),this._T},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"webSites",{get:function(){return p("webSites",this._W,"PersonaInfo",this._isNull),this._W},enumerable:!0,configurable:!0}),r.prototype.getAddresses=function(){return a(this,"GetAddresses",1,[],4,0)},r.prototype.getPhones=function(){return a(this,"GetPhones",1,[],4,0)},r.prototype._handleResult=function(e){if(n.prototype._handleResult.call(this,e),!l(e)){var t=e;g(this,t),u(t.Birthday)||(this._B=O(t.Birthday)),u(t.Birthdays)||(this._Bi=O(t.Birthdays)),u(t.CompanyName)||(this._C=t.CompanyName),u(t.DisplayName)||(this._D=t.DisplayName),u(t.Email)||(this._E=t.Email),u(t.EmailAddresses)||(this._Em=t.EmailAddresses),u(t.IsPersonResolved)||(this._I=t.IsPersonResolved),u(t.JobInfoDepartment)||(this._J=t.JobInfoDepartment),u(t.LinkedCompanyNames)||(this._L=t.LinkedCompanyNames),u(t.LinkedDepartments)||(this._Li=t.LinkedDepartments),u(t.LinkedOffices)||(this._Lin=t.LinkedOffices),u(t.LinkedTitles)||(this._Link=t.LinkedTitles),u(t.Notes)||(this._N=t.Notes),u(t.Office)||(this._O=t.Office),u(t.SipAddresses)||(this._S=t.SipAddresses),u(t.Title)||(this._T=t.Title),u(t.WebSites)||(this._W=t.WebSites),y(this,t,["sources","Sources"])}},r.prototype.load=function(e){return d(this,e)},r.prototype.retrieve=function(e){return h(this,e)},r.prototype._handleRetrieveResult=function(e,t){if(n.prototype._handleRetrieveResult.call(this,e,t),!l(e)){var r=e;u(r.Birthday)||(r.birthday=O(r.birthday)),u(r.Birthdays)||(r.birthdays=O(r.birthdays)),_(this,e,t)}},r.prototype.toJSON=function(){return m(this,{birthday:this._B,birthdays:this._Bi,companyName:this._C,displayName:this._D,email:this._E,emailAddresses:this._Em,isPersonResolved:this._I,jobInfoDepartment:this._J,linkedCompanyNames:this._L,linkedDepartments:this._Li,linkedOffices:this._Lin,linkedTitles:this._Link,notes:this._N,office:this._O,sipAddresses:this._S,title:this._T,webSites:this._W},{sources:this._So})},r.prototype.setMockData=function(e){b(this,e)},r.prototype.ensureUnchanged=function(e){s(this,e)},r}(OfficeExtension.ClientObject);e.PersonaInfo=V;var q=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"PersonaUnifiedCommunicationInfo"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["availability","status","isSelf","isTagged","customStatusString","isBlocked","presenceTooltip","isOutOfOffice","outOfOfficeNote","timezone","meetingLocation","meetingSubject","timezoneBias","idleStartTime","overallCapability","isOnBuddyList","presenceNote","voiceMailUri","availabilityText","availabilityTooltip","isDurationInAvailabilityText","freeBusyStatus","calendarState","presence"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Availability","Status","IsSelf","IsTagged","CustomStatusString","IsBlocked","PresenceTooltip","IsOutOfOffice","OutOfOfficeNote","Timezone","MeetingLocation","MeetingSubject","TimezoneBias","IdleStartTime","OverallCapability","IsOnBuddyList","PresenceNote","VoiceMailUri","AvailabilityText","AvailabilityTooltip","IsDurationInAvailabilityText","FreeBusyStatus","CalendarState","Presence"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"availability",{get:function(){return p("availability",this._A,"PersonaUnifiedCommunicationInfo",this._isNull),this._A},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"availabilityText",{get:function(){return p("availabilityText",this._Av,"PersonaUnifiedCommunicationInfo",this._isNull),this._Av},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"availabilityTooltip",{get:function(){return p("availabilityTooltip",this._Ava,"PersonaUnifiedCommunicationInfo",this._isNull),this._Ava},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"calendarState",{get:function(){return p("calendarState",this._C,"PersonaUnifiedCommunicationInfo",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"customStatusString",{get:function(){return p("customStatusString",this._Cu,"PersonaUnifiedCommunicationInfo",this._isNull),this._Cu},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"freeBusyStatus",{get:function(){return p("freeBusyStatus",this._F,"PersonaUnifiedCommunicationInfo",this._isNull),this._F},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"idleStartTime",{get:function(){return p("idleStartTime",this._I,"PersonaUnifiedCommunicationInfo",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isBlocked",{get:function(){return p("isBlocked",this._Is,"PersonaUnifiedCommunicationInfo",this._isNull),this._Is},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isDurationInAvailabilityText",{get:function(){return p("isDurationInAvailabilityText",this._IsD,"PersonaUnifiedCommunicationInfo",this._isNull),this._IsD},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isOnBuddyList",{get:function(){return p("isOnBuddyList",this._IsO,"PersonaUnifiedCommunicationInfo",this._isNull),this._IsO},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isOutOfOffice",{get:function(){return p("isOutOfOffice",this._IsOu,"PersonaUnifiedCommunicationInfo",this._isNull),this._IsOu},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isSelf",{get:function(){return p("isSelf",this._IsS,"PersonaUnifiedCommunicationInfo",this._isNull),this._IsS},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isTagged",{get:function(){return p("isTagged",this._IsT,"PersonaUnifiedCommunicationInfo",this._isNull),this._IsT},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"meetingLocation",{get:function(){return p("meetingLocation",this._M,"PersonaUnifiedCommunicationInfo",this._isNull),this._M},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"meetingSubject",{get:function(){return p("meetingSubject",this._Me,"PersonaUnifiedCommunicationInfo",this._isNull),this._Me},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"outOfOfficeNote",{get:function(){return p("outOfOfficeNote",this._O,"PersonaUnifiedCommunicationInfo",this._isNull),this._O},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"overallCapability",{get:function(){return p("overallCapability",this._Ov,"PersonaUnifiedCommunicationInfo",this._isNull),this._Ov},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"presence",{get:function(){return p("presence",this._P,"PersonaUnifiedCommunicationInfo",this._isNull),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"presenceNote",{get:function(){return p("presenceNote",this._Pr,"PersonaUnifiedCommunicationInfo",this._isNull),this._Pr},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"presenceTooltip",{get:function(){return p("presenceTooltip",this._Pre,"PersonaUnifiedCommunicationInfo",this._isNull),this._Pre},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"status",{get:function(){return p("status",this._S,"PersonaUnifiedCommunicationInfo",this._isNull),this._S},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"timezone",{get:function(){return p("timezone",this._T,"PersonaUnifiedCommunicationInfo",this._isNull),this._T},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"timezoneBias",{get:function(){return p("timezoneBias",this._Ti,"PersonaUnifiedCommunicationInfo",this._isNull),this._Ti},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"voiceMailUri",{get:function(){return p("voiceMailUri",this._V,"PersonaUnifiedCommunicationInfo",this._isNull),this._V},enumerable:!0,configurable:!0}),t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;g(this,n),u(n.Availability)||(this._A=n.Availability),u(n.AvailabilityText)||(this._Av=n.AvailabilityText),u(n.AvailabilityTooltip)||(this._Ava=n.AvailabilityTooltip),u(n.CalendarState)||(this._C=n.CalendarState),u(n.CustomStatusString)||(this._Cu=n.CustomStatusString),u(n.FreeBusyStatus)||(this._F=n.FreeBusyStatus),u(n.IdleStartTime)||(this._I=O(n.IdleStartTime)),u(n.IsBlocked)||(this._Is=n.IsBlocked),u(n.IsDurationInAvailabilityText)||(this._IsD=n.IsDurationInAvailabilityText),u(n.IsOnBuddyList)||(this._IsO=n.IsOnBuddyList),u(n.IsOutOfOffice)||(this._IsOu=n.IsOutOfOffice),u(n.IsSelf)||(this._IsS=n.IsSelf),u(n.IsTagged)||(this._IsT=n.IsTagged),u(n.MeetingLocation)||(this._M=n.MeetingLocation),u(n.MeetingSubject)||(this._Me=n.MeetingSubject),u(n.OutOfOfficeNote)||(this._O=n.OutOfOfficeNote),u(n.OverallCapability)||(this._Ov=n.OverallCapability),u(n.Presence)||(this._P=n.Presence),u(n.PresenceNote)||(this._Pr=n.PresenceNote),u(n.PresenceTooltip)||(this._Pre=n.PresenceTooltip),u(n.Status)||(this._S=n.Status),u(n.Timezone)||(this._T=n.Timezone),u(n.TimezoneBias)||(this._Ti=n.TimezoneBias),u(n.VoiceMailUri)||(this._V=n.VoiceMailUri)}},t.prototype.load=function(e){return d(this,e)},t.prototype.retrieve=function(e){return h(this,e)},t.prototype._handleRetrieveResult=function(t,n){if(e.prototype._handleRetrieveResult.call(this,t,n),!l(t)){var r=t;u(r.IdleStartTime)||(r.idleStartTime=O(r.idleStartTime)),_(this,t,n)}},t.prototype.toJSON=function(){return m(this,{availability:this._A,availabilityText:this._Av,availabilityTooltip:this._Ava,calendarState:this._C,customStatusString:this._Cu,freeBusyStatus:this._F,idleStartTime:this._I,isBlocked:this._Is,isDurationInAvailabilityText:this._IsD,isOnBuddyList:this._IsO,isOutOfOffice:this._IsOu,isSelf:this._IsS,isTagged:this._IsT,meetingLocation:this._M,meetingSubject:this._Me,outOfOfficeNote:this._O,overallCapability:this._Ov,presence:this._P,presenceNote:this._Pr,presenceTooltip:this._Pre,status:this._S,timezone:this._T,timezoneBias:this._Ti,voiceMailUri:this._V},{})},t.prototype.setMockData=function(e){b(this,e)},t.prototype.ensureUnchanged=function(e){s(this,e)},t}(OfficeExtension.ClientObject);e.PersonaUnifiedCommunicationInfo=q;var z=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"PersonaPhotoInfo"},enumerable:!0,configurable:!0}),t.prototype.getImageUri=function(e){return a(this,"getImageUri",1,[e],4,0)},t.prototype.getImageUriWithMetadata=function(e){return a(this,"getImageUriWithMetadata",1,[e],4,0)},t.prototype.getPlaceholderUri=function(e){return a(this,"getPlaceholderUri",1,[e],4,0)},t.prototype.setPlaceholderColor=function(e){a(this,"setPlaceholderColor",0,[e],0,0)},t.prototype._handleResult=function(t){(e.prototype._handleResult.call(this,t),l(t))||g(this,t)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),_(this,t,n)},t.prototype.toJSON=function(){return m(this,{},{})},t}(OfficeExtension.ClientObject);e.PersonaPhotoInfo=z;var J=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"PersonaCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"items",{get:function(){return p("items",this.m__items,"PersonaCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),n.prototype.getCount=function(){return a(this,"GetCount",1,[],4,0)},n.prototype.getItem=function(t){return r(e.Persona,this,[t])},n.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!l(n)){var r=n;if(g(this,r),!l(r[OfficeExtension.Constants.items])){this.m__items=[];for(var o=r[OfficeExtension.Constants.items],a=0;a<o.length;a++){var s=i(e.Persona,!0,this,o[a],a);s._handleResult(o[a]),this.m__items.push(s)}}}},n.prototype.load=function(e){return d(this,e)},n.prototype.retrieve=function(e){return h(this,e)},n.prototype._handleRetrieveResult=function(n,r){var o=this;t.prototype._handleRetrieveResult.call(this,n,r),_(this,n,r,(function(t,n){return i(e.Persona,!0,o,t,n)}))},n.prototype.toJSON=function(){return m(this,{},{},this.m__items)},n.prototype.setMockData=function(t){var n=this;b(this,t,(function(t,r){return i(e.Persona,!0,n,t,r)}),(function(e){return n.m__items=e}))},n}(OfficeExtension.ClientObject);e.PersonaCollection=J;var K=function(n){function r(){return null!==n&&n.apply(this,arguments)||this}return __extends(r,n),Object.defineProperty(r.prototype,"_className",{get:function(){return"PersonaOrganizationInfo"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["isWarmedUp","isWarmingUp"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["IsWarmedUp","IsWarmingUp"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["hierarchy","manager","directReports"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"directReports",{get:function(){return this._D||(this._D=t(e.PersonaCollection,this,"DirectReports",!0,4)),this._D},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"hierarchy",{get:function(){return this._H||(this._H=t(e.PersonaCollection,this,"Hierarchy",!0,4)),this._H},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"manager",{get:function(){return this._M||(this._M=t(e.Persona,this,"Manager",!1,4)),this._M},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"isWarmedUp",{get:function(){return p("isWarmedUp",this._I,"PersonaOrganizationInfo",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"isWarmingUp",{get:function(){return p("isWarmingUp",this._Is,"PersonaOrganizationInfo",this._isNull),this._Is},enumerable:!0,configurable:!0}),r.prototype._handleResult=function(e){if(n.prototype._handleResult.call(this,e),!l(e)){var t=e;g(this,t),u(t.IsWarmedUp)||(this._I=t.IsWarmedUp),u(t.IsWarmingUp)||(this._Is=t.IsWarmingUp),y(this,t,["directReports","DirectReports","hierarchy","Hierarchy","manager","Manager"])}},r.prototype.load=function(e){return d(this,e)},r.prototype.retrieve=function(e){return h(this,e)},r.prototype._handleRetrieveResult=function(e,t){n.prototype._handleRetrieveResult.call(this,e,t),_(this,e,t)},r.prototype.toJSON=function(){return m(this,{isWarmedUp:this._I,isWarmingUp:this._Is},{})},r.prototype.setMockData=function(e){b(this,e)},r.prototype.ensureUnchanged=function(e){s(this,e)},r}(OfficeExtension.ClientObject);e.PersonaOrganizationInfo=K,function(e){e.email="Email",e.workPhone="WorkPhone",e.workPhone2="WorkPhone2",e.workFax="WorkFax",e.mobilePhone="MobilePhone",e.homePhone="HomePhone",e.homePhone2="HomePhone2",e.otherPhone="OtherPhone",e.sipAddress="SipAddress",e.profile="Profile",e.office="Office",e.company="Company",e.workAddress="WorkAddress",e.homeAddress="HomeAddress",e.otherAddress="OtherAddress",e.birthday="Birthday"}(e.CustomizedData||(e.CustomizedData={}));var X=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"UnifiedGroupInfo"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["description","oneDrive","oneNote","isPublic","amIOwner","amIMember","amISubscribed","memberCount","ownerCount","hasGuests","site","planner","classification","subscriptionEnabled"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Description","OneDrive","OneNote","IsPublic","AmIOwner","AmIMember","AmISubscribed","MemberCount","OwnerCount","HasGuests","Site","Planner","Classification","SubscriptionEnabled"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyUpdateable",{get:function(){return[!0,!0,!0,!0,!0,!0,!0,!0,!0,!0,!0,!0,!0,!0]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"amIMember",{get:function(){return p("amIMember",this._A,"UnifiedGroupInfo",this._isNull),this._A},set:function(e){this._A=e,c(this,"AmIMember",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"amIOwner",{get:function(){return p("amIOwner",this._Am,"UnifiedGroupInfo",this._isNull),this._Am},set:function(e){this._Am=e,c(this,"AmIOwner",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"amISubscribed",{get:function(){return p("amISubscribed",this._AmI,"UnifiedGroupInfo",this._isNull),this._AmI},set:function(e){this._AmI=e,c(this,"AmISubscribed",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"classification",{get:function(){return p("classification",this._C,"UnifiedGroupInfo",this._isNull),this._C},set:function(e){this._C=e,c(this,"Classification",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"description",{get:function(){return p("description",this._D,"UnifiedGroupInfo",this._isNull),this._D},set:function(e){this._D=e,c(this,"Description",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"hasGuests",{get:function(){return p("hasGuests",this._H,"UnifiedGroupInfo",this._isNull),this._H},set:function(e){this._H=e,c(this,"HasGuests",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isPublic",{get:function(){return p("isPublic",this._I,"UnifiedGroupInfo",this._isNull),this._I},set:function(e){this._I=e,c(this,"IsPublic",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"memberCount",{get:function(){return p("memberCount",this._M,"UnifiedGroupInfo",this._isNull),this._M},set:function(e){this._M=e,c(this,"MemberCount",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"oneDrive",{get:function(){return p("oneDrive",this._O,"UnifiedGroupInfo",this._isNull),this._O},set:function(e){this._O=e,c(this,"OneDrive",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"oneNote",{get:function(){return p("oneNote",this._On,"UnifiedGroupInfo",this._isNull),this._On},set:function(e){this._On=e,c(this,"OneNote",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"ownerCount",{get:function(){return p("ownerCount",this._Ow,"UnifiedGroupInfo",this._isNull),this._Ow},set:function(e){this._Ow=e,c(this,"OwnerCount",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"planner",{get:function(){return p("planner",this._P,"UnifiedGroupInfo",this._isNull),this._P},set:function(e){this._P=e,c(this,"Planner",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"site",{get:function(){return p("site",this._S,"UnifiedGroupInfo",this._isNull),this._S},set:function(e){this._S=e,c(this,"Site",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"subscriptionEnabled",{get:function(){return p("subscriptionEnabled",this._Su,"UnifiedGroupInfo",this._isNull),this._Su},set:function(e){this._Su=e,c(this,"SubscriptionEnabled",e,0)},enumerable:!0,configurable:!0}),t.prototype.set=function(e,t){this._recursivelySet(e,t,["description","oneDrive","oneNote","isPublic","amIOwner","amIMember","amISubscribed","memberCount","ownerCount","hasGuests","site","planner","classification","subscriptionEnabled"],[],[])},t.prototype.update=function(e){this._recursivelyUpdate(e)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;g(this,n),u(n.AmIMember)||(this._A=n.AmIMember),u(n.AmIOwner)||(this._Am=n.AmIOwner),u(n.AmISubscribed)||(this._AmI=n.AmISubscribed),u(n.Classification)||(this._C=n.Classification),u(n.Description)||(this._D=n.Description),u(n.HasGuests)||(this._H=n.HasGuests),u(n.IsPublic)||(this._I=n.IsPublic),u(n.MemberCount)||(this._M=n.MemberCount),u(n.OneDrive)||(this._O=n.OneDrive),u(n.OneNote)||(this._On=n.OneNote),u(n.OwnerCount)||(this._Ow=n.OwnerCount),u(n.Planner)||(this._P=n.Planner),u(n.Site)||(this._S=n.Site),u(n.SubscriptionEnabled)||(this._Su=n.SubscriptionEnabled)}},t.prototype.load=function(e){return d(this,e)},t.prototype.retrieve=function(e){return h(this,e)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),_(this,t,n)},t.prototype.toJSON=function(){return m(this,{amIMember:this._A,amIOwner:this._Am,amISubscribed:this._AmI,classification:this._C,description:this._D,hasGuests:this._H,isPublic:this._I,memberCount:this._M,oneDrive:this._O,oneNote:this._On,ownerCount:this._Ow,planner:this._P,site:this._S,subscriptionEnabled:this._Su},{})},t.prototype.setMockData=function(e){b(this,e)},t.prototype.ensureUnchanged=function(e){s(this,e)},t}(OfficeExtension.ClientObject);e.UnifiedGroupInfo=X;var Q;!function(e){e[e.immediate=0]="immediate",e[e.load=3]="load"}(Q=e.PersonaPromiseType||(e.PersonaPromiseType={}));var Y=function(){return function(){}}();e.PersonaInfoAndSource=Y;var $=function(r){function o(){return null!==r&&r.apply(this,arguments)||this}return __extends(o,r),Object.defineProperty(o.prototype,"_className",{get:function(){return"Persona"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyNames",{get:function(){return["hostId","type","capabilities","diagnosticId","instanceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyOriginalNames",{get:function(){return["HostId","Type","Capabilities","DiagnosticId","InstanceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_navigationPropertyNames",{get:function(){return["photo","personaInfo","unifiedCommunicationInfo","organization","unifiedGroupInfo","actions"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"actions",{get:function(){return this._A||(this._A=t(e.PersonaActions,this,"Actions",!1,4)),this._A},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"organization",{get:function(){return this._O||(this._O=t(e.PersonaOrganizationInfo,this,"Organization",!1,4)),this._O},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"personaInfo",{get:function(){return this._P||(this._P=t(e.PersonaInfo,this,"PersonaInfo",!1,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"photo",{get:function(){return this._Ph||(this._Ph=t(e.PersonaPhotoInfo,this,"Photo",!1,4)),this._Ph},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"unifiedCommunicationInfo",{get:function(){return this._U||(this._U=t(e.PersonaUnifiedCommunicationInfo,this,"UnifiedCommunicationInfo",!1,4)),this._U},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"unifiedGroupInfo",{get:function(){return this._Un||(this._Un=t(e.UnifiedGroupInfo,this,"UnifiedGroupInfo",!1,4)),this._Un},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"capabilities",{get:function(){return p("capabilities",this._C,"Persona",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"diagnosticId",{get:function(){return p("diagnosticId",this._D,"Persona",this._isNull),this._D},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"hostId",{get:function(){return p("hostId",this._H,"Persona",this._isNull),this._H},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"instanceId",{get:function(){return p("instanceId",this._I,"Persona",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"type",{get:function(){return p("type",this._T,"Persona",this._isNull),this._T},enumerable:!0,configurable:!0}),o.prototype.set=function(e,t){this._recursivelySet(e,t,[],["unifiedGroupInfo"],["actions","organization","personaInfo","photo","unifiedCommunicationInfo"])},o.prototype.update=function(e){this._recursivelyUpdate(e)},o.prototype.dispose=function(){a(this,"Dispose",0,[],0,0)},o.prototype.getCustomizations=function(){return a(this,"GetCustomizations",1,[],4,0)},o.prototype.getMembers=function(){return n(e.MemberInfoList,this,"GetMembers",1,[],!1,!1,null,4)},o.prototype.getMembership=function(){return n(e.MemberInfoList,this,"GetMembership",1,[],!1,!1,null,4)},o.prototype.getViewableSources=function(){return a(this,"GetViewableSources",1,[],4,0)},o.prototype.reportTimeForRender=function(e,t){a(this,"ReportTimeForRender",0,[e,t],0,0)},o.prototype.warmup=function(e){a(this,"Warmup",0,[e],0,0)},o.prototype._handleResult=function(e){if(r.prototype._handleResult.call(this,e),!l(e)){var t=e;g(this,t),u(t.Capabilities)||(this._C=t.Capabilities),u(t.DiagnosticId)||(this._D=t.DiagnosticId),u(t.HostId)||(this._H=t.HostId),u(t.InstanceId)||(this._I=t.InstanceId),u(t.Type)||(this._T=t.Type),y(this,t,["actions","Actions","organization","Organization","personaInfo","PersonaInfo","photo","Photo","unifiedCommunicationInfo","UnifiedCommunicationInfo","unifiedGroupInfo","UnifiedGroupInfo"])}},o.prototype.load=function(e){return d(this,e)},o.prototype.retrieve=function(e){return h(this,e)},o.prototype._handleRetrieveResult=function(e,t){r.prototype._handleRetrieveResult.call(this,e,t),_(this,e,t)},o.prototype.toJSON=function(){return m(this,{capabilities:this._C,diagnosticId:this._D,hostId:this._H,instanceId:this._I,type:this._T},{organization:this._O,personaInfo:this._P,unifiedCommunicationInfo:this._U,unifiedGroupInfo:this._Un})},o.prototype.setMockData=function(e){b(this,e)},o.prototype.ensureUnchanged=function(e){s(this,e)},o}(OfficeExtension.ClientObject);e.Persona=$;var Z=function(){function t(){}return t.prototype.performAsyncOperation=function(e,t,n,r){var o=this;e!=Q.immediate?r().then((function(e){if(e)n();else{var i=o;i.load("hostId"),i.context.sync().then((function(){var e=i.hostId;o.getPersonaLifetime().then((function(o){var a=function(s){return new OfficeExtension.CoreUtility.Promise((function(c,l){if(s.sendingPersonaHostId==e)for(var u=0;u<s.dataUpdated.length;++u){var p=s.dataUpdated[u];if(t==p)return void r().then((function(e){e&&(n(),o.onPersonaUpdated.remove(a),i.context.sync()),c(e)}))}c(!1)}))};o.onPersonaUpdated.add(a),i.context.sync()}))}))}})):n()},t.prototype.getOrganizationAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var o=t;t.performAsyncOperation(e,H.organization,(function(){var e=o.organization;e.load("*"),o.context.sync().then((function(){n(e)}))}),(function(){return new OfficeExtension.CoreUtility.Promise((function(e,t){var n=o.organization;n.load("isWarmedUp"),o.context.sync().then((function(){e(n.isWarmedUp)}))}))}))}))},t.prototype.getIsPersonaInfoResolvedCheck=function(){var e=this;return new OfficeExtension.CoreUtility.Promise((function(t,n){var r=e.personaInfo;r.load("isPersonResolved"),e.context.sync().then((function(){t(r.isPersonResolved)}))}))},t.prototype.getPersonaInfoAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var o=t;t.performAsyncOperation(e,H.personaInfo,(function(){var e=o.personaInfo;e.load(),o.context.sync().then((function(){n(e)}))}),(function(){return t.getIsPersonaInfoResolvedCheck()}))}))},t.prototype.getPersonaInfoWithSourceAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var o=t;t.performAsyncOperation(e,H.personaInfo,(function(){var e=new Y;e.info=o.personaInfo,e.info.load(),e.source=o.personaInfo.sources,e.source.load(),o.context.sync().then((function(){n(e)}))}),(function(){return t.getIsPersonaInfoResolvedCheck()}))}))},t.prototype.getUnifiedCommunicationInfo=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var o=t;t.performAsyncOperation(e,H.personaInfo,(function(){var e=o.unifiedCommunicationInfo;e.load("*"),o.context.sync().then((function(){n(e)}))}),(function(){return t.getIsPersonaInfoResolvedCheck()}))}))},t.prototype.getUnifiedGroupInfoAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var o=t;t.performAsyncOperation(e,H.personaInfo,(function(){var e=o.unifiedGroupInfo;e.load("*"),o.context.sync().then((function(){n(e)}))}),(function(){return t.getIsPersonaInfoResolvedCheck()}))}))},t.prototype.getTypeAsync=function(t){var n=this;return new OfficeExtension.CoreUtility.Promise((function(r,o){var i=n;n.performAsyncOperation(t,H.personaInfo,(function(){i.load("type"),i.context.sync().then((function(){r(e.PersonaType[i.type.valueOf()])}))}),(function(){return n.getIsPersonaInfoResolvedCheck()}))}))},t.prototype.getCustomizationsAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var o=t;t.performAsyncOperation(e,H.personaInfo,(function(){var e=o.getCustomizations();o.context.sync().then((function(){n(e.value)}))}),(function(){return t.getIsPersonaInfoResolvedCheck()}))}))},t.prototype.getMembersAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var o=t;t.performAsyncOperation(e,H.members,(function(){var e=o.getMembers();e.load("isWarmedUp"),o.context.sync().then((function(){n(e)}))}),(function(){return new OfficeExtension.CoreUtility.Promise((function(e,t){var n=o.getMembers();n.load("isWarmedUp"),o.context.sync().then((function(){e(n.isWarmedUp)}))}))}))}))},t.prototype.getMembershipAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var o=t;t.performAsyncOperation(e,H.membership,(function(){var e=o.getMembership();e.load("*"),o.context.sync().then((function(){n(e)}))}),(function(){return new OfficeExtension.CoreUtility.Promise((function(e){var t=o.getMembership();t.load("isWarmedUp"),o.context.sync().then((function(){e(t.isWarmedUp)}))}))}))}))},t.prototype.getPersonaLifetime=function(){var e=this;return new OfficeExtension.CoreUtility.Promise((function(t,n){var r=e;r.load("instanceId"),r.context.sync().then((function(){new re(r.context,r.instanceId).getPersonaLifetime().then((function(e){t(e)}))}))}))},t}();e.PersonaCustom=Z,OfficeExtension.Utility.applyMixin($,Z);var ee=function(t){function r(){return null!==t&&t.apply(this,arguments)||this}return __extends(r,t),Object.defineProperty(r.prototype,"_className",{get:function(){return"PersonaLifetime"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["instanceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["InstanceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"instanceId",{get:function(){return p("instanceId",this._I,"PersonaLifetime",this._isNull),this._I},enumerable:!0,configurable:!0}),r.prototype.getPersona=function(t){return n(e.Persona,this,"GetPersona",1,[t],!1,!1,null,4)},r.prototype.getPersonaForOrgByEntryId=function(t,r,o,i){return n(e.Persona,this,"GetPersonaForOrgByEntryId",1,[t,r,o,i],!1,!1,null,4)},r.prototype.getPersonaForOrgEntry=function(t,r,o,i){return n(e.Persona,this,"GetPersonaForOrgEntry",1,[t,r,o,i],!1,!1,null,4)},r.prototype.getPolicies=function(){return a(this,"GetPolicies",1,[],4,0)},r.prototype.getTextScaleFactor=function(){return a(this,"GetTextScaleFactor",1,[],4,0)},r.prototype._RegisterPersonaUpdatedEvent=function(){a(this,"_RegisterPersonaUpdatedEvent",0,[],0,0)},r.prototype._UnregisterPersonaUpdatedEvent=function(){a(this,"_UnregisterPersonaUpdatedEvent",0,[],0,0)},r.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!l(e)){var n=e;g(this,n),u(n.InstanceId)||(this._I=n.InstanceId)}},r.prototype.load=function(e){return d(this,e)},r.prototype.retrieve=function(e){return h(this,e)},r.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},Object.defineProperty(r.prototype,"onPersonaUpdated",{get:function(){var e=this;return this.m_personaUpdated||(this.m_personaUpdated=new OfficeExtension.GenericEventHandlers(this.context,this,"PersonaUpdated",{eventType:3502,registerFunc:function(){return e._RegisterPersonaUpdatedEvent()},unregisterFunc:function(){return e._UnregisterPersonaUpdatedEvent()},getTargetIdFunc:function(){return e.instanceId},eventArgsTransformFunc:function(e){var t={dataUpdated:e.dataUpdated,sendingPersonaHostId:e.sendingPersonaHostId};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_personaUpdated},enumerable:!0,configurable:!0}),r.prototype.toJSON=function(){return m(this,{instanceId:this._I},{})},r.prototype.setMockData=function(e){b(this,e)},r.prototype.ensureUnchanged=function(e){s(this,e)},r}(OfficeExtension.ClientObject);e.PersonaLifetime=ee;var te=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"LokiTokenProvider"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["emailOrUpn","instanceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["EmailOrUpn","InstanceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"emailOrUpn",{get:function(){return p("emailOrUpn",this._E,"LokiTokenProvider",this._isNull),this._E},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"instanceId",{get:function(){return p("instanceId",this._I,"LokiTokenProvider",this._isNull),this._I},enumerable:!0,configurable:!0}),t.prototype.requestClientAccessToken=function(){a(this,"RequestClientAccessToken",0,[],0,0)},t.prototype.requestIdentityUniqueId=function(){a(this,"RequestIdentityUniqueId",0,[],0,0)},t.prototype.requestToken=function(){a(this,"RequestToken",0,[],0,0)},t.prototype._RegisterClientAccessTokenAvailableEvent=function(){a(this,"_RegisterClientAccessTokenAvailableEvent",0,[],0,0)},t.prototype._RegisterIdentityUniqueIdAvailableEvent=function(){a(this,"_RegisterIdentityUniqueIdAvailableEvent",0,[],0,0)},t.prototype._RegisterLokiTokenAvailableEvent=function(){a(this,"_RegisterLokiTokenAvailableEvent",0,[],0,0)},t.prototype._UnregisterClientAccessTokenAvailableEvent=function(){a(this,"_UnregisterClientAccessTokenAvailableEvent",0,[],0,0)},t.prototype._UnregisterIdentityUniqueIdAvailableEvent=function(){a(this,"_UnregisterIdentityUniqueIdAvailableEvent",0,[],0,0)},t.prototype._UnregisterLokiTokenAvailableEvent=function(){a(this,"_UnregisterLokiTokenAvailableEvent",0,[],0,0)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;g(this,n),u(n.EmailOrUpn)||(this._E=n.EmailOrUpn),u(n.InstanceId)||(this._I=n.InstanceId)}},t.prototype.load=function(e){return d(this,e)},t.prototype.retrieve=function(e){return h(this,e)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),_(this,t,n)},Object.defineProperty(t.prototype,"onClientAccessTokenAvailable",{get:function(){var e=this;return this.m_clientAccessTokenAvailable||(this.m_clientAccessTokenAvailable=new OfficeExtension.GenericEventHandlers(this.context,this,"ClientAccessTokenAvailable",{eventType:3505,registerFunc:function(){return e._RegisterClientAccessTokenAvailableEvent()},unregisterFunc:function(){return e._UnregisterClientAccessTokenAvailableEvent()},getTargetIdFunc:function(){return e.instanceId},eventArgsTransformFunc:function(e){var t={clientAccessToken:e.clientAccessToken,isAvailable:e.isAvailable,tokenTTLInSeconds:e.tokenTTLInSeconds};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_clientAccessTokenAvailable},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"onIdentityUniqueIdAvailable",{get:function(){var e=this;return this.m_identityUniqueIdAvailable||(this.m_identityUniqueIdAvailable=new OfficeExtension.GenericEventHandlers(this.context,this,"IdentityUniqueIdAvailable",{eventType:3504,registerFunc:function(){return e._RegisterIdentityUniqueIdAvailableEvent()},unregisterFunc:function(){return e._UnregisterIdentityUniqueIdAvailableEvent()},getTargetIdFunc:function(){return e.instanceId},eventArgsTransformFunc:function(e){var t={isAvailable:e.isAvailable,uniqueId:e.uniqueId};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_identityUniqueIdAvailable},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"onLokiTokenAvailable",{get:function(){var e=this;return this.m_lokiTokenAvailable||(this.m_lokiTokenAvailable=new OfficeExtension.GenericEventHandlers(this.context,this,"LokiTokenAvailable",{eventType:3503,registerFunc:function(){return e._RegisterLokiTokenAvailableEvent()},unregisterFunc:function(){return e._UnregisterLokiTokenAvailableEvent()},getTargetIdFunc:function(){return e.instanceId},eventArgsTransformFunc:function(e){var t={isAvailable:e.isAvailable,lokiAutoDiscoverUrl:e.lokiAutoDiscoverUrl,lokiToken:e.lokiToken};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_lokiTokenAvailable},enumerable:!0,configurable:!0}),t.prototype.toJSON=function(){return m(this,{emailOrUpn:this._E,instanceId:this._I},{})},t.prototype.setMockData=function(e){b(this,e)},t.prototype.ensureUnchanged=function(e){s(this,e)},t}(OfficeExtension.ClientObject);e.LokiTokenProvider=te;var ne=function(t){function r(){return null!==t&&t.apply(this,arguments)||this}return __extends(r,t),Object.defineProperty(r.prototype,"_className",{get:function(){return"LokiTokenProviderFactory"},enumerable:!0,configurable:!0}),r.prototype.getLokiTokenProvider=function(t){return n(e.LokiTokenProvider,this,"GetLokiTokenProvider",1,[t],!1,!1,null,4)},r.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||g(this,e)},r.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},r.newObject=function(t){return o(e.LokiTokenProviderFactory,t,"Microsoft.People.LokiTokenProviderFactory",!1,4)},r.prototype.toJSON=function(){return m(this,{},{})},r}(OfficeExtension.ClientObject);e.LokiTokenProviderFactory=ne;var re=function(){function t(e,t){this.context=e,this.instanceId=t}return Object.defineProperty(t.prototype,"serviceContext",{get:function(){return this.m_serviceConext||(this.m_serviceConext=e.ServiceContext.newObject(this.context)),this.m_serviceConext},enumerable:!0,configurable:!0}),t.prototype.getPersonaLifetime=function(){var e=this;return new OfficeExtension.CoreUtility.Promise((function(t,n){var r=e.serviceContext.getPersonaLifetime(e.instanceId);e.context.sync().then((function(){r.load("instanceId"),e.context.sync().then((function(){t(r)}))}))}))},t.prototype.getInitialPersona=function(){var e=this;return new OfficeExtension.CoreUtility.Promise((function(t,n){var r=e.serviceContext.getInitialPersona(e.instanceId);e.context.sync().then((function(){t(r)}))}))},t.prototype.getLokiTokenProvider=function(){var e=this;return new OfficeExtension.CoreUtility.Promise((function(t,n){var r=e.serviceContext.getLokiTokenProvider(e.instanceId);e.context.sync().then((function(){r.load("instanceId"),e.context.sync().then((function(){t(r)}))}))}))},t}();e.PeopleApiContext=re;var oe=function(t){function r(){return null!==t&&t.apply(this,arguments)||this}return __extends(r,t),Object.defineProperty(r.prototype,"_className",{get:function(){return"ServiceContext"},enumerable:!0,configurable:!0}),r.prototype.accountEmailOrUpn=function(e){return a(this,"AccountEmailOrUpn",1,[e],4,0)},r.prototype.dispose=function(e){a(this,"Dispose",0,[e],0,0)},r.prototype.getInitialPersona=function(t){return n(e.Persona,this,"GetInitialPersona",1,[t],!1,!1,null,4)},r.prototype.getLokiTokenProvider=function(t){return n(e.LokiTokenProvider,this,"GetLokiTokenProvider",1,[t],!1,!1,null,4)},r.prototype.getPersonaLifetime=function(t){return n(e.PersonaLifetime,this,"GetPersonaLifetime",1,[t],!1,!1,null,4)},r.prototype.getPersonaPolicies=function(){return a(this,"GetPersonaPolicies",1,[],4,0)},r.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||g(this,e)},r.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},r.newObject=function(t){return o(e.ServiceContext,t,"Microsoft.People.ServiceContext",!1,4)},r.prototype.toJSON=function(){return m(this,{},{})},r}(OfficeExtension.ClientObject);e.ServiceContext=oe;var ie=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"RichapiPcxFeatureChecks"},enumerable:!0,configurable:!0}),n.prototype.isAddChangePhotoLinkOnLpcPersonaImageFlightEnabled=function(){return a(this,"IsAddChangePhotoLinkOnLpcPersonaImageFlightEnabled",1,[],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||g(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},n.newObject=function(t){return o(e.RichapiPcxFeatureChecks,t,"Microsoft.People.RichapiPcxFeatureChecks",!1,4)},n.prototype.toJSON=function(){return m(this,{},{})},n}(OfficeExtension.ClientObject);e.RichapiPcxFeatureChecks=ie;var ae=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"Tap"},enumerable:!0,configurable:!0}),n.prototype.getEnterpriseUserInfo=function(){return a(this,"GetEnterpriseUserInfo",1,[],5,0)},n.prototype.getMruFriendlyPath=function(e){return a(this,"GetMruFriendlyPath",1,[e],5,0)},n.prototype.launchFileUrlInOfficeApp=function(e,t){return a(this,"LaunchFileUrlInOfficeApp",1,[e,t],5,0)},n.prototype.performLocalSearch=function(e,t,n,r){return a(this,"PerformLocalSearch",1,[e,t,n,r],5,0)},n.prototype.readSearchCache=function(e,t,n){return a(this,"ReadSearchCache",1,[e,t,n],5,0)},n.prototype.writeSearchCache=function(e,t,n){return a(this,"WriteSearchCache",1,[e,t,n],5,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||g(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},n.newObject=function(t){return o(e.Tap,t,"Microsoft.TapRichApi.Tap",!1,4)},n.prototype.toJSON=function(){return m(this,{},{})},n}(OfficeExtension.ClientObject);e.Tap=ae,function(e){e.unknown="Unknown",e.chart="Chart",e.smartArt="SmartArt",e.table="Table",e.image="Image",e.slide="Slide",e.ole="OLE",e.text="Text"}(e.ObjectType||(e.ObjectType={}));var se=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"AppRuntimePersistenceService"},enumerable:!0,configurable:!0}),n.prototype.getAppRuntimeStartState=function(){return a(this,"GetAppRuntimeStartState",1,[],4,0)},n.prototype.setAppRuntimeStartState=function(e){a(this,"SetAppRuntimeStartState",0,[e],v(2,"SharedRuntimeInternal","1.2"),0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||g(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},n.newObject=function(t){return o(e.AppRuntimePersistenceService,t,"Microsoft.AppRuntime.AppRuntimePersistenceService",!1,4)},n.prototype.toJSON=function(){return m(this,{},{})},n}(OfficeExtension.ClientObject);e.AppRuntimePersistenceService=se;var ce,le=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"AppRuntimeService"},enumerable:!0,configurable:!0}),n.prototype.getAppRuntimeState=function(){return a(this,"GetAppRuntimeState",1,[],4,0)},n.prototype.setAppRuntimeState=function(e){a(this,"SetAppRuntimeState",0,[e],v(2,"SharedRuntimeInternal","1.2"),0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||g(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},n.newObject=function(t){return o(e.AppRuntimeService,t,"Microsoft.AppRuntime.AppRuntimeService",!1,4)},Object.defineProperty(n.prototype,"onVisibilityChanged",{get:function(){return this.m_visibilityChanged||(this.m_visibilityChanged=new OfficeExtension.GenericEventHandlers(this.context,this,"VisibilityChanged",{eventType:65539,registerFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},unregisterFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={visibility:e.visibility};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_visibilityChanged},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return m(this,{},{})},n}(OfficeExtension.ClientObject);e.AppRuntimeService=le,function(e){e.inactive="Inactive",e.background="Background",e.visible="Visible"}(e.AppRuntimeState||(e.AppRuntimeState={})),function(e){e.hidden="Hidden",e.visible="Visible"}(e.Visibility||(e.Visibility={})),function(e){e.unknown="Unknown",e.basic="Basic",e.premium="Premium"}(ce=e.LicenseFeatureTier||(e.LicenseFeatureTier={}));var ue=function(t){function r(){return null!==t&&t.apply(this,arguments)||this}return __extends(r,t),Object.defineProperty(r.prototype,"_className",{get:function(){return"License"},enumerable:!0,configurable:!0}),r.prototype.getFeatureTier=function(e,t){return a(this,"GetFeatureTier",1,[e,t],4,0)},r.prototype.getLicenseFeature=function(t){return n(e.LicenseFeature,this,"GetLicenseFeature",1,[t],!1,!1,null,4)},r.prototype.getMsaDeviceTicket=function(e,t,n){return a(this,"GetMsaDeviceTicket",1,[e,t,n],5,0)},r.prototype.isFeatureEnabled=function(e,t){return a(this,"IsFeatureEnabled",1,[e,t],4,0)},r.prototype.isFreemiumUpsellEnabled=function(){return a(this,"IsFreemiumUpsellEnabled",1,[],4,0)},r.prototype.launchUpsellExperience=function(e){a(this,"LaunchUpsellExperience",1,[e],4,0)},r.prototype._TestFireStateChangedEvent=function(e){a(this,"_TestFireStateChangedEvent",0,[e],1,0)},r.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||g(this,e)},r.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},r.newObject=function(t){return o(e.License,t,"Microsoft.Office.Licensing.License",!1,4)},r.prototype.toJSON=function(){return m(this,{},{})},r}(OfficeExtension.ClientObject);e.License=ue;var pe=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"LicenseFeature"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["id"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"id",{get:function(){return p("id",this._I,"LicenseFeature",this._isNull),this._I},enumerable:!0,configurable:!0}),t.prototype._RegisterStateChange=function(){a(this,"_RegisterStateChange",1,[],4,0)},t.prototype._UnregisterStateChange=function(){a(this,"_UnregisterStateChange",1,[],4,0)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;g(this,n),u(n.Id)||(this._I=n.Id)}},t.prototype.load=function(e){return d(this,e)},t.prototype.retrieve=function(e){return h(this,e)},t.prototype._handleIdResult=function(t){e.prototype._handleIdResult.call(this,t),l(t)||u(t.Id)||(this._I=t.Id)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),_(this,t,n)},Object.defineProperty(t.prototype,"onStateChanged",{get:function(){var e=this;return this.m_stateChanged||(this.m_stateChanged=new OfficeExtension.GenericEventHandlers(this.context,this,"StateChanged",{eventType:1,registerFunc:function(){return e._RegisterStateChange()},unregisterFunc:function(){return e._UnregisterStateChange()},getTargetIdFunc:function(){return e.id},eventArgsTransformFunc:function(t){var n=A.LicenseFeature_StateChanged_EventArgsTransform(e,t);return OfficeExtension.Utility._createPromiseFromResult(n)}})),this.m_stateChanged},enumerable:!0,configurable:!0}),t.prototype.toJSON=function(){return m(this,{id:this._I},{})},t.prototype.setMockData=function(e){b(this,e)},t.prototype.ensureUnchanged=function(e){s(this,e)},t}(OfficeExtension.ClientObject);e.LicenseFeature=pe,function(e){e.LicenseFeature_StateChanged_EventArgsTransform=function(e,t){var n={feature:t.featureName,isEnabled:t.isEnabled,tier:t.tierName};return t.tierName&&(n.tier=0==t.tierName?ce.unknown:1==t.tierName?ce.basic:2==t.tierName?ce.premium:t.tierName),n}}(A=e._CC||(e._CC={}));var fe=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"MsaDeviceTicketOptions"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyNames",{get:function(){return["scopes"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Scopes"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyUpdateable",{get:function(){return[!0]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"scopes",{get:function(){return p("scopes",this._S,"MsaDeviceTicketOptions",this._isNull),this._S},set:function(e){this._S=e,c(this,"Scopes",e,0)},enumerable:!0,configurable:!0}),n.prototype.set=function(e,t){this._recursivelySet(e,t,["scopes"],[],[])},n.prototype.update=function(e){this._recursivelyUpdate(e)},n.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!l(e)){var n=e;g(this,n),u(n.Scopes)||(this._S=n.Scopes)}},n.prototype.load=function(e){return d(this,e)},n.prototype.retrieve=function(e){return h(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},n.newObject=function(t){return o(e.MsaDeviceTicketOptions,t,"Microsoft.Office.Licensing.MsaDeviceTicketOptions",!1,4)},n.prototype.toJSON=function(){return m(this,{scopes:this._S},{})},n.prototype.setMockData=function(e){b(this,e)},n.prototype.ensureUnchanged=function(e){s(this,e)},n}(OfficeExtension.ClientObject);e.MsaDeviceTicketOptions=fe;var de=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"DialogPage"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyNames",{get:function(){return["_Id"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_Id"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_Id",{get:function(){return p("_Id",this.__I,"DialogPage",this._isNull),this.__I},enumerable:!0,configurable:!0}),n.prototype.close=function(){a(this,"Close",1,[],4,0)},n.prototype.readyToShow=function(){a(this,"ReadyToShow",1,[],4,0)},n.prototype.registerOnShow=function(){a(this,"RegisterOnShow",1,[],4,0)},n.prototype.sendMessageToHost=function(e){a(this,"SendMessageToHost",1,[e],4,0)},n.prototype.unregisterOnShow=function(){a(this,"UnregisterOnShow",1,[],4,0)},n.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!l(e)){var n=e;g(this,n),u(n._Id)||(this.__I=n._Id)}},n.prototype.load=function(e){return d(this,e)},n.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),l(e)||u(e._Id)||(this.__I=e._Id)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},n.newObject=function(t){return o(e.DialogPage,t,"Microsoft.Office.DialogPage.DialogPage",!1,4)},Object.defineProperty(n.prototype,"onOnShowEvent",{get:function(){var e=this;return this.m_onShowEvent||(this.m_onShowEvent=new OfficeExtension.GenericEventHandlers(this.context,this,"OnShowEvent",{eventType:1,registerFunc:function(){return e.registerOnShow()},unregisterFunc:function(){return e.unregisterOnShow()},getTargetIdFunc:function(){return e._Id},eventArgsTransformFunc:function(e){return OfficeExtension.Utility._createPromiseFromResult({})}})),this.m_onShowEvent},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return m(this,{},{})},n}(OfficeExtension.ClientObject);e.DialogPage=de;var he=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"ActionService"},enumerable:!0,configurable:!0}),n.prototype.areShortcutsInUse=function(e){return a(this,"AreShortcutsInUse",0,[e],0,0)},n.prototype.getShortcuts=function(){return a(this,"GetShortcuts",1,[],4,0)},n.prototype.replaceShortcuts=function(e){a(this,"ReplaceShortcuts",0,[e],0,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||g(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),_(this,e,n)},n.newObject=function(t){return o(e.ActionService,t,"Microsoft.Office.ActionService",!1,4)},n.prototype.toJSON=function(){return m(this,{},{})},n}(OfficeExtension.ClientObject);e.ActionService=he,function(e){e.apiNotAvailable="ApiNotAvailable",e.clientError="ClientError",e.controlIdNotFound="ControlIdNotFound",e.entryIdRequired="EntryIdRequired",e.generalException="GeneralException",e.hostRestartNeeded="HostRestartNeeded",e.instanceNotFound="InstanceNotFound",e.interactiveFlowAborted="InteractiveFlowAborted",e.invalidArgument="InvalidArgument",e.invalidGrant="InvalidGrant",e.invalidResourceUrl="InvalidResourceUrl",e.invalidRibbonDefinition="InvalidRibbonDefinition",e.objectNotFound="ObjectNotFound",e.resourceNotSupported="ResourceNotSupported",e.serverError="ServerError",e.serviceUrlNotFound="ServiceUrlNotFound",e.sharedRuntimeNotAvailable="SharedRuntimeNotAvailable",e.ticketInvalidParams="TicketInvalidParams",e.ticketNetworkError="TicketNetworkError",e.ticketUnauthorized="TicketUnauthorized",e.ticketUninitialized="TicketUninitialized",e.ticketUnknownError="TicketUnknownError",e.unexpectedError="UnexpectedError",e.unsupportedUserIdentity="UnsupportedUserIdentity",e.userNotSignedIn="UserNotSignedIn"}(e.ErrorCodes||(e.ErrorCodes={})),e.Interfaces||(e.Interfaces={})}(OfficeCore||(OfficeCore={})),function(e){var t,n;!function(e){e.hidden="Hidden",e.taskpane="Taskpane"}(t=e.VisibilityMode||(e.VisibilityMode={})),function(e){e.none="None",e.load="Load"}(n=e.StartupBehavior||(e.StartupBehavior={})),function(e){function r(e){var t=new OfficeCore.RequestContext;return t._requestFlagModifier|=64,e&&(t._customData="WacPartition"),t}function o(e){return __awaiter(this,void 0,void 0,(function(){var t;return __generator(this,(function(n){switch(n.label){case 0:return t=r(!0),OfficeCore.AppRuntimeService.newObject(t).setAppRuntimeState(e),[4,t.sync()];case 1:return n.sent(),[2]}}))}))}var i;function a(e){return e===OfficeCore.Visibility.visible?t.taskpane:t.hidden}e.setStartupBehavior=function(e){return __awaiter(this,void 0,void 0,(function(){var t,o;return __generator(this,(function(i){switch(i.label){case 0:if(e!==n.load&&e!==n.none)throw OfficeExtension.Utility.createRuntimeError(OfficeExtension.ErrorCodes.invalidArgument,null,null);return t=e==n.load?OfficeCore.AppRuntimeState.background:OfficeCore.AppRuntimeState.inactive,o=r(!1),OfficeCore.AppRuntimePersistenceService.newObject(o).setAppRuntimeStartState(t),[4,o.sync()];case 1:return i.sent(),[2]}}))}))},e.getStartupBehavior=function(){return __awaiter(this,void 0,void 0,(function(){var e,t,o,i;return __generator(this,(function(a){switch(a.label){case 0:return e=r(!1),t=OfficeCore.AppRuntimePersistenceService.newObject(e),o=t.getAppRuntimeStartState(),[4,e.sync()];case 1:return a.sent(),i=o.value,[2,i==OfficeCore.AppRuntimeState.inactive?n.none:n.load]}}))}))},e._getState=function(){return __awaiter(this,void 0,void 0,(function(){var e,t,n;return __generator(this,(function(o){switch(o.label){case 0:return e=r(!0),t=OfficeCore.AppRuntimeService.newObject(e),n=t.getAppRuntimeState(),[4,e.sync()];case 1:return o.sent(),[2,n.value]}}))}))},e.showAsTaskpane=function(){return o(OfficeCore.AppRuntimeState.visible)},e.hide=function(){return o(OfficeCore.AppRuntimeState.background)},e.onVisibilityModeChanged=function(e){return __awaiter(this,void 0,void 0,(function(){var t,n,o=this;return __generator(this,(function(s){switch(s.label){case 0:return t=function(){if(!i){var e=r(!0);i=OfficeCore.AppRuntimeService.newObject(e)}return i}(),n=t.onVisibilityChanged.add((function(t){if(e){var n={visibilityMode:a(t.visibility)};e(n)}return null})),[4,t.context.sync()];case 1:return s.sent(),[2,function(){return __awaiter(o,void 0,void 0,(function(){return __generator(this,(function(e){switch(e.label){case 0:return n.remove(),[4,t.context.sync()];case 1:return e.sent(),[2]}}))}))}]}}))}))},function(e){function t(e){var t=new OfficeCore.RequestContext;return t._requestFlagModifier|=64,e&&(t._customData="WacPartition"),t}e.enable=function(){return __awaiter(this,void 0,void 0,(function(){var e,n;return __generator(this,(function(r){switch(r.label){case 0:return e=!1,"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(e=!0),n=t(e),OfficeCore.BeforeDocumentCloseNotification.newObject(n).enable(),[4,n.sync()];case 1:return r.sent(),[2]}}))}))},e.disable=function(){return __awaiter(this,void 0,void 0,(function(){var e,n;return __generator(this,(function(r){switch(r.label){case 0:return e=!1,"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(e=!0),n=t(e),OfficeCore.BeforeDocumentCloseNotification.newObject(n).disable(),[4,n.sync()];case 1:return r.sent(),[2]}}))}))},e.onCloseActionCancelled=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r,o,i,a=this;return __generator(this,(function(s){switch(s.label){case 0:return n=!1,"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(n=!0),r=t(n),o=OfficeCore.BeforeDocumentCloseNotification.newObject(r),i=o.onBeforeCloseNotificationCancelled.add((function(t){return e&&e(),null})),[4,r.sync()];case 1:return s.sent(),[2,function(){return __awaiter(a,void 0,void 0,(function(){return __generator(this,(function(e){switch(e.label){case 0:return i.remove(),[4,r.sync()];case 1:return e.sent(),[2]}}))}))}]}}))}))}}(e.beforeDocumentCloseNotification||(e.beforeDocumentCloseNotification={}))}(e.addin||(e.addin={}))}(Office||(Office={})),function(e){var t;!function(e){e.taskpane="Taskpane"}(t||(t={})),function(e){e.launchTaskpane=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r,o;return __generator(this,(function(i){switch(i.label){case 0:return n=function(e){return new OfficeCore.RequestContext}(),r=OfficeCore.ExtensionLifeCycle.newObject(n),void 0!=(o=e.settings)&&(e.settings=OSF.OUtil.serializeSettings(o)),r.launchExtensionComponent("",t.taskpane,e),[4,n.sync()];case 1:return i.sent(),[2]}}))}))}}(e.extensionLifeCycle||(e.extensionLifeCycle={}))}(Office||(Office={})),function(e){!function(e){function t(){var e=new OfficeCore.RequestContext;return"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(e._customData="WacPartition"),e}e.requestUpdate=function(e){var n=t(),r=n.ribbon;function o(e){void 0!==e.controls&&void 0!==e.controls.length&&e.controls.length&&e.controls.filter((function(e){return!!e.id})).forEach((function(e){var t=r.getButton(e.id);void 0!==e.enabled&&null!==e.enabled&&(t.enabled=e.enabled)}))}return e.tabs.filter((function(e){return!!e.id})).forEach((function(e){var t=r.getTab(e.id);void 0!==e.visible&&null!==e.visible&&t.setVisibility(e.visible),e.groups&&e.groups.length?e.groups.filter((function(e){return!!e.id})).forEach((function(e){o(e)})):o(e)})),n.sync()},e.requestCreateControls=function(e){var n=t();return n.ribbon.executeRequestCreate(JSON.stringify(e)),function(e){return new Promise((function(t,n){return setTimeout((function(){return t()}),e)}))}(250).then((function(){return n.sync()}))}}(e.ribbon||(e.ribbon={}))}(Office||(Office={})),function(e){var t;OfficeExtension.BatchApiHelper.createPropertyObject,OfficeExtension.BatchApiHelper.createMethodObject,OfficeExtension.BatchApiHelper.createIndexerObject,OfficeExtension.BatchApiHelper.createRootServiceObject,OfficeExtension.BatchApiHelper.createTopLevelServiceObject,OfficeExtension.BatchApiHelper.createChildItemObject,OfficeExtension.BatchApiHelper.invokeMethod,OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,OfficeExtension.BatchApiHelper.invokeSetProperty,OfficeExtension.Utility.isNullOrUndefined,OfficeExtension.Utility.isUndefined,OfficeExtension.Utility.throwIfNotLoaded,OfficeExtension.Utility.throwIfApiNotSupported,OfficeExtension.Utility.load,OfficeExtension.Utility.retrieve,OfficeExtension.Utility.toJson,OfficeExtension.Utility.fixObjectPathIfNecessary,OfficeExtension.Utility._handleNavigationPropertyResults,OfficeExtension.Utility.adjustToDateTime,OfficeExtension.Utility.processRetrieveResult,OfficeExtension.Utility.setMockData,OfficeExtension.CommonUtility.calculateApiFlags;!function(e){e.generalException="GeneralException"}(t||(t={}));new OfficeExtension.LibraryBuilder({metadata:{version:"1.0.0",name:"OfficeCore",defaultApiSetName:"OfficeSharedApi",hostName:"Office",apiSets:[],strings:["AddinInternalService"],enumTypes:[],clientObjectTypes:[[1,0,0,0,[["notifyActionHandlerReady",0,2,0,4]],0,0,0,0,"Microsoft.InternalService.AddinInternalService",4]]},targetNamespaceObject:e})}(OfficeCore||(OfficeCore={})),function(e){var t;!function(t){var n,r=OfficeExtension.Utility.isNullOrUndefined;function o(e){if(e){var t=e.toUpperCase(),o=n.mappings[t];if(!r(o)&&"function"===typeof o)return o}throw OfficeExtension.Utility.createRuntimeError("invalidOperation","sourceData","ActionProxy._getFunction")}function i(e){try{OfficeExtension.Utility.log("ActionProxy._handleMessage"),OfficeExtension.Utility.checkArgumentNull(e,"args");for(var t=e.entries,n=0;n<t.length;n++)if(2===t[n].messageCategory)if("string"===typeof t[n].message&&(t[n].message=JSON.parse(t[n].message)),1e3===t[n].messageType){var r=null,i=o(t[n].message[0]);if(t[n].message.length>=2){var s=t[n].message[1];s&&(r=a(s)?JSON.parse(s):s)}"undefined"!==typeof OSF&&OSF.AppTelemetry&&OSF.AppTelemetry.CallOnAppActivatedIfPending&&OSF.AppTelemetry.CallOnAppActivatedIfPending(),i.apply(null,[r])}else OfficeExtension.Utility.log("ActionProxy._handleMessage unknown message type "+t[n].messageType)}catch(e){throw function(e){var t=function(e){var t="Unknown Error";if(e)try{e.toString&&(t=e.toString()),t=t+" "+JSON.stringify(e)}catch(e){t="Unexpected Error"}return t}(e);OfficeExtension.Utility.log(t)}(e),e}return OfficeExtension.Utility._createPromiseFromResult(null)}function a(e){return"string"===typeof e&&"{"===e[0]}function s(){try{Microsoft.Office.WebExtension.onReadyInternal().then((function(){return function(){if("undefined"!==typeof OSF&&OSF.DDA&&OSF.DDA.RichApi&&OSF.DDA.RichApi.richApiMessageManager)return(new OfficeExtension.ClientRequestContext).eventRegistration.register(5,"",i)}()})).then((function(){var e=OSF._OfficeAppFactory.getHostInfo();return!0===e.isDialog||"web"===e.hostPlatform&&"word"!==e.hostType&&"excel"!==e.hostType?void 0:function(){var e=new OfficeExtension.ClientRequestContext,t=OfficeCore.AddinInternalService.newObject(e);return e._customData="WacPartition",t.notifyActionHandlerReady(),e.sync()}()}))}catch(e){}}!function(){OfficeExtension.Utility.log("ActionProxy.initOnce"),"undefined"!=typeof e.actions&&function(e){n=e}(e.actions._association),"undefined"!==typeof document&&(document.readyState&&"loading"!==document.readyState?(OfficeExtension.Utility.log("ActionProxy.initOnce: document.readyState is not loading state"),s()):document.addEventListener&&document.addEventListener("DOMContentLoaded",(function(){OfficeExtension.Utility.log("ActionProxy.initOnce: DOMContentLoaded event triggered"),s()}))),OfficeExtension.HostBridge.onInited((function(e){!function(e){e.addHostMessageHandler((function(e){3===e.type&&i(e.message)}))}(e)}))}()}(t||(t={}))}(Office||(Office={})),function(e){!function(e){function t(){var e=new OfficeCore.RequestContext;return"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(e._customData="WacPartition"),e}e.areShortcutsInUse=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r,o,i,a;return __generator(this,(function(s){switch(s.label){case 0:return n=t(),r=OfficeCore.ActionService.newObject(n),o=r.areShortcutsInUse(e),[4,n.sync()];case 1:for(s.sent(),i=[],a=0;a<e.length;a++)i.push({shortcut:e[a],inUse:o.value[a]});return[2,i]}}))}))},e.replaceShortcuts=function(e){return __awaiter(this,void 0,void 0,(function(){var n;return __generator(this,(function(r){switch(r.label){case 0:return n=t(),OfficeCore.ActionService.newObject(n).replaceShortcuts(e),[4,n.sync()];case 1:return r.sent(),[2]}}))}))},e.getShortcuts=function(){return __awaiter(this,void 0,void 0,(function(){var e,n,r;return __generator(this,(function(o){switch(o.label){case 0:return e=t(),n=OfficeCore.ActionService.newObject(e),r=n.getShortcuts(),[4,e.sync()];case 1:return o.sent(),[2,r.value]}}))}))}}(e.actions||(e.actions={}))}(Office||(Office={})),function(e){!function(e){e.close=function(){return __awaiter(this,void 0,void 0,(function(){var e;return __generator(this,(function(t){switch(t.label){case 0:return e=new OfficeCore.RequestContext,OfficeCore.DialogPage.newObject(e).close(),[4,e.sync()];case 1:return t.sent(),[2]}}))}))},e.readyToShow=function(){return __awaiter(this,void 0,void 0,(function(){var e;return __generator(this,(function(t){switch(t.label){case 0:return e=new OfficeCore.RequestContext,OfficeCore.DialogPage.newObject(e).readyToShow(),[4,e.sync()];case 1:return t.sent(),[2]}}))}))},e.onShow=function(e){return __awaiter(this,void 0,void 0,(function(){var t,n,r;return __generator(this,(function(o){switch(o.label){case 0:return t=new OfficeCore.RequestContext,(n=OfficeCore.DialogPage.newObject(t)).onOnShowEvent.add(e),r=function(){return n.onOnShowEvent.remove(e),null},[4,t.sync()];case 1:return o.sent(),[2,r]}}))}))},e.sendMessageToHost=function(e){return __awaiter(this,void 0,void 0,(function(){var t;return __generator(this,(function(n){switch(n.label){case 0:return t=new OfficeCore.RequestContext,OfficeCore.DialogPage.newObject(t).sendMessageToHost(e),[4,t.sync()];case 1:return n.sent(),[2]}}))}))}}(e.dialogPage||(e.dialogPage={}))}(Office||(Office={}));var OneNote;__extends=this&&this.__extends||function(){var e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();!function(e){var t=OfficeExtension.BatchApiHelper.createPropertyObject,n=OfficeExtension.BatchApiHelper.createMethodObject,r=OfficeExtension.BatchApiHelper.createIndexerObject,o=(OfficeExtension.BatchApiHelper.createRootServiceObject,OfficeExtension.BatchApiHelper.createTopLevelServiceObject,OfficeExtension.BatchApiHelper.createChildItemObject),i=OfficeExtension.BatchApiHelper.invokeMethod,a=OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,s=OfficeExtension.BatchApiHelper.invokeSetProperty,c=OfficeExtension.Utility.isNullOrUndefined,l=OfficeExtension.Utility.isUndefined,u=OfficeExtension.Utility.throwIfNotLoaded,p=OfficeExtension.Utility.throwIfApiNotSupported,f=OfficeExtension.Utility.load,d=OfficeExtension.Utility.retrieve,h=OfficeExtension.Utility.toJson,m=OfficeExtension.Utility.fixObjectPathIfNecessary,g=OfficeExtension.Utility._handleNavigationPropertyResults,y=(OfficeExtension.Utility.adjustToDateTime,OfficeExtension.Utility.processRetrieveResult),O=OfficeExtension.Utility.setMockData,_=(OfficeExtension.CommonUtility.calculateApiFlags,function(r){function o(){return null!==r&&r.apply(this,arguments)||this}return __extends(o,r),Object.defineProperty(o.prototype,"_className",{get:function(){return"Application"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyNames",{get:function(){return["_platform"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_platform"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_navigationPropertyNames",{get:function(){return["notebooks","noteTagManager","mathAssistantManager"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"mathAssistantManager",{get:function(){return p("Application.mathAssistantManager","OneNoteApi","1.9","OneNote"),this._M||(this._M=t(e.MathAssistantManager,this,"MathAssistantManager",!1,4)),this._M},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"noteTagManager",{get:function(){return p("Application.noteTagManager","OneNoteApi","1.3","OneNote"),this._No||(this._No=t(e.NoteTagManager,this,"NoteTagManager",!1,4)),this._No},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"notebooks",{get:function(){return this._N||(this._N=t(e.NotebookCollection,this,"Notebooks",!0,4)),this._N},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_platform",{get:function(){return u("_platform",this.__p,"Application",this._isNull),this.__p},enumerable:!0,configurable:!0}),o.prototype.set=function(e,t){this._recursivelySet(e,t,[],["mathAssistantManager"],["notebooks","noteTagManager"])},o.prototype.update=function(e){this._recursivelyUpdate(e)},o.prototype.getActiveNotebook=function(){return n(e.Notebook,this,"GetActiveNotebook",1,[],!1,!1,null,4)},o.prototype.getActiveNotebookOrNull=function(){return n(e.Notebook,this,"GetActiveNotebookOrNull",1,[],!1,!1,null,4)},o.prototype.getActiveOutline=function(){return n(e.Outline,this,"GetActiveOutline",1,[],!1,!1,null,4)},o.prototype.getActiveOutlineOrNull=function(){return n(e.Outline,this,"GetActiveOutlineOrNull",1,[],!1,!1,null,4)},o.prototype.getActivePage=function(){return n(e.Page,this,"GetActivePage",1,[],!1,!1,null,4)},o.prototype.getActivePageOrNull=function(){return n(e.Page,this,"GetActivePageOrNull",1,[],!1,!1,null,4)},o.prototype.getActiveParagraph=function(){return n(e.Paragraph,this,"GetActiveParagraph",1,[],!1,!1,null,4)},o.prototype.getActiveParagraphOrNull=function(){return n(e.Paragraph,this,"GetActiveParagraphOrNull",1,[],!1,!1,null,4)},o.prototype.getActiveSection=function(){return n(e.Section,this,"GetActiveSection",1,[],!1,!1,null,4)},o.prototype.getActiveSectionOrNull=function(){return n(e.Section,this,"GetActiveSectionOrNull",1,[],!1,!1,null,4)},o.prototype.getMathQuizContext=function(){return p("Application.getMathQuizContext","OneNoteApi","1.6","OneNote"),i(this,"GetMathQuizContext",1,[],4,0)},o.prototype.getSelectedInkStrokes=function(){return p("Application.getSelectedInkStrokes","OneNoteApi","1.9","OneNote"),n(e.InkStrokeCollection,this,"GetSelectedInkStrokes",1,[],!0,!1,null,4)},o.prototype.getSelectedPages=function(){return n(e.PageCollection,this,"GetSelectedPages",1,[],!0,!1,null,4)},o.prototype.getWindowSize=function(){return i(this,"GetWindowSize",0,[],0,0)},o.prototype.insertHtmlAtCurrentPosition=function(e){i(this,"InsertHtmlAtCurrentPosition",0,[e],0,0)},o.prototype.isHighContrast=function(){return p("Application.isHighContrast","OneNoteApi","1.3","OneNote"),i(this,"IsHighContrast",1,[],4,0)},o.prototype.isViewingDeletedNotes=function(){return p("Application.isViewingDeletedNotes","OneNoteApi","1.2","OneNote"),i(this,"IsViewingDeletedNotes",1,[],4,0)},o.prototype.navigateToPage=function(e){i(this,"NavigateToPage",1,[e],4,0)},o.prototype.navigateToPageWithClientUrl=function(t){return n(e.Page,this,"NavigateToPageWithClientUrl",1,[t],!1,!1,null,4)},o.prototype._ClientLog=function(e,t,n,r){i(this,"_ClientLog",1,[e,t,n,r],4,0)},o.prototype._CreateNotebook=function(e,t){return p("Application._CreateNotebook","OneNoteApi","1.5","OneNote"),i(this,"_CreateNotebook",1,[e,t],4,0)},o.prototype._EnableControl=function(e,t){i(this,"_EnableControl",0,[e,t],0,0)},o.prototype._EnterFullScreen=function(){i(this,"_EnterFullScreen",0,[],0,0)},o.prototype._ExitFullScreen=function(){i(this,"_ExitFullScreen",0,[],0,0)},o.prototype._FocusCanvas=function(){i(this,"_FocusCanvas",0,[],0,0)},o.prototype._GetAccountInfo=function(){return i(this,"_GetAccountInfo",1,[],4,0)},o.prototype._GetAccountInfoByType=function(e){return i(this,"_GetAccountInfoByType",1,[e],4,0)},o.prototype._GetAccountInfoCollection=function(){return p("Application._GetAccountInfoCollection","OneNoteApi","1.3","OneNote"),i(this,"_GetAccountInfoCollection",1,[],4,0)},o.prototype._GetControlVisibility=function(e){return i(this,"_GetControlVisibility",1,[e],4,0)},o.prototype._GetLoggingInfo=function(){return i(this,"_GetLoggingInfo",1,[],4,0)},o.prototype._GetMathPaneContent=function(){return i(this,"_GetMathPaneContent",1,[],4,0)},o.prototype._GetNodeInternalProperties=function(e){return p("Application._GetNodeInternalProperties","OneNoteApi","1.3","OneNote"),i(this,"_GetNodeInternalProperties",1,[e],4,0)},o.prototype._GetObjectByReferenceId=function(e){return i(this,"_GetObjectByReferenceId",1,[e],4,0)},o.prototype._GetObjectTypeNameByReferenceId=function(e){return i(this,"_GetObjectTypeNameByReferenceId",1,[e],4,0)},o.prototype._GetRoamingSetting=function(e,t){return i(this,"_GetRoamingSetting",0,[e,t],0,0)},o.prototype._GetServiceTokenByUrl=function(e){return i(this,"_GetServiceTokenByUrl",1,[e],4,0)},o.prototype._GetServiceTokenByUserEmail=function(e,t,n){return p("Application._GetServiceTokenByUserEmail","OneNoteApi","1.3","OneNote"),i(this,"_GetServiceTokenByUserEmail",1,[e,t,n],4,0)},o.prototype._GetServiceTokens=function(e){return i(this,"_GetServiceTokens",1,[e],4,0)},o.prototype._GetServiceTokensExt=function(e,t){return i(this,"_GetServiceTokensExt",1,[e,t],4,0)},o.prototype._GetServiceUrl=function(e){return i(this,"_GetServiceUrl",1,[e],4,0)},o.prototype._IsAccountEdpManaged=function(e){return p("Application._IsAccountEdpManaged","OneNoteApi","1.3","OneNote"),i(this,"_IsAccountEdpManaged",1,[e],4,0)},o.prototype._IsControlEnabled=function(e){return i(this,"_IsControlEnabled",1,[e],4,0)},o.prototype._IsImmersiveReaderUwpInstalled=function(){return i(this,"_IsImmersiveReaderUwpInstalled",0,[],0,0)},o.prototype._LaunchImmersiveReaderUwp=function(e){return i(this,"_LaunchImmersiveReaderUwp",0,[e],0,0)},o.prototype._RemoveAllReferences=function(){i(this,"_RemoveAllReferences",1,[],4,0)},o.prototype._RemoveReference=function(e){i(this,"_RemoveReference",1,[e],4,0)},o.prototype._SaveRoamingSetting=function(e,t){return i(this,"_SaveRoamingSetting",0,[e,t],0,0)},o.prototype._SendDataToLearningTools=function(e,t){return i(this,"_SendDataToLearningTools",0,[e,t],0,0)},o.prototype._SendDataToLearningToolsV2=function(e,t){return i(this,"_SendDataToLearningToolsV2",0,[e,t],0,0)},o.prototype._SetControlVisibility=function(e,t){i(this,"_SetControlVisibility",0,[e,t],0,0)},o.prototype._UploadToUserInfoService=function(e,t){i(this,"_UploadToUserInfoService",1,[e,t],4,0)},o.prototype._handleResult=function(e){if(r.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t._platform)||(this.__p=t._platform),g(this,t,["mathAssistantManager","MathAssistantManager","noteTagManager","NoteTagManager","notebooks","Notebooks"])}},o.prototype.load=function(e){return f(this,e)},o.prototype.retrieve=function(e){return d(this,e)},o.prototype._handleRetrieveResult=function(e,t){r.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},o.prototype.toJSON=function(){return h(this,{},{mathAssistantManager:this._M,notebooks:this._N,noteTagManager:this._No})},o.prototype.setMockData=function(e){O(this,e)},o.prototype.ensureUnchanged=function(e){a(this,e)},o}(OfficeExtension.ClientObject));e.Application=_;var b=function(n){function r(){return null!==n&&n.apply(this,arguments)||this}return __extends(r,n),Object.defineProperty(r.prototype,"_className",{get:function(){return"InkAnalysis"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["id","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["paragraphs","page"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"page",{get:function(){return this._P||(this._P=t(e.Page,this,"Page",!1,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"paragraphs",{get:function(){return this._Pa||(this._Pa=t(e.InkAnalysisParagraphCollection,this,"Paragraphs",!0,4)),this._Pa},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"id",{get:function(){return u("id",this._I,"InkAnalysis",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"InkAnalysis",this._isNull),this.__R},enumerable:!0,configurable:!0}),r.prototype.set=function(e,t){this._recursivelySet(e,t,[],["page"],["paragraphs"])},r.prototype.update=function(e){this._recursivelyUpdate(e)},r.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},r.prototype._handleResult=function(e){if(n.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.Id)||(this._I=t.Id),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["page","Page","paragraphs","Paragraphs"])}},r.prototype.load=function(e){return f(this,e)},r.prototype.retrieve=function(e){return d(this,e)},r.prototype._handleIdResult=function(e){n.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},r.prototype._handleRetrieveResult=function(e,t){n.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},r.prototype.track=function(){return this.context.trackedObjects.add(this),this},r.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},r.prototype.toJSON=function(){return h(this,{id:this._I},{page:this._P,paragraphs:this._Pa})},r.prototype.setMockData=function(e){O(this,e)},r.prototype.ensureUnchanged=function(e){a(this,e)},r}(OfficeExtension.ClientObject);e.InkAnalysis=b;var v=function(n){function r(){return null!==n&&n.apply(this,arguments)||this}return __extends(r,n),Object.defineProperty(r.prototype,"_className",{get:function(){return"InkAnalysisParagraph"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["id","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["lines","inkAnalysis"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"inkAnalysis",{get:function(){return this._In||(this._In=t(e.InkAnalysis,this,"InkAnalysis",!1,4)),this._In},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"lines",{get:function(){return this._L||(this._L=t(e.InkAnalysisLineCollection,this,"Lines",!0,4)),this._L},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"id",{get:function(){return u("id",this._I,"InkAnalysisParagraph",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"InkAnalysisParagraph",this._isNull),this.__R},enumerable:!0,configurable:!0}),r.prototype.set=function(e,t){this._recursivelySet(e,t,[],["inkAnalysis"],["lines"])},r.prototype.update=function(e){this._recursivelyUpdate(e)},r.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},r.prototype._handleResult=function(e){if(n.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.Id)||(this._I=t.Id),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["inkAnalysis","InkAnalysis","lines","Lines"])}},r.prototype.load=function(e){return f(this,e)},r.prototype.retrieve=function(e){return d(this,e)},r.prototype._handleIdResult=function(e){n.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},r.prototype._handleRetrieveResult=function(e,t){n.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},r.prototype.track=function(){return this.context.trackedObjects.add(this),this},r.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},r.prototype.toJSON=function(){return h(this,{id:this._I},{inkAnalysis:this._In,lines:this._L})},r.prototype.setMockData=function(e){O(this,e)},r.prototype.ensureUnchanged=function(e){a(this,e)},r}(OfficeExtension.ClientObject);e.InkAnalysisParagraph=v;var S=function(t){function a(){return null!==t&&t.apply(this,arguments)||this}return __extends(a,t),Object.defineProperty(a.prototype,"_className",{get:function(){return"InkAnalysisParagraphCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyNames",{get:function(){return["_ReferenceId","count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_ReferenceId","Count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"items",{get:function(){return u("items",this.m__items,"InkAnalysisParagraphCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"count",{get:function(){return u("count",this._C,"InkAnalysisParagraphCollection",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"InkAnalysisParagraphCollection",this._isNull),this.__R},enumerable:!0,configurable:!0}),a.prototype.getItem=function(t){return r(e.InkAnalysisParagraph,this,[t])},a.prototype.getItemAt=function(t){return n(e.InkAnalysisParagraph,this,"GetItemAt",1,[t],!1,!1,null,4)},a.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},a.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!c(n)){var r=n;if(m(this,r),l(r.Count)||(this._C=r.Count),l(r._ReferenceId)||(this.__R=r._ReferenceId),!c(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],a=0;a<i.length;a++){var s=o(e.InkAnalysisParagraph,!0,this,i[a],a);s._handleResult(i[a]),this.m__items.push(s)}}}},a.prototype.load=function(e){return f(this,e)},a.prototype.retrieve=function(e){return d(this,e)},a.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),c(e)||l(e._ReferenceId)||(this.__R=e._ReferenceId)},a.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),y(this,n,r,(function(t,n){return o(e.InkAnalysisParagraph,!0,i,t,n)}))},a.prototype.track=function(){return this.context.trackedObjects.add(this),this},a.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},a.prototype.toJSON=function(){return h(this,{count:this._C},{},this.m__items)},a.prototype.setMockData=function(t){var n=this;O(this,t,(function(t,r){return o(e.InkAnalysisParagraph,!0,n,t,r)}),(function(e){return n.m__items=e}))},a}(OfficeExtension.ClientObject);e.InkAnalysisParagraphCollection=S;var A=function(n){function r(){return null!==n&&n.apply(this,arguments)||this}return __extends(r,n),Object.defineProperty(r.prototype,"_className",{get:function(){return"InkAnalysisLine"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["id","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["words","paragraph"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"paragraph",{get:function(){return this._P||(this._P=t(e.InkAnalysisParagraph,this,"Paragraph",!1,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"words",{get:function(){return this._W||(this._W=t(e.InkAnalysisWordCollection,this,"Words",!0,4)),this._W},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"id",{get:function(){return u("id",this._I,"InkAnalysisLine",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"InkAnalysisLine",this._isNull),this.__R},enumerable:!0,configurable:!0}),r.prototype.set=function(e,t){this._recursivelySet(e,t,[],["paragraph"],["words"])},r.prototype.update=function(e){this._recursivelyUpdate(e)},r.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},r.prototype._handleResult=function(e){if(n.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.Id)||(this._I=t.Id),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["paragraph","Paragraph","words","Words"])}},r.prototype.load=function(e){return f(this,e)},r.prototype.retrieve=function(e){return d(this,e)},r.prototype._handleIdResult=function(e){n.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},r.prototype._handleRetrieveResult=function(e,t){n.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},r.prototype.track=function(){return this.context.trackedObjects.add(this),this},r.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},r.prototype.toJSON=function(){return h(this,{id:this._I},{paragraph:this._P,words:this._W})},r.prototype.setMockData=function(e){O(this,e)},r.prototype.ensureUnchanged=function(e){a(this,e)},r}(OfficeExtension.ClientObject);e.InkAnalysisLine=A;var D=function(t){function a(){return null!==t&&t.apply(this,arguments)||this}return __extends(a,t),Object.defineProperty(a.prototype,"_className",{get:function(){return"InkAnalysisLineCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyNames",{get:function(){return["_ReferenceId","count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_ReferenceId","Count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"items",{get:function(){return u("items",this.m__items,"InkAnalysisLineCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"count",{get:function(){return u("count",this._C,"InkAnalysisLineCollection",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"InkAnalysisLineCollection",this._isNull),this.__R},enumerable:!0,configurable:!0}),a.prototype.getItem=function(t){return r(e.InkAnalysisLine,this,[t])},a.prototype.getItemAt=function(t){return n(e.InkAnalysisLine,this,"GetItemAt",1,[t],!1,!1,null,4)},a.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},a.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!c(n)){var r=n;if(m(this,r),l(r.Count)||(this._C=r.Count),l(r._ReferenceId)||(this.__R=r._ReferenceId),!c(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],a=0;a<i.length;a++){var s=o(e.InkAnalysisLine,!0,this,i[a],a);s._handleResult(i[a]),this.m__items.push(s)}}}},a.prototype.load=function(e){return f(this,e)},a.prototype.retrieve=function(e){return d(this,e)},a.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),c(e)||l(e._ReferenceId)||(this.__R=e._ReferenceId)},a.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),y(this,n,r,(function(t,n){return o(e.InkAnalysisLine,!0,i,t,n)}))},a.prototype.track=function(){return this.context.trackedObjects.add(this),this},a.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},a.prototype.toJSON=function(){return h(this,{count:this._C},{},this.m__items)},a.prototype.setMockData=function(t){var n=this;O(this,t,(function(t,r){return o(e.InkAnalysisLine,!0,n,t,r)}),(function(e){return n.m__items=e}))},a}(OfficeExtension.ClientObject);e.InkAnalysisLineCollection=D;var P=function(n){function r(){return null!==n&&n.apply(this,arguments)||this}return __extends(r,n),Object.defineProperty(r.prototype,"_className",{get:function(){return"InkAnalysisWord"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["id","_ReferenceId","wordAlternates","strokePointers","languageId"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","_ReferenceId","WordAlternates","StrokePointers","LanguageId"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["line"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"line",{get:function(){return this._Li||(this._Li=t(e.InkAnalysisLine,this,"Line",!1,4)),this._Li},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"id",{get:function(){return u("id",this._I,"InkAnalysisWord",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"languageId",{get:function(){return u("languageId",this._L,"InkAnalysisWord",this._isNull),this._L},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"strokePointers",{get:function(){return u("strokePointers",this._S,"InkAnalysisWord",this._isNull),this._S},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"wordAlternates",{get:function(){return u("wordAlternates",this._W,"InkAnalysisWord",this._isNull),this._W},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"InkAnalysisWord",this._isNull),this.__R},enumerable:!0,configurable:!0}),r.prototype.set=function(e,t){this._recursivelySet(e,t,[],["line"],[])},r.prototype.update=function(e){this._recursivelyUpdate(e)},r.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},r.prototype._handleResult=function(e){if(n.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.Id)||(this._I=t.Id),l(t.LanguageId)||(this._L=t.LanguageId),l(t.StrokePointers)||(this._S=t.StrokePointers),l(t.WordAlternates)||(this._W=t.WordAlternates),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["line","Line"])}},r.prototype.load=function(e){return f(this,e)},r.prototype.retrieve=function(e){return d(this,e)},r.prototype._handleIdResult=function(e){n.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},r.prototype._handleRetrieveResult=function(e,t){n.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},r.prototype.track=function(){return this.context.trackedObjects.add(this),this},r.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},r.prototype.toJSON=function(){return h(this,{id:this._I,languageId:this._L,strokePointers:this._S,wordAlternates:this._W},{line:this._Li})},r.prototype.setMockData=function(e){O(this,e)},r.prototype.ensureUnchanged=function(e){a(this,e)},r}(OfficeExtension.ClientObject);e.InkAnalysisWord=P;var I=function(t){function a(){return null!==t&&t.apply(this,arguments)||this}return __extends(a,t),Object.defineProperty(a.prototype,"_className",{get:function(){return"InkAnalysisWordCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyNames",{get:function(){return["_ReferenceId","count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_ReferenceId","Count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"items",{get:function(){return u("items",this.m__items,"InkAnalysisWordCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"count",{get:function(){return u("count",this._C,"InkAnalysisWordCollection",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"InkAnalysisWordCollection",this._isNull),this.__R},enumerable:!0,configurable:!0}),a.prototype.getItem=function(t){return r(e.InkAnalysisWord,this,[t])},a.prototype.getItemAt=function(t){return n(e.InkAnalysisWord,this,"GetItemAt",1,[t],!1,!1,null,4)},a.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},a.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!c(n)){var r=n;if(m(this,r),l(r.Count)||(this._C=r.Count),l(r._ReferenceId)||(this.__R=r._ReferenceId),!c(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],a=0;a<i.length;a++){var s=o(e.InkAnalysisWord,!0,this,i[a],a);s._handleResult(i[a]),this.m__items.push(s)}}}},a.prototype.load=function(e){return f(this,e)},a.prototype.retrieve=function(e){return d(this,e)},a.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),c(e)||l(e._ReferenceId)||(this.__R=e._ReferenceId)},a.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),y(this,n,r,(function(t,n){return o(e.InkAnalysisWord,!0,i,t,n)}))},a.prototype.track=function(){return this.context.trackedObjects.add(this),this},a.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},a.prototype.toJSON=function(){return h(this,{count:this._C},{},this.m__items)},a.prototype.setMockData=function(t){var n=this;O(this,t,(function(t,r){return o(e.InkAnalysisWord,!0,n,t,r)}),(function(e){return n.m__items=e}))},a}(OfficeExtension.ClientObject);e.InkAnalysisWordCollection=I;var C=function(n){function r(){return null!==n&&n.apply(this,arguments)||this}return __extends(r,n),Object.defineProperty(r.prototype,"_className",{get:function(){return"FloatingInk"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["id","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["inkStrokes","pageContent"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"inkStrokes",{get:function(){return this._In||(this._In=t(e.InkStrokeCollection,this,"InkStrokes",!0,4)),this._In},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"pageContent",{get:function(){return this._P||(this._P=t(e.PageContent,this,"PageContent",!1,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"id",{get:function(){return u("id",this._I,"FloatingInk",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"FloatingInk",this._isNull),this.__R},enumerable:!0,configurable:!0}),r.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},r.prototype._handleResult=function(e){if(n.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.Id)||(this._I=t.Id),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["inkStrokes","InkStrokes","pageContent","PageContent"])}},r.prototype.load=function(e){return f(this,e)},r.prototype.retrieve=function(e){return d(this,e)},r.prototype._handleIdResult=function(e){n.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},r.prototype._handleRetrieveResult=function(e,t){n.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},r.prototype.track=function(){return this.context.trackedObjects.add(this),this},r.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},r.prototype.toJSON=function(){return h(this,{id:this._I},{inkStrokes:this._In})},r.prototype.setMockData=function(e){O(this,e)},r.prototype.ensureUnchanged=function(e){a(this,e)},r}(OfficeExtension.ClientObject);e.FloatingInk=C;var F=function(n){function r(){return null!==n&&n.apply(this,arguments)||this}return __extends(r,n),Object.defineProperty(r.prototype,"_className",{get:function(){return"InkStroke"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["id","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["floatingInk","points"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"floatingInk",{get:function(){return this._F||(this._F=t(e.FloatingInk,this,"FloatingInk",!1,4)),this._F},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"points",{get:function(){return p("InkStroke.points","OneNoteApi","1.9","OneNote"),this._P||(this._P=t(e.PointCollection,this,"Points",!0,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"id",{get:function(){return u("id",this._I,"InkStroke",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"InkStroke",this._isNull),this.__R},enumerable:!0,configurable:!0}),r.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},r.prototype._handleResult=function(e){if(n.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.Id)||(this._I=t.Id),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["floatingInk","FloatingInk","points","Points"])}},r.prototype.load=function(e){return f(this,e)},r.prototype.retrieve=function(e){return d(this,e)},r.prototype._handleIdResult=function(e){n.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},r.prototype._handleRetrieveResult=function(e,t){n.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},r.prototype.track=function(){return this.context.trackedObjects.add(this),this},r.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},r.prototype.toJSON=function(){return h(this,{id:this._I},{floatingInk:this._F,points:this._P})},r.prototype.setMockData=function(e){O(this,e)},r.prototype.ensureUnchanged=function(e){a(this,e)},r}(OfficeExtension.ClientObject);e.InkStroke=F;var E=function(t){function a(){return null!==t&&t.apply(this,arguments)||this}return __extends(a,t),Object.defineProperty(a.prototype,"_className",{get:function(){return"InkStrokeCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyNames",{get:function(){return["_ReferenceId","count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_ReferenceId","Count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"items",{get:function(){return u("items",this.m__items,"InkStrokeCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"count",{get:function(){return u("count",this._C,"InkStrokeCollection",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"InkStrokeCollection",this._isNull),this.__R},enumerable:!0,configurable:!0}),a.prototype.getItem=function(t){return r(e.InkStroke,this,[t])},a.prototype.getItemAt=function(t){return n(e.InkStroke,this,"GetItemAt",1,[t],!1,!1,null,4)},a.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},a.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!c(n)){var r=n;if(m(this,r),l(r.Count)||(this._C=r.Count),l(r._ReferenceId)||(this.__R=r._ReferenceId),!c(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],a=0;a<i.length;a++){var s=o(e.InkStroke,!0,this,i[a],a);s._handleResult(i[a]),this.m__items.push(s)}}}},a.prototype.load=function(e){return f(this,e)},a.prototype.retrieve=function(e){return d(this,e)},a.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),c(e)||l(e._ReferenceId)||(this.__R=e._ReferenceId)},a.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),y(this,n,r,(function(t,n){return o(e.InkStroke,!0,i,t,n)}))},a.prototype.track=function(){return this.context.trackedObjects.add(this),this},a.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},a.prototype.toJSON=function(){return h(this,{count:this._C},{},this.m__items)},a.prototype.setMockData=function(t){var n=this;O(this,t,(function(t,r){return o(e.InkStroke,!0,n,t,r)}),(function(e){return n.m__items=e}))},a}(OfficeExtension.ClientObject);e.InkStrokeCollection=E;var R=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"Point"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["id","_ReferenceId","x","y"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","_ReferenceId","X","Y"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"id",{get:function(){return u("id",this._I,"Point",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"x",{get:function(){return u("x",this._X,"Point",this._isNull),this._X},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"y",{get:function(){return u("y",this._Y,"Point",this._isNull),this._Y},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"Point",this._isNull),this.__R},enumerable:!0,configurable:!0}),t.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!c(t)){var n=t;m(this,n),l(n.Id)||(this._I=n.Id),l(n.X)||(this._X=n.X),l(n.Y)||(this._Y=n.Y),l(n._ReferenceId)||(this.__R=n._ReferenceId)}},t.prototype.load=function(e){return f(this,e)},t.prototype.retrieve=function(e){return d(this,e)},t.prototype._handleIdResult=function(t){e.prototype._handleIdResult.call(this,t),c(t)||(l(t._ReferenceId)||(this.__R=t._ReferenceId),l(t.Id)||(this._I=t.Id))},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),y(this,t,n)},t.prototype.track=function(){return this.context.trackedObjects.add(this),this},t.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},t.prototype.toJSON=function(){return h(this,{id:this._I,x:this._X,y:this._Y},{})},t.prototype.setMockData=function(e){O(this,e)},t.prototype.ensureUnchanged=function(e){a(this,e)},t}(OfficeExtension.ClientObject);e.Point=R;var N=function(t){function a(){return null!==t&&t.apply(this,arguments)||this}return __extends(a,t),Object.defineProperty(a.prototype,"_className",{get:function(){return"PointCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyNames",{get:function(){return["_ReferenceId","count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_ReferenceId","Count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"items",{get:function(){return u("items",this.m__items,"PointCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"count",{get:function(){return u("count",this._C,"PointCollection",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"PointCollection",this._isNull),this.__R},enumerable:!0,configurable:!0}),a.prototype.getItem=function(t){return r(e.Point,this,[t])},a.prototype.getItemAt=function(t){return n(e.Point,this,"GetItemAt",1,[t],!1,!1,null,4)},a.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},a.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!c(n)){var r=n;if(m(this,r),l(r.Count)||(this._C=r.Count),l(r._ReferenceId)||(this.__R=r._ReferenceId),!c(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],a=0;a<i.length;a++){var s=o(e.Point,!0,this,i[a],a);s._handleResult(i[a]),this.m__items.push(s)}}}},a.prototype.load=function(e){return f(this,e)},a.prototype.retrieve=function(e){return d(this,e)},a.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),c(e)||l(e._ReferenceId)||(this.__R=e._ReferenceId)},a.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),y(this,n,r,(function(t,n){return o(e.Point,!0,i,t,n)}))},a.prototype.track=function(){return this.context.trackedObjects.add(this),this},a.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},a.prototype.toJSON=function(){return h(this,{count:this._C},{},this.m__items)},a.prototype.setMockData=function(t){var n=this;O(this,t,(function(t,r){return o(e.Point,!0,n,t,r)}),(function(e){return n.m__items=e}))},a}(OfficeExtension.ClientObject);e.PointCollection=N;var x=function(n){function r(){return null!==n&&n.apply(this,arguments)||this}return __extends(r,n),Object.defineProperty(r.prototype,"_className",{get:function(){return"InkWord"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["id","_ReferenceId","wordAlternates","languageId"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","_ReferenceId","WordAlternates","LanguageId"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["paragraph"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"paragraph",{get:function(){return this._P||(this._P=t(e.Paragraph,this,"Paragraph",!1,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"id",{get:function(){return u("id",this._I,"InkWord",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"languageId",{get:function(){return u("languageId",this._L,"InkWord",this._isNull),this._L},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"wordAlternates",{get:function(){return u("wordAlternates",this._W,"InkWord",this._isNull),this._W},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"InkWord",this._isNull),this.__R},enumerable:!0,configurable:!0}),r.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},r.prototype._handleResult=function(e){if(n.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.Id)||(this._I=t.Id),l(t.LanguageId)||(this._L=t.LanguageId),l(t.WordAlternates)||(this._W=t.WordAlternates),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["paragraph","Paragraph"])}},r.prototype.load=function(e){return f(this,e)},r.prototype.retrieve=function(e){return d(this,e)},r.prototype._handleIdResult=function(e){n.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},r.prototype._handleRetrieveResult=function(e,t){n.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},r.prototype.track=function(){return this.context.trackedObjects.add(this),this},r.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},r.prototype.toJSON=function(){return h(this,{id:this._I,languageId:this._L,wordAlternates:this._W},{})},r.prototype.setMockData=function(e){O(this,e)},r.prototype.ensureUnchanged=function(e){a(this,e)},r}(OfficeExtension.ClientObject);e.InkWord=x;var M=function(t){function a(){return null!==t&&t.apply(this,arguments)||this}return __extends(a,t),Object.defineProperty(a.prototype,"_className",{get:function(){return"InkWordCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyNames",{get:function(){return["_ReferenceId","count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_ReferenceId","Count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"items",{get:function(){return u("items",this.m__items,"InkWordCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"count",{get:function(){return u("count",this._C,"InkWordCollection",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"InkWordCollection",this._isNull),this.__R},enumerable:!0,configurable:!0}),a.prototype.getItem=function(t){return r(e.InkWord,this,[t])},a.prototype.getItemAt=function(t){return n(e.InkWord,this,"GetItemAt",1,[t],!1,!1,null,4)},a.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},a.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!c(n)){var r=n;if(m(this,r),l(r.Count)||(this._C=r.Count),l(r._ReferenceId)||(this.__R=r._ReferenceId),!c(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],a=0;a<i.length;a++){var s=o(e.InkWord,!0,this,i[a],a);s._handleResult(i[a]),this.m__items.push(s)}}}},a.prototype.load=function(e){return f(this,e)},a.prototype.retrieve=function(e){return d(this,e)},a.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),c(e)||l(e._ReferenceId)||(this.__R=e._ReferenceId)},a.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),y(this,n,r,(function(t,n){return o(e.InkWord,!0,i,t,n)}))},a.prototype.track=function(){return this.context.trackedObjects.add(this),this},a.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},a.prototype.toJSON=function(){return h(this,{count:this._C},{},this.m__items)},a.prototype.setMockData=function(t){var n=this;O(this,t,(function(t,r){return o(e.InkWord,!0,n,t,r)}),(function(e){return n.m__items=e}))},a}(OfficeExtension.ClientObject);e.InkWordCollection=M;var T=function(r){function o(){return null!==r&&r.apply(this,arguments)||this}return __extends(o,r),Object.defineProperty(o.prototype,"_className",{get:function(){return"Notebook"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyNames",{get:function(){return["id","name","_ReferenceId","clientUrl","baseUrl","isVirtual","isForEducation","isReadOnly"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Name","_ReferenceId","ClientUrl","BaseUrl","IsVirtual","IsForEducation","IsReadOnly"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_navigationPropertyNames",{get:function(){return["sections","sectionGroups","accessibilityViolations"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"accessibilityViolations",{get:function(){return p("Notebook.accessibilityViolations","OneNoteApi","1.2","OneNote"),this._A||(this._A=t(e.AccessibilityViolationsByEntityCollection,this,"AccessibilityViolations",!0,4)),this._A},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"sectionGroups",{get:function(){return this._S||(this._S=t(e.SectionGroupCollection,this,"SectionGroups",!0,4)),this._S},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"sections",{get:function(){return this._Se||(this._Se=t(e.SectionCollection,this,"Sections",!0,4)),this._Se},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"baseUrl",{get:function(){return u("baseUrl",this._B,"Notebook",this._isNull),this._B},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"clientUrl",{get:function(){return u("clientUrl",this._C,"Notebook",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"id",{get:function(){return u("id",this._I,"Notebook",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"isForEducation",{get:function(){return u("isForEducation",this._Is,"Notebook",this._isNull),p("Notebook.isForEducation","OneNoteApi","1.11","OneNote"),this._Is},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"isReadOnly",{get:function(){return u("isReadOnly",this._IsR,"Notebook",this._isNull),p("Notebook.isReadOnly","OneNoteApi","1.11","OneNote"),this._IsR},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"isVirtual",{get:function(){return u("isVirtual",this._IsV,"Notebook",this._isNull),p("Notebook.isVirtual","OneNoteApi","1.2","OneNote"),this._IsV},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"name",{get:function(){return u("name",this._N,"Notebook",this._isNull),this._N},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"Notebook",this._isNull),this.__R},enumerable:!0,configurable:!0}),o.prototype.addSection=function(t){return n(e.Section,this,"AddSection",0,[t],!1,!0,null,0)},o.prototype.addSectionGroup=function(t){return n(e.SectionGroup,this,"AddSectionGroup",0,[t],!1,!0,null,0)},o.prototype.canCopyDataFromAccount=function(e){return p("Notebook.canCopyDataFromAccount","OneNoteApi","1.3","OneNote"),i(this,"CanCopyDataFromAccount",1,[e],4,0)},o.prototype.canCopyDataToAccount=function(e){return p("Notebook.canCopyDataToAccount","OneNoteApi","1.3","OneNote"),i(this,"CanCopyDataToAccount",1,[e],4,0)},o.prototype.getRestApiId=function(){return i(this,"GetRestApiId",1,[],4,0)},o.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},o.prototype._Sync=function(){i(this,"_Sync",0,[],0,0)},o.prototype._handleResult=function(e){if(r.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.BaseUrl)||(this._B=t.BaseUrl),l(t.ClientUrl)||(this._C=t.ClientUrl),l(t.Id)||(this._I=t.Id),l(t.IsForEducation)||(this._Is=t.IsForEducation),l(t.IsReadOnly)||(this._IsR=t.IsReadOnly),l(t.IsVirtual)||(this._IsV=t.IsVirtual),l(t.Name)||(this._N=t.Name),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["accessibilityViolations","AccessibilityViolations","sectionGroups","SectionGroups","sections","Sections"])}},o.prototype.load=function(e){return f(this,e)},o.prototype.retrieve=function(e){return d(this,e)},o.prototype._handleIdResult=function(e){r.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},o.prototype._handleRetrieveResult=function(e,t){r.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},o.prototype.track=function(){return this.context.trackedObjects.add(this),this},o.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},o.prototype.toJSON=function(){return h(this,{baseUrl:this._B,clientUrl:this._C,id:this._I,isForEducation:this._Is,isReadOnly:this._IsR,isVirtual:this._IsV,name:this._N},{accessibilityViolations:this._A,sectionGroups:this._S,sections:this._Se})},o.prototype.setMockData=function(e){O(this,e)},o.prototype.ensureUnchanged=function(e){a(this,e)},o}(OfficeExtension.ClientObject);e.Notebook=T;var j=function(t){function a(){return null!==t&&t.apply(this,arguments)||this}return __extends(a,t),Object.defineProperty(a.prototype,"_className",{get:function(){return"NotebookCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyNames",{get:function(){return["_ReferenceId","count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_ReferenceId","Count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"items",{get:function(){return u("items",this.m__items,"NotebookCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"count",{get:function(){return u("count",this._C,"NotebookCollection",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"NotebookCollection",this._isNull),this.__R},enumerable:!0,configurable:!0}),a.prototype.getByName=function(t){return n(e.NotebookCollection,this,"GetByName",1,[t],!0,!1,null,4)},a.prototype.getItem=function(t){return r(e.Notebook,this,[t])},a.prototype.getItemAt=function(t){return n(e.Notebook,this,"GetItemAt",1,[t],!1,!1,null,4)},a.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},a.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!c(n)){var r=n;if(m(this,r),l(r.Count)||(this._C=r.Count),l(r._ReferenceId)||(this.__R=r._ReferenceId),!c(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],a=0;a<i.length;a++){var s=o(e.Notebook,!0,this,i[a],a);s._handleResult(i[a]),this.m__items.push(s)}}}},a.prototype.load=function(e){return f(this,e)},a.prototype.retrieve=function(e){return d(this,e)},a.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),c(e)||l(e._ReferenceId)||(this.__R=e._ReferenceId)},a.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),y(this,n,r,(function(t,n){return o(e.Notebook,!0,i,t,n)}))},a.prototype.track=function(){return this.context.trackedObjects.add(this),this},a.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},a.prototype.toJSON=function(){return h(this,{count:this._C},{},this.m__items)},a.prototype.setMockData=function(t){var n=this;O(this,t,(function(t,r){return o(e.Notebook,!0,n,t,r)}),(function(e){return n.m__items=e}))},a}(OfficeExtension.ClientObject);e.NotebookCollection=j;var w=function(r){function o(){return null!==r&&r.apply(this,arguments)||this}return __extends(o,r),Object.defineProperty(o.prototype,"_className",{get:function(){return"SectionGroup"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyNames",{get:function(){return["id","name","_ReferenceId","clientUrl"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Name","_ReferenceId","ClientUrl"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_navigationPropertyNames",{get:function(){return["notebook","parentSectionGroup","parentSectionGroupOrNull","sections","sectionGroups"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"notebook",{get:function(){return this._No||(this._No=t(e.Notebook,this,"Notebook",!1,4)),this._No},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"parentSectionGroup",{get:function(){return this._P||(this._P=t(e.SectionGroup,this,"ParentSectionGroup",!1,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"parentSectionGroupOrNull",{get:function(){return this._Pa||(this._Pa=t(e.SectionGroup,this,"ParentSectionGroupOrNull",!1,4)),this._Pa},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"sectionGroups",{get:function(){return this._S||(this._S=t(e.SectionGroupCollection,this,"SectionGroups",!0,4)),this._S},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"sections",{get:function(){return this._Se||(this._Se=t(e.SectionCollection,this,"Sections",!0,4)),this._Se},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"clientUrl",{get:function(){return u("clientUrl",this._C,"SectionGroup",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"id",{get:function(){return u("id",this._I,"SectionGroup",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"name",{get:function(){return u("name",this._N,"SectionGroup",this._isNull),this._N},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"SectionGroup",this._isNull),this.__R},enumerable:!0,configurable:!0}),o.prototype.addSection=function(t){return n(e.Section,this,"AddSection",0,[t],!1,!0,null,0)},o.prototype.addSectionGroup=function(t){return n(e.SectionGroup,this,"AddSectionGroup",0,[t],!1,!0,null,0)},o.prototype.getRestApiId=function(){return i(this,"GetRestApiId",1,[],4,0)},o.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},o.prototype._handleResult=function(e){if(r.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.ClientUrl)||(this._C=t.ClientUrl),l(t.Id)||(this._I=t.Id),l(t.Name)||(this._N=t.Name),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["notebook","Notebook","parentSectionGroup","ParentSectionGroup","parentSectionGroupOrNull","ParentSectionGroupOrNull","sectionGroups","SectionGroups","sections","Sections"])}},o.prototype.load=function(e){return f(this,e)},o.prototype.retrieve=function(e){return d(this,e)},o.prototype._handleIdResult=function(e){r.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},o.prototype._handleRetrieveResult=function(e,t){r.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},o.prototype.track=function(){return this.context.trackedObjects.add(this),this},o.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},o.prototype.toJSON=function(){return h(this,{clientUrl:this._C,id:this._I,name:this._N},{sectionGroups:this._S,sections:this._Se})},o.prototype.setMockData=function(e){O(this,e)},o.prototype.ensureUnchanged=function(e){a(this,e)},o}(OfficeExtension.ClientObject);e.SectionGroup=w;var k=function(t){function a(){return null!==t&&t.apply(this,arguments)||this}return __extends(a,t),Object.defineProperty(a.prototype,"_className",{get:function(){return"SectionGroupCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyNames",{get:function(){return["_ReferenceId","count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_ReferenceId","Count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"items",{get:function(){return u("items",this.m__items,"SectionGroupCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"count",{get:function(){return u("count",this._C,"SectionGroupCollection",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"SectionGroupCollection",this._isNull),this.__R},enumerable:!0,configurable:!0}),a.prototype.getByName=function(t){return n(e.SectionGroupCollection,this,"GetByName",1,[t],!0,!1,null,4)},a.prototype.getItem=function(t){return r(e.SectionGroup,this,[t])},a.prototype.getItemAt=function(t){return n(e.SectionGroup,this,"GetItemAt",1,[t],!1,!1,null,4)},a.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},a.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!c(n)){var r=n;if(m(this,r),l(r.Count)||(this._C=r.Count),l(r._ReferenceId)||(this.__R=r._ReferenceId),!c(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],a=0;a<i.length;a++){var s=o(e.SectionGroup,!0,this,i[a],a);s._handleResult(i[a]),this.m__items.push(s)}}}},a.prototype.load=function(e){return f(this,e)},a.prototype.retrieve=function(e){return d(this,e)},a.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),c(e)||l(e._ReferenceId)||(this.__R=e._ReferenceId)},a.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),y(this,n,r,(function(t,n){return o(e.SectionGroup,!0,i,t,n)}))},a.prototype.track=function(){return this.context.trackedObjects.add(this),this},a.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},a.prototype.toJSON=function(){return h(this,{count:this._C},{},this.m__items)},a.prototype.setMockData=function(t){var n=this;O(this,t,(function(t,r){return o(e.SectionGroup,!0,n,t,r)}),(function(e){return n.m__items=e}))},a}(OfficeExtension.ClientObject);e.SectionGroupCollection=k;var U=function(r){function o(){return null!==r&&r.apply(this,arguments)||this}return __extends(o,r),Object.defineProperty(o.prototype,"_className",{get:function(){return"Section"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyNames",{get:function(){return["id","name","_ReferenceId","clientUrl","webUrl","isEncrypted","isLocked"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Name","_ReferenceId","ClientUrl","WebUrl","IsEncrypted","IsLocked"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_navigationPropertyNames",{get:function(){return["notebook","parentSectionGroup","parentSectionGroupOrNull","pages"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"notebook",{get:function(){return this._No||(this._No=t(e.Notebook,this,"Notebook",!1,4)),this._No},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"pages",{get:function(){return this._P||(this._P=t(e.PageCollection,this,"Pages",!0,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"parentSectionGroup",{get:function(){return this._Pa||(this._Pa=t(e.SectionGroup,this,"ParentSectionGroup",!1,4)),this._Pa},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"parentSectionGroupOrNull",{get:function(){return this._Par||(this._Par=t(e.SectionGroup,this,"ParentSectionGroupOrNull",!1,4)),this._Par},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"clientUrl",{get:function(){return u("clientUrl",this._C,"Section",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"id",{get:function(){return u("id",this._I,"Section",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"isEncrypted",{get:function(){return u("isEncrypted",this._Is,"Section",this._isNull),p("Section.isEncrypted","OneNoteApi","1.2","OneNote"),this._Is},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"isLocked",{get:function(){return u("isLocked",this._IsL,"Section",this._isNull),p("Section.isLocked","OneNoteApi","1.2","OneNote"),this._IsL},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"name",{get:function(){return u("name",this._N,"Section",this._isNull),this._N},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"webUrl",{get:function(){return u("webUrl",this._W,"Section",this._isNull),this._W},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"Section",this._isNull),this.__R},enumerable:!0,configurable:!0}),o.prototype.addPage=function(t){return n(e.Page,this,"AddPage",0,[t],!1,!0,null,0)},o.prototype.applyPageTemplate=function(t){return n(e.Page,this,"ApplyPageTemplate",0,[t],!1,!1,null,0)},o.prototype.copyToNotebook=function(t){return n(e.Section,this,"CopyToNotebook",0,[t],!1,!0,null,0)},o.prototype.copyToSectionGroup=function(t){return n(e.Section,this,"CopyToSectionGroup",0,[t],!1,!0,null,0)},o.prototype.getDefaultTemplateName=function(){return p("Section.getDefaultTemplateName","OneNoteApi","1.7","OneNote"),i(this,"GetDefaultTemplateName",0,[],0,0)},o.prototype.getRestApiId=function(){return i(this,"GetRestApiId",1,[],4,0)},o.prototype.insertSectionAsSibling=function(t,r){return n(e.Section,this,"InsertSectionAsSibling",0,[t,r],!1,!0,null,0)},o.prototype.removeDefaultTemplate=function(){p("Section.removeDefaultTemplate","OneNoteApi","1.7","OneNote"),i(this,"RemoveDefaultTemplate",0,[],0,0)},o.prototype.setDefaultTemplate=function(e){return p("Section.setDefaultTemplate","OneNoteApi","1.7","OneNote"),i(this,"SetDefaultTemplate",0,[e],0,0)},o.prototype._GetDefaultTemplateThumbnailAsync=function(e,t,n){return p("Section._GetDefaultTemplateThumbnailAsync","OneNoteApi","1.7","OneNote"),i(this,"_GetDefaultTemplateThumbnailAsync",0,[e,t,n],0,0)},o.prototype._GetGeoInfo=function(){return i(this,"_GetGeoInfo",1,[],4,0)},o.prototype._GetGeoInfoAsync=function(){return i(this,"_GetGeoInfoAsync",1,[],4,0)},o.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},o.prototype._handleResult=function(e){if(r.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.ClientUrl)||(this._C=t.ClientUrl),l(t.Id)||(this._I=t.Id),l(t.IsEncrypted)||(this._Is=t.IsEncrypted),l(t.IsLocked)||(this._IsL=t.IsLocked),l(t.Name)||(this._N=t.Name),l(t.WebUrl)||(this._W=t.WebUrl),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["notebook","Notebook","pages","Pages","parentSectionGroup","ParentSectionGroup","parentSectionGroupOrNull","ParentSectionGroupOrNull"])}},o.prototype.load=function(e){return f(this,e)},o.prototype.retrieve=function(e){return d(this,e)},o.prototype._handleIdResult=function(e){r.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},o.prototype._handleRetrieveResult=function(e,t){r.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},o.prototype.track=function(){return this.context.trackedObjects.add(this),this},o.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},o.prototype.toJSON=function(){return h(this,{clientUrl:this._C,id:this._I,isEncrypted:this._Is,isLocked:this._IsL,name:this._N,webUrl:this._W},{pages:this._P})},o.prototype.setMockData=function(e){O(this,e)},o.prototype.ensureUnchanged=function(e){a(this,e)},o}(OfficeExtension.ClientObject);e.Section=U;var L=function(t){function a(){return null!==t&&t.apply(this,arguments)||this}return __extends(a,t),Object.defineProperty(a.prototype,"_className",{get:function(){return"SectionCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyNames",{get:function(){return["_ReferenceId","count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_ReferenceId","Count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"items",{get:function(){return u("items",this.m__items,"SectionCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"count",{get:function(){return u("count",this._C,"SectionCollection",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"SectionCollection",this._isNull),this.__R},enumerable:!0,configurable:!0}),a.prototype.getByName=function(t){return n(e.SectionCollection,this,"GetByName",1,[t],!0,!1,null,4)},a.prototype.getItem=function(t){return r(e.Section,this,[t])},a.prototype.getItemAt=function(t){return n(e.Section,this,"GetItemAt",1,[t],!1,!1,null,4)},a.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},a.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!c(n)){var r=n;if(m(this,r),l(r.Count)||(this._C=r.Count),l(r._ReferenceId)||(this.__R=r._ReferenceId),!c(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],a=0;a<i.length;a++){var s=o(e.Section,!0,this,i[a],a);s._handleResult(i[a]),this.m__items.push(s)}}}},a.prototype.load=function(e){return f(this,e)},a.prototype.retrieve=function(e){return d(this,e)},a.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),c(e)||l(e._ReferenceId)||(this.__R=e._ReferenceId)},a.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),y(this,n,r,(function(t,n){return o(e.Section,!0,i,t,n)}))},a.prototype.track=function(){return this.context.trackedObjects.add(this),this},a.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},a.prototype.toJSON=function(){return h(this,{count:this._C},{},this.m__items)},a.prototype.setMockData=function(t){var n=this;O(this,t,(function(t,r){return o(e.Section,!0,n,t,r)}),(function(e){return n.m__items=e}))},a}(OfficeExtension.ClientObject);e.SectionCollection=L;var H=function(r){function o(){return null!==r&&r.apply(this,arguments)||this}return __extends(o,r),Object.defineProperty(o.prototype,"_className",{get:function(){return"Page"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyNames",{get:function(){return["id","title","pageLevel","_ReferenceId","clientUrl","webUrl","classNotebookPageSource"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Title","PageLevel","_ReferenceId","ClientUrl","WebUrl","ClassNotebookPageSource"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyUpdateable",{get:function(){return[!1,!0,!0,!1,!1,!1,!1]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_navigationPropertyNames",{get:function(){return["parentSection","contents","inkAnalysisOrNull","accessibilityViolations"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"accessibilityViolations",{get:function(){return p("Page.accessibilityViolations","OneNoteApi","1.2","OneNote"),this._A||(this._A=t(e.AccessibilityViolationCollection,this,"AccessibilityViolations",!0,4)),this._A},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"contents",{get:function(){return this._Co||(this._Co=t(e.PageContentCollection,this,"Contents",!0,4)),this._Co},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"inkAnalysisOrNull",{get:function(){return this._In||(this._In=t(e.InkAnalysis,this,"InkAnalysisOrNull",!1,4)),this._In},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"parentSection",{get:function(){return this._Pa||(this._Pa=t(e.Section,this,"ParentSection",!1,4)),this._Pa},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"classNotebookPageSource",{get:function(){return u("classNotebookPageSource",this._C,"Page",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"clientUrl",{get:function(){return u("clientUrl",this._Cl,"Page",this._isNull),this._Cl},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"id",{get:function(){return u("id",this._I,"Page",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"pageLevel",{get:function(){return u("pageLevel",this._P,"Page",this._isNull),this._P},set:function(e){this._P=e,s(this,"PageLevel",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"title",{get:function(){return u("title",this._T,"Page",this._isNull),this._T},set:function(e){this._T=e,s(this,"Title",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"webUrl",{get:function(){return u("webUrl",this._W,"Page",this._isNull),this._W},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"Page",this._isNull),this.__R},enumerable:!0,configurable:!0}),o.prototype.set=function(e,t){this._recursivelySet(e,t,["title","pageLevel"],["inkAnalysisOrNull"],["accessibilityViolations","contents","parentSection"])},o.prototype.update=function(e){this._recursivelyUpdate(e)},o.prototype.addOutline=function(t,r,o){return n(e.Outline,this,"AddOutline",0,[t,r,o],!1,!0,null,0)},o.prototype.analyzePage=function(){return i(this,"AnalyzePage",1,[],4,0)},o.prototype.applyTranslation=function(e){i(this,"ApplyTranslation",0,[e],0,0)},o.prototype.copyToSection=function(t){return n(e.Page,this,"CopyToSection",0,[t],!1,!0,null,0)},o.prototype.copyToSectionAndSetClassNotebookPageSource=function(t){return n(e.Page,this,"CopyToSectionAndSetClassNotebookPageSource",0,[t],!1,!0,null,0)},o.prototype.getRestApiId=function(){return i(this,"GetRestApiId",1,[],4,0)},o.prototype.hasTitleContent=function(){return i(this,"HasTitleContent",1,[],4,0)},o.prototype.insertPageAsSibling=function(t,r){return n(e.Page,this,"InsertPageAsSibling",0,[t,r],!1,!0,null,0)},o.prototype._GetInternalHierarchy=function(){return p("Page._GetInternalHierarchy","OneNoteApi","1.3","OneNote"),i(this,"_GetInternalHierarchy",1,[],4,0)},o.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},o.prototype._Sync=function(){i(this,"_Sync",0,[],0,0)},o.prototype._handleResult=function(e){if(r.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.ClassNotebookPageSource)||(this._C=t.ClassNotebookPageSource),l(t.ClientUrl)||(this._Cl=t.ClientUrl),l(t.Id)||(this._I=t.Id),l(t.PageLevel)||(this._P=t.PageLevel),l(t.Title)||(this._T=t.Title),l(t.WebUrl)||(this._W=t.WebUrl),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["accessibilityViolations","AccessibilityViolations","contents","Contents","inkAnalysisOrNull","InkAnalysisOrNull","parentSection","ParentSection"])}},o.prototype.load=function(e){return f(this,e)},o.prototype.retrieve=function(e){return d(this,e)},o.prototype._handleIdResult=function(e){r.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},o.prototype._handleRetrieveResult=function(e,t){r.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},o.prototype.track=function(){return this.context.trackedObjects.add(this),this},o.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},o.prototype.toJSON=function(){return h(this,{classNotebookPageSource:this._C,clientUrl:this._Cl,id:this._I,pageLevel:this._P,title:this._T,webUrl:this._W},{accessibilityViolations:this._A,contents:this._Co,inkAnalysisOrNull:this._In})},o.prototype.setMockData=function(e){O(this,e)},o.prototype.ensureUnchanged=function(e){a(this,e)},o}(OfficeExtension.ClientObject);e.Page=H;var W=function(t){function a(){return null!==t&&t.apply(this,arguments)||this}return __extends(a,t),Object.defineProperty(a.prototype,"_className",{get:function(){return"PageCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyNames",{get:function(){return["_ReferenceId","count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_ReferenceId","Count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"items",{get:function(){return u("items",this.m__items,"PageCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"count",{get:function(){return u("count",this._C,"PageCollection",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"PageCollection",this._isNull),this.__R},enumerable:!0,configurable:!0}),a.prototype.getByTitle=function(t){return n(e.PageCollection,this,"GetByTitle",1,[t],!0,!1,null,4)},a.prototype.getItem=function(t){return r(e.Page,this,[t])},a.prototype.getItemAt=function(t){return n(e.Page,this,"GetItemAt",1,[t],!1,!1,null,4)},a.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},a.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!c(n)){var r=n;if(m(this,r),l(r.Count)||(this._C=r.Count),l(r._ReferenceId)||(this.__R=r._ReferenceId),!c(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],a=0;a<i.length;a++){var s=o(e.Page,!0,this,i[a],a);s._handleResult(i[a]),this.m__items.push(s)}}}},a.prototype.load=function(e){return f(this,e)},a.prototype.retrieve=function(e){return d(this,e)},a.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),c(e)||l(e._ReferenceId)||(this.__R=e._ReferenceId)},a.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),y(this,n,r,(function(t,n){return o(e.Page,!0,i,t,n)}))},a.prototype.track=function(){return this.context.trackedObjects.add(this),this},a.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},a.prototype.toJSON=function(){return h(this,{count:this._C},{},this.m__items)},a.prototype.setMockData=function(t){var n=this;O(this,t,(function(t,r){return o(e.Page,!0,n,t,r)}),(function(e){return n.m__items=e}))},a}(OfficeExtension.ClientObject);e.PageCollection=W;var B=function(n){function r(){return null!==n&&n.apply(this,arguments)||this}return __extends(r,n),Object.defineProperty(r.prototype,"_className",{get:function(){return"PageContent"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["id","type","_ReferenceId","left","top"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Type","_ReferenceId","Left","Top"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyUpdateable",{get:function(){return[!1,!1,!1,!0,!0]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["parentPage","image","outline","ink"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"image",{get:function(){return this._Im||(this._Im=t(e.Image,this,"Image",!1,4)),this._Im},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"ink",{get:function(){return this._In||(this._In=t(e.FloatingInk,this,"Ink",!1,4)),this._In},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"outline",{get:function(){return this._O||(this._O=t(e.Outline,this,"Outline",!1,4)),this._O},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"parentPage",{get:function(){return this._P||(this._P=t(e.Page,this,"ParentPage",!1,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"id",{get:function(){return u("id",this._I,"PageContent",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"left",{get:function(){return u("left",this._L,"PageContent",this._isNull),this._L},set:function(e){this._L=e,s(this,"Left",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"top",{get:function(){return u("top",this._T,"PageContent",this._isNull),this._T},set:function(e){this._T=e,s(this,"Top",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"type",{get:function(){return u("type",this._Ty,"PageContent",this._isNull),this._Ty},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"PageContent",this._isNull),this.__R},enumerable:!0,configurable:!0}),r.prototype.set=function(e,t){this._recursivelySet(e,t,["left","top"],["image"],["ink","outline","parentPage"])},r.prototype.update=function(e){this._recursivelyUpdate(e)},r.prototype.delete=function(){i(this,"Delete",0,[],0,0)},r.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},r.prototype._handleResult=function(e){if(n.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.Id)||(this._I=t.Id),l(t.Left)||(this._L=t.Left),l(t.Top)||(this._T=t.Top),l(t.Type)||(this._Ty=t.Type),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["image","Image","ink","Ink","outline","Outline","parentPage","ParentPage"])}},r.prototype.load=function(e){return f(this,e)},r.prototype.retrieve=function(e){return d(this,e)},r.prototype._handleIdResult=function(e){n.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},r.prototype._handleRetrieveResult=function(e,t){n.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},r.prototype.track=function(){return this.context.trackedObjects.add(this),this},r.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},r.prototype.toJSON=function(){return h(this,{id:this._I,left:this._L,top:this._T,type:this._Ty},{image:this._Im,ink:this._In,outline:this._O})},r.prototype.setMockData=function(e){O(this,e)},r.prototype.ensureUnchanged=function(e){a(this,e)},r}(OfficeExtension.ClientObject);e.PageContent=B;var G=function(t){function a(){return null!==t&&t.apply(this,arguments)||this}return __extends(a,t),Object.defineProperty(a.prototype,"_className",{get:function(){return"PageContentCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyNames",{get:function(){return["_ReferenceId","count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_ReferenceId","Count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"items",{get:function(){return u("items",this.m__items,"PageContentCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"count",{get:function(){return u("count",this._C,"PageContentCollection",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"PageContentCollection",this._isNull),this.__R},enumerable:!0,configurable:!0}),a.prototype.getItem=function(t){return r(e.PageContent,this,[t])},a.prototype.getItemAt=function(t){return n(e.PageContent,this,"GetItemAt",1,[t],!1,!1,null,4)},a.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},a.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!c(n)){var r=n;if(m(this,r),l(r.Count)||(this._C=r.Count),l(r._ReferenceId)||(this.__R=r._ReferenceId),!c(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],a=0;a<i.length;a++){var s=o(e.PageContent,!0,this,i[a],a);s._handleResult(i[a]),this.m__items.push(s)}}}},a.prototype.load=function(e){return f(this,e)},a.prototype.retrieve=function(e){return d(this,e)},a.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),c(e)||l(e._ReferenceId)||(this.__R=e._ReferenceId)},a.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),y(this,n,r,(function(t,n){return o(e.PageContent,!0,i,t,n)}))},a.prototype.track=function(){return this.context.trackedObjects.add(this),this},a.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},a.prototype.toJSON=function(){return h(this,{count:this._C},{},this.m__items)},a.prototype.setMockData=function(t){var n=this;O(this,t,(function(t,r){return o(e.PageContent,!0,n,t,r)}),(function(e){return n.m__items=e}))},a}(OfficeExtension.ClientObject);e.PageContentCollection=G;var V=function(r){function o(){return null!==r&&r.apply(this,arguments)||this}return __extends(o,r),Object.defineProperty(o.prototype,"_className",{get:function(){return"Outline"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyNames",{get:function(){return["id","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_navigationPropertyNames",{get:function(){return["pageContent","paragraphs"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"pageContent",{get:function(){return this._P||(this._P=t(e.PageContent,this,"PageContent",!1,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"paragraphs",{get:function(){return this._Pa||(this._Pa=t(e.ParagraphCollection,this,"Paragraphs",!0,4)),this._Pa},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"id",{get:function(){return u("id",this._I,"Outline",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"Outline",this._isNull),this.__R},enumerable:!0,configurable:!0}),o.prototype.appendHtml=function(e){i(this,"AppendHtml",0,[e],0,0)},o.prototype.appendImage=function(t,r,o){return n(e.Image,this,"AppendImage",0,[t,r,o],!1,!0,null,0)},o.prototype.appendRichText=function(t){return n(e.RichText,this,"AppendRichText",0,[t],!1,!0,null,0)},o.prototype.appendTable=function(t,r,o){return n(e.Table,this,"AppendTable",0,[t,r,o],!1,!0,null,0)},o.prototype.isTitle=function(){return i(this,"IsTitle",0,[],0,0)},o.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},o.prototype._handleResult=function(e){if(r.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.Id)||(this._I=t.Id),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["pageContent","PageContent","paragraphs","Paragraphs"])}},o.prototype.load=function(e){return f(this,e)},o.prototype.retrieve=function(e){return d(this,e)},o.prototype._handleIdResult=function(e){r.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},o.prototype._handleRetrieveResult=function(e,t){r.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},o.prototype.track=function(){return this.context.trackedObjects.add(this),this},o.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},o.prototype.toJSON=function(){return h(this,{id:this._I},{paragraphs:this._Pa})},o.prototype.setMockData=function(e){O(this,e)},o.prototype.ensureUnchanged=function(e){a(this,e)},o}(OfficeExtension.ClientObject);e.Outline=V;var q=function(r){function o(){return null!==r&&r.apply(this,arguments)||this}return __extends(o,r),Object.defineProperty(o.prototype,"_className",{get:function(){return"Paragraph"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyNames",{get:function(){return["id","type","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Type","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_navigationPropertyNames",{get:function(){return["outline","parentTableCell","parentTableCellOrNull","richText","image","table","parentParagraph","parentParagraphOrNull","paragraphs","inkWords"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"image",{get:function(){return this._Im||(this._Im=t(e.Image,this,"Image",!1,4)),this._Im},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"inkWords",{get:function(){return this._In||(this._In=t(e.InkWordCollection,this,"InkWords",!0,4)),this._In},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"outline",{get:function(){return this._O||(this._O=t(e.Outline,this,"Outline",!1,4)),this._O},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"paragraphs",{get:function(){return this._P||(this._P=t(e.ParagraphCollection,this,"Paragraphs",!0,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"parentParagraph",{get:function(){return this._Pa||(this._Pa=t(e.Paragraph,this,"ParentParagraph",!1,4)),this._Pa},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"parentParagraphOrNull",{get:function(){return this._Par||(this._Par=t(e.Paragraph,this,"ParentParagraphOrNull",!1,4)),this._Par},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"parentTableCell",{get:function(){return this._Pare||(this._Pare=t(e.TableCell,this,"ParentTableCell",!1,4)),this._Pare},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"parentTableCellOrNull",{get:function(){return this._Paren||(this._Paren=t(e.TableCell,this,"ParentTableCellOrNull",!1,4)),this._Paren},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"richText",{get:function(){return this._R||(this._R=t(e.RichText,this,"RichText",!1,4)),this._R},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"table",{get:function(){return this._T||(this._T=t(e.Table,this,"Table",!1,4)),this._T},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"id",{get:function(){return u("id",this._I,"Paragraph",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"type",{get:function(){return u("type",this._Ty,"Paragraph",this._isNull),this._Ty},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"Paragraph",this._isNull),this.__R},enumerable:!0,configurable:!0}),o.prototype.set=function(e,t){this._recursivelySet(e,t,[],["image","table"],["inkWords","outline","paragraphs","parentParagraph","parentParagraphOrNull","parentTableCell","parentTableCellOrNull","richText"])},o.prototype.update=function(e){this._recursivelyUpdate(e)},o.prototype.addNoteTag=function(t,r){return n(e.NoteTag,this,"AddNoteTag",0,[t,r],!1,!0,null,0)},o.prototype.delete=function(){i(this,"Delete",0,[],0,0)},o.prototype.getParagraphInfo=function(){return i(this,"GetParagraphInfo",0,[],0,0)},o.prototype.insertHtmlAsSibling=function(e,t){i(this,"InsertHtmlAsSibling",0,[e,t],0,0)},o.prototype.insertImageAsSibling=function(t,r,o,i){return n(e.Image,this,"InsertImageAsSibling",0,[t,r,o,i],!1,!0,null,0)},o.prototype.insertRichTextAsSibling=function(t,r){return n(e.RichText,this,"InsertRichTextAsSibling",0,[t,r],!1,!0,null,0)},o.prototype.insertTableAsSibling=function(t,r,o,i){return n(e.Table,this,"InsertTableAsSibling",0,[t,r,o,i],!1,!0,null,0)},o.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},o.prototype._handleResult=function(e){if(r.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.Id)||(this._I=t.Id),l(t.Type)||(this._Ty=t.Type),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["image","Image","inkWords","InkWords","outline","Outline","paragraphs","Paragraphs","parentParagraph","ParentParagraph","parentParagraphOrNull","ParentParagraphOrNull","parentTableCell","ParentTableCell","parentTableCellOrNull","ParentTableCellOrNull","richText","RichText","table","Table"])}},o.prototype.load=function(e){return f(this,e)},o.prototype.retrieve=function(e){return d(this,e)},o.prototype._handleIdResult=function(e){r.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},o.prototype._handleRetrieveResult=function(e,t){r.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},o.prototype.track=function(){return this.context.trackedObjects.add(this),this},o.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},o.prototype.toJSON=function(){return h(this,{id:this._I,type:this._Ty},{image:this._Im,inkWords:this._In,paragraphs:this._P,richText:this._R,table:this._T})},o.prototype.setMockData=function(e){O(this,e)},o.prototype.ensureUnchanged=function(e){a(this,e)},o}(OfficeExtension.ClientObject);e.Paragraph=q;var z=function(t){function a(){return null!==t&&t.apply(this,arguments)||this}return __extends(a,t),Object.defineProperty(a.prototype,"_className",{get:function(){return"ParagraphCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyNames",{get:function(){return["_ReferenceId","count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_ReferenceId","Count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"items",{get:function(){return u("items",this.m__items,"ParagraphCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"count",{get:function(){return u("count",this._C,"ParagraphCollection",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"ParagraphCollection",this._isNull),this.__R},enumerable:!0,configurable:!0}),a.prototype.getItem=function(t){return r(e.Paragraph,this,[t])},a.prototype.getItemAt=function(t){return n(e.Paragraph,this,"GetItemAt",1,[t],!1,!1,null,4)},a.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},a.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!c(n)){var r=n;if(m(this,r),l(r.Count)||(this._C=r.Count),l(r._ReferenceId)||(this.__R=r._ReferenceId),!c(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],a=0;a<i.length;a++){var s=o(e.Paragraph,!0,this,i[a],a);s._handleResult(i[a]),this.m__items.push(s)}}}},a.prototype.load=function(e){return f(this,e)},a.prototype.retrieve=function(e){return d(this,e)},a.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),c(e)||l(e._ReferenceId)||(this.__R=e._ReferenceId)},a.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),y(this,n,r,(function(t,n){return o(e.Paragraph,!0,i,t,n)}))},a.prototype.track=function(){return this.context.trackedObjects.add(this),this},a.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},a.prototype.toJSON=function(){return h(this,{count:this._C},{},this.m__items)},a.prototype.setMockData=function(t){var n=this;O(this,t,(function(t,r){return o(e.Paragraph,!0,n,t,r)}),(function(e){return n.m__items=e}))},a}(OfficeExtension.ClientObject);e.ParagraphCollection=z;var J=function(n){function r(){return null!==n&&n.apply(this,arguments)||this}return __extends(r,n),Object.defineProperty(r.prototype,"_className",{get:function(){return"NoteTag"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["id","type","status"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Type","Status"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["tagIcon"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"tagIcon",{get:function(){return p("NoteTag.tagIcon","OneNoteApi","1.3","OneNote"),this._T||(this._T=t(e.TagIcon,this,"TagIcon",!1,4)),this._T},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"id",{get:function(){return u("id",this._I,"NoteTag",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"status",{get:function(){return u("status",this._S,"NoteTag",this._isNull),this._S},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"type",{get:function(){return u("type",this._Ty,"NoteTag",this._isNull),this._Ty},enumerable:!0,configurable:!0}),r.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},r.prototype._handleResult=function(e){if(n.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.Id)||(this._I=t.Id),l(t.Status)||(this._S=t.Status),l(t.Type)||(this._Ty=t.Type),g(this,t,["tagIcon","TagIcon"])}},r.prototype.load=function(e){return f(this,e)},r.prototype.retrieve=function(e){return d(this,e)},r.prototype._handleIdResult=function(e){n.prototype._handleIdResult.call(this,e),c(e)||l(e.Id)||(this._I=e.Id)},r.prototype._handleRetrieveResult=function(e,t){n.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},r.prototype.track=function(){return this.context.trackedObjects.add(this),this},r.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},r.prototype.toJSON=function(){return h(this,{id:this._I,status:this._S,type:this._Ty},{tagIcon:this._T})},r.prototype.setMockData=function(e){O(this,e)},r.prototype.ensureUnchanged=function(e){a(this,e)},r}(OfficeExtension.ClientObject);e.NoteTag=J;var K=function(t){function a(){return null!==t&&t.apply(this,arguments)||this}return __extends(a,t),Object.defineProperty(a.prototype,"_className",{get:function(){return"NoteTagCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyNames",{get:function(){return["_ReferenceId","count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_ReferenceId","Count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"items",{get:function(){return u("items",this.m__items,"NoteTagCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"count",{get:function(){return u("count",this._C,"NoteTagCollection",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"NoteTagCollection",this._isNull),this.__R},enumerable:!0,configurable:!0}),a.prototype.getItem=function(t){return r(e.NoteTag,this,[t])},a.prototype.getItemAt=function(t){return n(e.NoteTag,this,"GetItemAt",1,[t],!1,!1,null,4)},a.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},a.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!c(n)){var r=n;if(m(this,r),l(r.Count)||(this._C=r.Count),l(r._ReferenceId)||(this.__R=r._ReferenceId),!c(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],a=0;a<i.length;a++){var s=o(e.NoteTag,!0,this,i[a],a);s._handleResult(i[a]),this.m__items.push(s)}}}},a.prototype.load=function(e){return f(this,e)},a.prototype.retrieve=function(e){return d(this,e)},a.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),c(e)||l(e._ReferenceId)||(this.__R=e._ReferenceId)},a.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),y(this,n,r,(function(t,n){return o(e.NoteTag,!0,i,t,n)}))},a.prototype.track=function(){return this.context.trackedObjects.add(this),this},a.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},a.prototype.toJSON=function(){return h(this,{count:this._C},{},this.m__items)},a.prototype.setMockData=function(t){var n=this;O(this,t,(function(t,r){return o(e.NoteTag,!0,n,t,r)}),(function(e){return n.m__items=e}))},a}(OfficeExtension.ClientObject);e.NoteTagCollection=K;var X=function(n){function r(){return null!==n&&n.apply(this,arguments)||this}return __extends(r,n),Object.defineProperty(r.prototype,"_className",{get:function(){return"RichText"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["text","_ReferenceId","id","languageId","style"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Text","_ReferenceId","Id","LanguageId","Style"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["paragraph"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"paragraph",{get:function(){return this._P||(this._P=t(e.Paragraph,this,"Paragraph",!1,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"id",{get:function(){return u("id",this._I,"RichText",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"languageId",{get:function(){return u("languageId",this._L,"RichText",this._isNull),this._L},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"style",{get:function(){return u("style",this._S,"RichText",this._isNull),p("RichText.style","OneNoteApi","1.8","OneNote"),this._S},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"text",{get:function(){return u("text",this._T,"RichText",this._isNull),this._T},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"RichText",this._isNull),this.__R},enumerable:!0,configurable:!0}),r.prototype.getHtml=function(){return i(this,"GetHtml",1,[],4,0)},r.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},r.prototype._handleResult=function(e){if(n.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.Id)||(this._I=t.Id),l(t.LanguageId)||(this._L=t.LanguageId),l(t.Style)||(this._S=t.Style),l(t.Text)||(this._T=t.Text),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["paragraph","Paragraph"])}},r.prototype.load=function(e){return f(this,e)},r.prototype.retrieve=function(e){return d(this,e)},r.prototype._handleIdResult=function(e){n.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},r.prototype._handleRetrieveResult=function(e,t){n.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},r.prototype.track=function(){return this.context.trackedObjects.add(this),this},r.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},r.prototype.toJSON=function(){return h(this,{id:this._I,languageId:this._L,style:this._S,text:this._T},{})},r.prototype.setMockData=function(e){O(this,e)},r.prototype.ensureUnchanged=function(e){a(this,e)},r}(OfficeExtension.ClientObject);e.RichText=X;var Q=function(n){function r(){return null!==n&&n.apply(this,arguments)||this}return __extends(r,n),Object.defineProperty(r.prototype,"_className",{get:function(){return"Image"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["description","height","hyperlink","width","_ReferenceId","id","ocrData"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Description","Height","Hyperlink","Width","_ReferenceId","Id","OcrData"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyUpdateable",{get:function(){return[!0,!0,!0,!0,!1,!1,!1]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["paragraph","pageContent"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"pageContent",{get:function(){return this._P||(this._P=t(e.PageContent,this,"PageContent",!1,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"paragraph",{get:function(){return this._Pa||(this._Pa=t(e.Paragraph,this,"Paragraph",!1,4)),this._Pa},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"description",{get:function(){return u("description",this._D,"Image",this._isNull),this._D},set:function(e){this._D=e,s(this,"Description",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"height",{get:function(){return u("height",this._H,"Image",this._isNull),this._H},set:function(e){this._H=e,s(this,"Height",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"hyperlink",{get:function(){return u("hyperlink",this._Hy,"Image",this._isNull),this._Hy},set:function(e){this._Hy=e,s(this,"Hyperlink",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"id",{get:function(){return u("id",this._I,"Image",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"ocrData",{get:function(){return u("ocrData",this._O,"Image",this._isNull),this._O},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"width",{get:function(){return u("width",this._W,"Image",this._isNull),this._W},set:function(e){this._W=e,s(this,"Width",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"Image",this._isNull),this.__R},enumerable:!0,configurable:!0}),r.prototype.set=function(e,t){this._recursivelySet(e,t,["description","height","hyperlink","width"],[],["pageContent","paragraph"])},r.prototype.update=function(e){this._recursivelyUpdate(e)},r.prototype.getBase64Image=function(){return i(this,"GetBase64Image",1,[],4,0)},r.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},r.prototype._handleResult=function(e){if(n.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.Description)||(this._D=t.Description),l(t.Height)||(this._H=t.Height),l(t.Hyperlink)||(this._Hy=t.Hyperlink),l(t.Id)||(this._I=t.Id),l(t.OcrData)||(this._O=t.OcrData),l(t.Width)||(this._W=t.Width),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["pageContent","PageContent","paragraph","Paragraph"])}},r.prototype.load=function(e){return f(this,e)},r.prototype.retrieve=function(e){return d(this,e)},r.prototype._handleIdResult=function(e){n.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},r.prototype._handleRetrieveResult=function(e,t){n.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},r.prototype.track=function(){return this.context.trackedObjects.add(this),this},r.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},r.prototype.toJSON=function(){return h(this,{description:this._D,height:this._H,hyperlink:this._Hy,id:this._I,ocrData:this._O,width:this._W},{})},r.prototype.setMockData=function(e){O(this,e)},r.prototype.ensureUnchanged=function(e){a(this,e)},r}(OfficeExtension.ClientObject);e.Image=Q;var Y=function(r){function o(){return null!==r&&r.apply(this,arguments)||this}return __extends(o,r),Object.defineProperty(o.prototype,"_className",{get:function(){return"Table"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyNames",{get:function(){return["id","_ReferenceId","rowCount","columnCount","borderVisible"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","_ReferenceId","RowCount","ColumnCount","BorderVisible"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyUpdateable",{get:function(){return[!1,!1,!1,!1,!0]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_navigationPropertyNames",{get:function(){return["paragraph","rows"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"paragraph",{get:function(){return this._P||(this._P=t(e.Paragraph,this,"Paragraph",!1,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"rows",{get:function(){return this._Ro||(this._Ro=t(e.TableRowCollection,this,"Rows",!0,4)),this._Ro},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"borderVisible",{get:function(){return u("borderVisible",this._B,"Table",this._isNull),this._B},set:function(e){this._B=e,s(this,"BorderVisible",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"columnCount",{get:function(){return u("columnCount",this._C,"Table",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"id",{get:function(){return u("id",this._I,"Table",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"rowCount",{get:function(){return u("rowCount",this._R,"Table",this._isNull),this._R},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"Table",this._isNull),this.__R},enumerable:!0,configurable:!0}),o.prototype.set=function(e,t){this._recursivelySet(e,t,["borderVisible"],[],["paragraph","rows"])},o.prototype.update=function(e){this._recursivelyUpdate(e)},o.prototype.appendColumn=function(e){i(this,"AppendColumn",0,[e],0,0)},o.prototype.appendRow=function(t){return n(e.TableRow,this,"AppendRow",0,[t],!1,!0,null,0)},o.prototype.clear=function(){i(this,"Clear",0,[],0,0)},o.prototype.getCell=function(t,r){return n(e.TableCell,this,"GetCell",1,[t,r],!1,!1,null,4)},o.prototype.insertColumn=function(e,t){i(this,"InsertColumn",0,[e,t],0,0)},o.prototype.insertRow=function(t,r){return n(e.TableRow,this,"InsertRow",0,[t,r],!1,!0,null,0)},o.prototype.setShadingColor=function(e){i(this,"SetShadingColor",0,[e],0,0)},o.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},o.prototype._handleResult=function(e){if(r.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.BorderVisible)||(this._B=t.BorderVisible),l(t.ColumnCount)||(this._C=t.ColumnCount),l(t.Id)||(this._I=t.Id),l(t.RowCount)||(this._R=t.RowCount),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["paragraph","Paragraph","rows","Rows"])}},o.prototype.load=function(e){return f(this,e)},o.prototype.retrieve=function(e){return d(this,e)},o.prototype._handleIdResult=function(e){r.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},o.prototype._handleRetrieveResult=function(e,t){r.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},o.prototype.track=function(){return this.context.trackedObjects.add(this),this},o.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},o.prototype.toJSON=function(){return h(this,{borderVisible:this._B,columnCount:this._C,id:this._I,rowCount:this._R},{rows:this._Ro})},o.prototype.setMockData=function(e){O(this,e)},o.prototype.ensureUnchanged=function(e){a(this,e)},o}(OfficeExtension.ClientObject);e.Table=Y;var $=function(r){function o(){return null!==r&&r.apply(this,arguments)||this}return __extends(o,r),Object.defineProperty(o.prototype,"_className",{get:function(){return"TableRow"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyNames",{get:function(){return["id","_ReferenceId","cellCount","rowIndex"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","_ReferenceId","CellCount","RowIndex"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_navigationPropertyNames",{get:function(){return["cells","parentTable"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"cells",{get:function(){return this._Ce||(this._Ce=t(e.TableCellCollection,this,"Cells",!0,4)),this._Ce},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"parentTable",{get:function(){return this._P||(this._P=t(e.Table,this,"ParentTable",!1,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"cellCount",{get:function(){return u("cellCount",this._C,"TableRow",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"id",{get:function(){return u("id",this._I,"TableRow",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"rowIndex",{get:function(){return u("rowIndex",this._R,"TableRow",this._isNull),this._R},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"TableRow",this._isNull),this.__R},enumerable:!0,configurable:!0}),o.prototype.clear=function(){i(this,"Clear",0,[],0,0)},o.prototype.insertRowAsSibling=function(t,r){return n(e.TableRow,this,"InsertRowAsSibling",0,[t,r],!1,!0,null,0)},o.prototype.setShadingColor=function(e){i(this,"SetShadingColor",0,[e],0,0)},o.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},o.prototype._handleResult=function(e){if(r.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.CellCount)||(this._C=t.CellCount),l(t.Id)||(this._I=t.Id),l(t.RowIndex)||(this._R=t.RowIndex),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["cells","Cells","parentTable","ParentTable"])}},o.prototype.load=function(e){return f(this,e)},o.prototype.retrieve=function(e){return d(this,e)},o.prototype._handleIdResult=function(e){r.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},o.prototype._handleRetrieveResult=function(e,t){r.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},o.prototype.track=function(){return this.context.trackedObjects.add(this),this},o.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},o.prototype.toJSON=function(){return h(this,{cellCount:this._C,id:this._I,rowIndex:this._R},{cells:this._Ce})},o.prototype.setMockData=function(e){O(this,e)},o.prototype.ensureUnchanged=function(e){a(this,e)},o}(OfficeExtension.ClientObject);e.TableRow=$;var Z=function(t){function a(){return null!==t&&t.apply(this,arguments)||this}return __extends(a,t),Object.defineProperty(a.prototype,"_className",{get:function(){return"TableRowCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyNames",{get:function(){return["_ReferenceId","count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_ReferenceId","Count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"items",{get:function(){return u("items",this.m__items,"TableRowCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"count",{get:function(){return u("count",this._C,"TableRowCollection",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"TableRowCollection",this._isNull),this.__R},enumerable:!0,configurable:!0}),a.prototype.getItem=function(t){return r(e.TableRow,this,[t])},a.prototype.getItemAt=function(t){return n(e.TableRow,this,"GetItemAt",1,[t],!1,!1,null,4)},a.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},a.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!c(n)){var r=n;if(m(this,r),l(r.Count)||(this._C=r.Count),l(r._ReferenceId)||(this.__R=r._ReferenceId),!c(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],a=0;a<i.length;a++){var s=o(e.TableRow,!0,this,i[a],a);s._handleResult(i[a]),this.m__items.push(s)}}}},a.prototype.load=function(e){return f(this,e)},a.prototype.retrieve=function(e){return d(this,e)},a.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),c(e)||l(e._ReferenceId)||(this.__R=e._ReferenceId)},a.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),y(this,n,r,(function(t,n){return o(e.TableRow,!0,i,t,n)}))},a.prototype.track=function(){return this.context.trackedObjects.add(this),this},a.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},a.prototype.toJSON=function(){return h(this,{count:this._C},{},this.m__items)},a.prototype.setMockData=function(t){var n=this;O(this,t,(function(t,r){return o(e.TableRow,!0,n,t,r)}),(function(e){return n.m__items=e}))},a}(OfficeExtension.ClientObject);e.TableRowCollection=Z;var ee=function(r){function o(){return null!==r&&r.apply(this,arguments)||this}return __extends(o,r),Object.defineProperty(o.prototype,"_className",{get:function(){return"TableCell"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyNames",{get:function(){return["id","_ReferenceId","rowIndex","cellIndex","shadingColor"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","_ReferenceId","RowIndex","CellIndex","ShadingColor"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyUpdateable",{get:function(){return[!1,!1,!1,!1,!0]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_navigationPropertyNames",{get:function(){return["parentRow","paragraphs"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"paragraphs",{get:function(){return this._P||(this._P=t(e.ParagraphCollection,this,"Paragraphs",!0,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"parentRow",{get:function(){return this._Pa||(this._Pa=t(e.TableRow,this,"ParentRow",!1,4)),this._Pa},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"cellIndex",{get:function(){return u("cellIndex",this._C,"TableCell",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"id",{get:function(){return u("id",this._I,"TableCell",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"rowIndex",{get:function(){return u("rowIndex",this._R,"TableCell",this._isNull),this._R},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"shadingColor",{get:function(){return u("shadingColor",this._S,"TableCell",this._isNull),this._S},set:function(e){this._S=e,s(this,"ShadingColor",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"TableCell",this._isNull),this.__R},enumerable:!0,configurable:!0}),o.prototype.set=function(e,t){this._recursivelySet(e,t,["shadingColor"],[],["paragraphs","parentRow"])},o.prototype.update=function(e){this._recursivelyUpdate(e)},o.prototype.appendHtml=function(e){i(this,"AppendHtml",0,[e],0,0)},o.prototype.appendImage=function(t,r,o){return n(e.Image,this,"AppendImage",0,[t,r,o],!1,!0,null,0)},o.prototype.appendRichText=function(t){return n(e.RichText,this,"AppendRichText",0,[t],!1,!0,null,0)},o.prototype.appendTable=function(t,r,o){return n(e.Table,this,"AppendTable",0,[t,r,o],!1,!0,null,0)},o.prototype.clear=function(){i(this,"Clear",0,[],0,0)},o.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},o.prototype._handleResult=function(e){if(r.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.CellIndex)||(this._C=t.CellIndex),l(t.Id)||(this._I=t.Id),l(t.RowIndex)||(this._R=t.RowIndex),l(t.ShadingColor)||(this._S=t.ShadingColor),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["paragraphs","Paragraphs","parentRow","ParentRow"])}},o.prototype.load=function(e){return f(this,e)},o.prototype.retrieve=function(e){return d(this,e)},o.prototype._handleIdResult=function(e){r.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},o.prototype._handleRetrieveResult=function(e,t){r.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},o.prototype.track=function(){return this.context.trackedObjects.add(this),this},o.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},o.prototype.toJSON=function(){return h(this,{cellIndex:this._C,id:this._I,rowIndex:this._R,shadingColor:this._S},{paragraphs:this._P})},o.prototype.setMockData=function(e){O(this,e)},o.prototype.ensureUnchanged=function(e){a(this,e)},o}(OfficeExtension.ClientObject);e.TableCell=ee;var te=function(t){function a(){return null!==t&&t.apply(this,arguments)||this}return __extends(a,t),Object.defineProperty(a.prototype,"_className",{get:function(){return"TableCellCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyNames",{get:function(){return["_ReferenceId","count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_ReferenceId","Count"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"items",{get:function(){return u("items",this.m__items,"TableCellCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"count",{get:function(){return u("count",this._C,"TableCellCollection",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"TableCellCollection",this._isNull),this.__R},enumerable:!0,configurable:!0}),a.prototype.getItem=function(t){return r(e.TableCell,this,[t])},a.prototype.getItemAt=function(t){return n(e.TableCell,this,"GetItemAt",1,[t],!1,!1,null,4)},a.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},a.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!c(n)){var r=n;if(m(this,r),l(r.Count)||(this._C=r.Count),l(r._ReferenceId)||(this.__R=r._ReferenceId),!c(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],a=0;a<i.length;a++){var s=o(e.TableCell,!0,this,i[a],a);s._handleResult(i[a]),this.m__items.push(s)}}}},a.prototype.load=function(e){return f(this,e)},a.prototype.retrieve=function(e){return d(this,e)},a.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),c(e)||l(e._ReferenceId)||(this.__R=e._ReferenceId)},a.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),y(this,n,r,(function(t,n){return o(e.TableCell,!0,i,t,n)}))},a.prototype.track=function(){return this.context.trackedObjects.add(this),this},a.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},a.prototype.toJSON=function(){return h(this,{count:this._C},{},this.m__items)},a.prototype.setMockData=function(t){var n=this;O(this,t,(function(t,r){return o(e.TableCell,!0,n,t,r)}),(function(e){return n.m__items=e}))},a}(OfficeExtension.ClientObject);e.TableCellCollection=te;var ne=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"AccessibilityViolation"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["id","type","location","name","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Type","Location","Name","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"id",{get:function(){return u("id",this._I,"AccessibilityViolation",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"location",{get:function(){return u("location",this._L,"AccessibilityViolation",this._isNull),this._L},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"name",{get:function(){return u("name",this._N,"AccessibilityViolation",this._isNull),this._N},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"type",{get:function(){return u("type",this._T,"AccessibilityViolation",this._isNull),this._T},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"AccessibilityViolation",this._isNull),this.__R},enumerable:!0,configurable:!0}),t.prototype.show=function(e){i(this,"Show",0,[e],0,0)},t.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!c(t)){var n=t;m(this,n),l(n.Id)||(this._I=n.Id),l(n.Location)||(this._L=n.Location),l(n.Name)||(this._N=n.Name),l(n.Type)||(this._T=n.Type),l(n._ReferenceId)||(this.__R=n._ReferenceId)}},t.prototype.load=function(e){return f(this,e)},t.prototype.retrieve=function(e){return d(this,e)},t.prototype._handleIdResult=function(t){e.prototype._handleIdResult.call(this,t),c(t)||(l(t._ReferenceId)||(this.__R=t._ReferenceId),l(t.Id)||(this._I=t.Id))},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),y(this,t,n)},t.prototype.track=function(){return this.context.trackedObjects.add(this),this},t.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},t.prototype.toJSON=function(){return h(this,{id:this._I,location:this._L,name:this._N,type:this._T},{})},t.prototype.setMockData=function(e){O(this,e)},t.prototype.ensureUnchanged=function(e){a(this,e)},t}(OfficeExtension.ClientObject);e.AccessibilityViolation=ne;var re=function(t){function a(){return null!==t&&t.apply(this,arguments)||this}return __extends(a,t),Object.defineProperty(a.prototype,"_className",{get:function(){return"AccessibilityViolationCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyNames",{get:function(){return["_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"items",{get:function(){return u("items",this.m__items,"AccessibilityViolationCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"AccessibilityViolationCollection",this._isNull),this.__R},enumerable:!0,configurable:!0}),a.prototype.getCount=function(){return i(this,"GetCount",1,[],4,0)},a.prototype.getItem=function(t){return r(e.AccessibilityViolation,this,[t])},a.prototype.getItemAt=function(t){return n(e.AccessibilityViolation,this,"GetItemAt",1,[t],!1,!1,null,4)},a.prototype.isScanCompleted=function(){return i(this,"IsScanCompleted",1,[],4,0)},a.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},a.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!c(n)){var r=n;if(m(this,r),l(r._ReferenceId)||(this.__R=r._ReferenceId),!c(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],a=0;a<i.length;a++){var s=o(e.AccessibilityViolation,!0,this,i[a],a);s._handleResult(i[a]),this.m__items.push(s)}}}},a.prototype.load=function(e){return f(this,e)},a.prototype.retrieve=function(e){return d(this,e)},a.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),c(e)||l(e._ReferenceId)||(this.__R=e._ReferenceId)},a.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),y(this,n,r,(function(t,n){return o(e.AccessibilityViolation,!0,i,t,n)}))},a.prototype.track=function(){return this.context.trackedObjects.add(this),this},a.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},a.prototype.toJSON=function(){return h(this,{},{},this.m__items)},a.prototype.setMockData=function(t){var n=this;O(this,t,(function(t,r){return o(e.AccessibilityViolation,!0,n,t,r)}),(function(e){return n.m__items=e}))},a}(OfficeExtension.ClientObject);e.AccessibilityViolationCollection=re;var oe=function(n){function r(){return null!==n&&n.apply(this,arguments)||this}return __extends(r,n),Object.defineProperty(r.prototype,"_className",{get:function(){return"AccessibilityViolationsByEntity"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["id","entityType","entityName","violationsCount","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","EntityType","EntityName","ViolationsCount","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["parentSectionOrNull","parentSectionGroupOrNull"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"parentSectionGroupOrNull",{get:function(){return this._P||(this._P=t(e.SectionGroup,this,"ParentSectionGroupOrNull",!1,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"parentSectionOrNull",{get:function(){return this._Pa||(this._Pa=t(e.Section,this,"ParentSectionOrNull",!1,4)),this._Pa},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"entityName",{get:function(){return u("entityName",this._E,"AccessibilityViolationsByEntity",this._isNull),this._E},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"entityType",{get:function(){return u("entityType",this._En,"AccessibilityViolationsByEntity",this._isNull),this._En},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"id",{get:function(){return u("id",this._I,"AccessibilityViolationsByEntity",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"violationsCount",{get:function(){return u("violationsCount",this._V,"AccessibilityViolationsByEntity",this._isNull),this._V},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"AccessibilityViolationsByEntity",this._isNull),this.__R},enumerable:!0,configurable:!0}),r.prototype.navigate=function(){i(this,"Navigate",0,[],0,0)},r.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},r.prototype._handleResult=function(e){if(n.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),l(t.EntityName)||(this._E=t.EntityName),l(t.EntityType)||(this._En=t.EntityType),l(t.Id)||(this._I=t.Id),l(t.ViolationsCount)||(this._V=t.ViolationsCount),l(t._ReferenceId)||(this.__R=t._ReferenceId),g(this,t,["parentSectionGroupOrNull","ParentSectionGroupOrNull","parentSectionOrNull","ParentSectionOrNull"])}},r.prototype.load=function(e){return f(this,e)},r.prototype.retrieve=function(e){return d(this,e)},r.prototype._handleIdResult=function(e){n.prototype._handleIdResult.call(this,e),c(e)||(l(e._ReferenceId)||(this.__R=e._ReferenceId),l(e.Id)||(this._I=e.Id))},r.prototype._handleRetrieveResult=function(e,t){n.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},r.prototype.track=function(){return this.context.trackedObjects.add(this),this},r.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},r.prototype.toJSON=function(){return h(this,{entityName:this._E,entityType:this._En,id:this._I,violationsCount:this._V},{parentSectionGroupOrNull:this._P,parentSectionOrNull:this._Pa})},r.prototype.setMockData=function(e){O(this,e)},r.prototype.ensureUnchanged=function(e){a(this,e)},r}(OfficeExtension.ClientObject);e.AccessibilityViolationsByEntity=oe;var ie=function(t){function a(){return null!==t&&t.apply(this,arguments)||this}return __extends(a,t),Object.defineProperty(a.prototype,"_className",{get:function(){return"AccessibilityViolationsByEntityCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyNames",{get:function(){return["_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"items",{get:function(){return u("items",this.m__items,"AccessibilityViolationsByEntityCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),Object.defineProperty(a.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"AccessibilityViolationsByEntityCollection",this._isNull),this.__R},enumerable:!0,configurable:!0}),a.prototype.getCount=function(){return i(this,"GetCount",1,[],4,0)},a.prototype.getItem=function(t){return r(e.AccessibilityViolationsByEntity,this,[t])},a.prototype.getItemAt=function(t){return n(e.AccessibilityViolationsByEntity,this,"GetItemAt",1,[t],!1,!1,null,4)},a.prototype.isScanCompleted=function(){return i(this,"IsScanCompleted",1,[],4,0)},a.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},a.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!c(n)){var r=n;if(m(this,r),l(r._ReferenceId)||(this.__R=r._ReferenceId),!c(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],a=0;a<i.length;a++){var s=o(e.AccessibilityViolationsByEntity,!0,this,i[a],a);s._handleResult(i[a]),this.m__items.push(s)}}}},a.prototype.load=function(e){return f(this,e)},a.prototype.retrieve=function(e){return d(this,e)},a.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),c(e)||l(e._ReferenceId)||(this.__R=e._ReferenceId)},a.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),y(this,n,r,(function(t,n){return o(e.AccessibilityViolationsByEntity,!0,i,t,n)}))},a.prototype.track=function(){return this.context.trackedObjects.add(this),this},a.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},a.prototype.toJSON=function(){return h(this,{},{},this.m__items)},a.prototype.setMockData=function(t){var n=this;O(this,t,(function(t,r){return o(e.AccessibilityViolationsByEntity,!0,n,t,r)}),(function(e){return n.m__items=e}))},a}(OfficeExtension.ClientObject);e.AccessibilityViolationsByEntityCollection=ie;var ae=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"TagIcon"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["name","type","bitmaps","noteTagShape","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Name","Type","Bitmaps","NoteTagShape","_ReferenceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"bitmaps",{get:function(){return u("bitmaps",this._B,"TagIcon",this._isNull),this._B},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"name",{get:function(){return u("name",this._N,"TagIcon",this._isNull),this._N},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"noteTagShape",{get:function(){return u("noteTagShape",this._No,"TagIcon",this._isNull),this._No},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"type",{get:function(){return u("type",this._T,"TagIcon",this._isNull),this._T},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_ReferenceId",{get:function(){return u("_ReferenceId",this.__R,"TagIcon",this._isNull),this.__R},enumerable:!0,configurable:!0}),t.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!c(t)){var n=t;m(this,n),l(n.Bitmaps)||(this._B=n.Bitmaps),l(n.Name)||(this._N=n.Name),l(n.NoteTagShape)||(this._No=n.NoteTagShape),l(n.Type)||(this._T=n.Type),l(n._ReferenceId)||(this.__R=n._ReferenceId)}},t.prototype.load=function(e){return f(this,e)},t.prototype.retrieve=function(e){return d(this,e)},t.prototype._handleIdResult=function(t){e.prototype._handleIdResult.call(this,t),c(t)||l(t._ReferenceId)||(this.__R=t._ReferenceId)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),y(this,t,n)},t.prototype.track=function(){return this.context.trackedObjects.add(this),this},t.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},t.prototype.toJSON=function(){return h(this,{bitmaps:this._B,name:this._N,noteTagShape:this._No,type:this._T},{})},t.prototype.setMockData=function(e){O(this,e)},t.prototype.ensureUnchanged=function(e){a(this,e)},t}(OfficeExtension.ClientObject);e.TagIcon=ae;var se=function(n){function r(){return null!==n&&n.apply(this,arguments)||this}return __extends(r,n),Object.defineProperty(r.prototype,"_className",{get:function(){return"NoteTagManager"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["allNoteTags","featuredNoteTags"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"allNoteTags",{get:function(){return p("NoteTagManager.allNoteTags","OneNoteApi","1.4","OneNote"),this._A||(this._A=t(e.NoteTagCollection,this,"AllNoteTags",!0,4)),this._A},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"featuredNoteTags",{get:function(){return p("NoteTagManager.featuredNoteTags","OneNoteApi","1.4","OneNote"),this._F||(this._F=t(e.NoteTagCollection,this,"FeaturedNoteTags",!0,4)),this._F},enumerable:!0,configurable:!0}),r.prototype.getModificationResult=function(e){return i(this,"GetModificationResult",1,[e],4,0)},r.prototype.setCustomTag=function(e,t,n){return i(this,"SetCustomTag",1,[e,t,n],4,0)},r.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},r.prototype._handleResult=function(e){if(n.prototype._handleResult.call(this,e),!c(e)){var t=e;m(this,t),g(this,t,["allNoteTags","AllNoteTags","featuredNoteTags","FeaturedNoteTags"])}},r.prototype.load=function(e){return f(this,e)},r.prototype.retrieve=function(e){return d(this,e)},r.prototype._handleRetrieveResult=function(e,t){n.prototype._handleRetrieveResult.call(this,e,t),y(this,e,t)},r.prototype.track=function(){return this.context.trackedObjects.add(this),this},r.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},r.prototype.toJSON=function(){return h(this,{},{allNoteTags:this._A,featuredNoteTags:this._F})},r.prototype.setMockData=function(e){O(this,e)},r.prototype.ensureUnchanged=function(e){a(this,e)},r}(OfficeExtension.ClientObject);e.NoteTagManager=se;var ce=function(t){function r(){return null!==t&&t.apply(this,arguments)||this}return __extends(r,t),Object.defineProperty(r.prototype,"_className",{get:function(){return"MathAssistantManager"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["selectAndCorrectMode","settingsNumberField","settingsTrigUnitMode"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["SelectAndCorrectMode","SettingsNumberField","SettingsTrigUnitMode"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyUpdateable",{get:function(){return[!0,!0,!0]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"selectAndCorrectMode",{get:function(){return u("selectAndCorrectMode",this._S,"MathAssistantManager",this._isNull),this._S},set:function(e){this._S=e,s(this,"SelectAndCorrectMode",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"settingsNumberField",{get:function(){return u("settingsNumberField",this._Se,"MathAssistantManager",this._isNull),p("MathAssistantManager.settingsNumberField","OneNoteApi","1.10","OneNote"),this._Se},set:function(e){this._Se=e,s(this,"SettingsNumberField",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"settingsTrigUnitMode",{get:function(){return u("settingsTrigUnitMode",this._Set,"MathAssistantManager",this._isNull),p("MathAssistantManager.settingsTrigUnitMode","OneNoteApi","1.10","OneNote"),this._Set},set:function(e){this._Set=e,s(this,"SettingsTrigUnitMode",e,0)},enumerable:!0,configurable:!0}),r.prototype.set=function(e,t){this._recursivelySet(e,t,["selectAndCorrectMode","settingsNumberField","settingsTrigUnitMode"],[],[])},r.prototype.update=function(e){this._recursivelyUpdate(e)},r.prototype.convertInkStrokesToTypesetMath=function(e){i(this,"ConvertInkStrokesToTypesetMath",1,[e],4,0)},r.prototype.getActiveInkStrokes=function(){return n(e.InkStrokeCollection,this,"GetActiveInkStrokes",1,[],!0,!1,null,4)},r.prototype.getActiveMathMLs=function(){return i(this,"GetActiveMathMLs",1,[],4,0)},r.prototype.getAlternateInkStrokes=function(){return n(e.InkStrokeCollection,this,"GetAlternateInkStrokes",1,[],!0,!1,null,4)},r.prototype.initialize=function(){i(this,"Initialize",1,[],4,0)},r.prototype.onClosing=function(){i(this,"OnClosing",1,[],4,0)},r.prototype.registerAlterationSelectedEvent=function(){i(this,"RegisterAlterationSelectedEvent",0,[],0,0)},r.prototype.registerInkSelectedForCorrectionEvent=function(){i(this,"RegisterInkSelectedForCorrectionEvent",0,[],0,0)},r.prototype.registerResetEvent=function(){i(this,"RegisterResetEvent",0,[],0,0)},r.prototype.registerRestrictionsCalculatedEvent=function(){i(this,"RegisterRestrictionsCalculatedEvent",0,[],0,0)},r.prototype.showAlternatesMenu=function(e,t){i(this,"ShowAlternatesMenu",1,[e,t],4,0)},r.prototype.unregisterAlterationSelectedEvent=function(){i(this,"UnregisterAlterationSelectedEvent",0,[],0,0)},r.prototype.unregisterInkSelectedForCorrectionEvent=function(){i(this,"UnregisterInkSelectedForCorrectionEvent",0,[],0,0)},r.prototype.unregisterResetEvent=function(){i(this,"UnregisterResetEvent",0,[],0,0)},r.prototype.unregisterRestrictionsCalculatedEvent=function(){i(this,"UnregisterRestrictionsCalculatedEvent",0,[],0,0)},r.prototype._KeepReference=function(){i(this,"_KeepReference",1,[],4,0)},r.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!c(e)){var n=e;m(this,n),l(n.SelectAndCorrectMode)||(this._S=n.SelectAndCorrectMode),l(n.SettingsNumberField)||(this._Se=n.SettingsNumberField),l(n.SettingsTrigUnitMode)||(this._Set=n.SettingsTrigUnitMode)}},r.prototype.load=function(e){return f(this,e)},r.prototype.retrieve=function(e){return d(this,e)},r.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),y(this,e,n)},Object.defineProperty(r.prototype,"onAlterationSelected",{get:function(){var e=this;return this.m_alterationSelected||(this.m_alterationSelected=new OfficeExtension.GenericEventHandlers(this.context,this,"AlterationSelected",{eventType:14,registerFunc:function(){return e.registerAlterationSelectedEvent()},unregisterFunc:function(){return e.unregisterAlterationSelectedEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={firstLevelIndex:e.firstLevelIndex,mathML:e.mathML,secondLevelIndex:e.secondLevelIndex,strokeIds:e.strokeIds};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_alterationSelected},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"onInkSelectedForCorrection",{get:function(){var e=this;return this.m_inkSelectedForCorrection||(this.m_inkSelectedForCorrection=new OfficeExtension.GenericEventHandlers(this.context,this,"InkSelectedForCorrection",{eventType:15,registerFunc:function(){return e.registerInkSelectedForCorrectionEvent()},unregisterFunc:function(){return e.unregisterInkSelectedForCorrectionEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={isInSnCMode:e.isInSnCMode};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_inkSelectedForCorrection},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"onReset",{get:function(){var e=this;return this.m_reset||(this.m_reset=new OfficeExtension.GenericEventHandlers(this.context,this,"Reset",{eventType:17,registerFunc:function(){return e.registerResetEvent()},unregisterFunc:function(){return e.unregisterResetEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){return OfficeExtension.Utility._createPromiseFromResult({})}})),this.m_reset},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"onRestrictionsCalculated",{get:function(){var e=this;return this.m_restrictionsCalculated||(this.m_restrictionsCalculated=new OfficeExtension.GenericEventHandlers(this.context,this,"RestrictionsCalculated",{eventType:16,registerFunc:function(){return e.registerRestrictionsCalculatedEvent()},unregisterFunc:function(){return e.unregisterRestrictionsCalculatedEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={isGraphingEnabled:e.isGraphingEnabled,isKeyGraphFeaturesEnabled:e.isKeyGraphFeaturesEnabled,isSolvingEnabled:e.isSolvingEnabled,isStepByStepEnabled:e.isStepByStepEnabled};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_restrictionsCalculated},enumerable:!0,configurable:!0}),r.prototype.track=function(){return this.context.trackedObjects.add(this),this},r.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this},r.prototype.toJSON=function(){return h(this,{selectAndCorrectMode:this._S,settingsNumberField:this._Se,settingsTrigUnitMode:this._Set},{})},r.prototype.setMockData=function(e){O(this,e)},r.prototype.ensureUnchanged=function(e){a(this,e)},r}(OfficeExtension.ClientObject);e.MathAssistantManager=ce,function(e){e.notebook="Notebook",e.sectionGroup="SectionGroup",e.section="Section",e.page="Page"}(e.EntityType||(e.EntityType={})),function(e){e.before="Before",e.after="After"}(e.InsertLocation||(e.InsertLocation={})),function(e){e.other="Other",e.web="Web",e.uwp="UWP",e.win32="Win32",e.mac="Mac",e.ios="IOS"}(e.Platform||(e.Platform={})),function(e){e.outline="Outline",e.image="Image",e.ink="Ink",e.other="Other"}(e.PageContentType||(e.PageContentType={})),function(e){e.richText="RichText",e.image="Image",e.table="Table",e.ink="Ink",e.other="Other"}(e.ParagraphType||(e.ParagraphType={})),function(e){e.unknown="Unknown",e.toDo="ToDo",e.important="Important",e.question="Question",e.contact="Contact",e.address="Address",e.phoneNumber="PhoneNumber",e.website="Website",e.idea="Idea",e.critical="Critical",e.toDoPriority1="ToDoPriority1",e.toDoPriority2="ToDoPriority2"}(e.NoteTagType||(e.NoteTagType={})),function(e){e.unknown="Unknown",e.normal="Normal",e.completed="Completed",e.disabled="Disabled",e.outlookTask="OutlookTask",e.taskNotSyncedYet="TaskNotSyncedYet",e.taskRemoved="TaskRemoved"}(e.NoteTagStatus||(e.NoteTagStatus={})),function(e){e.form="Form",e.entity="Entity",e.graph="Graph",e.oneService="OneService",e.classNotebooks="ClassNotebooks",e.mathSolver="MathSolver",e.mathRecognizer="MathRecognizer"}(e.ServiceId||(e.ServiceId={})),function(e){e.selection="Selection",e.activeProfile="ActiveProfile",e.liveId="LiveId",e.orgId="OrgId",e.adal="ADAL",e.notebook="Notebook"}(e.IdentityFilter||(e.IdentityFilter={})),function(e){e.none="None",e.number="Number",e.bullet="Bullet"}(e.ListType||(e.ListType={})),function(e){e.other="Other",e.liveId="LiveId",e.orgId="OrgId",e.adal="ADAL"}(e.AccountType||(e.AccountType={})),function(e){e.trace="Trace",e.data="Data",e.exception="Exception",e.warning="Warning"}(e.LogLevel||(e.LogLevel={})),function(e){e.defaultFlag="DefaultFlag",e.criticalFlag="CriticalFlag",e.measureFlag="MeasureFlag"}(e.EventFlag||(e.EventFlag={})),function(e){e.none="None",e.arabic="Arabic",e.ucroman="UCRoman",e.lcroman="LCRoman",e.ucletter="UCLetter",e.lcletter="LCLetter",e.ordinal="Ordinal",e.cardtext="Cardtext",e.ordtext="Ordtext",e.hex="Hex",e.chiManSty="ChiManSty",e.dbNum1="DbNum1",e.dbNum2="DbNum2",e.aiueo="Aiueo",e.iroha="Iroha",e.dbChar="DbChar",e.sbChar="SbChar",e.dbNum3="DbNum3",e.dbNum4="DbNum4",e.circlenum="Circlenum",e.darabic="DArabic",e.daiueo="DAiueo",e.diroha="DIroha",e.arabicLZ="ArabicLZ",e.bullet="Bullet",e.ganada="Ganada",e.chosung="Chosung",e.gb1="GB1",e.gb2="GB2",e.gb3="GB3",e.gb4="GB4",e.zodiac1="Zodiac1",e.zodiac2="Zodiac2",e.zodiac3="Zodiac3",e.tpeDbNum1="TpeDbNum1",e.tpeDbNum2="TpeDbNum2",e.tpeDbNum3="TpeDbNum3",e.tpeDbNum4="TpeDbNum4",e.chnDbNum1="ChnDbNum1",e.chnDbNum2="ChnDbNum2",e.chnDbNum3="ChnDbNum3",e.chnDbNum4="ChnDbNum4",e.korDbNum1="KorDbNum1",e.korDbNum2="KorDbNum2",e.korDbNum3="KorDbNum3",e.korDbNum4="KorDbNum4",e.hebrew1="Hebrew1",e.arabic1="Arabic1",e.hebrew2="Hebrew2",e.arabic2="Arabic2",e.hindi1="Hindi1",e.hindi2="Hindi2",e.hindi3="Hindi3",e.thai1="Thai1",e.thai2="Thai2",e.numInDash="NumInDash",e.lcrus="LCRus",e.ucrus="UCRus",e.lcgreek="LCGreek",e.ucgreek="UCGreek",e.lim="Lim",e.custom="Custom"}(e.NumberType||(e.NumberType={})),function(e){e.preinstallClassNotebook="PreinstallClassNotebook",e.distributePageId="DistributePageId",e.distributeSection="DistributeSection",e.reviewStudentWork="ReviewStudentWork",e.openTabForCreateClassNotebook="OpenTabForCreateClassNotebook",e.openTabForManageStudent="OpenTabForManageStudent",e.openTabForManageTeacher="OpenTabForManageTeacher",e.openTabForGetNotebookLink="OpenTabForGetNotebookLink",e.openTabForTeacherTraining="OpenTabForTeacherTraining",e.openTabForAddinGuide="OpenTabForAddinGuide",e.openTabForEducationBlog="OpenTabForEducationBlog",e.openTabForEducatorCommunity="OpenTabForEducatorCommunity",e.openTabToSendFeedback="OpenTabToSendFeedback",e.openTabForViewKnowledgeBase="OpenTabForViewKnowledgeBase",e.openTabForSuggestingFeature="OpenTabForSuggestingFeature",e.manageClasses="ManageClasses",e.distributePageMenu="DistributePageMenu",e.distributeSectionMenu="DistributeSectionMenu",e.reviewStudentWorkMenu="ReviewStudentWorkMenu"}(e.ControlId||(e.ControlId={})),function(e){e.none="None",e.missingAltText="MissingAltText",e.tableWithNoHeaderRow="TableWithNoHeaderRow",e.untitledPage="UntitledPage",e.unnamedSection="UnnamedSection",e.unnamedSectionGroup="UnnamedSectionGroup",e.nonDescriptiveAltText="NonDescriptiveAltText",e.nestedTable="NestedTable",e.headingOutOfOrder="HeadingOutOfOrder",e.extraOutline="ExtraOutline",e.extraWhitespace="ExtraWhitespace",e.noHeadingsInALongDocument="NoHeadingsInALongDocument",e.insufficientTextContrast="InsufficientTextContrast"}(e.AccessibilityViolationType||(e.AccessibilityViolationType={})),function(e){e.none="None",e.onHighlight="OnHighlight",e.onMultipleParagraphs="OnMultipleParagraphs",e.onOutline="OnOutline",e.onPage="OnPage",e.onParagraph="OnParagraph",e.onParagraphBegin="OnParagraphBegin",e.onParagraphEnd="OnParagraphEnd",e.onTable="OnTable",e.withinParagraph="WithinParagraph"}(e.AccessibilityViolationLocation||(e.AccessibilityViolationLocation={})),function(e){e.static="Static",e.interactive="Interactive"}(e.TagIconType||(e.TagIconType={})),function(e){e.success="Success",e.pending="Pending",e.invalidIdentity="InvalidIdentity",e.previousStorageError="PreviousStorageError",e.storageError="StorageError",e.alreadyExists="AlreadyExists",e.invalidGUID="InvalidGUID",e.invalidLabel="InvalidLabel"}(e.TagModificationResult||(e.TagModificationResult={})),function(e){e.accessDenied="AccessDenied",e.generalException="GeneralException",e.invalidArgument="InvalidArgument",e.invalidOperation="InvalidOperation",e.invalidState="InvalidState",e.itemNotFound="ItemNotFound",e.notImplemented="NotImplemented",e.notSupported="NotSupported",e.operationAborted="OperationAborted"}(e.ErrorCodes||(e.ErrorCodes={})),e.Interfaces||(e.Interfaces={})}(OneNote||(OneNote={})),function(e){var t=function(t){function n(n){var r=t.call(this,n)||this;return r.m_onenote=new e.Application(r,OfficeExtension.ObjectPathFactory.createGlobalObjectObjectPath(r)),r._rootObject=r.m_onenote,r}return __extends(n,t),Object.defineProperty(n.prototype,"application",{get:function(){return this.m_onenote},enumerable:!0,configurable:!0}),n}(OfficeCore.RequestContext);e.RequestContext=t,e.run=function(t,n){return OfficeExtension.ClientRequestContext._runBatch("OneNote.run",arguments,(function(){return new e.RequestContext}))}}(OneNote||(OneNote={})),OSFAriaLogger.AriaLogger.EnableSendingTelemetryWithOTel=!0,OSFAriaLogger.AriaLogger.EnableSendingTelemetryWithLegacyAria=!1,OfficeExtension.Utility._doApiNotSupportedCheck=!0;